/* enumvalue.c generated by valac, the Vala compiler
 * generated from enumvalue.vala, do not modify */

/* enumvalue.vala
 *
 * Copyright (C) 2008-2011  Florian Brosch
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Florian Brosch <flo.brosch@gmail.com>
 */

#include "valadoc.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <vala.h>
#include <valacodegen.h>

enum  {
	VALADOC_API_ENUM_VALUE_0_PROPERTY,
	VALADOC_API_ENUM_VALUE_DEFAULT_VALUE_PROPERTY,
	VALADOC_API_ENUM_VALUE_HAS_DEFAULT_VALUE_PROPERTY,
	VALADOC_API_ENUM_VALUE_NODE_TYPE_PROPERTY,
	VALADOC_API_ENUM_VALUE_NUM_PROPERTIES
};
static GParamSpec* valadoc_api_enum_value_properties[VALADOC_API_ENUM_VALUE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _valadoc_api_signature_builder_unref0(var) ((var == NULL) ? NULL : (var = (valadoc_api_signature_builder_unref (var), NULL)))

struct _ValadocApiEnumValuePrivate {
	gchar* cname;
	ValadocContentRun* _default_value;
};

static gint ValadocApiEnumValue_private_offset;
static gpointer valadoc_api_enum_value_parent_class = NULL;

static void valadoc_api_enum_value_real_accept (ValadocApiNode* base,
                                         ValadocApiVisitor* visitor);
static ValadocContentInline* valadoc_api_enum_value_real_build_signature (ValadocApiItem* base);
static void valadoc_api_enum_value_finalize (GObject * obj);
static GType valadoc_api_enum_value_get_type_once (void);
static void _vala_valadoc_api_enum_value_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_valadoc_api_enum_value_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
valadoc_api_enum_value_get_instance_private (ValadocApiEnumValue* self)
{
	return G_STRUCT_MEMBER_P (self, ValadocApiEnumValue_private_offset);
}

ValadocContentRun*
valadoc_api_enum_value_get_default_value (ValadocApiEnumValue* self)
{
	ValadocContentRun* result;
	ValadocContentRun* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_value;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
valadoc_api_enum_value_set_default_value (ValadocApiEnumValue* self,
                                          ValadocContentRun* value)
{
	ValadocContentRun* old_value;
	g_return_if_fail (self != NULL);
	old_value = valadoc_api_enum_value_get_default_value (self);
	if (old_value != value) {
		ValadocContentRun* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_default_value);
		self->priv->_default_value = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, valadoc_api_enum_value_properties[VALADOC_API_ENUM_VALUE_DEFAULT_VALUE_PROPERTY]);
	}
}

gboolean
valadoc_api_enum_value_get_has_default_value (ValadocApiEnumValue* self)
{
	gboolean result;
	ValadocContentRun* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_default_value;
	result = _tmp0_ != NULL;
	return result;
}

ValadocApiEnumValue*
valadoc_api_enum_value_construct (GType object_type,
                                  ValadocApiEnum* parent,
                                  ValadocApiSourceFile* file,
                                  const gchar* name,
                                  ValadocApiSourceComment* comment,
                                  ValaEnumValue* data)
{
	ValadocApiEnumValue * self = NULL;
	ValaSymbolAccessibility _tmp0_;
	ValaSymbolAccessibility _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (parent != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (data != NULL, NULL);
	_tmp0_ = valadoc_api_symbol_get_accessibility ((ValadocApiSymbol*) parent);
	_tmp1_ = _tmp0_;
	self = (ValadocApiEnumValue*) valadoc_api_symbol_construct (object_type, (ValadocApiNode*) parent, file, name, _tmp1_, comment, (ValaSymbol*) data);
	_tmp2_ = vala_get_ccode_name ((ValaCodeNode*) data);
	_g_free0 (self->priv->cname);
	self->priv->cname = _tmp2_;
	return self;
}

ValadocApiEnumValue*
valadoc_api_enum_value_new (ValadocApiEnum* parent,
                            ValadocApiSourceFile* file,
                            const gchar* name,
                            ValadocApiSourceComment* comment,
                            ValaEnumValue* data)
{
	return valadoc_api_enum_value_construct (VALADOC_API_TYPE_ENUM_VALUE, parent, file, name, comment, data);
}

/**
 * Returns the name of this enum value as it is used in C.
 */
gchar*
valadoc_api_enum_value_get_cname (ValadocApiEnumValue* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->cname;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}

static ValadocApiNodeType
valadoc_api_enum_value_real_get_node_type (ValadocApiNode* base)
{
	ValadocApiNodeType result;
	ValadocApiEnumValue* self;
	self = (ValadocApiEnumValue*) base;
	result = VALADOC_API_NODE_TYPE_ENUM_VALUE;
	return result;
}

/**
 * {@inheritDoc}
 */
static void
valadoc_api_enum_value_real_accept (ValadocApiNode* base,
                                    ValadocApiVisitor* visitor)
{
	ValadocApiEnumValue * self;
	self = (ValadocApiEnumValue*) base;
	g_return_if_fail (visitor != NULL);
	valadoc_api_visitor_visit_enum_value (visitor, self);
}

/**
 * {@inheritDoc}
 */
static gpointer
_valadoc_api_signature_builder_ref0 (gpointer self)
{
	return self ? valadoc_api_signature_builder_ref (self) : NULL;
}

static ValadocContentInline*
valadoc_api_enum_value_real_build_signature (ValadocApiItem* base)
{
	ValadocApiEnumValue * self;
	ValadocApiSignatureBuilder* builder = NULL;
	ValadocApiSignatureBuilder* _tmp0_;
	ValadocApiSignatureBuilder* _tmp1_;
	ValadocApiSignatureBuilder* _tmp2_;
	ValadocApiSignatureBuilder* _tmp3_;
	ValadocApiSignatureBuilder* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	ValadocApiSignatureBuilder* _tmp10_;
	ValadocContentRun* _tmp11_;
	ValadocContentInline* result = NULL;
	self = (ValadocApiEnumValue*) base;
	_tmp0_ = valadoc_api_signature_builder_new ();
	_tmp1_ = _tmp0_;
	_tmp2_ = valadoc_api_signature_builder_append_symbol (_tmp1_, (ValadocApiNode*) self, TRUE);
	_tmp3_ = _valadoc_api_signature_builder_ref0 (_tmp2_);
	_tmp4_ = _tmp3_;
	_valadoc_api_signature_builder_unref0 (_tmp1_);
	builder = _tmp4_;
	_tmp5_ = valadoc_api_enum_value_get_has_default_value (self);
	_tmp6_ = _tmp5_;
	if (_tmp6_) {
		ValadocApiSignatureBuilder* _tmp7_;
		ValadocApiSignatureBuilder* _tmp8_;
		ValadocContentRun* _tmp9_;
		_tmp7_ = builder;
		valadoc_api_signature_builder_append (_tmp7_, "=", TRUE);
		_tmp8_ = builder;
		_tmp9_ = self->priv->_default_value;
		valadoc_api_signature_builder_append_content (_tmp8_, (ValadocContentInline*) _tmp9_, TRUE);
	}
	_tmp10_ = builder;
	_tmp11_ = valadoc_api_signature_builder_get (_tmp10_);
	result = (ValadocContentInline*) _tmp11_;
	_valadoc_api_signature_builder_unref0 (builder);
	return result;
}

static void
valadoc_api_enum_value_class_init (ValadocApiEnumValueClass * klass,
                                   gpointer klass_data)
{
	valadoc_api_enum_value_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ValadocApiEnumValue_private_offset);
	((ValadocApiNodeClass *) klass)->accept = (void (*) (ValadocApiNode*, ValadocApiVisitor*)) valadoc_api_enum_value_real_accept;
	((ValadocApiItemClass *) klass)->build_signature = (ValadocContentInline* (*) (ValadocApiItem*)) valadoc_api_enum_value_real_build_signature;
	VALADOC_API_NODE_CLASS (klass)->get_node_type = valadoc_api_enum_value_real_get_node_type;
	G_OBJECT_CLASS (klass)->get_property = _vala_valadoc_api_enum_value_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_valadoc_api_enum_value_set_property;
	G_OBJECT_CLASS (klass)->finalize = valadoc_api_enum_value_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_ENUM_VALUE_DEFAULT_VALUE_PROPERTY, valadoc_api_enum_value_properties[VALADOC_API_ENUM_VALUE_DEFAULT_VALUE_PROPERTY] = g_param_spec_object ("default-value", "default-value", "default-value", VALADOC_CONTENT_TYPE_RUN, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * Specifies whether the parameter has a default value
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_ENUM_VALUE_HAS_DEFAULT_VALUE_PROPERTY, valadoc_api_enum_value_properties[VALADOC_API_ENUM_VALUE_HAS_DEFAULT_VALUE_PROPERTY] = g_param_spec_boolean ("has-default-value", "has-default-value", "has-default-value", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	 * {@inheritDoc}
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_ENUM_VALUE_NODE_TYPE_PROPERTY, valadoc_api_enum_value_properties[VALADOC_API_ENUM_VALUE_NODE_TYPE_PROPERTY] = g_param_spec_enum ("node-type", "node-type", "node-type", VALADOC_API_TYPE_NODE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
valadoc_api_enum_value_instance_init (ValadocApiEnumValue * self,
                                      gpointer klass)
{
	self->priv = valadoc_api_enum_value_get_instance_private (self);
}

static void
valadoc_api_enum_value_finalize (GObject * obj)
{
	ValadocApiEnumValue * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALADOC_API_TYPE_ENUM_VALUE, ValadocApiEnumValue);
	_g_free0 (self->priv->cname);
	_g_object_unref0 (self->priv->_default_value);
	G_OBJECT_CLASS (valadoc_api_enum_value_parent_class)->finalize (obj);
}

/**
 * Represents an enum member.
 */
static GType
valadoc_api_enum_value_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValadocApiEnumValueClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valadoc_api_enum_value_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValadocApiEnumValue), 0, (GInstanceInitFunc) valadoc_api_enum_value_instance_init, NULL };
	GType valadoc_api_enum_value_type_id;
	valadoc_api_enum_value_type_id = g_type_register_static (VALADOC_API_TYPE_SYMBOL, "ValadocApiEnumValue", &g_define_type_info, 0);
	ValadocApiEnumValue_private_offset = g_type_add_instance_private (valadoc_api_enum_value_type_id, sizeof (ValadocApiEnumValuePrivate));
	return valadoc_api_enum_value_type_id;
}

GType
valadoc_api_enum_value_get_type (void)
{
	static volatile gsize valadoc_api_enum_value_type_id__volatile = 0;
	if (g_once_init_enter (&valadoc_api_enum_value_type_id__volatile)) {
		GType valadoc_api_enum_value_type_id;
		valadoc_api_enum_value_type_id = valadoc_api_enum_value_get_type_once ();
		g_once_init_leave (&valadoc_api_enum_value_type_id__volatile, valadoc_api_enum_value_type_id);
	}
	return valadoc_api_enum_value_type_id__volatile;
}

static void
_vala_valadoc_api_enum_value_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	ValadocApiEnumValue * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_API_TYPE_ENUM_VALUE, ValadocApiEnumValue);
	switch (property_id) {
		case VALADOC_API_ENUM_VALUE_DEFAULT_VALUE_PROPERTY:
		g_value_set_object (value, valadoc_api_enum_value_get_default_value (self));
		break;
		case VALADOC_API_ENUM_VALUE_HAS_DEFAULT_VALUE_PROPERTY:
		g_value_set_boolean (value, valadoc_api_enum_value_get_has_default_value (self));
		break;
		case VALADOC_API_ENUM_VALUE_NODE_TYPE_PROPERTY:
		g_value_set_enum (value, valadoc_api_node_get_node_type ((ValadocApiNode*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_valadoc_api_enum_value_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	ValadocApiEnumValue * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_API_TYPE_ENUM_VALUE, ValadocApiEnumValue);
	switch (property_id) {
		case VALADOC_API_ENUM_VALUE_DEFAULT_VALUE_PROPERTY:
		valadoc_api_enum_value_set_default_value (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

