/* valaparser.c generated by valac, the Vala compiler
 * generated from valaparser.vala, do not modify */

/* valaparser.vala
 *
 * Copyright (C) 2006-2013  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include "vala.h"
#include <glib-object.h>
#include <glib.h>
#include <valagee.h>
#include <stdlib.h>
#include <string.h>

#define VALA_PARSER_TYPE_TOKEN_INFO (vala_parser_token_info_get_type ())
typedef struct _ValaParserTokenInfo ValaParserTokenInfo;
typedef enum  {
	VALA_PARSER_MODIFIER_FLAGS_NONE = 0,
	VALA_PARSER_MODIFIER_FLAGS_ABSTRACT = 1 << 0,
	VALA_PARSER_MODIFIER_FLAGS_CLASS = 1 << 1,
	VALA_PARSER_MODIFIER_FLAGS_EXTERN = 1 << 2,
	VALA_PARSER_MODIFIER_FLAGS_INLINE = 1 << 3,
	VALA_PARSER_MODIFIER_FLAGS_NEW = 1 << 4,
	VALA_PARSER_MODIFIER_FLAGS_OVERRIDE = 1 << 5,
	VALA_PARSER_MODIFIER_FLAGS_STATIC = 1 << 6,
	VALA_PARSER_MODIFIER_FLAGS_VIRTUAL = 1 << 7,
	VALA_PARSER_MODIFIER_FLAGS_ASYNC = 1 << 8,
	VALA_PARSER_MODIFIER_FLAGS_SEALED = 1 << 9
} ValaParserModifierFlags;

#define VALA_PARSER_TYPE_MODIFIER_FLAGS (vala_parser_modifier_flags_get_type ())
typedef enum  {
	VALA_PARSER_RECOVERY_STATE_EOF,
	VALA_PARSER_RECOVERY_STATE_DECLARATION_BEGIN,
	VALA_PARSER_RECOVERY_STATE_STATEMENT_BEGIN
} ValaParserRecoveryState;

#define VALA_PARSER_TYPE_RECOVERY_STATE (vala_parser_recovery_state_get_type ())
#define _vala_scanner_unref0(var) ((var == NULL) ? NULL : (var = (vala_scanner_unref (var), NULL)))
#define _vala_code_context_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_context_unref (var), NULL)))
#define _vala_comment_unref0(var) ((var == NULL) ? NULL : (var = (vala_comment_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_source_reference_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_reference_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ValaParserTokenInfo {
	ValaTokenType type;
	ValaSourceLocation begin;
	ValaSourceLocation end;
};

struct _ValaParserPrivate {
	ValaScanner* scanner;
	ValaCodeContext* context;
	ValaParserTokenInfo* tokens;
	gint tokens_length1;
	gint _tokens_size_;
	gint index;
	gint size;
	ValaComment* comment;
};

static gint ValaParser_private_offset;
static gpointer vala_parser_parent_class = NULL;
static ValaList* vala_parser__empty_type_parameter_list;
static ValaList* vala_parser__empty_type_parameter_list = NULL;

static GType vala_parser_token_info_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static ValaParserTokenInfo* vala_parser_token_info_dup (const ValaParserTokenInfo* self);
static void vala_parser_token_info_free (ValaParserTokenInfo* self);
static GType vala_parser_modifier_flags_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GType vala_parser_recovery_state_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define VALA_PARSER_BUFFER_SIZE 32
static void vala_parser_real_visit_source_file (ValaCodeVisitor* base,
                                         ValaSourceFile* source_file);
static inline gboolean vala_parser_next (ValaParser* self);
static inline void vala_parser_prev (ValaParser* self);
static inline void vala_parser_safe_prev (ValaParser* self);
static inline ValaTokenType vala_parser_previous (ValaParser* self);
static inline ValaTokenType vala_parser_current (ValaParser* self);
static inline gboolean vala_parser_accept (ValaParser* self,
                             ValaTokenType type);
static void vala_parser_report_parse_error (ValaParser* self,
                                     GError* e);
static inline void vala_parser_get_location (ValaParser* self,
                               ValaSourceLocation* result);
static ValaSourceReference* vala_parser_get_src (ValaParser* self,
                                          ValaSourceLocation* begin);
static inline gboolean vala_parser_expect (ValaParser* self,
                             ValaTokenType type,
                             GError** error);
static gchar* vala_parser_get_location_string (ValaParser* self);
static gchar* vala_parser_get_current_string (ValaParser* self);
static gchar* vala_parser_get_last_string (ValaParser* self);
static ValaSourceReference* vala_parser_get_current_src (ValaParser* self);
static ValaSourceReference* vala_parser_get_last_src (ValaParser* self);
static void vala_parser_rollback (ValaParser* self,
                           ValaSourceLocation* location);
static void vala_parser_skip_identifier (ValaParser* self,
                                  GError** error);
static gchar* vala_parser_parse_identifier (ValaParser* self,
                                     GError** error);
static ValaExpression* vala_parser_parse_literal (ValaParser* self,
                                           GError** error);
static void vala_parser_parse_file_comments (ValaParser* self);
static void vala_parser_parse_using_directives (ValaParser* self,
                                         ValaNamespace* ns,
                                         GError** error);
static void vala_parser_parse_declarations (ValaParser* self,
                                     ValaSymbol* parent,
                                     gboolean root,
                                     GError** error);
static void vala_parser_skip_symbol_name (ValaParser* self,
                                   GError** error);
static ValaUnresolvedSymbol* vala_parser_parse_symbol_name (ValaParser* self,
                                                     GError** error);
static void vala_parser_skip_type (ValaParser* self,
                            GError** error);
static gboolean vala_parser_is_inner_array_type (ValaParser* self);
static void vala_parser_skip_type_argument_list (ValaParser* self,
                                          GError** error);
static ValaExpression* vala_parser_parse_expression (ValaParser* self,
                                              GError** error);
static ValaDataType* vala_parser_parse_type (ValaParser* self,
                                      gboolean owned_by_default,
                                      gboolean can_weak_ref,
                                      gboolean require_unowned,
                                      GError** error);
static ValaList* vala_parser_parse_type_argument_list (ValaParser* self,
                                                gboolean maybe_expression,
                                                GError** error);
static ValaDataType* vala_parser_parse_inline_array_type (ValaParser* self,
                                                   ValaDataType* type,
                                                   GError** error);
static ValaList* vala_parser_parse_argument_list (ValaParser* self,
                                           GError** error);
static ValaExpression* vala_parser_parse_argument (ValaParser* self,
                                            GError** error);
static ValaExpression* vala_parser_parse_primary_expression (ValaParser* self,
                                                      GError** error);
static ValaInitializerList* vala_parser_parse_initializer (ValaParser* self,
                                                    GError** error);
static ValaExpression* vala_parser_parse_simple_name (ValaParser* self,
                                               GError** error);
static ValaExpression* vala_parser_parse_tuple (ValaParser* self,
                                         GError** error);
static ValaExpression* vala_parser_parse_template (ValaParser* self,
                                            GError** error);
static ValaExpression* vala_parser_parse_regex_literal (ValaParser* self,
                                                 GError** error);
static ValaExpression* vala_parser_parse_this_access (ValaParser* self,
                                               GError** error);
static ValaExpression* vala_parser_parse_base_access (ValaParser* self,
                                               GError** error);
static ValaExpression* vala_parser_parse_object_or_array_creation_expression (ValaParser* self,
                                                                       GError** error);
static ValaExpression* vala_parser_parse_yield_expression (ValaParser* self,
                                                    GError** error);
static ValaExpression* vala_parser_parse_sizeof_expression (ValaParser* self,
                                                     GError** error);
static ValaExpression* vala_parser_parse_typeof_expression (ValaParser* self,
                                                     GError** error);
static ValaExpression* vala_parser_parse_member_access (ValaParser* self,
                                                 ValaSourceLocation* begin,
                                                 ValaExpression* inner,
                                                 GError** error);
static ValaExpression* vala_parser_parse_pointer_member_access (ValaParser* self,
                                                         ValaSourceLocation* begin,
                                                         ValaExpression* inner,
                                                         GError** error);
static ValaExpression* vala_parser_parse_method_call (ValaParser* self,
                                               ValaSourceLocation* begin,
                                               ValaExpression* inner,
                                               GError** error);
static ValaExpression* vala_parser_parse_element_access (ValaParser* self,
                                                  ValaSourceLocation* begin,
                                                  ValaExpression* inner,
                                                  GError** error);
static ValaExpression* vala_parser_parse_post_increment_expression (ValaParser* self,
                                                             ValaSourceLocation* begin,
                                                             ValaExpression* inner,
                                                             GError** error);
static ValaExpression* vala_parser_parse_post_decrement_expression (ValaParser* self,
                                                             ValaSourceLocation* begin,
                                                             ValaExpression* inner,
                                                             GError** error);
static ValaList* vala_parser_parse_object_initializer (ValaParser* self,
                                                GError** error);
static ValaList* vala_parser_parse_expression_list (ValaParser* self,
                                             GError** error);
static ValaExpression* vala_parser_parse_array_creation_expression (ValaParser* self,
                                                             GError** error);
static ValaMemberAccess* vala_parser_parse_member_name (ValaParser* self,
                                                 ValaExpression* base_expr,
                                                 GError** error);
static ValaExpression* vala_parser_parse_object_creation_expression (ValaParser* self,
                                                              ValaSourceLocation* begin,
                                                              ValaMemberAccess* member,
                                                              GError** error);
static ValaMemberInitializer* vala_parser_parse_member_initializer (ValaParser* self,
                                                             GError** error);
static ValaUnaryOperator vala_parser_get_unary_operator (ValaParser* self,
                                                  ValaTokenType token_type);
static ValaExpression* vala_parser_parse_unary_expression (ValaParser* self,
                                                    GError** error);
static ValaBinaryOperator vala_parser_get_binary_operator (ValaParser* self,
                                                    ValaTokenType token_type);
static ValaExpression* vala_parser_parse_multiplicative_expression (ValaParser* self,
                                                             GError** error);
static ValaExpression* vala_parser_parse_additive_expression (ValaParser* self,
                                                       GError** error);
static ValaExpression* vala_parser_parse_shift_expression (ValaParser* self,
                                                    GError** error);
static ValaExpression* vala_parser_parse_relational_expression (ValaParser* self,
                                                         GError** error);
static ValaExpression* vala_parser_parse_equality_expression (ValaParser* self,
                                                       GError** error);
static ValaExpression* vala_parser_parse_and_expression (ValaParser* self,
                                                  GError** error);
static ValaExpression* vala_parser_parse_exclusive_or_expression (ValaParser* self,
                                                           GError** error);
static ValaExpression* vala_parser_parse_inclusive_or_expression (ValaParser* self,
                                                           GError** error);
static ValaExpression* vala_parser_parse_in_expression (ValaParser* self,
                                                 GError** error);
static ValaExpression* vala_parser_parse_conditional_and_expression (ValaParser* self,
                                                              GError** error);
static ValaExpression* vala_parser_parse_conditional_or_expression (ValaParser* self,
                                                             GError** error);
static ValaExpression* vala_parser_parse_coalescing_expression (ValaParser* self,
                                                         GError** error);
static ValaExpression* vala_parser_parse_conditional_expression (ValaParser* self,
                                                          GError** error);
static ValaParameter* vala_parser_parse_lambda_parameter (ValaParser* self,
                                                   GError** error);
static ValaExpression* vala_parser_parse_lambda_expression (ValaParser* self,
                                                     GError** error);
static ValaBlock* vala_parser_parse_block (ValaParser* self,
                                    GError** error);
static ValaAssignmentOperator vala_parser_get_assignment_operator (ValaParser* self,
                                                            ValaTokenType token_type);
static gboolean vala_parser_is_lambda_expression (ValaParser* self);
static void vala_parser_parse_statements (ValaParser* self,
                                   ValaBlock* block,
                                   GError** error);
static ValaStatement* vala_parser_parse_empty_statement (ValaParser* self,
                                                  GError** error);
static ValaStatement* vala_parser_parse_if_statement (ValaParser* self,
                                               GError** error);
static ValaStatement* vala_parser_parse_switch_statement (ValaParser* self,
                                                   GError** error);
static ValaStatement* vala_parser_parse_while_statement (ValaParser* self,
                                                  GError** error);
static ValaStatement* vala_parser_parse_do_statement (ValaParser* self,
                                               GError** error);
static ValaStatement* vala_parser_parse_for_statement (ValaParser* self,
                                                GError** error);
static ValaStatement* vala_parser_parse_foreach_statement (ValaParser* self,
                                                    GError** error);
static ValaStatement* vala_parser_parse_break_statement (ValaParser* self,
                                                  GError** error);
static ValaStatement* vala_parser_parse_continue_statement (ValaParser* self,
                                                     GError** error);
static ValaStatement* vala_parser_parse_return_statement (ValaParser* self,
                                                   GError** error);
static ValaStatement* vala_parser_parse_yield_statement (ValaParser* self,
                                                  GError** error);
static ValaStatement* vala_parser_parse_throw_statement (ValaParser* self,
                                                  GError** error);
static ValaStatement* vala_parser_parse_try_statement (ValaParser* self,
                                                GError** error);
static ValaStatement* vala_parser_parse_lock_statement (ValaParser* self,
                                                 GError** error);
static ValaStatement* vala_parser_parse_unlock_statement (ValaParser* self,
                                                   GError** error);
static ValaStatement* vala_parser_parse_delete_statement (ValaParser* self,
                                                   GError** error);
static void vala_parser_parse_local_variable_declarations (ValaParser* self,
                                                    ValaBlock* block,
                                                    GError** error);
static void vala_parser_parse_local_constant_declarations (ValaParser* self,
                                                    ValaBlock* block,
                                                    GError** error);
static ValaStatement* vala_parser_parse_expression_statement (ValaParser* self,
                                                       GError** error);
static gboolean vala_parser_is_expression (ValaParser* self,
                                    GError** error);
static ValaParserRecoveryState vala_parser_recover (ValaParser* self);
static ValaBlock* vala_parser_parse_embedded_statement (ValaParser* self,
                                                 const gchar* statement_name,
                                                 gboolean accept_empty_body,
                                                 GError** error);
static ValaStatement* vala_parser_parse_embedded_statement_without_block (ValaParser* self,
                                                                   const gchar* statement_name,
                                                                   gboolean accept_empty_body,
                                                                   GError** error);
static void _vala_array_add12 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static ValaLocalVariable* vala_parser_parse_local_variable (ValaParser* self,
                                                     ValaDataType* variable_type,
                                                     GError** error);
static ValaConstant* vala_parser_parse_local_constant (ValaParser* self,
                                                ValaDataType* constant_type,
                                                GError** error);
static ValaExpression* vala_parser_parse_statement_expression (ValaParser* self,
                                                        GError** error);
static void vala_parser_parse_catch_clauses (ValaParser* self,
                                      ValaList* catch_clauses,
                                      GError** error);
static ValaBlock* vala_parser_parse_finally_clause (ValaParser* self,
                                             GError** error);
static gchar* vala_parser_parse_attribute_value (ValaParser* self,
                                          GError** error);
static ValaList* vala_parser_parse_attributes (ValaParser* self,
                                        GError** error);
static void vala_parser_set_attributes (ValaParser* self,
                                 ValaCodeNode* node,
                                 ValaList* attributes);
static void vala_parser_parse_main_block (ValaParser* self,
                                   ValaSymbol* parent,
                                   GError** error);
static void vala_parser_parse_declaration (ValaParser* self,
                                    ValaSymbol* parent,
                                    gboolean root,
                                    GError** error);
static gboolean vala_parser_is_declaration_keyword (ValaParser* self,
                                             ValaTokenType type);
static void vala_parser_parse_constructor_declaration (ValaParser* self,
                                                ValaSymbol* parent,
                                                ValaList* attrs,
                                                GError** error);
static void vala_parser_parse_destructor_declaration (ValaParser* self,
                                               ValaSymbol* parent,
                                               ValaList* attrs,
                                               GError** error);
static void vala_parser_parse_class_declaration (ValaParser* self,
                                          ValaSymbol* parent,
                                          ValaList* attrs,
                                          GError** error);
static void vala_parser_parse_enum_declaration (ValaParser* self,
                                         ValaSymbol* parent,
                                         ValaList* attrs,
                                         GError** error);
static void vala_parser_parse_errordomain_declaration (ValaParser* self,
                                                ValaSymbol* parent,
                                                ValaList* attrs,
                                                GError** error);
static void vala_parser_parse_interface_declaration (ValaParser* self,
                                              ValaSymbol* parent,
                                              ValaList* attrs,
                                              GError** error);
static void vala_parser_parse_namespace_declaration (ValaParser* self,
                                              ValaSymbol* parent,
                                              ValaList* attrs,
                                              GError** error);
static void vala_parser_parse_struct_declaration (ValaParser* self,
                                           ValaSymbol* parent,
                                           ValaList* attrs,
                                           GError** error);
static void vala_parser_parse_creation_method_declaration (ValaParser* self,
                                                    ValaSymbol* parent,
                                                    ValaList* attrs,
                                                    GError** error);
static void vala_parser_parse_delegate_declaration (ValaParser* self,
                                             ValaSymbol* parent,
                                             ValaList* attrs,
                                             GError** error);
static void vala_parser_parse_signal_declaration (ValaParser* self,
                                           ValaSymbol* parent,
                                           ValaList* attrs,
                                           GError** error);
static void vala_parser_parse_method_declaration (ValaParser* self,
                                           ValaSymbol* parent,
                                           ValaList* attrs,
                                           GError** error);
static void vala_parser_parse_constant_declaration (ValaParser* self,
                                             ValaSymbol* parent,
                                             ValaList* attrs,
                                             GError** error);
static void vala_parser_parse_field_declaration (ValaParser* self,
                                          ValaSymbol* parent,
                                          ValaList* attrs,
                                          GError** error);
static void vala_parser_parse_property_declaration (ValaParser* self,
                                             ValaSymbol* parent,
                                             ValaList* attrs,
                                             GError** error);
static ValaSymbolAccessibility vala_parser_parse_access_modifier (ValaParser* self,
                                                           ValaSymbolAccessibility default_access);
static ValaParserModifierFlags vala_parser_parse_type_declaration_modifiers (ValaParser* self);
static ValaList* vala_parser_parse_type_parameter_list (ValaParser* self,
                                                 GError** error);
static ValaParserModifierFlags vala_parser_parse_member_declaration_modifiers (ValaParser* self);
static ValaParameter* vala_parser_parse_parameter (ValaParser* self,
                                            GError** error);
static void vala_parser_finalize (ValaCodeVisitor * obj);
static GType vala_parser_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
vala_parser_get_instance_private (ValaParser* self)
{
	return G_STRUCT_MEMBER_P (self, ValaParser_private_offset);
}

static GType
vala_parser_modifier_flags_get_type_once (void)
{
	static const GFlagsValue values[] = {{VALA_PARSER_MODIFIER_FLAGS_NONE, "VALA_PARSER_MODIFIER_FLAGS_NONE", "none"}, {VALA_PARSER_MODIFIER_FLAGS_ABSTRACT, "VALA_PARSER_MODIFIER_FLAGS_ABSTRACT", "abstract"}, {VALA_PARSER_MODIFIER_FLAGS_CLASS, "VALA_PARSER_MODIFIER_FLAGS_CLASS", "class"}, {VALA_PARSER_MODIFIER_FLAGS_EXTERN, "VALA_PARSER_MODIFIER_FLAGS_EXTERN", "extern"}, {VALA_PARSER_MODIFIER_FLAGS_INLINE, "VALA_PARSER_MODIFIER_FLAGS_INLINE", "inline"}, {VALA_PARSER_MODIFIER_FLAGS_NEW, "VALA_PARSER_MODIFIER_FLAGS_NEW", "new"}, {VALA_PARSER_MODIFIER_FLAGS_OVERRIDE, "VALA_PARSER_MODIFIER_FLAGS_OVERRIDE", "override"}, {VALA_PARSER_MODIFIER_FLAGS_STATIC, "VALA_PARSER_MODIFIER_FLAGS_STATIC", "static"}, {VALA_PARSER_MODIFIER_FLAGS_VIRTUAL, "VALA_PARSER_MODIFIER_FLAGS_VIRTUAL", "virtual"}, {VALA_PARSER_MODIFIER_FLAGS_ASYNC, "VALA_PARSER_MODIFIER_FLAGS_ASYNC", "async"}, {VALA_PARSER_MODIFIER_FLAGS_SEALED, "VALA_PARSER_MODIFIER_FLAGS_SEALED", "sealed"}, {0, NULL, NULL}};
	GType vala_parser_modifier_flags_type_id;
	vala_parser_modifier_flags_type_id = g_flags_register_static ("ValaParserModifierFlags", values);
	return vala_parser_modifier_flags_type_id;
}

static GType
vala_parser_modifier_flags_get_type (void)
{
	static volatile gsize vala_parser_modifier_flags_type_id__volatile = 0;
	if (g_once_init_enter (&vala_parser_modifier_flags_type_id__volatile)) {
		GType vala_parser_modifier_flags_type_id;
		vala_parser_modifier_flags_type_id = vala_parser_modifier_flags_get_type_once ();
		g_once_init_leave (&vala_parser_modifier_flags_type_id__volatile, vala_parser_modifier_flags_type_id);
	}
	return vala_parser_modifier_flags_type_id__volatile;
}

static GType
vala_parser_recovery_state_get_type_once (void)
{
	static const GEnumValue values[] = {{VALA_PARSER_RECOVERY_STATE_EOF, "VALA_PARSER_RECOVERY_STATE_EOF", "eof"}, {VALA_PARSER_RECOVERY_STATE_DECLARATION_BEGIN, "VALA_PARSER_RECOVERY_STATE_DECLARATION_BEGIN", "declaration-begin"}, {VALA_PARSER_RECOVERY_STATE_STATEMENT_BEGIN, "VALA_PARSER_RECOVERY_STATE_STATEMENT_BEGIN", "statement-begin"}, {0, NULL, NULL}};
	GType vala_parser_recovery_state_type_id;
	vala_parser_recovery_state_type_id = g_enum_register_static ("ValaParserRecoveryState", values);
	return vala_parser_recovery_state_type_id;
}

static GType
vala_parser_recovery_state_get_type (void)
{
	static volatile gsize vala_parser_recovery_state_type_id__volatile = 0;
	if (g_once_init_enter (&vala_parser_recovery_state_type_id__volatile)) {
		GType vala_parser_recovery_state_type_id;
		vala_parser_recovery_state_type_id = vala_parser_recovery_state_get_type_once ();
		g_once_init_leave (&vala_parser_recovery_state_type_id__volatile, vala_parser_recovery_state_type_id);
	}
	return vala_parser_recovery_state_type_id__volatile;
}

ValaParser*
vala_parser_construct (GType object_type)
{
	ValaParser* self = NULL;
	ValaParserTokenInfo* _tmp0_;
	self = (ValaParser*) vala_code_visitor_construct (object_type);
	_tmp0_ = g_new0 (ValaParserTokenInfo, VALA_PARSER_BUFFER_SIZE);
	self->priv->tokens = (g_free (self->priv->tokens), NULL);
	self->priv->tokens = _tmp0_;
	self->priv->tokens_length1 = VALA_PARSER_BUFFER_SIZE;
	self->priv->_tokens_size_ = self->priv->tokens_length1;
	return self;
}

ValaParser*
vala_parser_new (void)
{
	return vala_parser_construct (VALA_TYPE_PARSER);
}

/**
 * Parses all .vala and .vapi source files in the specified code
 * context and builds a code tree.
 *
 * @param context a code context
 */
static gpointer
_vala_code_context_ref0 (gpointer self)
{
	return self ? vala_code_context_ref (self) : NULL;
}

void
vala_parser_parse (ValaParser* self,
                   ValaCodeContext* context)
{
	ValaCodeContext* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = _vala_code_context_ref0 (context);
	_vala_code_context_unref0 (self->priv->context);
	self->priv->context = _tmp0_;
	vala_code_context_accept (context, (ValaCodeVisitor*) self);
	_vala_code_context_unref0 (self->priv->context);
	self->priv->context = NULL;
}

static void
vala_parser_real_visit_source_file (ValaCodeVisitor* base,
                                    ValaSourceFile* source_file)
{
	ValaParser * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	ValaCodeContext* _tmp3_;
	self = (ValaParser*) base;
	g_return_if_fail (source_file != NULL);
	_tmp3_ = self->priv->context;
	if (_tmp3_ != NULL) {
		ValaCodeContext* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = self->priv->context;
		_tmp5_ = vala_code_context_get_run_output (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp2_ = _tmp6_;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		_tmp7_ = vala_source_file_get_filename (source_file);
		_tmp8_ = _tmp7_;
		_tmp1_ = g_str_has_suffix (_tmp8_, ".vala");
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		_tmp9_ = vala_source_file_get_filename (source_file);
		_tmp10_ = _tmp9_;
		_tmp0_ = g_str_has_suffix (_tmp10_, ".vapi");
	}
	if (_tmp0_) {
		vala_parser_parse_file (self, source_file);
	}
}

static inline gboolean
vala_parser_next (ValaParser* self)
{
	gint _tmp0_;
	ValaParserTokenInfo* _tmp10_;
	gint _tmp10__length1;
	ValaParserTokenInfo _tmp11_;
	ValaTokenType _tmp12_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->index = (self->priv->index + 1) % VALA_PARSER_BUFFER_SIZE;
	_tmp0_ = self->priv->size;
	self->priv->size = _tmp0_ - 1;
	if (self->priv->size <= 0) {
		ValaSourceLocation begin = {0};
		ValaSourceLocation end = {0};
		ValaTokenType type = 0;
		ValaScanner* _tmp1_;
		ValaSourceLocation _tmp2_ = {0};
		ValaSourceLocation _tmp3_ = {0};
		ValaTokenType _tmp4_;
		ValaParserTokenInfo* _tmp5_;
		gint _tmp5__length1;
		ValaTokenType _tmp6_;
		ValaSourceLocation _tmp7_;
		ValaSourceLocation _tmp8_;
		ValaParserTokenInfo _tmp9_ = {0};
		_tmp1_ = self->priv->scanner;
		_tmp4_ = vala_scanner_read_token (_tmp1_, &_tmp2_, &_tmp3_);
		begin = _tmp2_;
		end = _tmp3_;
		type = _tmp4_;
		_tmp5_ = self->priv->tokens;
		_tmp5__length1 = self->priv->tokens_length1;
		_tmp6_ = type;
		_tmp7_ = begin;
		_tmp8_ = end;
		_tmp9_.type = _tmp6_;
		_tmp9_.begin = _tmp7_;
		_tmp9_.end = _tmp8_;
		_tmp5_[self->priv->index] = _tmp9_;
		self->priv->size = 1;
	}
	_tmp10_ = self->priv->tokens;
	_tmp10__length1 = self->priv->tokens_length1;
	_tmp11_ = _tmp10_[self->priv->index];
	_tmp12_ = _tmp11_.type;
	result = _tmp12_ != VALA_TOKEN_TYPE_EOF;
	return result;
}

static inline void
vala_parser_prev (ValaParser* self)
{
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->index = ((self->priv->index - 1) + VALA_PARSER_BUFFER_SIZE) % VALA_PARSER_BUFFER_SIZE;
	_tmp0_ = self->priv->size;
	self->priv->size = _tmp0_ + 1;
	_vala_assert (self->priv->size <= VALA_PARSER_BUFFER_SIZE, "size <= BUFFER_SIZE");
}

static inline void
vala_parser_safe_prev (ValaParser* self)
{
	g_return_if_fail (self != NULL);
	switch (vala_parser_previous (self)) {
		case VALA_TOKEN_TYPE_DOT:
		case VALA_TOKEN_TYPE_DOUBLE_COLON:
		{
			break;
		}
		default:
		{
			vala_parser_prev (self);
			break;
		}
	}
}

static inline ValaTokenType
vala_parser_current (ValaParser* self)
{
	ValaParserTokenInfo* _tmp0_;
	gint _tmp0__length1;
	ValaParserTokenInfo _tmp1_;
	ValaTokenType _tmp2_;
	ValaTokenType result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->tokens;
	_tmp0__length1 = self->priv->tokens_length1;
	_tmp1_ = _tmp0_[self->priv->index];
	_tmp2_ = _tmp1_.type;
	result = _tmp2_;
	return result;
}

static inline ValaTokenType
vala_parser_previous (ValaParser* self)
{
	ValaParserTokenInfo* _tmp0_;
	gint _tmp0__length1;
	ValaParserTokenInfo _tmp1_;
	ValaTokenType _tmp2_;
	ValaTokenType result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->tokens;
	_tmp0__length1 = self->priv->tokens_length1;
	_tmp1_ = _tmp0_[((self->priv->index - 1) + VALA_PARSER_BUFFER_SIZE) % VALA_PARSER_BUFFER_SIZE];
	_tmp2_ = _tmp1_.type;
	result = _tmp2_;
	return result;
}

static inline gboolean
vala_parser_accept (ValaParser* self,
                    ValaTokenType type)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (vala_parser_current (self) == type) {
		vala_parser_next (self);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static void
vala_parser_report_parse_error (ValaParser* self,
                                GError* e)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSourceLocation _tmp1_;
	ValaSourceReference* _tmp2_;
	ValaSourceReference* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	g_return_if_fail (self != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_next (self);
	_tmp1_ = begin;
	_tmp2_ = vala_parser_get_src (self, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = e->message;
	_tmp5_ = g_strconcat ("syntax error, ", _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	vala_report_error (_tmp3_, _tmp6_);
	_g_free0 (_tmp6_);
	_vala_source_reference_unref0 (_tmp3_);
}

static inline gboolean
vala_parser_expect (ValaParser* self,
                    ValaTokenType type,
                    GError** error)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (vala_parser_accept (self, type)) {
		result = TRUE;
		return result;
	}
	switch (type) {
		case VALA_TOKEN_TYPE_CLOSE_BRACE:
		{
			const gchar* _tmp0_;
			GError* _tmp1_;
			GError* _tmp2_;
			vala_parser_safe_prev (self);
			_tmp0_ = vala_token_type_to_string (type);
			_tmp1_ = g_error_new (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "following block delimiter %s missing", _tmp0_);
			_tmp2_ = _tmp1_;
			vala_parser_report_parse_error (self, _tmp2_);
			_g_error_free0 (_tmp2_);
			result = TRUE;
			return result;
		}
		case VALA_TOKEN_TYPE_CLOSE_BRACKET:
		case VALA_TOKEN_TYPE_CLOSE_PARENS:
		case VALA_TOKEN_TYPE_SEMICOLON:
		{
			const gchar* _tmp3_;
			GError* _tmp4_;
			GError* _tmp5_;
			vala_parser_safe_prev (self);
			_tmp3_ = vala_token_type_to_string (type);
			_tmp4_ = g_error_new (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "following expression/statement delimiter %s missing", _tmp3_);
			_tmp5_ = _tmp4_;
			vala_parser_report_parse_error (self, _tmp5_);
			_g_error_free0 (_tmp5_);
			result = TRUE;
			return result;
		}
		default:
		{
			const gchar* _tmp6_;
			GError* _tmp7_;
			_tmp6_ = vala_token_type_to_string (type);
			_tmp7_ = g_error_new (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "expected %s", _tmp6_);
			_inner_error0_ = _tmp7_;
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				gboolean _tmp8_ = FALSE;
				g_propagate_error (error, _inner_error0_);
				return _tmp8_;
			} else {
				gboolean _tmp9_ = FALSE;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp9_;
			}
		}
	}
}

static inline void
vala_parser_get_location (ValaParser* self,
                          ValaSourceLocation* result)
{
	ValaParserTokenInfo* _tmp0_;
	gint _tmp0__length1;
	ValaParserTokenInfo _tmp1_;
	ValaSourceLocation _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->tokens;
	_tmp0__length1 = self->priv->tokens_length1;
	_tmp1_ = _tmp0_[self->priv->index];
	_tmp2_ = _tmp1_.begin;
	*result = _tmp2_;
	return;
}

static gchar*
vala_parser_get_location_string (ValaParser* self)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSourceLocation _tmp1_;
	ValaSourceLocation _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = begin;
	_tmp2_ = begin;
	_tmp3_ = g_strdup_printf ("__VALA_L%d_C%d__", _tmp1_.line, _tmp2_.column);
	result = _tmp3_;
	return result;
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

static gchar*
vala_parser_get_current_string (ValaParser* self)
{
	ValaParserTokenInfo token = {0};
	ValaParserTokenInfo* _tmp0_;
	gint _tmp0__length1;
	ValaParserTokenInfo _tmp1_;
	ValaParserTokenInfo _tmp2_;
	ValaSourceLocation _tmp3_;
	gchar* _tmp4_;
	ValaParserTokenInfo _tmp5_;
	ValaSourceLocation _tmp6_;
	gchar* _tmp7_;
	ValaParserTokenInfo _tmp8_;
	ValaSourceLocation _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->tokens;
	_tmp0__length1 = self->priv->tokens_length1;
	_tmp1_ = _tmp0_[self->priv->index];
	token = _tmp1_;
	_tmp2_ = token;
	_tmp3_ = _tmp2_.begin;
	_tmp4_ = _tmp3_.pos;
	_tmp5_ = token;
	_tmp6_ = _tmp5_.end;
	_tmp7_ = _tmp6_.pos;
	_tmp8_ = token;
	_tmp9_ = _tmp8_.begin;
	_tmp10_ = _tmp9_.pos;
	_tmp11_ = string_substring ((const gchar*) _tmp4_, (glong) 0, (glong) ((gint) (_tmp7_ - _tmp10_)));
	result = _tmp11_;
	return result;
}

static gchar*
vala_parser_get_last_string (ValaParser* self)
{
	gint last_index = 0;
	ValaParserTokenInfo token = {0};
	ValaParserTokenInfo* _tmp0_;
	gint _tmp0__length1;
	ValaParserTokenInfo _tmp1_;
	ValaParserTokenInfo _tmp2_;
	ValaSourceLocation _tmp3_;
	gchar* _tmp4_;
	ValaParserTokenInfo _tmp5_;
	ValaSourceLocation _tmp6_;
	gchar* _tmp7_;
	ValaParserTokenInfo _tmp8_;
	ValaSourceLocation _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	last_index = ((self->priv->index + VALA_PARSER_BUFFER_SIZE) - 1) % VALA_PARSER_BUFFER_SIZE;
	_tmp0_ = self->priv->tokens;
	_tmp0__length1 = self->priv->tokens_length1;
	_tmp1_ = _tmp0_[last_index];
	token = _tmp1_;
	_tmp2_ = token;
	_tmp3_ = _tmp2_.begin;
	_tmp4_ = _tmp3_.pos;
	_tmp5_ = token;
	_tmp6_ = _tmp5_.end;
	_tmp7_ = _tmp6_.pos;
	_tmp8_ = token;
	_tmp9_ = _tmp8_.begin;
	_tmp10_ = _tmp9_.pos;
	_tmp11_ = string_substring ((const gchar*) _tmp4_, (glong) 0, (glong) ((gint) (_tmp7_ - _tmp10_)));
	result = _tmp11_;
	return result;
}

static ValaSourceReference*
vala_parser_get_src (ValaParser* self,
                     ValaSourceLocation* begin)
{
	gint last_index = 0;
	ValaScanner* _tmp0_;
	ValaSourceFile* _tmp1_;
	ValaSourceFile* _tmp2_;
	ValaSourceLocation _tmp3_;
	ValaParserTokenInfo* _tmp4_;
	gint _tmp4__length1;
	ValaParserTokenInfo _tmp5_;
	ValaSourceLocation _tmp6_;
	ValaSourceReference* _tmp7_;
	ValaSourceReference* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (begin != NULL, NULL);
	last_index = ((self->priv->index + VALA_PARSER_BUFFER_SIZE) - 1) % VALA_PARSER_BUFFER_SIZE;
	_tmp0_ = self->priv->scanner;
	_tmp1_ = vala_scanner_get_source_file (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = *begin;
	_tmp4_ = self->priv->tokens;
	_tmp4__length1 = self->priv->tokens_length1;
	_tmp5_ = _tmp4_[last_index];
	_tmp6_ = _tmp5_.end;
	_tmp7_ = vala_source_reference_new (_tmp2_, &_tmp3_, &_tmp6_);
	result = _tmp7_;
	return result;
}

static ValaSourceReference*
vala_parser_get_current_src (ValaParser* self)
{
	ValaParserTokenInfo token = {0};
	ValaParserTokenInfo* _tmp0_;
	gint _tmp0__length1;
	ValaParserTokenInfo _tmp1_;
	ValaScanner* _tmp2_;
	ValaSourceFile* _tmp3_;
	ValaSourceFile* _tmp4_;
	ValaParserTokenInfo _tmp5_;
	ValaSourceLocation _tmp6_;
	ValaParserTokenInfo _tmp7_;
	ValaSourceLocation _tmp8_;
	ValaSourceReference* _tmp9_;
	ValaSourceReference* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->tokens;
	_tmp0__length1 = self->priv->tokens_length1;
	_tmp1_ = _tmp0_[self->priv->index];
	token = _tmp1_;
	_tmp2_ = self->priv->scanner;
	_tmp3_ = vala_scanner_get_source_file (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = token;
	_tmp6_ = _tmp5_.begin;
	_tmp7_ = token;
	_tmp8_ = _tmp7_.end;
	_tmp9_ = vala_source_reference_new (_tmp4_, &_tmp6_, &_tmp8_);
	result = _tmp9_;
	return result;
}

static ValaSourceReference*
vala_parser_get_last_src (ValaParser* self)
{
	gint last_index = 0;
	ValaParserTokenInfo token = {0};
	ValaParserTokenInfo* _tmp0_;
	gint _tmp0__length1;
	ValaParserTokenInfo _tmp1_;
	ValaScanner* _tmp2_;
	ValaSourceFile* _tmp3_;
	ValaSourceFile* _tmp4_;
	ValaParserTokenInfo _tmp5_;
	ValaSourceLocation _tmp6_;
	ValaParserTokenInfo _tmp7_;
	ValaSourceLocation _tmp8_;
	ValaSourceReference* _tmp9_;
	ValaSourceReference* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	last_index = ((self->priv->index + VALA_PARSER_BUFFER_SIZE) - 1) % VALA_PARSER_BUFFER_SIZE;
	_tmp0_ = self->priv->tokens;
	_tmp0__length1 = self->priv->tokens_length1;
	_tmp1_ = _tmp0_[last_index];
	token = _tmp1_;
	_tmp2_ = self->priv->scanner;
	_tmp3_ = vala_scanner_get_source_file (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = token;
	_tmp6_ = _tmp5_.begin;
	_tmp7_ = token;
	_tmp8_ = _tmp7_.end;
	_tmp9_ = vala_source_reference_new (_tmp4_, &_tmp6_, &_tmp8_);
	result = _tmp9_;
	return result;
}

static void
vala_parser_rollback (ValaParser* self,
                      ValaSourceLocation* location)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (location != NULL);
	while (TRUE) {
		ValaParserTokenInfo* _tmp0_;
		gint _tmp0__length1;
		ValaParserTokenInfo _tmp1_;
		ValaSourceLocation _tmp2_;
		gchar* _tmp3_;
		ValaSourceLocation _tmp4_;
		gchar* _tmp5_;
		gint _tmp6_;
		_tmp0_ = self->priv->tokens;
		_tmp0__length1 = self->priv->tokens_length1;
		_tmp1_ = _tmp0_[self->priv->index];
		_tmp2_ = _tmp1_.begin;
		_tmp3_ = _tmp2_.pos;
		_tmp4_ = *location;
		_tmp5_ = _tmp4_.pos;
		if (!(_tmp3_ != _tmp5_)) {
			break;
		}
		self->priv->index = ((self->priv->index - 1) + VALA_PARSER_BUFFER_SIZE) % VALA_PARSER_BUFFER_SIZE;
		_tmp6_ = self->priv->size;
		self->priv->size = _tmp6_ + 1;
		if (self->priv->size > VALA_PARSER_BUFFER_SIZE) {
			ValaScanner* _tmp7_;
			ValaSourceLocation _tmp8_;
			_tmp7_ = self->priv->scanner;
			_tmp8_ = *location;
			vala_scanner_seek (_tmp7_, &_tmp8_);
			self->priv->size = 0;
			self->priv->index = 0;
			vala_parser_next (self);
		}
	}
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static void
vala_parser_skip_identifier (ValaParser* self,
                             GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	switch (vala_parser_current (self)) {
		case VALA_TOKEN_TYPE_ABSTRACT:
		case VALA_TOKEN_TYPE_AS:
		case VALA_TOKEN_TYPE_ASYNC:
		case VALA_TOKEN_TYPE_BASE:
		case VALA_TOKEN_TYPE_BREAK:
		case VALA_TOKEN_TYPE_CASE:
		case VALA_TOKEN_TYPE_CATCH:
		case VALA_TOKEN_TYPE_CLASS:
		case VALA_TOKEN_TYPE_CONST:
		case VALA_TOKEN_TYPE_CONSTRUCT:
		case VALA_TOKEN_TYPE_CONTINUE:
		case VALA_TOKEN_TYPE_DEFAULT:
		case VALA_TOKEN_TYPE_DELEGATE:
		case VALA_TOKEN_TYPE_DELETE:
		case VALA_TOKEN_TYPE_DO:
		case VALA_TOKEN_TYPE_DYNAMIC:
		case VALA_TOKEN_TYPE_ELSE:
		case VALA_TOKEN_TYPE_ENUM:
		case VALA_TOKEN_TYPE_ENSURES:
		case VALA_TOKEN_TYPE_ERRORDOMAIN:
		case VALA_TOKEN_TYPE_EXTERN:
		case VALA_TOKEN_TYPE_FALSE:
		case VALA_TOKEN_TYPE_FINALLY:
		case VALA_TOKEN_TYPE_FOR:
		case VALA_TOKEN_TYPE_FOREACH:
		case VALA_TOKEN_TYPE_GET:
		case VALA_TOKEN_TYPE_IDENTIFIER:
		case VALA_TOKEN_TYPE_IF:
		case VALA_TOKEN_TYPE_IN:
		case VALA_TOKEN_TYPE_INLINE:
		case VALA_TOKEN_TYPE_INTERFACE:
		case VALA_TOKEN_TYPE_INTERNAL:
		case VALA_TOKEN_TYPE_IS:
		case VALA_TOKEN_TYPE_LOCK:
		case VALA_TOKEN_TYPE_NAMESPACE:
		case VALA_TOKEN_TYPE_NEW:
		case VALA_TOKEN_TYPE_NULL:
		case VALA_TOKEN_TYPE_OUT:
		case VALA_TOKEN_TYPE_OVERRIDE:
		case VALA_TOKEN_TYPE_OWNED:
		case VALA_TOKEN_TYPE_PARAMS:
		case VALA_TOKEN_TYPE_PRIVATE:
		case VALA_TOKEN_TYPE_PROTECTED:
		case VALA_TOKEN_TYPE_PUBLIC:
		case VALA_TOKEN_TYPE_REF:
		case VALA_TOKEN_TYPE_REQUIRES:
		case VALA_TOKEN_TYPE_RETURN:
		case VALA_TOKEN_TYPE_SEALED:
		case VALA_TOKEN_TYPE_SET:
		case VALA_TOKEN_TYPE_SIGNAL:
		case VALA_TOKEN_TYPE_SIZEOF:
		case VALA_TOKEN_TYPE_STATIC:
		case VALA_TOKEN_TYPE_STRUCT:
		case VALA_TOKEN_TYPE_SWITCH:
		case VALA_TOKEN_TYPE_THIS:
		case VALA_TOKEN_TYPE_THROW:
		case VALA_TOKEN_TYPE_THROWS:
		case VALA_TOKEN_TYPE_TRUE:
		case VALA_TOKEN_TYPE_TRY:
		case VALA_TOKEN_TYPE_TYPEOF:
		case VALA_TOKEN_TYPE_UNLOCK:
		case VALA_TOKEN_TYPE_UNOWNED:
		case VALA_TOKEN_TYPE_USING:
		case VALA_TOKEN_TYPE_VAR:
		case VALA_TOKEN_TYPE_VIRTUAL:
		case VALA_TOKEN_TYPE_VOID:
		case VALA_TOKEN_TYPE_VOLATILE:
		case VALA_TOKEN_TYPE_WEAK:
		case VALA_TOKEN_TYPE_WHILE:
		case VALA_TOKEN_TYPE_YIELD:
		{
			vala_parser_next (self);
			return;
		}
		case VALA_TOKEN_TYPE_INTEGER_LITERAL:
		case VALA_TOKEN_TYPE_REAL_LITERAL:
		{
			gchar* id = NULL;
			gchar* _tmp0_;
			gboolean _tmp1_ = FALSE;
			const gchar* _tmp2_;
			const gchar* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			_tmp0_ = vala_parser_get_current_string (self);
			id = _tmp0_;
			_tmp2_ = id;
			_tmp3_ = id;
			_tmp4_ = strlen (_tmp3_);
			_tmp5_ = _tmp4_;
			if (g_ascii_isalpha (string_get (_tmp2_, (glong) (_tmp5_ - 1)))) {
				const gchar* _tmp6_;
				_tmp6_ = id;
				_tmp1_ = !string_contains (_tmp6_, ".");
			} else {
				_tmp1_ = FALSE;
			}
			if (_tmp1_) {
				vala_parser_next (self);
				_g_free0 (id);
				return;
			}
			_g_free0 (id);
			break;
		}
		default:
		{
			GError* _tmp7_;
			_tmp7_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "expected identifier");
			_inner_error0_ = _tmp7_;
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
}

static gpointer
_g_error_copy0 (gpointer self)
{
	return self ? g_error_copy (self) : NULL;
}

static gchar*
vala_parser_parse_identifier (ValaParser* self,
                              GError** error)
{
	gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		vala_parser_skip_identifier (self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				goto __catch0_vala_parse_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	goto __finally0;
	__catch0_vala_parse_error:
	{
		GError* e = NULL;
		ValaCodeContext* _tmp0_;
		gboolean _tmp1_;
		gboolean _tmp2_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = self->priv->context;
		_tmp1_ = vala_code_context_get_keep_going (_tmp0_);
		_tmp2_ = _tmp1_;
		if (_tmp2_) {
			GError* _tmp3_;
			gchar* _tmp4_;
			_tmp3_ = e;
			vala_parser_report_parse_error (self, _tmp3_);
			vala_parser_prev (self);
			_tmp4_ = vala_parser_get_location_string (self);
			result = _tmp4_;
			_g_error_free0 (e);
			return result;
		} else {
			GError* _tmp5_;
			GError* _tmp6_;
			_tmp5_ = e;
			_tmp6_ = _g_error_copy0 (_tmp5_);
			_inner_error0_ = _tmp6_;
			_g_error_free0 (e);
			goto __finally0;
		}
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp7_ = vala_parser_get_last_string (self);
	result = _tmp7_;
	return result;
}

static ValaExpression*
vala_parser_parse_literal (ValaParser* self,
                           GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	switch (vala_parser_current (self)) {
		case VALA_TOKEN_TYPE_TRUE:
		{
			ValaSourceLocation _tmp1_;
			ValaSourceReference* _tmp2_;
			ValaSourceReference* _tmp3_;
			ValaBooleanLiteral* _tmp4_;
			ValaExpression* _tmp5_;
			vala_parser_next (self);
			_tmp1_ = begin;
			_tmp2_ = vala_parser_get_src (self, &_tmp1_);
			_tmp3_ = _tmp2_;
			_tmp4_ = vala_boolean_literal_new (TRUE, _tmp3_);
			_tmp5_ = (ValaExpression*) _tmp4_;
			_vala_source_reference_unref0 (_tmp3_);
			result = _tmp5_;
			return result;
		}
		case VALA_TOKEN_TYPE_FALSE:
		{
			ValaSourceLocation _tmp6_;
			ValaSourceReference* _tmp7_;
			ValaSourceReference* _tmp8_;
			ValaBooleanLiteral* _tmp9_;
			ValaExpression* _tmp10_;
			vala_parser_next (self);
			_tmp6_ = begin;
			_tmp7_ = vala_parser_get_src (self, &_tmp6_);
			_tmp8_ = _tmp7_;
			_tmp9_ = vala_boolean_literal_new (FALSE, _tmp8_);
			_tmp10_ = (ValaExpression*) _tmp9_;
			_vala_source_reference_unref0 (_tmp8_);
			result = _tmp10_;
			return result;
		}
		case VALA_TOKEN_TYPE_INTEGER_LITERAL:
		{
			gchar* _tmp11_;
			gchar* _tmp12_;
			ValaSourceLocation _tmp13_;
			ValaSourceReference* _tmp14_;
			ValaSourceReference* _tmp15_;
			ValaIntegerLiteral* _tmp16_;
			ValaExpression* _tmp17_;
			vala_parser_next (self);
			_tmp11_ = vala_parser_get_last_string (self);
			_tmp12_ = _tmp11_;
			_tmp13_ = begin;
			_tmp14_ = vala_parser_get_src (self, &_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = vala_integer_literal_new (_tmp12_, _tmp15_);
			_tmp17_ = (ValaExpression*) _tmp16_;
			_vala_source_reference_unref0 (_tmp15_);
			_g_free0 (_tmp12_);
			result = _tmp17_;
			return result;
		}
		case VALA_TOKEN_TYPE_REAL_LITERAL:
		{
			gchar* _tmp18_;
			gchar* _tmp19_;
			ValaSourceLocation _tmp20_;
			ValaSourceReference* _tmp21_;
			ValaSourceReference* _tmp22_;
			ValaRealLiteral* _tmp23_;
			ValaExpression* _tmp24_;
			vala_parser_next (self);
			_tmp18_ = vala_parser_get_last_string (self);
			_tmp19_ = _tmp18_;
			_tmp20_ = begin;
			_tmp21_ = vala_parser_get_src (self, &_tmp20_);
			_tmp22_ = _tmp21_;
			_tmp23_ = vala_real_literal_new (_tmp19_, _tmp22_);
			_tmp24_ = (ValaExpression*) _tmp23_;
			_vala_source_reference_unref0 (_tmp22_);
			_g_free0 (_tmp19_);
			result = _tmp24_;
			return result;
		}
		case VALA_TOKEN_TYPE_CHARACTER_LITERAL:
		{
			ValaCharacterLiteral* lit = NULL;
			gchar* _tmp25_;
			gchar* _tmp26_;
			ValaSourceLocation _tmp27_;
			ValaSourceReference* _tmp28_;
			ValaSourceReference* _tmp29_;
			ValaCharacterLiteral* _tmp30_;
			ValaCharacterLiteral* _tmp31_;
			ValaCharacterLiteral* _tmp32_;
			gboolean _tmp33_;
			gboolean _tmp34_;
			vala_parser_next (self);
			_tmp25_ = vala_parser_get_last_string (self);
			_tmp26_ = _tmp25_;
			_tmp27_ = begin;
			_tmp28_ = vala_parser_get_src (self, &_tmp27_);
			_tmp29_ = _tmp28_;
			_tmp30_ = vala_character_literal_new (_tmp26_, _tmp29_);
			_tmp31_ = _tmp30_;
			_vala_source_reference_unref0 (_tmp29_);
			_g_free0 (_tmp26_);
			lit = _tmp31_;
			_tmp32_ = lit;
			_tmp33_ = vala_code_node_get_error ((ValaCodeNode*) _tmp32_);
			_tmp34_ = _tmp33_;
			if (_tmp34_) {
				ValaCharacterLiteral* _tmp35_;
				ValaSourceReference* _tmp36_;
				ValaSourceReference* _tmp37_;
				_tmp35_ = lit;
				_tmp36_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp35_);
				_tmp37_ = _tmp36_;
				vala_report_error (_tmp37_, "invalid character literal");
			}
			result = (ValaExpression*) lit;
			return result;
		}
		case VALA_TOKEN_TYPE_REGEX_LITERAL:
		{
			gchar* match_part = NULL;
			gchar* _tmp38_;
			ValaSourceReference* src_begin = NULL;
			ValaSourceLocation _tmp39_;
			ValaSourceReference* _tmp40_;
			gchar* close_token = NULL;
			gchar* _tmp41_;
			const gchar* _tmp42_;
			const gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			ValaSourceReference* _tmp46_;
			ValaRegexLiteral* _tmp47_;
			ValaExpression* _tmp48_;
			vala_parser_next (self);
			_tmp38_ = vala_parser_get_last_string (self);
			match_part = _tmp38_;
			_tmp39_ = begin;
			_tmp40_ = vala_parser_get_src (self, &_tmp39_);
			src_begin = _tmp40_;
			vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_REGEX_LITERAL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_source_reference_unref0 (src_begin);
					_g_free0 (match_part);
					return NULL;
				} else {
					_vala_source_reference_unref0 (src_begin);
					_g_free0 (match_part);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp41_ = vala_parser_get_last_string (self);
			close_token = _tmp41_;
			_tmp42_ = close_token;
			_tmp43_ = match_part;
			_tmp44_ = g_strdup_printf ("%s/%s", _tmp42_, _tmp43_);
			_tmp45_ = _tmp44_;
			_tmp46_ = src_begin;
			_tmp47_ = vala_regex_literal_new (_tmp45_, _tmp46_);
			_tmp48_ = (ValaExpression*) _tmp47_;
			_g_free0 (_tmp45_);
			result = _tmp48_;
			_g_free0 (close_token);
			_vala_source_reference_unref0 (src_begin);
			_g_free0 (match_part);
			return result;
		}
		case VALA_TOKEN_TYPE_STRING_LITERAL:
		{
			gchar* _tmp49_;
			gchar* _tmp50_;
			ValaSourceLocation _tmp51_;
			ValaSourceReference* _tmp52_;
			ValaSourceReference* _tmp53_;
			ValaStringLiteral* _tmp54_;
			ValaExpression* _tmp55_;
			vala_parser_next (self);
			_tmp49_ = vala_parser_get_last_string (self);
			_tmp50_ = _tmp49_;
			_tmp51_ = begin;
			_tmp52_ = vala_parser_get_src (self, &_tmp51_);
			_tmp53_ = _tmp52_;
			_tmp54_ = vala_string_literal_new (_tmp50_, _tmp53_);
			_tmp55_ = (ValaExpression*) _tmp54_;
			_vala_source_reference_unref0 (_tmp53_);
			_g_free0 (_tmp50_);
			result = _tmp55_;
			return result;
		}
		case VALA_TOKEN_TYPE_TEMPLATE_STRING_LITERAL:
		{
			gchar* _tmp56_;
			gchar* _tmp57_;
			gchar* _tmp58_;
			gchar* _tmp59_;
			ValaSourceLocation _tmp60_;
			ValaSourceReference* _tmp61_;
			ValaSourceReference* _tmp62_;
			ValaStringLiteral* _tmp63_;
			ValaExpression* _tmp64_;
			vala_parser_next (self);
			_tmp56_ = vala_parser_get_last_string (self);
			_tmp57_ = _tmp56_;
			_tmp58_ = g_strdup_printf ("\"%s\"", _tmp57_);
			_tmp59_ = _tmp58_;
			_tmp60_ = begin;
			_tmp61_ = vala_parser_get_src (self, &_tmp60_);
			_tmp62_ = _tmp61_;
			_tmp63_ = vala_string_literal_new (_tmp59_, _tmp62_);
			_tmp64_ = (ValaExpression*) _tmp63_;
			_vala_source_reference_unref0 (_tmp62_);
			_g_free0 (_tmp59_);
			_g_free0 (_tmp57_);
			result = _tmp64_;
			return result;
		}
		case VALA_TOKEN_TYPE_VERBATIM_STRING_LITERAL:
		{
			gchar* raw_string = NULL;
			gchar* _tmp65_;
			gchar* escaped_string = NULL;
			const gchar* _tmp66_;
			const gchar* _tmp67_;
			gint _tmp68_;
			gint _tmp69_;
			gchar* _tmp70_;
			gchar* _tmp71_;
			gchar* _tmp72_;
			gchar* _tmp73_;
			const gchar* _tmp74_;
			gchar* _tmp75_;
			gchar* _tmp76_;
			ValaSourceLocation _tmp77_;
			ValaSourceReference* _tmp78_;
			ValaSourceReference* _tmp79_;
			ValaStringLiteral* _tmp80_;
			ValaExpression* _tmp81_;
			vala_parser_next (self);
			_tmp65_ = vala_parser_get_last_string (self);
			raw_string = _tmp65_;
			_tmp66_ = raw_string;
			_tmp67_ = raw_string;
			_tmp68_ = strlen (_tmp67_);
			_tmp69_ = _tmp68_;
			_tmp70_ = string_substring (_tmp66_, (glong) 3, (glong) (_tmp69_ - 6));
			_tmp71_ = _tmp70_;
			_tmp72_ = g_strescape (_tmp71_, "");
			_tmp73_ = _tmp72_;
			_g_free0 (_tmp71_);
			escaped_string = _tmp73_;
			_tmp74_ = escaped_string;
			_tmp75_ = g_strdup_printf ("\"%s\"", _tmp74_);
			_tmp76_ = _tmp75_;
			_tmp77_ = begin;
			_tmp78_ = vala_parser_get_src (self, &_tmp77_);
			_tmp79_ = _tmp78_;
			_tmp80_ = vala_string_literal_new (_tmp76_, _tmp79_);
			_tmp81_ = (ValaExpression*) _tmp80_;
			_vala_source_reference_unref0 (_tmp79_);
			_g_free0 (_tmp76_);
			result = _tmp81_;
			_g_free0 (escaped_string);
			_g_free0 (raw_string);
			return result;
		}
		case VALA_TOKEN_TYPE_NULL:
		{
			ValaSourceLocation _tmp82_;
			ValaSourceReference* _tmp83_;
			ValaSourceReference* _tmp84_;
			ValaNullLiteral* _tmp85_;
			ValaExpression* _tmp86_;
			vala_parser_next (self);
			_tmp82_ = begin;
			_tmp83_ = vala_parser_get_src (self, &_tmp82_);
			_tmp84_ = _tmp83_;
			_tmp85_ = vala_null_literal_new (_tmp84_);
			_tmp86_ = (ValaExpression*) _tmp85_;
			_vala_source_reference_unref0 (_tmp84_);
			result = _tmp86_;
			return result;
		}
		default:
		{
			GError* _tmp87_;
			_tmp87_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "expected literal");
			_inner_error0_ = _tmp87_;
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
}

void
vala_parser_parse_file (ValaParser* self,
                        ValaSourceFile* source_file)
{
	gboolean has_global_context = FALSE;
	ValaCodeContext* _tmp0_;
	ValaScanner* _tmp4_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source_file != NULL);
	_tmp0_ = self->priv->context;
	has_global_context = _tmp0_ != NULL;
	if (!has_global_context) {
		ValaCodeContext* _tmp1_;
		ValaCodeContext* _tmp2_;
		ValaCodeContext* _tmp3_;
		_tmp1_ = vala_source_file_get_context (source_file);
		_tmp2_ = _tmp1_;
		_tmp3_ = _vala_code_context_ref0 (_tmp2_);
		_vala_code_context_unref0 (self->priv->context);
		self->priv->context = _tmp3_;
	}
	_tmp4_ = vala_scanner_new (source_file);
	_vala_scanner_unref0 (self->priv->scanner);
	self->priv->scanner = _tmp4_;
	vala_parser_parse_file_comments (self);
	self->priv->index = -1;
	self->priv->size = 0;
	vala_parser_next (self);
	{
		ValaCodeContext* _tmp5_;
		ValaNamespace* _tmp6_;
		ValaNamespace* _tmp7_;
		ValaCodeContext* _tmp8_;
		ValaNamespace* _tmp9_;
		ValaNamespace* _tmp10_;
		_tmp5_ = self->priv->context;
		_tmp6_ = vala_code_context_get_root (_tmp5_);
		_tmp7_ = _tmp6_;
		vala_parser_parse_using_directives (self, _tmp7_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				goto __catch0_vala_parse_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp8_ = self->priv->context;
		_tmp9_ = vala_code_context_get_root (_tmp8_);
		_tmp10_ = _tmp9_;
		vala_parser_parse_declarations (self, (ValaSymbol*) _tmp10_, TRUE, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				goto __catch0_vala_parse_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		if (vala_parser_accept (self, VALA_TOKEN_TYPE_CLOSE_BRACE)) {
			ValaCodeContext* _tmp11_;
			ValaReport* _tmp12_;
			ValaReport* _tmp13_;
			_tmp11_ = self->priv->context;
			_tmp12_ = vala_code_context_get_report (_tmp11_);
			_tmp13_ = _tmp12_;
			if (vala_report_get_errors (_tmp13_) == 0) {
				ValaSourceReference* _tmp14_;
				ValaSourceReference* _tmp15_;
				_tmp14_ = vala_parser_get_last_src (self);
				_tmp15_ = _tmp14_;
				vala_report_error (_tmp15_, "unexpected `}'");
				_vala_source_reference_unref0 (_tmp15_);
			}
		}
	}
	goto __finally0;
	__catch0_vala_parse_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp16_ = e;
		vala_parser_report_parse_error (self, _tmp16_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_vala_scanner_unref0 (self->priv->scanner);
	self->priv->scanner = NULL;
	if (!has_global_context) {
		_vala_code_context_unref0 (self->priv->context);
		self->priv->context = NULL;
	}
}

static void
vala_parser_parse_file_comments (ValaParser* self)
{
	ValaScanner* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->scanner;
	vala_scanner_parse_file_comments (_tmp0_);
}

static void
vala_parser_skip_symbol_name (ValaParser* self,
                              GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			if (!_tmp0_) {
				gboolean _tmp1_ = FALSE;
				if (vala_parser_accept (self, VALA_TOKEN_TYPE_DOT)) {
					_tmp1_ = TRUE;
				} else {
					_tmp1_ = vala_parser_accept (self, VALA_TOKEN_TYPE_DOUBLE_COLON);
				}
				if (!_tmp1_) {
					break;
				}
			}
			_tmp0_ = FALSE;
			vala_parser_skip_identifier (self, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
		}
	}
}

static ValaUnresolvedSymbol*
vala_parser_parse_symbol_name (ValaParser* self,
                               GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaUnresolvedSymbol* sym = NULL;
	GError* _inner_error0_ = NULL;
	ValaUnresolvedSymbol* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	sym = NULL;
	{
		gboolean _tmp1_ = FALSE;
		_tmp1_ = TRUE;
		while (TRUE) {
			gchar* name = NULL;
			gchar* _tmp2_;
			gboolean _tmp3_ = FALSE;
			const gchar* _tmp4_;
			ValaUnresolvedSymbol* _tmp15_;
			const gchar* _tmp16_;
			ValaSourceLocation _tmp17_;
			ValaSourceReference* _tmp18_;
			ValaSourceReference* _tmp19_;
			ValaUnresolvedSymbol* _tmp20_;
			if (!_tmp1_) {
				if (!vala_parser_accept (self, VALA_TOKEN_TYPE_DOT)) {
					break;
				}
			}
			_tmp1_ = FALSE;
			_tmp2_ = vala_parser_parse_identifier (self, &_inner_error0_);
			name = _tmp2_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (sym);
					return NULL;
				} else {
					_vala_code_node_unref0 (sym);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp4_ = name;
			if (g_strcmp0 (_tmp4_, "global") == 0) {
				_tmp3_ = vala_parser_accept (self, VALA_TOKEN_TYPE_DOUBLE_COLON);
			} else {
				_tmp3_ = FALSE;
			}
			if (_tmp3_) {
				gchar* _tmp5_ = NULL;
				gchar* _tmp6_;
				gchar* _tmp7_;
				ValaUnresolvedSymbol* _tmp8_;
				const gchar* _tmp9_;
				ValaSourceLocation _tmp10_;
				ValaSourceReference* _tmp11_;
				ValaSourceReference* _tmp12_;
				ValaUnresolvedSymbol* _tmp13_;
				ValaUnresolvedSymbol* _tmp14_;
				_tmp6_ = vala_parser_parse_identifier (self, &_inner_error0_);
				_tmp5_ = _tmp6_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_g_free0 (name);
						_vala_code_node_unref0 (sym);
						return NULL;
					} else {
						_g_free0 (name);
						_vala_code_node_unref0 (sym);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp7_ = _tmp5_;
				_tmp5_ = NULL;
				_g_free0 (name);
				name = _tmp7_;
				_tmp8_ = sym;
				_tmp9_ = name;
				_tmp10_ = begin;
				_tmp11_ = vala_parser_get_src (self, &_tmp10_);
				_tmp12_ = _tmp11_;
				_tmp13_ = vala_unresolved_symbol_new (_tmp8_, _tmp9_, _tmp12_);
				_vala_code_node_unref0 (sym);
				sym = _tmp13_;
				_vala_source_reference_unref0 (_tmp12_);
				_tmp14_ = sym;
				vala_unresolved_symbol_set_qualified (_tmp14_, TRUE);
				_g_free0 (_tmp5_);
				_g_free0 (name);
				continue;
			}
			_tmp15_ = sym;
			_tmp16_ = name;
			_tmp17_ = begin;
			_tmp18_ = vala_parser_get_src (self, &_tmp17_);
			_tmp19_ = _tmp18_;
			_tmp20_ = vala_unresolved_symbol_new (_tmp15_, _tmp16_, _tmp19_);
			_vala_code_node_unref0 (sym);
			sym = _tmp20_;
			_vala_source_reference_unref0 (_tmp19_);
			_g_free0 (name);
		}
	}
	result = sym;
	return result;
}

static void
vala_parser_skip_type (ValaParser* self,
                       GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	vala_parser_accept (self, VALA_TOKEN_TYPE_DYNAMIC);
	vala_parser_accept (self, VALA_TOKEN_TYPE_OWNED);
	vala_parser_accept (self, VALA_TOKEN_TYPE_UNOWNED);
	vala_parser_accept (self, VALA_TOKEN_TYPE_WEAK);
	if (vala_parser_is_inner_array_type (self)) {
		vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_UNOWNED, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		vala_parser_skip_type (self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_BRACKET, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		vala_parser_prev (self);
	} else {
		if (vala_parser_accept (self, VALA_TOKEN_TYPE_VOID)) {
		} else {
			vala_parser_skip_symbol_name (self, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			vala_parser_skip_type_argument_list (self, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
		}
		while (TRUE) {
			if (!vala_parser_accept (self, VALA_TOKEN_TYPE_STAR)) {
				break;
			}
		}
		vala_parser_accept (self, VALA_TOKEN_TYPE_INTERR);
	}
	while (TRUE) {
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_OPEN_BRACKET)) {
			break;
		}
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean _tmp1_ = FALSE;
				if (!_tmp0_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp0_ = FALSE;
				if (vala_parser_current (self) != VALA_TOKEN_TYPE_COMMA) {
					_tmp1_ = vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_BRACKET;
				} else {
					_tmp1_ = FALSE;
				}
				if (_tmp1_) {
					ValaExpression* _tmp2_;
					ValaExpression* _tmp3_;
					_tmp2_ = vala_parser_parse_expression (self, &_inner_error0_);
					_tmp3_ = _tmp2_;
					_vala_code_node_unref0 (_tmp3_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							return;
						} else {
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
					}
				}
			}
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_BRACKET, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		vala_parser_accept (self, VALA_TOKEN_TYPE_INTERR);
	}
	vala_parser_accept (self, VALA_TOKEN_TYPE_OP_NEG);
}

static gboolean
vala_parser_is_inner_array_type (ValaParser* self)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _result_ = FALSE;
	ValaSourceLocation _tmp3_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_OPEN_PARENS)) {
		_tmp2_ = vala_parser_accept (self, VALA_TOKEN_TYPE_UNOWNED);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_PARENS;
	} else {
		_tmp1_ = FALSE;
	}
	_result_ = _tmp1_;
	_tmp3_ = begin;
	vala_parser_rollback (self, &_tmp3_);
	result = _result_;
	return result;
}

static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}

static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}

static ValaDataType*
vala_parser_parse_type (ValaParser* self,
                        gboolean owned_by_default,
                        gboolean can_weak_ref,
                        gboolean require_unowned,
                        GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	gboolean is_dynamic = FALSE;
	gboolean value_owned = FALSE;
	ValaDataType* type = NULL;
	gboolean inner_type_owned = FALSE;
	ValaDataType* _tmp68_;
	ValaDataType* _tmp69_;
	ValaDataType* _tmp70_;
	GError* _inner_error0_ = NULL;
	ValaDataType* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	is_dynamic = vala_parser_accept (self, VALA_TOKEN_TYPE_DYNAMIC);
	value_owned = owned_by_default;
	if (require_unowned) {
		vala_parser_expect (self, VALA_TOKEN_TYPE_UNOWNED, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	} else {
		if (owned_by_default) {
			if (vala_parser_accept (self, VALA_TOKEN_TYPE_UNOWNED)) {
				value_owned = FALSE;
			} else {
				if (vala_parser_accept (self, VALA_TOKEN_TYPE_WEAK)) {
					gboolean _tmp1_ = FALSE;
					if (!can_weak_ref) {
						ValaCodeContext* _tmp2_;
						gboolean _tmp3_;
						gboolean _tmp4_;
						_tmp2_ = self->priv->context;
						_tmp3_ = vala_code_context_get_deprecated (_tmp2_);
						_tmp4_ = _tmp3_;
						_tmp1_ = !_tmp4_;
					} else {
						_tmp1_ = FALSE;
					}
					if (_tmp1_) {
						ValaSourceReference* _tmp5_;
						ValaSourceReference* _tmp6_;
						_tmp5_ = vala_parser_get_last_src (self);
						_tmp6_ = _tmp5_;
						vala_report_warning (_tmp6_, "deprecated syntax, use `unowned` modifier");
						_vala_source_reference_unref0 (_tmp6_);
					}
					value_owned = FALSE;
				} else {
					if (vala_parser_accept (self, VALA_TOKEN_TYPE_OWNED)) {
						ValaSourceReference* _tmp7_;
						ValaSourceReference* _tmp8_;
						_tmp7_ = vala_parser_get_last_src (self);
						_tmp8_ = _tmp7_;
						vala_report_warning (_tmp8_, "`owned' is default in this context");
						_vala_source_reference_unref0 (_tmp8_);
					}
				}
			}
		} else {
			if (vala_parser_accept (self, VALA_TOKEN_TYPE_OWNED)) {
				value_owned = TRUE;
			} else {
				value_owned = FALSE;
				if (vala_parser_accept (self, VALA_TOKEN_TYPE_UNOWNED)) {
					ValaSourceReference* _tmp9_;
					ValaSourceReference* _tmp10_;
					_tmp9_ = vala_parser_get_last_src (self);
					_tmp10_ = _tmp9_;
					vala_report_warning (_tmp10_, "`unowned' is default in this context");
					_vala_source_reference_unref0 (_tmp10_);
				}
			}
		}
	}
	inner_type_owned = TRUE;
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_OPEN_PARENS)) {
		ValaDataType* _tmp11_ = NULL;
		ValaDataType* _tmp12_;
		ValaDataType* _tmp13_;
		_tmp12_ = vala_parser_parse_type (self, FALSE, FALSE, TRUE, &_inner_error0_);
		_tmp11_ = _tmp12_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (type);
				return NULL;
			} else {
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp13_ = _tmp11_;
		_tmp11_ = NULL;
		_vala_code_node_unref0 (type);
		type = _tmp13_;
		vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (_tmp11_);
				_vala_code_node_unref0 (type);
				return NULL;
			} else {
				_vala_code_node_unref0 (_tmp11_);
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		inner_type_owned = FALSE;
		vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_BRACKET, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (_tmp11_);
				_vala_code_node_unref0 (type);
				return NULL;
			} else {
				_vala_code_node_unref0 (_tmp11_);
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		vala_parser_prev (self);
		_vala_code_node_unref0 (_tmp11_);
	} else {
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		ValaDataType* _tmp44_;
		if (!is_dynamic) {
			_tmp15_ = value_owned == owned_by_default;
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			_tmp14_ = vala_parser_accept (self, VALA_TOKEN_TYPE_VOID);
		} else {
			_tmp14_ = FALSE;
		}
		if (_tmp14_) {
			ValaSourceLocation _tmp16_;
			ValaSourceReference* _tmp17_;
			ValaSourceReference* _tmp18_;
			ValaVoidType* _tmp19_;
			_tmp16_ = begin;
			_tmp17_ = vala_parser_get_src (self, &_tmp16_);
			_tmp18_ = _tmp17_;
			_tmp19_ = vala_void_type_new (_tmp18_);
			_vala_code_node_unref0 (type);
			type = (ValaDataType*) _tmp19_;
			_vala_source_reference_unref0 (_tmp18_);
		} else {
			ValaUnresolvedSymbol* sym = NULL;
			ValaUnresolvedSymbol* _tmp20_;
			ValaList* type_arg_list = NULL;
			ValaList* _tmp21_;
			ValaUnresolvedSymbol* _tmp22_;
			ValaSourceLocation _tmp23_;
			ValaSourceReference* _tmp24_;
			ValaSourceReference* _tmp25_;
			ValaUnresolvedType* _tmp26_;
			ValaList* _tmp27_;
			_tmp20_ = vala_parser_parse_symbol_name (self, &_inner_error0_);
			sym = _tmp20_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (type);
					return NULL;
				} else {
					_vala_code_node_unref0 (type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp21_ = vala_parser_parse_type_argument_list (self, FALSE, &_inner_error0_);
			type_arg_list = _tmp21_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (sym);
					_vala_code_node_unref0 (type);
					return NULL;
				} else {
					_vala_code_node_unref0 (sym);
					_vala_code_node_unref0 (type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp22_ = sym;
			_tmp23_ = begin;
			_tmp24_ = vala_parser_get_src (self, &_tmp23_);
			_tmp25_ = _tmp24_;
			_tmp26_ = vala_unresolved_type_new_from_symbol (_tmp22_, _tmp25_);
			_vala_code_node_unref0 (type);
			type = (ValaDataType*) _tmp26_;
			_vala_source_reference_unref0 (_tmp25_);
			_tmp27_ = type_arg_list;
			if (_tmp27_ != NULL) {
				{
					ValaList* _type_arg_list = NULL;
					ValaList* _tmp28_;
					ValaList* _tmp29_;
					gint _type_arg_size = 0;
					ValaList* _tmp30_;
					gint _tmp31_;
					gint _tmp32_;
					gint _type_arg_index = 0;
					_tmp28_ = type_arg_list;
					_tmp29_ = _vala_iterable_ref0 (_tmp28_);
					_type_arg_list = _tmp29_;
					_tmp30_ = _type_arg_list;
					_tmp31_ = vala_collection_get_size ((ValaCollection*) _tmp30_);
					_tmp32_ = _tmp31_;
					_type_arg_size = _tmp32_;
					_type_arg_index = -1;
					while (TRUE) {
						gint _tmp33_;
						gint _tmp34_;
						ValaDataType* type_arg = NULL;
						ValaList* _tmp35_;
						gpointer _tmp36_;
						ValaDataType* _tmp37_;
						ValaDataType* _tmp38_;
						_type_arg_index = _type_arg_index + 1;
						_tmp33_ = _type_arg_index;
						_tmp34_ = _type_arg_size;
						if (!(_tmp33_ < _tmp34_)) {
							break;
						}
						_tmp35_ = _type_arg_list;
						_tmp36_ = vala_list_get (_tmp35_, _type_arg_index);
						type_arg = (ValaDataType*) _tmp36_;
						_tmp37_ = type;
						_tmp38_ = type_arg;
						vala_data_type_add_type_argument (_tmp37_, _tmp38_);
						_vala_code_node_unref0 (type_arg);
					}
					_vala_iterable_unref0 (_type_arg_list);
				}
			}
			_vala_iterable_unref0 (type_arg_list);
			_vala_code_node_unref0 (sym);
		}
		while (TRUE) {
			ValaDataType* _tmp39_;
			ValaSourceLocation _tmp40_;
			ValaSourceReference* _tmp41_;
			ValaSourceReference* _tmp42_;
			ValaPointerType* _tmp43_;
			if (!vala_parser_accept (self, VALA_TOKEN_TYPE_STAR)) {
				break;
			}
			_tmp39_ = type;
			_tmp40_ = begin;
			_tmp41_ = vala_parser_get_src (self, &_tmp40_);
			_tmp42_ = _tmp41_;
			_tmp43_ = vala_pointer_type_new (_tmp39_, _tmp42_);
			_vala_code_node_unref0 (type);
			type = (ValaDataType*) _tmp43_;
			_vala_source_reference_unref0 (_tmp42_);
		}
		_tmp44_ = type;
		if (!VALA_IS_POINTER_TYPE (_tmp44_)) {
			ValaDataType* _tmp45_;
			ValaDataType* _tmp46_;
			ValaSourceLocation _tmp47_;
			ValaSourceReference* _tmp48_;
			ValaSourceReference* _tmp49_;
			_tmp45_ = type;
			vala_data_type_set_nullable (_tmp45_, vala_parser_accept (self, VALA_TOKEN_TYPE_INTERR));
			_tmp46_ = type;
			_tmp47_ = begin;
			_tmp48_ = vala_parser_get_src (self, &_tmp47_);
			_tmp49_ = _tmp48_;
			vala_code_node_set_source_reference ((ValaCodeNode*) _tmp46_, _tmp49_);
			_vala_source_reference_unref0 (_tmp49_);
		}
	}
	while (TRUE) {
		gboolean invalid_array = FALSE;
		gint array_rank = 0;
		ValaDataType* _tmp55_;
		ValaArrayType* array_type = NULL;
		ValaDataType* _tmp56_;
		ValaSourceLocation _tmp57_;
		ValaSourceReference* _tmp58_;
		ValaSourceReference* _tmp59_;
		ValaArrayType* _tmp60_;
		ValaArrayType* _tmp61_;
		ValaArrayType* _tmp62_;
		ValaArrayType* _tmp63_;
		ValaArrayType* _tmp64_;
		ValaDataType* _tmp65_;
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_OPEN_BRACKET)) {
			break;
		}
		invalid_array = FALSE;
		array_rank = 0;
		{
			gboolean _tmp50_ = FALSE;
			_tmp50_ = TRUE;
			while (TRUE) {
				gint _tmp51_;
				gboolean _tmp52_ = FALSE;
				if (!_tmp50_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp50_ = FALSE;
				_tmp51_ = array_rank;
				array_rank = _tmp51_ + 1;
				if (vala_parser_current (self) != VALA_TOKEN_TYPE_COMMA) {
					_tmp52_ = vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_BRACKET;
				} else {
					_tmp52_ = FALSE;
				}
				if (_tmp52_) {
					ValaExpression* _tmp53_;
					ValaExpression* _tmp54_;
					_tmp53_ = vala_parser_parse_expression (self, &_inner_error0_);
					_tmp54_ = _tmp53_;
					_vala_code_node_unref0 (_tmp54_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_vala_code_node_unref0 (type);
							return NULL;
						} else {
							_vala_code_node_unref0 (type);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return NULL;
						}
					}
					invalid_array = TRUE;
				}
			}
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_BRACKET, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (type);
				return NULL;
			} else {
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp55_ = type;
		vala_data_type_set_value_owned (_tmp55_, inner_type_owned);
		_tmp56_ = type;
		_tmp57_ = begin;
		_tmp58_ = vala_parser_get_src (self, &_tmp57_);
		_tmp59_ = _tmp58_;
		_tmp60_ = vala_array_type_new (_tmp56_, array_rank, _tmp59_);
		_tmp61_ = _tmp60_;
		_vala_source_reference_unref0 (_tmp59_);
		array_type = _tmp61_;
		_tmp62_ = array_type;
		vala_data_type_set_nullable ((ValaDataType*) _tmp62_, vala_parser_accept (self, VALA_TOKEN_TYPE_INTERR));
		_tmp63_ = array_type;
		vala_array_type_set_invalid_syntax (_tmp63_, invalid_array);
		_tmp64_ = array_type;
		_tmp65_ = _vala_code_node_ref0 ((ValaDataType*) _tmp64_);
		_vala_code_node_unref0 (type);
		type = _tmp65_;
		_vala_code_node_unref0 (array_type);
	}
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_OP_NEG)) {
		ValaSourceReference* _tmp66_;
		ValaSourceReference* _tmp67_;
		_tmp66_ = vala_parser_get_last_src (self);
		_tmp67_ = _tmp66_;
		vala_report_warning (_tmp67_, "obsolete syntax, types are non-null by default");
		_vala_source_reference_unref0 (_tmp67_);
	}
	_tmp68_ = type;
	if (VALA_IS_POINTER_TYPE (_tmp68_)) {
		value_owned = FALSE;
	}
	_tmp69_ = type;
	vala_data_type_set_is_dynamic (_tmp69_, is_dynamic);
	_tmp70_ = type;
	vala_data_type_set_value_owned (_tmp70_, value_owned);
	result = type;
	return result;
}

static ValaDataType*
vala_parser_parse_inline_array_type (ValaParser* self,
                                     ValaDataType* type,
                                     GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	ValaDataType* _tmp18_;
	GError* _inner_error0_ = NULL;
	ValaDataType* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	if (type != NULL) {
		_tmp1_ = vala_parser_accept (self, VALA_TOKEN_TYPE_OPEN_BRACKET);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		ValaExpression* array_length = NULL;
		ValaArrayType* array_type = NULL;
		ValaSourceLocation _tmp5_;
		ValaSourceReference* _tmp6_;
		ValaSourceReference* _tmp7_;
		ValaArrayType* _tmp8_;
		ValaArrayType* _tmp9_;
		ValaArrayType* _tmp10_;
		ValaExpression* _tmp11_;
		ValaArrayType* _tmp15_;
		gboolean _tmp16_;
		gboolean _tmp17_;
		array_length = NULL;
		if (vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_BRACKET) {
			ValaExpression* _tmp2_ = NULL;
			ValaExpression* _tmp3_;
			ValaExpression* _tmp4_;
			_tmp3_ = vala_parser_parse_expression (self, &_inner_error0_);
			_tmp2_ = _tmp3_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (array_length);
					return NULL;
				} else {
					_vala_code_node_unref0 (array_length);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp4_ = _tmp2_;
			_tmp2_ = NULL;
			_vala_code_node_unref0 (array_length);
			array_length = _tmp4_;
			_vala_code_node_unref0 (_tmp2_);
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_BRACKET, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (array_length);
				return NULL;
			} else {
				_vala_code_node_unref0 (array_length);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp5_ = begin;
		_tmp6_ = vala_parser_get_src (self, &_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = vala_array_type_new (type, 1, _tmp7_);
		_tmp9_ = _tmp8_;
		_vala_source_reference_unref0 (_tmp7_);
		array_type = _tmp9_;
		_tmp10_ = array_type;
		vala_array_type_set_inline_allocated (_tmp10_, TRUE);
		_tmp11_ = array_length;
		if (_tmp11_ != NULL) {
			ValaArrayType* _tmp12_;
			ValaArrayType* _tmp13_;
			ValaExpression* _tmp14_;
			_tmp12_ = array_type;
			vala_array_type_set_fixed_length (_tmp12_, TRUE);
			_tmp13_ = array_type;
			_tmp14_ = array_length;
			vala_array_type_set_length (_tmp13_, _tmp14_);
		}
		_tmp15_ = array_type;
		_tmp16_ = vala_data_type_get_value_owned (type);
		_tmp17_ = _tmp16_;
		vala_data_type_set_value_owned ((ValaDataType*) _tmp15_, _tmp17_);
		result = (ValaDataType*) array_type;
		_vala_code_node_unref0 (array_length);
		return result;
	}
	_tmp18_ = _vala_code_node_ref0 (type);
	result = _tmp18_;
	return result;
}

static ValaList*
vala_parser_parse_argument_list (ValaParser* self,
                                 GError** error)
{
	ValaArrayList* list = NULL;
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	GError* _inner_error0_ = NULL;
	ValaList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (VALA_TYPE_EXPRESSION, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp0_);
	list = _tmp1_;
	if (vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_PARENS) {
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				if (!_tmp2_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp2_ = FALSE;
				{
					ValaExpression* _tmp3_ = NULL;
					ValaExpression* _tmp4_;
					ValaArrayList* _tmp5_;
					_tmp4_ = vala_parser_parse_argument (self, &_inner_error0_);
					_tmp3_ = _tmp4_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						_vala_iterable_unref0 (list);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
					_tmp5_ = list;
					vala_collection_add ((ValaCollection*) _tmp5_, _tmp3_);
					_vala_code_node_unref0 (_tmp3_);
				}
				goto __finally0;
				__catch0_vala_parse_error:
				{
					GError* e = NULL;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					if (vala_parser_current (self) == VALA_TOKEN_TYPE_CLOSE_PARENS) {
						GError* _tmp6_;
						GError* _tmp7_;
						vala_parser_prev (self);
						_tmp6_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "incomplete argument list");
						_tmp7_ = _tmp6_;
						vala_parser_report_parse_error (self, _tmp7_);
						_g_error_free0 (_tmp7_);
					} else {
						ValaCodeContext* _tmp8_;
						gboolean _tmp9_;
						gboolean _tmp10_;
						_tmp8_ = self->priv->context;
						_tmp9_ = vala_code_context_get_keep_going (_tmp8_);
						_tmp10_ = _tmp9_;
						if (_tmp10_) {
							GError* _tmp11_;
							_tmp11_ = e;
							vala_parser_report_parse_error (self, _tmp11_);
						} else {
							GError* _tmp12_;
							GError* _tmp13_;
							_tmp12_ = e;
							_tmp13_ = _g_error_copy0 (_tmp12_);
							_inner_error0_ = _tmp13_;
							_g_error_free0 (e);
							goto __finally0;
						}
					}
					_g_error_free0 (e);
				}
				__finally0:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_iterable_unref0 (list);
						return NULL;
					} else {
						_vala_iterable_unref0 (list);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
			}
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_iterable_unref0 (list);
			return NULL;
		} else {
			_vala_iterable_unref0 (list);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = (ValaList*) list;
	return result;
}

static ValaExpression*
vala_parser_parse_argument (ValaParser* self,
                            GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_REF)) {
		ValaExpression* inner = NULL;
		ValaExpression* _tmp1_;
		ValaExpression* _tmp2_;
		ValaSourceLocation _tmp3_;
		ValaSourceReference* _tmp4_;
		ValaSourceReference* _tmp5_;
		ValaUnaryExpression* _tmp6_;
		ValaExpression* _tmp7_;
		_tmp1_ = vala_parser_parse_expression (self, &_inner_error0_);
		inner = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp2_ = inner;
		_tmp3_ = begin;
		_tmp4_ = vala_parser_get_src (self, &_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = vala_unary_expression_new (VALA_UNARY_OPERATOR_REF, _tmp2_, _tmp5_);
		_tmp7_ = (ValaExpression*) _tmp6_;
		_vala_source_reference_unref0 (_tmp5_);
		result = _tmp7_;
		_vala_code_node_unref0 (inner);
		return result;
	} else {
		if (vala_parser_accept (self, VALA_TOKEN_TYPE_OUT)) {
			ValaExpression* inner = NULL;
			ValaExpression* _tmp8_;
			ValaExpression* _tmp9_;
			ValaSourceLocation _tmp10_;
			ValaSourceReference* _tmp11_;
			ValaSourceReference* _tmp12_;
			ValaUnaryExpression* _tmp13_;
			ValaExpression* _tmp14_;
			_tmp8_ = vala_parser_parse_expression (self, &_inner_error0_);
			inner = _tmp8_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp9_ = inner;
			_tmp10_ = begin;
			_tmp11_ = vala_parser_get_src (self, &_tmp10_);
			_tmp12_ = _tmp11_;
			_tmp13_ = vala_unary_expression_new (VALA_UNARY_OPERATOR_OUT, _tmp9_, _tmp12_);
			_tmp14_ = (ValaExpression*) _tmp13_;
			_vala_source_reference_unref0 (_tmp12_);
			result = _tmp14_;
			_vala_code_node_unref0 (inner);
			return result;
		} else {
			ValaExpression* expr = NULL;
			ValaExpression* _tmp15_;
			ValaMemberAccess* ma = NULL;
			ValaExpression* _tmp16_;
			ValaMemberAccess* _tmp17_;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			ValaMemberAccess* _tmp20_;
			_tmp15_ = vala_parser_parse_expression (self, &_inner_error0_);
			expr = _tmp15_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp16_ = expr;
			_tmp17_ = _vala_code_node_ref0 (VALA_IS_MEMBER_ACCESS (_tmp16_) ? ((ValaMemberAccess*) _tmp16_) : NULL);
			ma = _tmp17_;
			_tmp20_ = ma;
			if (_tmp20_ != NULL) {
				ValaMemberAccess* _tmp21_;
				ValaExpression* _tmp22_;
				ValaExpression* _tmp23_;
				_tmp21_ = ma;
				_tmp22_ = vala_member_access_get_inner (_tmp21_);
				_tmp23_ = _tmp22_;
				_tmp19_ = _tmp23_ == NULL;
			} else {
				_tmp19_ = FALSE;
			}
			if (_tmp19_) {
				_tmp18_ = vala_parser_accept (self, VALA_TOKEN_TYPE_COLON);
			} else {
				_tmp18_ = FALSE;
			}
			if (_tmp18_) {
				ValaExpression* _tmp24_ = NULL;
				ValaExpression* _tmp25_;
				ValaExpression* _tmp26_;
				ValaMemberAccess* _tmp27_;
				const gchar* _tmp28_;
				const gchar* _tmp29_;
				ValaExpression* _tmp30_;
				ValaSourceLocation _tmp31_;
				ValaSourceReference* _tmp32_;
				ValaSourceReference* _tmp33_;
				ValaNamedArgument* _tmp34_;
				ValaExpression* _tmp35_;
				_tmp25_ = vala_parser_parse_expression (self, &_inner_error0_);
				_tmp24_ = _tmp25_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (ma);
						_vala_code_node_unref0 (expr);
						return NULL;
					} else {
						_vala_code_node_unref0 (ma);
						_vala_code_node_unref0 (expr);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp26_ = _tmp24_;
				_tmp24_ = NULL;
				_vala_code_node_unref0 (expr);
				expr = _tmp26_;
				_tmp27_ = ma;
				_tmp28_ = vala_member_access_get_member_name (_tmp27_);
				_tmp29_ = _tmp28_;
				_tmp30_ = expr;
				_tmp31_ = begin;
				_tmp32_ = vala_parser_get_src (self, &_tmp31_);
				_tmp33_ = _tmp32_;
				_tmp34_ = vala_named_argument_new (_tmp29_, _tmp30_, _tmp33_);
				_tmp35_ = (ValaExpression*) _tmp34_;
				_vala_source_reference_unref0 (_tmp33_);
				result = _tmp35_;
				_vala_code_node_unref0 (_tmp24_);
				_vala_code_node_unref0 (ma);
				_vala_code_node_unref0 (expr);
				return result;
			} else {
				result = expr;
				_vala_code_node_unref0 (ma);
				return result;
			}
			_vala_code_node_unref0 (ma);
			_vala_code_node_unref0 (expr);
		}
	}
}

static ValaExpression*
vala_parser_parse_primary_expression (ValaParser* self,
                                      GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* expr = NULL;
	gboolean found = FALSE;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	switch (vala_parser_current (self)) {
		case VALA_TOKEN_TYPE_TRUE:
		case VALA_TOKEN_TYPE_FALSE:
		case VALA_TOKEN_TYPE_INTEGER_LITERAL:
		case VALA_TOKEN_TYPE_REAL_LITERAL:
		case VALA_TOKEN_TYPE_CHARACTER_LITERAL:
		case VALA_TOKEN_TYPE_STRING_LITERAL:
		case VALA_TOKEN_TYPE_REGEX_LITERAL:
		case VALA_TOKEN_TYPE_TEMPLATE_STRING_LITERAL:
		case VALA_TOKEN_TYPE_VERBATIM_STRING_LITERAL:
		case VALA_TOKEN_TYPE_NULL:
		{
			ValaExpression* _tmp1_ = NULL;
			ValaExpression* _tmp2_;
			ValaExpression* _tmp3_;
			_tmp2_ = vala_parser_parse_literal (self, &_inner_error0_);
			_tmp1_ = _tmp2_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (expr);
					return NULL;
				} else {
					_vala_code_node_unref0 (expr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp3_ = _tmp1_;
			_tmp1_ = NULL;
			_vala_code_node_unref0 (expr);
			expr = _tmp3_;
			_vala_code_node_unref0 (_tmp1_);
			break;
		}
		case VALA_TOKEN_TYPE_OPEN_BRACE:
		{
			ValaInitializerList* _tmp4_ = NULL;
			ValaInitializerList* _tmp5_;
			ValaInitializerList* _tmp6_;
			_tmp5_ = vala_parser_parse_initializer (self, &_inner_error0_);
			_tmp4_ = _tmp5_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (expr);
					return NULL;
				} else {
					_vala_code_node_unref0 (expr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp6_ = _tmp4_;
			_tmp4_ = NULL;
			_vala_code_node_unref0 (expr);
			expr = (ValaExpression*) _tmp6_;
			_vala_code_node_unref0 (_tmp4_);
			break;
		}
		case VALA_TOKEN_TYPE_OPEN_BRACKET:
		{
			ValaExpression* _tmp7_ = NULL;
			ValaExpression* _tmp8_;
			ValaExpression* _tmp9_;
			_tmp8_ = vala_parser_parse_simple_name (self, &_inner_error0_);
			_tmp7_ = _tmp8_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (expr);
					return NULL;
				} else {
					_vala_code_node_unref0 (expr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp9_ = _tmp7_;
			_tmp7_ = NULL;
			_vala_code_node_unref0 (expr);
			expr = _tmp9_;
			_vala_code_node_unref0 (_tmp7_);
			break;
		}
		case VALA_TOKEN_TYPE_OPEN_PARENS:
		{
			ValaExpression* _tmp10_ = NULL;
			ValaExpression* _tmp11_;
			ValaExpression* _tmp12_;
			_tmp11_ = vala_parser_parse_tuple (self, &_inner_error0_);
			_tmp10_ = _tmp11_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (expr);
					return NULL;
				} else {
					_vala_code_node_unref0 (expr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp12_ = _tmp10_;
			_tmp10_ = NULL;
			_vala_code_node_unref0 (expr);
			expr = _tmp12_;
			_vala_code_node_unref0 (_tmp10_);
			break;
		}
		case VALA_TOKEN_TYPE_OPEN_TEMPLATE:
		{
			ValaExpression* _tmp13_ = NULL;
			ValaExpression* _tmp14_;
			ValaExpression* _tmp15_;
			_tmp14_ = vala_parser_parse_template (self, &_inner_error0_);
			_tmp13_ = _tmp14_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (expr);
					return NULL;
				} else {
					_vala_code_node_unref0 (expr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp15_ = _tmp13_;
			_tmp13_ = NULL;
			_vala_code_node_unref0 (expr);
			expr = _tmp15_;
			_vala_code_node_unref0 (_tmp13_);
			break;
		}
		case VALA_TOKEN_TYPE_OPEN_REGEX_LITERAL:
		{
			ValaExpression* _tmp16_ = NULL;
			ValaExpression* _tmp17_;
			ValaExpression* _tmp18_;
			_tmp17_ = vala_parser_parse_regex_literal (self, &_inner_error0_);
			_tmp16_ = _tmp17_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (expr);
					return NULL;
				} else {
					_vala_code_node_unref0 (expr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp18_ = _tmp16_;
			_tmp16_ = NULL;
			_vala_code_node_unref0 (expr);
			expr = _tmp18_;
			_vala_code_node_unref0 (_tmp16_);
			break;
		}
		case VALA_TOKEN_TYPE_THIS:
		{
			ValaExpression* _tmp19_ = NULL;
			ValaExpression* _tmp20_;
			ValaExpression* _tmp21_;
			_tmp20_ = vala_parser_parse_this_access (self, &_inner_error0_);
			_tmp19_ = _tmp20_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (expr);
					return NULL;
				} else {
					_vala_code_node_unref0 (expr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp21_ = _tmp19_;
			_tmp19_ = NULL;
			_vala_code_node_unref0 (expr);
			expr = _tmp21_;
			_vala_code_node_unref0 (_tmp19_);
			break;
		}
		case VALA_TOKEN_TYPE_BASE:
		{
			ValaExpression* _tmp22_ = NULL;
			ValaExpression* _tmp23_;
			ValaExpression* _tmp24_;
			_tmp23_ = vala_parser_parse_base_access (self, &_inner_error0_);
			_tmp22_ = _tmp23_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (expr);
					return NULL;
				} else {
					_vala_code_node_unref0 (expr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp24_ = _tmp22_;
			_tmp22_ = NULL;
			_vala_code_node_unref0 (expr);
			expr = _tmp24_;
			_vala_code_node_unref0 (_tmp22_);
			break;
		}
		case VALA_TOKEN_TYPE_NEW:
		{
			ValaExpression* _tmp25_ = NULL;
			ValaExpression* _tmp26_;
			ValaExpression* _tmp27_;
			_tmp26_ = vala_parser_parse_object_or_array_creation_expression (self, &_inner_error0_);
			_tmp25_ = _tmp26_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (expr);
					return NULL;
				} else {
					_vala_code_node_unref0 (expr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp27_ = _tmp25_;
			_tmp25_ = NULL;
			_vala_code_node_unref0 (expr);
			expr = _tmp27_;
			_vala_code_node_unref0 (_tmp25_);
			break;
		}
		case VALA_TOKEN_TYPE_YIELD:
		{
			ValaExpression* _tmp28_ = NULL;
			ValaExpression* _tmp29_;
			ValaExpression* _tmp30_;
			_tmp29_ = vala_parser_parse_yield_expression (self, &_inner_error0_);
			_tmp28_ = _tmp29_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (expr);
					return NULL;
				} else {
					_vala_code_node_unref0 (expr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp30_ = _tmp28_;
			_tmp28_ = NULL;
			_vala_code_node_unref0 (expr);
			expr = _tmp30_;
			_vala_code_node_unref0 (_tmp28_);
			break;
		}
		case VALA_TOKEN_TYPE_SIZEOF:
		{
			ValaExpression* _tmp31_ = NULL;
			ValaExpression* _tmp32_;
			ValaExpression* _tmp33_;
			_tmp32_ = vala_parser_parse_sizeof_expression (self, &_inner_error0_);
			_tmp31_ = _tmp32_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (expr);
					return NULL;
				} else {
					_vala_code_node_unref0 (expr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp33_ = _tmp31_;
			_tmp31_ = NULL;
			_vala_code_node_unref0 (expr);
			expr = _tmp33_;
			_vala_code_node_unref0 (_tmp31_);
			break;
		}
		case VALA_TOKEN_TYPE_TYPEOF:
		{
			ValaExpression* _tmp34_ = NULL;
			ValaExpression* _tmp35_;
			ValaExpression* _tmp36_;
			_tmp35_ = vala_parser_parse_typeof_expression (self, &_inner_error0_);
			_tmp34_ = _tmp35_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (expr);
					return NULL;
				} else {
					_vala_code_node_unref0 (expr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp36_ = _tmp34_;
			_tmp34_ = NULL;
			_vala_code_node_unref0 (expr);
			expr = _tmp36_;
			_vala_code_node_unref0 (_tmp34_);
			break;
		}
		default:
		{
			ValaExpression* _tmp37_ = NULL;
			ValaExpression* _tmp38_;
			ValaExpression* _tmp39_;
			_tmp38_ = vala_parser_parse_simple_name (self, &_inner_error0_);
			_tmp37_ = _tmp38_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (expr);
					return NULL;
				} else {
					_vala_code_node_unref0 (expr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp39_ = _tmp37_;
			_tmp37_ = NULL;
			_vala_code_node_unref0 (expr);
			expr = _tmp39_;
			_vala_code_node_unref0 (_tmp37_);
			break;
		}
	}
	found = TRUE;
	while (TRUE) {
		if (!found) {
			break;
		}
		switch (vala_parser_current (self)) {
			case VALA_TOKEN_TYPE_DOT:
			{
				ValaExpression* _tmp40_ = NULL;
				ValaSourceLocation _tmp41_;
				ValaExpression* _tmp42_;
				ValaExpression* _tmp43_;
				ValaExpression* _tmp44_;
				_tmp41_ = begin;
				_tmp42_ = expr;
				_tmp43_ = vala_parser_parse_member_access (self, &_tmp41_, _tmp42_, &_inner_error0_);
				_tmp40_ = _tmp43_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (expr);
						return NULL;
					} else {
						_vala_code_node_unref0 (expr);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp44_ = _tmp40_;
				_tmp40_ = NULL;
				_vala_code_node_unref0 (expr);
				expr = _tmp44_;
				_vala_code_node_unref0 (_tmp40_);
				break;
			}
			case VALA_TOKEN_TYPE_OP_PTR:
			{
				ValaExpression* _tmp45_ = NULL;
				ValaSourceLocation _tmp46_;
				ValaExpression* _tmp47_;
				ValaExpression* _tmp48_;
				ValaExpression* _tmp49_;
				_tmp46_ = begin;
				_tmp47_ = expr;
				_tmp48_ = vala_parser_parse_pointer_member_access (self, &_tmp46_, _tmp47_, &_inner_error0_);
				_tmp45_ = _tmp48_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (expr);
						return NULL;
					} else {
						_vala_code_node_unref0 (expr);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp49_ = _tmp45_;
				_tmp45_ = NULL;
				_vala_code_node_unref0 (expr);
				expr = _tmp49_;
				_vala_code_node_unref0 (_tmp45_);
				break;
			}
			case VALA_TOKEN_TYPE_OPEN_PARENS:
			{
				ValaExpression* _tmp50_ = NULL;
				ValaSourceLocation _tmp51_;
				ValaExpression* _tmp52_;
				ValaExpression* _tmp53_;
				ValaExpression* _tmp54_;
				_tmp51_ = begin;
				_tmp52_ = expr;
				_tmp53_ = vala_parser_parse_method_call (self, &_tmp51_, _tmp52_, &_inner_error0_);
				_tmp50_ = _tmp53_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (expr);
						return NULL;
					} else {
						_vala_code_node_unref0 (expr);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp54_ = _tmp50_;
				_tmp50_ = NULL;
				_vala_code_node_unref0 (expr);
				expr = _tmp54_;
				_vala_code_node_unref0 (_tmp50_);
				break;
			}
			case VALA_TOKEN_TYPE_OPEN_BRACKET:
			{
				ValaExpression* _tmp55_ = NULL;
				ValaSourceLocation _tmp56_;
				ValaExpression* _tmp57_;
				ValaExpression* _tmp58_;
				ValaExpression* _tmp59_;
				_tmp56_ = begin;
				_tmp57_ = expr;
				_tmp58_ = vala_parser_parse_element_access (self, &_tmp56_, _tmp57_, &_inner_error0_);
				_tmp55_ = _tmp58_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (expr);
						return NULL;
					} else {
						_vala_code_node_unref0 (expr);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp59_ = _tmp55_;
				_tmp55_ = NULL;
				_vala_code_node_unref0 (expr);
				expr = _tmp59_;
				_vala_code_node_unref0 (_tmp55_);
				break;
			}
			case VALA_TOKEN_TYPE_OP_INC:
			{
				ValaExpression* _tmp60_ = NULL;
				ValaSourceLocation _tmp61_;
				ValaExpression* _tmp62_;
				ValaExpression* _tmp63_;
				ValaExpression* _tmp64_;
				_tmp61_ = begin;
				_tmp62_ = expr;
				_tmp63_ = vala_parser_parse_post_increment_expression (self, &_tmp61_, _tmp62_, &_inner_error0_);
				_tmp60_ = _tmp63_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (expr);
						return NULL;
					} else {
						_vala_code_node_unref0 (expr);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp64_ = _tmp60_;
				_tmp60_ = NULL;
				_vala_code_node_unref0 (expr);
				expr = _tmp64_;
				_vala_code_node_unref0 (_tmp60_);
				break;
			}
			case VALA_TOKEN_TYPE_OP_DEC:
			{
				ValaExpression* _tmp65_ = NULL;
				ValaSourceLocation _tmp66_;
				ValaExpression* _tmp67_;
				ValaExpression* _tmp68_;
				ValaExpression* _tmp69_;
				_tmp66_ = begin;
				_tmp67_ = expr;
				_tmp68_ = vala_parser_parse_post_decrement_expression (self, &_tmp66_, _tmp67_, &_inner_error0_);
				_tmp65_ = _tmp68_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (expr);
						return NULL;
					} else {
						_vala_code_node_unref0 (expr);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp69_ = _tmp65_;
				_tmp65_ = NULL;
				_vala_code_node_unref0 (expr);
				expr = _tmp69_;
				_vala_code_node_unref0 (_tmp65_);
				break;
			}
			default:
			{
				found = FALSE;
				break;
			}
		}
	}
	result = expr;
	return result;
}

static ValaExpression*
vala_parser_parse_simple_name (ValaParser* self,
                               GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	gchar* id = NULL;
	gchar* _tmp1_;
	gboolean qualified = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	ValaList* type_arg_list = NULL;
	ValaList* _tmp7_;
	ValaMemberAccess* expr = NULL;
	const gchar* _tmp8_;
	ValaSourceLocation _tmp9_;
	ValaSourceReference* _tmp10_;
	ValaSourceReference* _tmp11_;
	ValaMemberAccess* _tmp12_;
	ValaMemberAccess* _tmp13_;
	ValaMemberAccess* _tmp14_;
	ValaList* _tmp15_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_identifier (self, &_inner_error0_);
	id = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	qualified = FALSE;
	_tmp3_ = id;
	if (g_strcmp0 (_tmp3_, "global") == 0) {
		_tmp2_ = vala_parser_accept (self, VALA_TOKEN_TYPE_DOUBLE_COLON);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = vala_parser_parse_identifier (self, &_inner_error0_);
		_tmp4_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (id);
				return NULL;
			} else {
				_g_free0 (id);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp6_ = _tmp4_;
		_tmp4_ = NULL;
		_g_free0 (id);
		id = _tmp6_;
		qualified = TRUE;
		_g_free0 (_tmp4_);
	}
	_tmp7_ = vala_parser_parse_type_argument_list (self, TRUE, &_inner_error0_);
	type_arg_list = _tmp7_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (id);
			return NULL;
		} else {
			_g_free0 (id);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp8_ = id;
	_tmp9_ = begin;
	_tmp10_ = vala_parser_get_src (self, &_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = vala_member_access_new (NULL, _tmp8_, _tmp11_);
	_tmp13_ = _tmp12_;
	_vala_source_reference_unref0 (_tmp11_);
	expr = _tmp13_;
	_tmp14_ = expr;
	vala_member_access_set_qualified (_tmp14_, qualified);
	_tmp15_ = type_arg_list;
	if (_tmp15_ != NULL) {
		{
			ValaList* _type_arg_list = NULL;
			ValaList* _tmp16_;
			ValaList* _tmp17_;
			gint _type_arg_size = 0;
			ValaList* _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			gint _type_arg_index = 0;
			_tmp16_ = type_arg_list;
			_tmp17_ = _vala_iterable_ref0 (_tmp16_);
			_type_arg_list = _tmp17_;
			_tmp18_ = _type_arg_list;
			_tmp19_ = vala_collection_get_size ((ValaCollection*) _tmp18_);
			_tmp20_ = _tmp19_;
			_type_arg_size = _tmp20_;
			_type_arg_index = -1;
			while (TRUE) {
				gint _tmp21_;
				gint _tmp22_;
				ValaDataType* type_arg = NULL;
				ValaList* _tmp23_;
				gpointer _tmp24_;
				ValaMemberAccess* _tmp25_;
				ValaDataType* _tmp26_;
				_type_arg_index = _type_arg_index + 1;
				_tmp21_ = _type_arg_index;
				_tmp22_ = _type_arg_size;
				if (!(_tmp21_ < _tmp22_)) {
					break;
				}
				_tmp23_ = _type_arg_list;
				_tmp24_ = vala_list_get (_tmp23_, _type_arg_index);
				type_arg = (ValaDataType*) _tmp24_;
				_tmp25_ = expr;
				_tmp26_ = type_arg;
				vala_member_access_add_type_argument (_tmp25_, _tmp26_);
				_vala_code_node_unref0 (type_arg);
			}
			_vala_iterable_unref0 (_type_arg_list);
		}
	}
	result = (ValaExpression*) expr;
	_vala_iterable_unref0 (type_arg_list);
	_g_free0 (id);
	return result;
}

static ValaExpression*
vala_parser_parse_tuple (ValaParser* self,
                         GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaArrayList* expr_list = NULL;
	GEqualFunc _tmp1_;
	ValaArrayList* _tmp2_;
	ValaArrayList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = g_direct_equal;
	_tmp2_ = vala_array_list_new (VALA_TYPE_EXPRESSION, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp1_);
	expr_list = _tmp2_;
	if (vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_PARENS) {
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				ValaExpression* _tmp4_ = NULL;
				ValaExpression* _tmp5_;
				ValaArrayList* _tmp6_;
				if (!_tmp3_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp3_ = FALSE;
				_tmp5_ = vala_parser_parse_expression (self, &_inner_error0_);
				_tmp4_ = _tmp5_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_iterable_unref0 (expr_list);
						return NULL;
					} else {
						_vala_iterable_unref0 (expr_list);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp6_ = expr_list;
				vala_collection_add ((ValaCollection*) _tmp6_, _tmp4_);
				_vala_code_node_unref0 (_tmp4_);
			}
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_iterable_unref0 (expr_list);
			return NULL;
		} else {
			_vala_iterable_unref0 (expr_list);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp7_ = expr_list;
	_tmp8_ = vala_collection_get_size ((ValaCollection*) _tmp7_);
	_tmp9_ = _tmp8_;
	if (_tmp9_ != 1) {
		ValaTuple* tuple = NULL;
		ValaSourceLocation _tmp10_;
		ValaSourceReference* _tmp11_;
		ValaSourceReference* _tmp12_;
		ValaTuple* _tmp13_;
		ValaTuple* _tmp14_;
		_tmp10_ = begin;
		_tmp11_ = vala_parser_get_src (self, &_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = vala_tuple_new (_tmp12_);
		_tmp14_ = _tmp13_;
		_vala_source_reference_unref0 (_tmp12_);
		tuple = _tmp14_;
		{
			ValaArrayList* _expr_list = NULL;
			ValaArrayList* _tmp15_;
			ValaArrayList* _tmp16_;
			gint _expr_size = 0;
			ValaArrayList* _tmp17_;
			gint _tmp18_;
			gint _tmp19_;
			gint _expr_index = 0;
			_tmp15_ = expr_list;
			_tmp16_ = _vala_iterable_ref0 (_tmp15_);
			_expr_list = _tmp16_;
			_tmp17_ = _expr_list;
			_tmp18_ = vala_collection_get_size ((ValaCollection*) _tmp17_);
			_tmp19_ = _tmp18_;
			_expr_size = _tmp19_;
			_expr_index = -1;
			while (TRUE) {
				gint _tmp20_;
				gint _tmp21_;
				ValaExpression* expr = NULL;
				ValaArrayList* _tmp22_;
				gpointer _tmp23_;
				ValaTuple* _tmp24_;
				ValaExpression* _tmp25_;
				_expr_index = _expr_index + 1;
				_tmp20_ = _expr_index;
				_tmp21_ = _expr_size;
				if (!(_tmp20_ < _tmp21_)) {
					break;
				}
				_tmp22_ = _expr_list;
				_tmp23_ = vala_list_get ((ValaList*) _tmp22_, _expr_index);
				expr = (ValaExpression*) _tmp23_;
				_tmp24_ = tuple;
				_tmp25_ = expr;
				vala_tuple_add_expression (_tmp24_, _tmp25_);
				_vala_code_node_unref0 (expr);
			}
			_vala_iterable_unref0 (_expr_list);
		}
		result = (ValaExpression*) tuple;
		_vala_iterable_unref0 (expr_list);
		return result;
	} else {
		ValaExpression* expr = NULL;
		ValaArrayList* _tmp26_;
		gpointer _tmp27_;
		ValaExpression* _tmp28_;
		ValaSourceLocation _tmp29_;
		ValaSourceReference* _tmp30_;
		ValaSourceReference* _tmp31_;
		_tmp26_ = expr_list;
		_tmp27_ = vala_list_get ((ValaList*) _tmp26_, 0);
		expr = (ValaExpression*) _tmp27_;
		_tmp28_ = expr;
		_tmp29_ = begin;
		_tmp30_ = vala_parser_get_src (self, &_tmp29_);
		_tmp31_ = _tmp30_;
		vala_code_node_set_source_reference ((ValaCodeNode*) _tmp28_, _tmp31_);
		_vala_source_reference_unref0 (_tmp31_);
		result = expr;
		_vala_iterable_unref0 (expr_list);
		return result;
	}
	_vala_iterable_unref0 (expr_list);
}

static ValaExpression*
vala_parser_parse_template (ValaParser* self,
                            GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaTemplate* template = NULL;
	ValaTemplate* _tmp1_;
	ValaTemplate* _tmp5_;
	ValaSourceLocation _tmp6_;
	ValaSourceReference* _tmp7_;
	ValaSourceReference* _tmp8_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_template_new (NULL);
	template = _tmp1_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_TEMPLATE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (template);
			return NULL;
		} else {
			_vala_code_node_unref0 (template);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	while (TRUE) {
		ValaExpression* _tmp2_ = NULL;
		ValaExpression* _tmp3_;
		ValaTemplate* _tmp4_;
		if (!(vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_TEMPLATE)) {
			break;
		}
		_tmp3_ = vala_parser_parse_expression (self, &_inner_error0_);
		_tmp2_ = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (template);
				return NULL;
			} else {
				_vala_code_node_unref0 (template);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp4_ = template;
		vala_template_add_expression (_tmp4_, _tmp2_);
		vala_parser_expect (self, VALA_TOKEN_TYPE_COMMA, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (_tmp2_);
				_vala_code_node_unref0 (template);
				return NULL;
			} else {
				_vala_code_node_unref0 (_tmp2_);
				_vala_code_node_unref0 (template);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_vala_code_node_unref0 (_tmp2_);
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_TEMPLATE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (template);
			return NULL;
		} else {
			_vala_code_node_unref0 (template);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp5_ = template;
	_tmp6_ = begin;
	_tmp7_ = vala_parser_get_src (self, &_tmp6_);
	_tmp8_ = _tmp7_;
	vala_code_node_set_source_reference ((ValaCodeNode*) _tmp5_, _tmp8_);
	_vala_source_reference_unref0 (_tmp8_);
	result = (ValaExpression*) template;
	return result;
}

static ValaExpression*
vala_parser_parse_regex_literal (ValaParser* self,
                                 GError** error)
{
	ValaExpression* expr = NULL;
	ValaExpression* _tmp0_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_REGEX_LITERAL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp0_ = vala_parser_parse_literal (self, &_inner_error0_);
	expr = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = expr;
	return result;
}

static ValaExpression*
vala_parser_parse_member_access (ValaParser* self,
                                 ValaSourceLocation* begin,
                                 ValaExpression* inner,
                                 GError** error)
{
	gchar* id = NULL;
	gchar* _tmp0_;
	ValaList* type_arg_list = NULL;
	ValaList* _tmp1_;
	ValaMemberAccess* expr = NULL;
	const gchar* _tmp2_;
	ValaSourceLocation _tmp3_;
	ValaSourceReference* _tmp4_;
	ValaSourceReference* _tmp5_;
	ValaMemberAccess* _tmp6_;
	ValaMemberAccess* _tmp7_;
	ValaList* _tmp8_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (begin != NULL, NULL);
	g_return_val_if_fail (inner != NULL, NULL);
	vala_parser_expect (self, VALA_TOKEN_TYPE_DOT, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp0_ = vala_parser_parse_identifier (self, &_inner_error0_);
	id = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = vala_parser_parse_type_argument_list (self, TRUE, &_inner_error0_);
	type_arg_list = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (id);
			return NULL;
		} else {
			_g_free0 (id);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = id;
	_tmp3_ = *begin;
	_tmp4_ = vala_parser_get_src (self, &_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = vala_member_access_new (inner, _tmp2_, _tmp5_);
	_tmp7_ = _tmp6_;
	_vala_source_reference_unref0 (_tmp5_);
	expr = _tmp7_;
	_tmp8_ = type_arg_list;
	if (_tmp8_ != NULL) {
		{
			ValaList* _type_arg_list = NULL;
			ValaList* _tmp9_;
			ValaList* _tmp10_;
			gint _type_arg_size = 0;
			ValaList* _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _type_arg_index = 0;
			_tmp9_ = type_arg_list;
			_tmp10_ = _vala_iterable_ref0 (_tmp9_);
			_type_arg_list = _tmp10_;
			_tmp11_ = _type_arg_list;
			_tmp12_ = vala_collection_get_size ((ValaCollection*) _tmp11_);
			_tmp13_ = _tmp12_;
			_type_arg_size = _tmp13_;
			_type_arg_index = -1;
			while (TRUE) {
				gint _tmp14_;
				gint _tmp15_;
				ValaDataType* type_arg = NULL;
				ValaList* _tmp16_;
				gpointer _tmp17_;
				ValaMemberAccess* _tmp18_;
				ValaDataType* _tmp19_;
				_type_arg_index = _type_arg_index + 1;
				_tmp14_ = _type_arg_index;
				_tmp15_ = _type_arg_size;
				if (!(_tmp14_ < _tmp15_)) {
					break;
				}
				_tmp16_ = _type_arg_list;
				_tmp17_ = vala_list_get (_tmp16_, _type_arg_index);
				type_arg = (ValaDataType*) _tmp17_;
				_tmp18_ = expr;
				_tmp19_ = type_arg;
				vala_member_access_add_type_argument (_tmp18_, _tmp19_);
				_vala_code_node_unref0 (type_arg);
			}
			_vala_iterable_unref0 (_type_arg_list);
		}
	}
	result = (ValaExpression*) expr;
	_vala_iterable_unref0 (type_arg_list);
	_g_free0 (id);
	return result;
}

static ValaExpression*
vala_parser_parse_pointer_member_access (ValaParser* self,
                                         ValaSourceLocation* begin,
                                         ValaExpression* inner,
                                         GError** error)
{
	gchar* id = NULL;
	gchar* _tmp0_;
	ValaList* type_arg_list = NULL;
	ValaList* _tmp1_;
	ValaMemberAccess* expr = NULL;
	const gchar* _tmp2_;
	ValaSourceLocation _tmp3_;
	ValaSourceReference* _tmp4_;
	ValaSourceReference* _tmp5_;
	ValaMemberAccess* _tmp6_;
	ValaMemberAccess* _tmp7_;
	ValaList* _tmp8_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (begin != NULL, NULL);
	g_return_val_if_fail (inner != NULL, NULL);
	vala_parser_expect (self, VALA_TOKEN_TYPE_OP_PTR, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp0_ = vala_parser_parse_identifier (self, &_inner_error0_);
	id = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = vala_parser_parse_type_argument_list (self, TRUE, &_inner_error0_);
	type_arg_list = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (id);
			return NULL;
		} else {
			_g_free0 (id);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = id;
	_tmp3_ = *begin;
	_tmp4_ = vala_parser_get_src (self, &_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = vala_member_access_new_pointer (inner, _tmp2_, _tmp5_);
	_tmp7_ = _tmp6_;
	_vala_source_reference_unref0 (_tmp5_);
	expr = _tmp7_;
	_tmp8_ = type_arg_list;
	if (_tmp8_ != NULL) {
		{
			ValaList* _type_arg_list = NULL;
			ValaList* _tmp9_;
			ValaList* _tmp10_;
			gint _type_arg_size = 0;
			ValaList* _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _type_arg_index = 0;
			_tmp9_ = type_arg_list;
			_tmp10_ = _vala_iterable_ref0 (_tmp9_);
			_type_arg_list = _tmp10_;
			_tmp11_ = _type_arg_list;
			_tmp12_ = vala_collection_get_size ((ValaCollection*) _tmp11_);
			_tmp13_ = _tmp12_;
			_type_arg_size = _tmp13_;
			_type_arg_index = -1;
			while (TRUE) {
				gint _tmp14_;
				gint _tmp15_;
				ValaDataType* type_arg = NULL;
				ValaList* _tmp16_;
				gpointer _tmp17_;
				ValaMemberAccess* _tmp18_;
				ValaDataType* _tmp19_;
				_type_arg_index = _type_arg_index + 1;
				_tmp14_ = _type_arg_index;
				_tmp15_ = _type_arg_size;
				if (!(_tmp14_ < _tmp15_)) {
					break;
				}
				_tmp16_ = _type_arg_list;
				_tmp17_ = vala_list_get (_tmp16_, _type_arg_index);
				type_arg = (ValaDataType*) _tmp17_;
				_tmp18_ = expr;
				_tmp19_ = type_arg;
				vala_member_access_add_type_argument (_tmp18_, _tmp19_);
				_vala_code_node_unref0 (type_arg);
			}
			_vala_iterable_unref0 (_type_arg_list);
		}
	}
	result = (ValaExpression*) expr;
	_vala_iterable_unref0 (type_arg_list);
	_g_free0 (id);
	return result;
}

static ValaExpression*
vala_parser_parse_method_call (ValaParser* self,
                               ValaSourceLocation* begin,
                               ValaExpression* inner,
                               GError** error)
{
	ValaList* arg_list = NULL;
	ValaList* _tmp0_;
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp1_;
	ValaSourceReference* _tmp2_;
	ValaList* init_list = NULL;
	ValaList* _tmp3_;
	gboolean _tmp4_ = FALSE;
	ValaList* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (begin != NULL, NULL);
	g_return_val_if_fail (inner != NULL, NULL);
	_tmp0_ = vala_parser_parse_argument_list (self, &_inner_error0_);
	arg_list = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = *begin;
	_tmp2_ = vala_parser_get_src (self, &_tmp1_);
	src = _tmp2_;
	_tmp3_ = vala_parser_parse_object_initializer (self, &_inner_error0_);
	init_list = _tmp3_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_source_reference_unref0 (src);
			_vala_iterable_unref0 (arg_list);
			return NULL;
		} else {
			_vala_source_reference_unref0 (src);
			_vala_iterable_unref0 (arg_list);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp5_ = init_list;
	_tmp6_ = vala_collection_get_size ((ValaCollection*) _tmp5_);
	_tmp7_ = _tmp6_;
	if (_tmp7_ > 0) {
		_tmp4_ = VALA_IS_MEMBER_ACCESS (inner);
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		ValaMemberAccess* member = NULL;
		ValaMemberAccess* _tmp8_;
		ValaObjectCreationExpression* expr = NULL;
		ValaMemberAccess* _tmp9_;
		ValaSourceReference* _tmp10_;
		ValaObjectCreationExpression* _tmp11_;
		ValaObjectCreationExpression* _tmp12_;
		member = G_TYPE_CHECK_INSTANCE_CAST (inner, VALA_TYPE_MEMBER_ACCESS, ValaMemberAccess);
		_tmp8_ = member;
		vala_member_access_set_creation_member (_tmp8_, TRUE);
		_tmp9_ = member;
		_tmp10_ = src;
		_tmp11_ = vala_object_creation_expression_new (_tmp9_, _tmp10_);
		expr = _tmp11_;
		_tmp12_ = expr;
		vala_object_creation_expression_set_struct_creation (_tmp12_, TRUE);
		{
			ValaList* _arg_list = NULL;
			ValaList* _tmp13_;
			ValaList* _tmp14_;
			gint _arg_size = 0;
			ValaList* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			gint _arg_index = 0;
			_tmp13_ = arg_list;
			_tmp14_ = _vala_iterable_ref0 (_tmp13_);
			_arg_list = _tmp14_;
			_tmp15_ = _arg_list;
			_tmp16_ = vala_collection_get_size ((ValaCollection*) _tmp15_);
			_tmp17_ = _tmp16_;
			_arg_size = _tmp17_;
			_arg_index = -1;
			while (TRUE) {
				gint _tmp18_;
				gint _tmp19_;
				ValaExpression* arg = NULL;
				ValaList* _tmp20_;
				gpointer _tmp21_;
				ValaObjectCreationExpression* _tmp22_;
				ValaExpression* _tmp23_;
				_arg_index = _arg_index + 1;
				_tmp18_ = _arg_index;
				_tmp19_ = _arg_size;
				if (!(_tmp18_ < _tmp19_)) {
					break;
				}
				_tmp20_ = _arg_list;
				_tmp21_ = vala_list_get (_tmp20_, _arg_index);
				arg = (ValaExpression*) _tmp21_;
				_tmp22_ = expr;
				_tmp23_ = arg;
				vala_object_creation_expression_add_argument (_tmp22_, _tmp23_);
				_vala_code_node_unref0 (arg);
			}
			_vala_iterable_unref0 (_arg_list);
		}
		{
			ValaList* _initializer_list = NULL;
			ValaList* _tmp24_;
			ValaList* _tmp25_;
			gint _initializer_size = 0;
			ValaList* _tmp26_;
			gint _tmp27_;
			gint _tmp28_;
			gint _initializer_index = 0;
			_tmp24_ = init_list;
			_tmp25_ = _vala_iterable_ref0 (_tmp24_);
			_initializer_list = _tmp25_;
			_tmp26_ = _initializer_list;
			_tmp27_ = vala_collection_get_size ((ValaCollection*) _tmp26_);
			_tmp28_ = _tmp27_;
			_initializer_size = _tmp28_;
			_initializer_index = -1;
			while (TRUE) {
				gint _tmp29_;
				gint _tmp30_;
				ValaMemberInitializer* initializer = NULL;
				ValaList* _tmp31_;
				gpointer _tmp32_;
				ValaObjectCreationExpression* _tmp33_;
				ValaMemberInitializer* _tmp34_;
				_initializer_index = _initializer_index + 1;
				_tmp29_ = _initializer_index;
				_tmp30_ = _initializer_size;
				if (!(_tmp29_ < _tmp30_)) {
					break;
				}
				_tmp31_ = _initializer_list;
				_tmp32_ = vala_list_get (_tmp31_, _initializer_index);
				initializer = (ValaMemberInitializer*) _tmp32_;
				_tmp33_ = expr;
				_tmp34_ = initializer;
				vala_object_creation_expression_add_member_initializer (_tmp33_, _tmp34_);
				_vala_code_node_unref0 (initializer);
			}
			_vala_iterable_unref0 (_initializer_list);
		}
		result = (ValaExpression*) expr;
		_vala_iterable_unref0 (init_list);
		_vala_source_reference_unref0 (src);
		_vala_iterable_unref0 (arg_list);
		return result;
	} else {
		ValaMethodCall* expr = NULL;
		ValaSourceReference* _tmp35_;
		ValaMethodCall* _tmp36_;
		_tmp35_ = src;
		_tmp36_ = vala_method_call_new (inner, _tmp35_);
		expr = _tmp36_;
		{
			ValaList* _arg_list = NULL;
			ValaList* _tmp37_;
			ValaList* _tmp38_;
			gint _arg_size = 0;
			ValaList* _tmp39_;
			gint _tmp40_;
			gint _tmp41_;
			gint _arg_index = 0;
			_tmp37_ = arg_list;
			_tmp38_ = _vala_iterable_ref0 (_tmp37_);
			_arg_list = _tmp38_;
			_tmp39_ = _arg_list;
			_tmp40_ = vala_collection_get_size ((ValaCollection*) _tmp39_);
			_tmp41_ = _tmp40_;
			_arg_size = _tmp41_;
			_arg_index = -1;
			while (TRUE) {
				gint _tmp42_;
				gint _tmp43_;
				ValaExpression* arg = NULL;
				ValaList* _tmp44_;
				gpointer _tmp45_;
				ValaMethodCall* _tmp46_;
				ValaExpression* _tmp47_;
				_arg_index = _arg_index + 1;
				_tmp42_ = _arg_index;
				_tmp43_ = _arg_size;
				if (!(_tmp42_ < _tmp43_)) {
					break;
				}
				_tmp44_ = _arg_list;
				_tmp45_ = vala_list_get (_tmp44_, _arg_index);
				arg = (ValaExpression*) _tmp45_;
				_tmp46_ = expr;
				_tmp47_ = arg;
				vala_method_call_add_argument (_tmp46_, _tmp47_);
				_vala_code_node_unref0 (arg);
			}
			_vala_iterable_unref0 (_arg_list);
		}
		result = (ValaExpression*) expr;
		_vala_iterable_unref0 (init_list);
		_vala_source_reference_unref0 (src);
		_vala_iterable_unref0 (arg_list);
		return result;
	}
	_vala_iterable_unref0 (init_list);
	_vala_source_reference_unref0 (src);
	_vala_iterable_unref0 (arg_list);
}

static ValaExpression*
vala_parser_parse_element_access (ValaParser* self,
                                  ValaSourceLocation* begin,
                                  ValaExpression* inner,
                                  GError** error)
{
	ValaList* index_list = NULL;
	ValaList* _tmp0_;
	ValaExpression* stop = NULL;
	gboolean _tmp1_ = FALSE;
	ValaList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	ValaExpression* _tmp8_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (begin != NULL, NULL);
	g_return_val_if_fail (inner != NULL, NULL);
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_BRACKET, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp0_ = vala_parser_parse_expression_list (self, &_inner_error0_);
	index_list = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	stop = NULL;
	_tmp2_ = index_list;
	_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ == 1) {
		_tmp1_ = vala_parser_accept (self, VALA_TOKEN_TYPE_COLON);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		ValaExpression* _tmp5_ = NULL;
		ValaExpression* _tmp6_;
		ValaExpression* _tmp7_;
		_tmp6_ = vala_parser_parse_expression (self, &_inner_error0_);
		_tmp5_ = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (stop);
				_vala_iterable_unref0 (index_list);
				return NULL;
			} else {
				_vala_code_node_unref0 (stop);
				_vala_iterable_unref0 (index_list);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp7_ = _tmp5_;
		_tmp5_ = NULL;
		_vala_code_node_unref0 (stop);
		stop = _tmp7_;
		_vala_code_node_unref0 (_tmp5_);
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_BRACKET, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (stop);
			_vala_iterable_unref0 (index_list);
			return NULL;
		} else {
			_vala_code_node_unref0 (stop);
			_vala_iterable_unref0 (index_list);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp8_ = stop;
	if (_tmp8_ == NULL) {
		ValaElementAccess* expr = NULL;
		ValaSourceLocation _tmp9_;
		ValaSourceReference* _tmp10_;
		ValaSourceReference* _tmp11_;
		ValaElementAccess* _tmp12_;
		ValaElementAccess* _tmp13_;
		_tmp9_ = *begin;
		_tmp10_ = vala_parser_get_src (self, &_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = vala_element_access_new (inner, _tmp11_);
		_tmp13_ = _tmp12_;
		_vala_source_reference_unref0 (_tmp11_);
		expr = _tmp13_;
		{
			ValaList* _index_list = NULL;
			ValaList* _tmp14_;
			ValaList* _tmp15_;
			gint _index_size = 0;
			ValaList* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			gint _index_index = 0;
			_tmp14_ = index_list;
			_tmp15_ = _vala_iterable_ref0 (_tmp14_);
			_index_list = _tmp15_;
			_tmp16_ = _index_list;
			_tmp17_ = vala_collection_get_size ((ValaCollection*) _tmp16_);
			_tmp18_ = _tmp17_;
			_index_size = _tmp18_;
			_index_index = -1;
			while (TRUE) {
				gint _tmp19_;
				gint _tmp20_;
				ValaExpression* index = NULL;
				ValaList* _tmp21_;
				gpointer _tmp22_;
				ValaElementAccess* _tmp23_;
				ValaExpression* _tmp24_;
				_index_index = _index_index + 1;
				_tmp19_ = _index_index;
				_tmp20_ = _index_size;
				if (!(_tmp19_ < _tmp20_)) {
					break;
				}
				_tmp21_ = _index_list;
				_tmp22_ = vala_list_get (_tmp21_, _index_index);
				index = (ValaExpression*) _tmp22_;
				_tmp23_ = expr;
				_tmp24_ = index;
				vala_element_access_append_index (_tmp23_, _tmp24_);
				_vala_code_node_unref0 (index);
			}
			_vala_iterable_unref0 (_index_list);
		}
		result = (ValaExpression*) expr;
		_vala_code_node_unref0 (stop);
		_vala_iterable_unref0 (index_list);
		return result;
	} else {
		ValaList* _tmp25_;
		gpointer _tmp26_;
		ValaExpression* _tmp27_;
		ValaExpression* _tmp28_;
		ValaSourceLocation _tmp29_;
		ValaSourceReference* _tmp30_;
		ValaSourceReference* _tmp31_;
		ValaSliceExpression* _tmp32_;
		ValaExpression* _tmp33_;
		_tmp25_ = index_list;
		_tmp26_ = vala_list_get (_tmp25_, 0);
		_tmp27_ = (ValaExpression*) _tmp26_;
		_tmp28_ = stop;
		_tmp29_ = *begin;
		_tmp30_ = vala_parser_get_src (self, &_tmp29_);
		_tmp31_ = _tmp30_;
		_tmp32_ = vala_slice_expression_new (inner, _tmp27_, _tmp28_, _tmp31_);
		_tmp33_ = (ValaExpression*) _tmp32_;
		_vala_source_reference_unref0 (_tmp31_);
		_vala_code_node_unref0 (_tmp27_);
		result = _tmp33_;
		_vala_code_node_unref0 (stop);
		_vala_iterable_unref0 (index_list);
		return result;
	}
	_vala_code_node_unref0 (stop);
	_vala_iterable_unref0 (index_list);
}

static ValaList*
vala_parser_parse_expression_list (ValaParser* self,
                                   GError** error)
{
	ValaArrayList* list = NULL;
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	GError* _inner_error0_ = NULL;
	ValaList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (VALA_TYPE_EXPRESSION, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp0_);
	list = _tmp1_;
	{
		gboolean _tmp2_ = FALSE;
		_tmp2_ = TRUE;
		while (TRUE) {
			ValaExpression* _tmp3_ = NULL;
			ValaExpression* _tmp4_;
			ValaArrayList* _tmp5_;
			if (!_tmp2_) {
				if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
					break;
				}
			}
			_tmp2_ = FALSE;
			_tmp4_ = vala_parser_parse_expression (self, &_inner_error0_);
			_tmp3_ = _tmp4_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_iterable_unref0 (list);
					return NULL;
				} else {
					_vala_iterable_unref0 (list);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp5_ = list;
			vala_collection_add ((ValaCollection*) _tmp5_, _tmp3_);
			_vala_code_node_unref0 (_tmp3_);
		}
	}
	result = (ValaList*) list;
	return result;
}

static ValaExpression*
vala_parser_parse_this_access (ValaParser* self,
                               GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSourceLocation _tmp1_;
	ValaSourceReference* _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaMemberAccess* _tmp4_;
	ValaExpression* _tmp5_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_THIS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = begin;
	_tmp2_ = vala_parser_get_src (self, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = vala_member_access_new (NULL, "this", _tmp3_);
	_tmp5_ = (ValaExpression*) _tmp4_;
	_vala_source_reference_unref0 (_tmp3_);
	result = _tmp5_;
	return result;
}

static ValaExpression*
vala_parser_parse_base_access (ValaParser* self,
                               GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSourceLocation _tmp1_;
	ValaSourceReference* _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaBaseAccess* _tmp4_;
	ValaExpression* _tmp5_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_BASE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = begin;
	_tmp2_ = vala_parser_get_src (self, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = vala_base_access_new (_tmp3_);
	_tmp5_ = (ValaExpression*) _tmp4_;
	_vala_source_reference_unref0 (_tmp3_);
	result = _tmp5_;
	return result;
}

static ValaExpression*
vala_parser_parse_post_increment_expression (ValaParser* self,
                                             ValaSourceLocation* begin,
                                             ValaExpression* inner,
                                             GError** error)
{
	ValaSourceLocation _tmp0_;
	ValaSourceReference* _tmp1_;
	ValaSourceReference* _tmp2_;
	ValaPostfixExpression* _tmp3_;
	ValaExpression* _tmp4_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (begin != NULL, NULL);
	g_return_val_if_fail (inner != NULL, NULL);
	vala_parser_expect (self, VALA_TOKEN_TYPE_OP_INC, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp0_ = *begin;
	_tmp1_ = vala_parser_get_src (self, &_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = vala_postfix_expression_new (inner, TRUE, _tmp2_);
	_tmp4_ = (ValaExpression*) _tmp3_;
	_vala_source_reference_unref0 (_tmp2_);
	result = _tmp4_;
	return result;
}

static ValaExpression*
vala_parser_parse_post_decrement_expression (ValaParser* self,
                                             ValaSourceLocation* begin,
                                             ValaExpression* inner,
                                             GError** error)
{
	ValaSourceLocation _tmp0_;
	ValaSourceReference* _tmp1_;
	ValaSourceReference* _tmp2_;
	ValaPostfixExpression* _tmp3_;
	ValaExpression* _tmp4_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (begin != NULL, NULL);
	g_return_val_if_fail (inner != NULL, NULL);
	vala_parser_expect (self, VALA_TOKEN_TYPE_OP_DEC, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp0_ = *begin;
	_tmp1_ = vala_parser_get_src (self, &_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = vala_postfix_expression_new (inner, FALSE, _tmp2_);
	_tmp4_ = (ValaExpression*) _tmp3_;
	_vala_source_reference_unref0 (_tmp2_);
	result = _tmp4_;
	return result;
}

static ValaExpression*
vala_parser_parse_object_or_array_creation_expression (ValaParser* self,
                                                       GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaMemberAccess* member = NULL;
	ValaMemberAccess* _tmp5_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_NEW, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	if (vala_parser_is_inner_array_type (self)) {
		ValaSourceLocation _tmp1_;
		ValaExpression* _tmp2_ = NULL;
		ValaExpression* _tmp3_;
		ValaExpression* _tmp4_;
		_tmp1_ = begin;
		vala_parser_rollback (self, &_tmp1_);
		_tmp3_ = vala_parser_parse_array_creation_expression (self, &_inner_error0_);
		_tmp2_ = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp4_ = _tmp2_;
		_tmp2_ = NULL;
		result = _tmp4_;
		_vala_code_node_unref0 (_tmp2_);
		return result;
	}
	_tmp5_ = vala_parser_parse_member_name (self, NULL, &_inner_error0_);
	member = _tmp5_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	if (vala_parser_current (self) == VALA_TOKEN_TYPE_OPEN_PARENS) {
		ValaExpression* expr = NULL;
		ValaSourceLocation _tmp6_;
		ValaMemberAccess* _tmp7_;
		ValaExpression* _tmp8_;
		_tmp6_ = begin;
		_tmp7_ = member;
		_tmp8_ = vala_parser_parse_object_creation_expression (self, &_tmp6_, _tmp7_, &_inner_error0_);
		expr = _tmp8_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (member);
				return NULL;
			} else {
				_vala_code_node_unref0 (member);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		result = expr;
		_vala_code_node_unref0 (member);
		return result;
	} else {
		gboolean is_pointer_type = FALSE;
		is_pointer_type = FALSE;
		while (TRUE) {
			if (!vala_parser_accept (self, VALA_TOKEN_TYPE_STAR)) {
				break;
			}
			is_pointer_type = TRUE;
		}
		if (!is_pointer_type) {
			vala_parser_accept (self, VALA_TOKEN_TYPE_INTERR);
		}
		if (vala_parser_accept (self, VALA_TOKEN_TYPE_OPEN_BRACKET)) {
			ValaSourceLocation _tmp9_;
			ValaExpression* expr = NULL;
			ValaExpression* _tmp10_;
			_tmp9_ = begin;
			vala_parser_rollback (self, &_tmp9_);
			_tmp10_ = vala_parser_parse_array_creation_expression (self, &_inner_error0_);
			expr = _tmp10_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (member);
					return NULL;
				} else {
					_vala_code_node_unref0 (member);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			result = expr;
			_vala_code_node_unref0 (member);
			return result;
		} else {
			GError* _tmp11_;
			_tmp11_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "expected ( or [");
			_inner_error0_ = _tmp11_;
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (member);
				return NULL;
			} else {
				_vala_code_node_unref0 (member);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
	_vala_code_node_unref0 (member);
}

static ValaExpression*
vala_parser_parse_object_creation_expression (ValaParser* self,
                                              ValaSourceLocation* begin,
                                              ValaMemberAccess* member,
                                              GError** error)
{
	ValaList* arg_list = NULL;
	ValaList* _tmp0_;
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp1_;
	ValaSourceReference* _tmp2_;
	ValaList* init_list = NULL;
	ValaList* _tmp3_;
	ValaObjectCreationExpression* expr = NULL;
	ValaSourceReference* _tmp4_;
	ValaObjectCreationExpression* _tmp5_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (begin != NULL, NULL);
	g_return_val_if_fail (member != NULL, NULL);
	vala_member_access_set_creation_member (member, TRUE);
	_tmp0_ = vala_parser_parse_argument_list (self, &_inner_error0_);
	arg_list = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = *begin;
	_tmp2_ = vala_parser_get_src (self, &_tmp1_);
	src = _tmp2_;
	_tmp3_ = vala_parser_parse_object_initializer (self, &_inner_error0_);
	init_list = _tmp3_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_source_reference_unref0 (src);
			_vala_iterable_unref0 (arg_list);
			return NULL;
		} else {
			_vala_source_reference_unref0 (src);
			_vala_iterable_unref0 (arg_list);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp4_ = src;
	_tmp5_ = vala_object_creation_expression_new (member, _tmp4_);
	expr = _tmp5_;
	{
		ValaList* _arg_list = NULL;
		ValaList* _tmp6_;
		ValaList* _tmp7_;
		gint _arg_size = 0;
		ValaList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _arg_index = 0;
		_tmp6_ = arg_list;
		_tmp7_ = _vala_iterable_ref0 (_tmp6_);
		_arg_list = _tmp7_;
		_tmp8_ = _arg_list;
		_tmp9_ = vala_collection_get_size ((ValaCollection*) _tmp8_);
		_tmp10_ = _tmp9_;
		_arg_size = _tmp10_;
		_arg_index = -1;
		while (TRUE) {
			gint _tmp11_;
			gint _tmp12_;
			ValaExpression* arg = NULL;
			ValaList* _tmp13_;
			gpointer _tmp14_;
			ValaObjectCreationExpression* _tmp15_;
			ValaExpression* _tmp16_;
			_arg_index = _arg_index + 1;
			_tmp11_ = _arg_index;
			_tmp12_ = _arg_size;
			if (!(_tmp11_ < _tmp12_)) {
				break;
			}
			_tmp13_ = _arg_list;
			_tmp14_ = vala_list_get (_tmp13_, _arg_index);
			arg = (ValaExpression*) _tmp14_;
			_tmp15_ = expr;
			_tmp16_ = arg;
			vala_object_creation_expression_add_argument (_tmp15_, _tmp16_);
			_vala_code_node_unref0 (arg);
		}
		_vala_iterable_unref0 (_arg_list);
	}
	{
		ValaList* _initializer_list = NULL;
		ValaList* _tmp17_;
		ValaList* _tmp18_;
		gint _initializer_size = 0;
		ValaList* _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		gint _initializer_index = 0;
		_tmp17_ = init_list;
		_tmp18_ = _vala_iterable_ref0 (_tmp17_);
		_initializer_list = _tmp18_;
		_tmp19_ = _initializer_list;
		_tmp20_ = vala_collection_get_size ((ValaCollection*) _tmp19_);
		_tmp21_ = _tmp20_;
		_initializer_size = _tmp21_;
		_initializer_index = -1;
		while (TRUE) {
			gint _tmp22_;
			gint _tmp23_;
			ValaMemberInitializer* initializer = NULL;
			ValaList* _tmp24_;
			gpointer _tmp25_;
			ValaObjectCreationExpression* _tmp26_;
			ValaMemberInitializer* _tmp27_;
			_initializer_index = _initializer_index + 1;
			_tmp22_ = _initializer_index;
			_tmp23_ = _initializer_size;
			if (!(_tmp22_ < _tmp23_)) {
				break;
			}
			_tmp24_ = _initializer_list;
			_tmp25_ = vala_list_get (_tmp24_, _initializer_index);
			initializer = (ValaMemberInitializer*) _tmp25_;
			_tmp26_ = expr;
			_tmp27_ = initializer;
			vala_object_creation_expression_add_member_initializer (_tmp26_, _tmp27_);
			_vala_code_node_unref0 (initializer);
		}
		_vala_iterable_unref0 (_initializer_list);
	}
	result = (ValaExpression*) expr;
	_vala_iterable_unref0 (init_list);
	_vala_source_reference_unref0 (src);
	_vala_iterable_unref0 (arg_list);
	return result;
}

static ValaExpression*
vala_parser_parse_array_creation_expression (ValaParser* self,
                                             GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	gboolean inner_array_type = FALSE;
	ValaMemberAccess* member = NULL;
	ValaMemberAccess* _tmp1_;
	ValaDataType* element_type = NULL;
	ValaMemberAccess* _tmp2_;
	ValaUnresolvedType* _tmp3_;
	gboolean is_pointer_type = FALSE;
	gboolean size_specified = FALSE;
	ValaList* size_specifier_list = NULL;
	gboolean first = FALSE;
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp31_;
	ValaSourceReference* _tmp32_;
	ValaInitializerList* initializer = NULL;
	ValaArrayCreationExpression* expr = NULL;
	ValaDataType* _tmp36_;
	ValaList* _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	ValaInitializerList* _tmp40_;
	ValaSourceReference* _tmp41_;
	ValaArrayCreationExpression* _tmp42_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_NEW, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	inner_array_type = vala_parser_is_inner_array_type (self);
	if (inner_array_type) {
		vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_UNOWNED, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
	_tmp1_ = vala_parser_parse_member_name (self, NULL, &_inner_error0_);
	member = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = member;
	_tmp3_ = vala_unresolved_type_new_from_expression ((ValaExpression*) _tmp2_);
	element_type = (ValaDataType*) _tmp3_;
	is_pointer_type = FALSE;
	while (TRUE) {
		ValaDataType* _tmp4_;
		ValaSourceLocation _tmp5_;
		ValaSourceReference* _tmp6_;
		ValaSourceReference* _tmp7_;
		ValaPointerType* _tmp8_;
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_STAR)) {
			break;
		}
		_tmp4_ = element_type;
		_tmp5_ = begin;
		_tmp6_ = vala_parser_get_src (self, &_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = vala_pointer_type_new (_tmp4_, _tmp7_);
		_vala_code_node_unref0 (element_type);
		element_type = (ValaDataType*) _tmp8_;
		_vala_source_reference_unref0 (_tmp7_);
		is_pointer_type = TRUE;
	}
	if (!is_pointer_type) {
		if (vala_parser_accept (self, VALA_TOKEN_TYPE_INTERR)) {
			ValaDataType* _tmp9_;
			_tmp9_ = element_type;
			vala_data_type_set_nullable (_tmp9_, TRUE);
		}
	}
	if (inner_array_type) {
		ValaDataType* _tmp10_;
		vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (element_type);
				_vala_code_node_unref0 (member);
				return NULL;
			} else {
				_vala_code_node_unref0 (element_type);
				_vala_code_node_unref0 (member);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp10_ = element_type;
		vala_data_type_set_value_owned (_tmp10_, FALSE);
	} else {
		ValaDataType* _tmp11_;
		_tmp11_ = element_type;
		vala_data_type_set_value_owned (_tmp11_, TRUE);
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_BRACKET, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (element_type);
			_vala_code_node_unref0 (member);
			return NULL;
		} else {
			_vala_code_node_unref0 (element_type);
			_vala_code_node_unref0 (member);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	size_specified = FALSE;
	size_specifier_list = NULL;
	first = TRUE;
	{
		gboolean _tmp12_ = FALSE;
		_tmp12_ = TRUE;
		while (TRUE) {
			GEqualFunc _tmp22_;
			ValaArrayList* _tmp23_;
			if (!_tmp12_) {
				if (!vala_parser_accept (self, VALA_TOKEN_TYPE_OPEN_BRACKET)) {
					break;
				}
			}
			_tmp12_ = FALSE;
			if (!first) {
				ValaDataType* _tmp14_;
				ValaList* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				ValaDataType* _tmp18_;
				ValaSourceReference* _tmp19_;
				ValaSourceReference* _tmp20_;
				ValaArrayType* _tmp21_;
				if (size_specified) {
					GError* _tmp13_;
					_tmp13_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "size of inner arrays must not be specified in array creation expressio" \
"n");
					_inner_error0_ = _tmp13_;
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_iterable_unref0 (size_specifier_list);
						_vala_code_node_unref0 (element_type);
						_vala_code_node_unref0 (member);
						return NULL;
					} else {
						_vala_iterable_unref0 (size_specifier_list);
						_vala_code_node_unref0 (element_type);
						_vala_code_node_unref0 (member);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp14_ = element_type;
				_tmp15_ = size_specifier_list;
				_tmp16_ = vala_collection_get_size ((ValaCollection*) _tmp15_);
				_tmp17_ = _tmp16_;
				_tmp18_ = element_type;
				_tmp19_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp18_);
				_tmp20_ = _tmp19_;
				_tmp21_ = vala_array_type_new (_tmp14_, _tmp17_, _tmp20_);
				_vala_code_node_unref0 (element_type);
				element_type = (ValaDataType*) _tmp21_;
			} else {
				first = FALSE;
			}
			_tmp22_ = g_direct_equal;
			_tmp23_ = vala_array_list_new (VALA_TYPE_EXPRESSION, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp22_);
			_vala_iterable_unref0 (size_specifier_list);
			size_specifier_list = (ValaList*) _tmp23_;
			{
				gboolean _tmp24_ = FALSE;
				_tmp24_ = TRUE;
				while (TRUE) {
					ValaExpression* size = NULL;
					gboolean _tmp25_ = FALSE;
					ValaList* _tmp29_;
					ValaExpression* _tmp30_;
					if (!_tmp24_) {
						if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
							break;
						}
					}
					_tmp24_ = FALSE;
					size = NULL;
					if (vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_BRACKET) {
						_tmp25_ = vala_parser_current (self) != VALA_TOKEN_TYPE_COMMA;
					} else {
						_tmp25_ = FALSE;
					}
					if (_tmp25_) {
						ValaExpression* _tmp26_ = NULL;
						ValaExpression* _tmp27_;
						ValaExpression* _tmp28_;
						_tmp27_ = vala_parser_parse_expression (self, &_inner_error0_);
						_tmp26_ = _tmp27_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							if (_inner_error0_->domain == VALA_PARSE_ERROR) {
								g_propagate_error (error, _inner_error0_);
								_vala_code_node_unref0 (size);
								_vala_iterable_unref0 (size_specifier_list);
								_vala_code_node_unref0 (element_type);
								_vala_code_node_unref0 (member);
								return NULL;
							} else {
								_vala_code_node_unref0 (size);
								_vala_iterable_unref0 (size_specifier_list);
								_vala_code_node_unref0 (element_type);
								_vala_code_node_unref0 (member);
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return NULL;
							}
						}
						_tmp28_ = _tmp26_;
						_tmp26_ = NULL;
						_vala_code_node_unref0 (size);
						size = _tmp28_;
						size_specified = TRUE;
						_vala_code_node_unref0 (_tmp26_);
					}
					_tmp29_ = size_specifier_list;
					_tmp30_ = size;
					vala_collection_add ((ValaCollection*) _tmp29_, _tmp30_);
					_vala_code_node_unref0 (size);
				}
			}
			vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_BRACKET, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_iterable_unref0 (size_specifier_list);
					_vala_code_node_unref0 (element_type);
					_vala_code_node_unref0 (member);
					return NULL;
				} else {
					_vala_iterable_unref0 (size_specifier_list);
					_vala_code_node_unref0 (element_type);
					_vala_code_node_unref0 (member);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
		}
	}
	_tmp31_ = begin;
	_tmp32_ = vala_parser_get_src (self, &_tmp31_);
	src = _tmp32_;
	initializer = NULL;
	if (vala_parser_current (self) == VALA_TOKEN_TYPE_OPEN_BRACE) {
		ValaInitializerList* _tmp33_ = NULL;
		ValaInitializerList* _tmp34_;
		ValaInitializerList* _tmp35_;
		_tmp34_ = vala_parser_parse_initializer (self, &_inner_error0_);
		_tmp33_ = _tmp34_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (initializer);
				_vala_source_reference_unref0 (src);
				_vala_iterable_unref0 (size_specifier_list);
				_vala_code_node_unref0 (element_type);
				_vala_code_node_unref0 (member);
				return NULL;
			} else {
				_vala_code_node_unref0 (initializer);
				_vala_source_reference_unref0 (src);
				_vala_iterable_unref0 (size_specifier_list);
				_vala_code_node_unref0 (element_type);
				_vala_code_node_unref0 (member);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp35_ = _tmp33_;
		_tmp33_ = NULL;
		_vala_code_node_unref0 (initializer);
		initializer = _tmp35_;
		_vala_code_node_unref0 (_tmp33_);
	}
	_tmp36_ = element_type;
	_tmp37_ = size_specifier_list;
	_tmp38_ = vala_collection_get_size ((ValaCollection*) _tmp37_);
	_tmp39_ = _tmp38_;
	_tmp40_ = initializer;
	_tmp41_ = src;
	_tmp42_ = vala_array_creation_expression_new (_tmp36_, _tmp39_, _tmp40_, _tmp41_);
	expr = _tmp42_;
	if (size_specified) {
		{
			ValaList* _size_list = NULL;
			ValaList* _tmp43_;
			ValaList* _tmp44_;
			gint _size_size = 0;
			ValaList* _tmp45_;
			gint _tmp46_;
			gint _tmp47_;
			gint _size_index = 0;
			_tmp43_ = size_specifier_list;
			_tmp44_ = _vala_iterable_ref0 (_tmp43_);
			_size_list = _tmp44_;
			_tmp45_ = _size_list;
			_tmp46_ = vala_collection_get_size ((ValaCollection*) _tmp45_);
			_tmp47_ = _tmp46_;
			_size_size = _tmp47_;
			_size_index = -1;
			while (TRUE) {
				gint _tmp48_;
				gint _tmp49_;
				ValaExpression* size = NULL;
				ValaList* _tmp50_;
				gpointer _tmp51_;
				ValaArrayCreationExpression* _tmp52_;
				ValaExpression* _tmp53_;
				_size_index = _size_index + 1;
				_tmp48_ = _size_index;
				_tmp49_ = _size_size;
				if (!(_tmp48_ < _tmp49_)) {
					break;
				}
				_tmp50_ = _size_list;
				_tmp51_ = vala_list_get (_tmp50_, _size_index);
				size = (ValaExpression*) _tmp51_;
				_tmp52_ = expr;
				_tmp53_ = size;
				vala_array_creation_expression_append_size (_tmp52_, _tmp53_);
				_vala_code_node_unref0 (size);
			}
			_vala_iterable_unref0 (_size_list);
		}
	} else {
		ValaInitializerList* _tmp54_;
		_tmp54_ = initializer;
		if (_tmp54_ == NULL) {
			ValaSourceReference* _tmp55_;
			GError* _tmp56_;
			_tmp55_ = src;
			vala_report_warning (_tmp55_, "possibly missing array size");
			_tmp56_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "expected array initializer list");
			_inner_error0_ = _tmp56_;
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (expr);
				_vala_code_node_unref0 (initializer);
				_vala_source_reference_unref0 (src);
				_vala_iterable_unref0 (size_specifier_list);
				_vala_code_node_unref0 (element_type);
				_vala_code_node_unref0 (member);
				return NULL;
			} else {
				_vala_code_node_unref0 (expr);
				_vala_code_node_unref0 (initializer);
				_vala_source_reference_unref0 (src);
				_vala_iterable_unref0 (size_specifier_list);
				_vala_code_node_unref0 (element_type);
				_vala_code_node_unref0 (member);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
	result = (ValaExpression*) expr;
	_vala_code_node_unref0 (initializer);
	_vala_source_reference_unref0 (src);
	_vala_iterable_unref0 (size_specifier_list);
	_vala_code_node_unref0 (element_type);
	_vala_code_node_unref0 (member);
	return result;
}

static ValaList*
vala_parser_parse_object_initializer (ValaParser* self,
                                      GError** error)
{
	ValaArrayList* list = NULL;
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	GError* _inner_error0_ = NULL;
	ValaList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (VALA_TYPE_MEMBER_INITIALIZER, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp0_);
	list = _tmp1_;
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_OPEN_BRACE)) {
		while (TRUE) {
			ValaMemberInitializer* _tmp2_ = NULL;
			ValaMemberInitializer* _tmp3_;
			ValaArrayList* _tmp4_;
			if (!(vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_BRACE)) {
				break;
			}
			_tmp3_ = vala_parser_parse_member_initializer (self, &_inner_error0_);
			_tmp2_ = _tmp3_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_iterable_unref0 (list);
					return NULL;
				} else {
					_vala_iterable_unref0 (list);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp4_ = list;
			vala_collection_add ((ValaCollection*) _tmp4_, _tmp2_);
			if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
				_vala_code_node_unref0 (_tmp2_);
				break;
			}
			_vala_code_node_unref0 (_tmp2_);
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_BRACE, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_iterable_unref0 (list);
				return NULL;
			} else {
				_vala_iterable_unref0 (list);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
	result = (ValaList*) list;
	return result;
}

static ValaMemberInitializer*
vala_parser_parse_member_initializer (ValaParser* self,
                                      GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	gchar* id = NULL;
	gchar* _tmp1_;
	ValaExpression* expr = NULL;
	ValaExpression* _tmp2_;
	const gchar* _tmp3_;
	ValaExpression* _tmp4_;
	ValaSourceLocation _tmp5_;
	ValaSourceReference* _tmp6_;
	ValaSourceReference* _tmp7_;
	ValaMemberInitializer* _tmp8_;
	ValaMemberInitializer* _tmp9_;
	GError* _inner_error0_ = NULL;
	ValaMemberInitializer* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_identifier (self, &_inner_error0_);
	id = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_ASSIGN, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (id);
			return NULL;
		} else {
			_g_free0 (id);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = vala_parser_parse_expression (self, &_inner_error0_);
	expr = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (id);
			return NULL;
		} else {
			_g_free0 (id);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp3_ = id;
	_tmp4_ = expr;
	_tmp5_ = begin;
	_tmp6_ = vala_parser_get_src (self, &_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = vala_member_initializer_new (_tmp3_, _tmp4_, _tmp7_);
	_tmp9_ = _tmp8_;
	_vala_source_reference_unref0 (_tmp7_);
	result = _tmp9_;
	_vala_code_node_unref0 (expr);
	_g_free0 (id);
	return result;
}

static ValaExpression*
vala_parser_parse_yield_expression (ValaParser* self,
                                    GError** error)
{
	ValaExpression* expr = NULL;
	ValaExpression* _tmp0_;
	ValaMethodCall* call = NULL;
	ValaExpression* _tmp1_;
	ValaObjectCreationExpression* object_creation = NULL;
	ValaExpression* _tmp2_;
	gboolean _tmp3_ = FALSE;
	ValaMethodCall* _tmp4_;
	ValaMethodCall* _tmp10_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_expect (self, VALA_TOKEN_TYPE_YIELD, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp0_ = vala_parser_parse_expression (self, &_inner_error0_);
	expr = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = expr;
	call = VALA_IS_METHOD_CALL (_tmp1_) ? ((ValaMethodCall*) _tmp1_) : NULL;
	_tmp2_ = expr;
	object_creation = VALA_IS_OBJECT_CREATION_EXPRESSION (_tmp2_) ? ((ValaObjectCreationExpression*) _tmp2_) : NULL;
	_tmp4_ = call;
	if (_tmp4_ == NULL) {
		ValaObjectCreationExpression* _tmp5_;
		_tmp5_ = object_creation;
		_tmp3_ = _tmp5_ == NULL;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		ValaExpression* _tmp6_;
		ValaSourceReference* _tmp7_;
		ValaSourceReference* _tmp8_;
		GError* _tmp9_;
		_tmp6_ = expr;
		_tmp7_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp6_);
		_tmp8_ = _tmp7_;
		vala_report_error (_tmp8_, "syntax error, expected method call");
		_tmp9_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "expected method call");
		_inner_error0_ = _tmp9_;
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (expr);
			return NULL;
		} else {
			_vala_code_node_unref0 (expr);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp10_ = call;
	if (_tmp10_ != NULL) {
		ValaMethodCall* _tmp11_;
		_tmp11_ = call;
		vala_method_call_set_is_yield_expression (_tmp11_, TRUE);
	} else {
		ValaObjectCreationExpression* _tmp12_;
		_tmp12_ = object_creation;
		if (_tmp12_ != NULL) {
			ValaObjectCreationExpression* _tmp13_;
			_tmp13_ = object_creation;
			vala_object_creation_expression_set_is_yield_expression (_tmp13_, TRUE);
		}
	}
	result = expr;
	return result;
}

static ValaExpression*
vala_parser_parse_sizeof_expression (ValaParser* self,
                                     GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaDataType* type = NULL;
	ValaDataType* _tmp1_;
	ValaDataType* _tmp2_;
	ValaSourceLocation _tmp3_;
	ValaSourceReference* _tmp4_;
	ValaSourceReference* _tmp5_;
	ValaSizeofExpression* _tmp6_;
	ValaExpression* _tmp7_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_SIZEOF, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = vala_parser_parse_type (self, TRUE, FALSE, FALSE, &_inner_error0_);
	type = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (type);
			return NULL;
		} else {
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = type;
	_tmp3_ = begin;
	_tmp4_ = vala_parser_get_src (self, &_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = vala_sizeof_expression_new (_tmp2_, _tmp5_);
	_tmp7_ = (ValaExpression*) _tmp6_;
	_vala_source_reference_unref0 (_tmp5_);
	result = _tmp7_;
	_vala_code_node_unref0 (type);
	return result;
}

static ValaExpression*
vala_parser_parse_typeof_expression (ValaParser* self,
                                     GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaDataType* type = NULL;
	ValaDataType* _tmp1_;
	ValaDataType* _tmp2_;
	ValaSourceLocation _tmp3_;
	ValaSourceReference* _tmp4_;
	ValaSourceReference* _tmp5_;
	ValaTypeofExpression* _tmp6_;
	ValaExpression* _tmp7_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_TYPEOF, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = vala_parser_parse_type (self, TRUE, FALSE, FALSE, &_inner_error0_);
	type = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (type);
			return NULL;
		} else {
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = type;
	_tmp3_ = begin;
	_tmp4_ = vala_parser_get_src (self, &_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = vala_typeof_expression_new (_tmp2_, _tmp5_);
	_tmp7_ = (ValaExpression*) _tmp6_;
	_vala_source_reference_unref0 (_tmp5_);
	result = _tmp7_;
	_vala_code_node_unref0 (type);
	return result;
}

static ValaUnaryOperator
vala_parser_get_unary_operator (ValaParser* self,
                                ValaTokenType token_type)
{
	ValaUnaryOperator result = 0;
	g_return_val_if_fail (self != NULL, 0);
	switch (token_type) {
		case VALA_TOKEN_TYPE_PLUS:
		{
			result = VALA_UNARY_OPERATOR_PLUS;
			return result;
		}
		case VALA_TOKEN_TYPE_MINUS:
		{
			result = VALA_UNARY_OPERATOR_MINUS;
			return result;
		}
		case VALA_TOKEN_TYPE_OP_NEG:
		{
			result = VALA_UNARY_OPERATOR_LOGICAL_NEGATION;
			return result;
		}
		case VALA_TOKEN_TYPE_TILDE:
		{
			result = VALA_UNARY_OPERATOR_BITWISE_COMPLEMENT;
			return result;
		}
		case VALA_TOKEN_TYPE_OP_INC:
		{
			result = VALA_UNARY_OPERATOR_INCREMENT;
			return result;
		}
		case VALA_TOKEN_TYPE_OP_DEC:
		{
			result = VALA_UNARY_OPERATOR_DECREMENT;
			return result;
		}
		default:
		{
			result = VALA_UNARY_OPERATOR_NONE;
			return result;
		}
	}
}

static ValaExpression*
vala_parser_parse_unary_expression (ValaParser* self,
                                    GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaUnaryOperator operator = 0;
	ValaUnaryOperator _tmp1_;
	ValaExpression* expr = NULL;
	ValaExpression* _tmp93_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	operator = vala_parser_get_unary_operator (self, vala_parser_current (self));
	_tmp1_ = operator;
	if (_tmp1_ != VALA_UNARY_OPERATOR_NONE) {
		ValaExpression* op = NULL;
		ValaExpression* _tmp2_;
		ValaIntegerLiteral* lit = NULL;
		ValaExpression* _tmp3_;
		ValaIntegerLiteral* _tmp4_;
		ValaUnaryOperator _tmp19_;
		ValaExpression* _tmp20_;
		ValaSourceLocation _tmp21_;
		ValaSourceReference* _tmp22_;
		ValaSourceReference* _tmp23_;
		ValaUnaryExpression* _tmp24_;
		ValaExpression* _tmp25_;
		vala_parser_next (self);
		_tmp2_ = vala_parser_parse_unary_expression (self, &_inner_error0_);
		op = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp3_ = op;
		lit = VALA_IS_INTEGER_LITERAL (_tmp3_) ? ((ValaIntegerLiteral*) _tmp3_) : NULL;
		_tmp4_ = lit;
		if (_tmp4_ != NULL) {
			ValaUnaryOperator _tmp5_;
			_tmp5_ = operator;
			if (_tmp5_ == VALA_UNARY_OPERATOR_PLUS) {
				ValaIntegerLiteral* _tmp6_;
				ValaExpression* _tmp7_;
				_tmp6_ = lit;
				_tmp7_ = _vala_code_node_ref0 ((ValaExpression*) _tmp6_);
				result = _tmp7_;
				_vala_code_node_unref0 (op);
				return result;
			} else {
				ValaUnaryOperator _tmp8_;
				_tmp8_ = operator;
				if (_tmp8_ == VALA_UNARY_OPERATOR_MINUS) {
					ValaIntegerLiteral* _tmp9_;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					ValaSourceLocation _tmp14_;
					ValaSourceReference* _tmp15_;
					ValaSourceReference* _tmp16_;
					ValaIntegerLiteral* _tmp17_;
					ValaExpression* _tmp18_;
					_tmp9_ = lit;
					_tmp10_ = vala_integer_literal_get_value (_tmp9_);
					_tmp11_ = _tmp10_;
					_tmp12_ = g_strconcat ("-", _tmp11_, NULL);
					_tmp13_ = _tmp12_;
					_tmp14_ = begin;
					_tmp15_ = vala_parser_get_src (self, &_tmp14_);
					_tmp16_ = _tmp15_;
					_tmp17_ = vala_integer_literal_new (_tmp13_, _tmp16_);
					_tmp18_ = (ValaExpression*) _tmp17_;
					_vala_source_reference_unref0 (_tmp16_);
					_g_free0 (_tmp13_);
					result = _tmp18_;
					_vala_code_node_unref0 (op);
					return result;
				}
			}
		}
		_tmp19_ = operator;
		_tmp20_ = op;
		_tmp21_ = begin;
		_tmp22_ = vala_parser_get_src (self, &_tmp21_);
		_tmp23_ = _tmp22_;
		_tmp24_ = vala_unary_expression_new (_tmp19_, _tmp20_, _tmp23_);
		_tmp25_ = (ValaExpression*) _tmp24_;
		_vala_source_reference_unref0 (_tmp23_);
		result = _tmp25_;
		_vala_code_node_unref0 (op);
		return result;
	}
	switch (vala_parser_current (self)) {
		case VALA_TOKEN_TYPE_OPEN_PARENS:
		{
			ValaSourceLocation _tmp78_;
			vala_parser_next (self);
			switch (vala_parser_current (self)) {
				case VALA_TOKEN_TYPE_UNOWNED:
				{
					break;
				}
				case VALA_TOKEN_TYPE_OWNED:
				{
					vala_parser_next (self);
					if (vala_parser_accept (self, VALA_TOKEN_TYPE_CLOSE_PARENS)) {
						ValaExpression* op = NULL;
						ValaExpression* _tmp26_;
						ValaExpression* _tmp27_;
						ValaSourceLocation _tmp28_;
						ValaSourceReference* _tmp29_;
						ValaSourceReference* _tmp30_;
						ValaReferenceTransferExpression* _tmp31_;
						ValaExpression* _tmp32_;
						_tmp26_ = vala_parser_parse_unary_expression (self, &_inner_error0_);
						op = _tmp26_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							if (_inner_error0_->domain == VALA_PARSE_ERROR) {
								g_propagate_error (error, _inner_error0_);
								return NULL;
							} else {
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return NULL;
							}
						}
						_tmp27_ = op;
						_tmp28_ = begin;
						_tmp29_ = vala_parser_get_src (self, &_tmp28_);
						_tmp30_ = _tmp29_;
						_tmp31_ = vala_reference_transfer_expression_new (_tmp27_, _tmp30_);
						_tmp32_ = (ValaExpression*) _tmp31_;
						_vala_source_reference_unref0 (_tmp30_);
						result = _tmp32_;
						_vala_code_node_unref0 (op);
						return result;
					}
					break;
				}
				case VALA_TOKEN_TYPE_VOID:
				case VALA_TOKEN_TYPE_DYNAMIC:
				case VALA_TOKEN_TYPE_OPEN_PARENS:
				case VALA_TOKEN_TYPE_IDENTIFIER:
				{
					gboolean _tmp33_ = FALSE;
					if (vala_parser_current (self) != VALA_TOKEN_TYPE_OPEN_PARENS) {
						_tmp33_ = TRUE;
					} else {
						_tmp33_ = vala_parser_is_inner_array_type (self);
					}
					if (_tmp33_) {
						ValaDataType* type = NULL;
						ValaDataType* _tmp34_;
						_tmp34_ = vala_parser_parse_type (self, TRUE, FALSE, FALSE, &_inner_error0_);
						type = _tmp34_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							if (_inner_error0_->domain == VALA_PARSE_ERROR) {
								g_propagate_error (error, _inner_error0_);
								return NULL;
							} else {
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return NULL;
							}
						}
						if (vala_parser_accept (self, VALA_TOKEN_TYPE_CLOSE_PARENS)) {
							switch (vala_parser_current (self)) {
								case VALA_TOKEN_TYPE_OP_NEG:
								case VALA_TOKEN_TYPE_TILDE:
								case VALA_TOKEN_TYPE_OPEN_PARENS:
								case VALA_TOKEN_TYPE_TRUE:
								case VALA_TOKEN_TYPE_FALSE:
								case VALA_TOKEN_TYPE_INTEGER_LITERAL:
								case VALA_TOKEN_TYPE_REAL_LITERAL:
								case VALA_TOKEN_TYPE_CHARACTER_LITERAL:
								case VALA_TOKEN_TYPE_STRING_LITERAL:
								case VALA_TOKEN_TYPE_TEMPLATE_STRING_LITERAL:
								case VALA_TOKEN_TYPE_VERBATIM_STRING_LITERAL:
								case VALA_TOKEN_TYPE_REGEX_LITERAL:
								case VALA_TOKEN_TYPE_NULL:
								case VALA_TOKEN_TYPE_THIS:
								case VALA_TOKEN_TYPE_BASE:
								case VALA_TOKEN_TYPE_NEW:
								case VALA_TOKEN_TYPE_YIELD:
								case VALA_TOKEN_TYPE_SIZEOF:
								case VALA_TOKEN_TYPE_TYPEOF:
								case VALA_TOKEN_TYPE_IDENTIFIER:
								case VALA_TOKEN_TYPE_PARAMS:
								{
									ValaExpression* inner = NULL;
									ValaExpression* _tmp35_;
									ValaExpression* _tmp36_;
									ValaDataType* _tmp37_;
									ValaSourceLocation _tmp38_;
									ValaSourceReference* _tmp39_;
									ValaSourceReference* _tmp40_;
									ValaCastExpression* _tmp41_;
									ValaExpression* _tmp42_;
									_tmp35_ = vala_parser_parse_unary_expression (self, &_inner_error0_);
									inner = _tmp35_;
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
										if (_inner_error0_->domain == VALA_PARSE_ERROR) {
											g_propagate_error (error, _inner_error0_);
											_vala_code_node_unref0 (type);
											return NULL;
										} else {
											_vala_code_node_unref0 (type);
											g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
											g_clear_error (&_inner_error0_);
											return NULL;
										}
									}
									_tmp36_ = inner;
									_tmp37_ = type;
									_tmp38_ = begin;
									_tmp39_ = vala_parser_get_src (self, &_tmp38_);
									_tmp40_ = _tmp39_;
									_tmp41_ = vala_cast_expression_new (_tmp36_, _tmp37_, _tmp40_);
									_tmp42_ = (ValaExpression*) _tmp41_;
									_vala_source_reference_unref0 (_tmp40_);
									result = _tmp42_;
									_vala_code_node_unref0 (inner);
									_vala_code_node_unref0 (type);
									return result;
								}
								case VALA_TOKEN_TYPE_STAR:
								{
									ValaExpression* op = NULL;
									ValaExpression* _tmp43_;
									ValaPointerIndirection* inner = NULL;
									ValaExpression* _tmp44_;
									ValaSourceLocation _tmp45_;
									ValaSourceReference* _tmp46_;
									ValaSourceReference* _tmp47_;
									ValaPointerIndirection* _tmp48_;
									ValaPointerIndirection* _tmp49_;
									ValaPointerIndirection* _tmp50_;
									ValaDataType* _tmp51_;
									ValaSourceLocation _tmp52_;
									ValaSourceReference* _tmp53_;
									ValaSourceReference* _tmp54_;
									ValaCastExpression* _tmp55_;
									ValaExpression* _tmp56_;
									vala_parser_next (self);
									_tmp43_ = vala_parser_parse_unary_expression (self, &_inner_error0_);
									op = _tmp43_;
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
										if (_inner_error0_->domain == VALA_PARSE_ERROR) {
											g_propagate_error (error, _inner_error0_);
											_vala_code_node_unref0 (type);
											return NULL;
										} else {
											_vala_code_node_unref0 (type);
											g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
											g_clear_error (&_inner_error0_);
											return NULL;
										}
									}
									_tmp44_ = op;
									_tmp45_ = begin;
									_tmp46_ = vala_parser_get_src (self, &_tmp45_);
									_tmp47_ = _tmp46_;
									_tmp48_ = vala_pointer_indirection_new (_tmp44_, _tmp47_);
									_tmp49_ = _tmp48_;
									_vala_source_reference_unref0 (_tmp47_);
									inner = _tmp49_;
									_tmp50_ = inner;
									_tmp51_ = type;
									_tmp52_ = begin;
									_tmp53_ = vala_parser_get_src (self, &_tmp52_);
									_tmp54_ = _tmp53_;
									_tmp55_ = vala_cast_expression_new ((ValaExpression*) _tmp50_, _tmp51_, _tmp54_);
									_tmp56_ = (ValaExpression*) _tmp55_;
									_vala_source_reference_unref0 (_tmp54_);
									result = _tmp56_;
									_vala_code_node_unref0 (inner);
									_vala_code_node_unref0 (op);
									_vala_code_node_unref0 (type);
									return result;
								}
								case VALA_TOKEN_TYPE_BITWISE_AND:
								{
									ValaExpression* op = NULL;
									ValaExpression* _tmp57_;
									ValaAddressofExpression* inner = NULL;
									ValaExpression* _tmp58_;
									ValaSourceLocation _tmp59_;
									ValaSourceReference* _tmp60_;
									ValaSourceReference* _tmp61_;
									ValaAddressofExpression* _tmp62_;
									ValaAddressofExpression* _tmp63_;
									ValaAddressofExpression* _tmp64_;
									ValaDataType* _tmp65_;
									ValaSourceLocation _tmp66_;
									ValaSourceReference* _tmp67_;
									ValaSourceReference* _tmp68_;
									ValaCastExpression* _tmp69_;
									ValaExpression* _tmp70_;
									vala_parser_next (self);
									_tmp57_ = vala_parser_parse_unary_expression (self, &_inner_error0_);
									op = _tmp57_;
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
										if (_inner_error0_->domain == VALA_PARSE_ERROR) {
											g_propagate_error (error, _inner_error0_);
											_vala_code_node_unref0 (type);
											return NULL;
										} else {
											_vala_code_node_unref0 (type);
											g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
											g_clear_error (&_inner_error0_);
											return NULL;
										}
									}
									_tmp58_ = op;
									_tmp59_ = begin;
									_tmp60_ = vala_parser_get_src (self, &_tmp59_);
									_tmp61_ = _tmp60_;
									_tmp62_ = vala_addressof_expression_new (_tmp58_, _tmp61_);
									_tmp63_ = _tmp62_;
									_vala_source_reference_unref0 (_tmp61_);
									inner = _tmp63_;
									_tmp64_ = inner;
									_tmp65_ = type;
									_tmp66_ = begin;
									_tmp67_ = vala_parser_get_src (self, &_tmp66_);
									_tmp68_ = _tmp67_;
									_tmp69_ = vala_cast_expression_new ((ValaExpression*) _tmp64_, _tmp65_, _tmp68_);
									_tmp70_ = (ValaExpression*) _tmp69_;
									_vala_source_reference_unref0 (_tmp68_);
									result = _tmp70_;
									_vala_code_node_unref0 (inner);
									_vala_code_node_unref0 (op);
									_vala_code_node_unref0 (type);
									return result;
								}
								default:
								{
									break;
								}
							}
						}
						_vala_code_node_unref0 (type);
					}
					break;
				}
				case VALA_TOKEN_TYPE_OP_NEG:
				{
					vala_parser_next (self);
					if (vala_parser_accept (self, VALA_TOKEN_TYPE_CLOSE_PARENS)) {
						ValaExpression* inner = NULL;
						ValaExpression* _tmp71_;
						ValaExpression* _tmp72_;
						ValaSourceLocation _tmp73_;
						ValaSourceReference* _tmp74_;
						ValaSourceReference* _tmp75_;
						ValaCastExpression* _tmp76_;
						ValaExpression* _tmp77_;
						_tmp71_ = vala_parser_parse_unary_expression (self, &_inner_error0_);
						inner = _tmp71_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							if (_inner_error0_->domain == VALA_PARSE_ERROR) {
								g_propagate_error (error, _inner_error0_);
								return NULL;
							} else {
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return NULL;
							}
						}
						_tmp72_ = inner;
						_tmp73_ = begin;
						_tmp74_ = vala_parser_get_src (self, &_tmp73_);
						_tmp75_ = _tmp74_;
						_tmp76_ = vala_cast_expression_new_non_null (_tmp72_, _tmp75_);
						_tmp77_ = (ValaExpression*) _tmp76_;
						_vala_source_reference_unref0 (_tmp75_);
						result = _tmp77_;
						_vala_code_node_unref0 (inner);
						return result;
					}
					break;
				}
				default:
				{
					break;
				}
			}
			_tmp78_ = begin;
			vala_parser_rollback (self, &_tmp78_);
			break;
		}
		case VALA_TOKEN_TYPE_STAR:
		{
			ValaExpression* op = NULL;
			ValaExpression* _tmp79_;
			ValaExpression* _tmp80_;
			ValaSourceLocation _tmp81_;
			ValaSourceReference* _tmp82_;
			ValaSourceReference* _tmp83_;
			ValaPointerIndirection* _tmp84_;
			ValaExpression* _tmp85_;
			vala_parser_next (self);
			_tmp79_ = vala_parser_parse_unary_expression (self, &_inner_error0_);
			op = _tmp79_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp80_ = op;
			_tmp81_ = begin;
			_tmp82_ = vala_parser_get_src (self, &_tmp81_);
			_tmp83_ = _tmp82_;
			_tmp84_ = vala_pointer_indirection_new (_tmp80_, _tmp83_);
			_tmp85_ = (ValaExpression*) _tmp84_;
			_vala_source_reference_unref0 (_tmp83_);
			result = _tmp85_;
			_vala_code_node_unref0 (op);
			return result;
		}
		case VALA_TOKEN_TYPE_BITWISE_AND:
		{
			ValaExpression* op = NULL;
			ValaExpression* _tmp86_;
			ValaExpression* _tmp87_;
			ValaSourceLocation _tmp88_;
			ValaSourceReference* _tmp89_;
			ValaSourceReference* _tmp90_;
			ValaAddressofExpression* _tmp91_;
			ValaExpression* _tmp92_;
			vala_parser_next (self);
			_tmp86_ = vala_parser_parse_unary_expression (self, &_inner_error0_);
			op = _tmp86_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp87_ = op;
			_tmp88_ = begin;
			_tmp89_ = vala_parser_get_src (self, &_tmp88_);
			_tmp90_ = _tmp89_;
			_tmp91_ = vala_addressof_expression_new (_tmp87_, _tmp90_);
			_tmp92_ = (ValaExpression*) _tmp91_;
			_vala_source_reference_unref0 (_tmp90_);
			result = _tmp92_;
			_vala_code_node_unref0 (op);
			return result;
		}
		default:
		{
			break;
		}
	}
	_tmp93_ = vala_parser_parse_primary_expression (self, &_inner_error0_);
	expr = _tmp93_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = expr;
	return result;
}

static ValaBinaryOperator
vala_parser_get_binary_operator (ValaParser* self,
                                 ValaTokenType token_type)
{
	ValaBinaryOperator result = 0;
	g_return_val_if_fail (self != NULL, 0);
	switch (token_type) {
		case VALA_TOKEN_TYPE_STAR:
		{
			result = VALA_BINARY_OPERATOR_MUL;
			return result;
		}
		case VALA_TOKEN_TYPE_DIV:
		{
			result = VALA_BINARY_OPERATOR_DIV;
			return result;
		}
		case VALA_TOKEN_TYPE_PERCENT:
		{
			result = VALA_BINARY_OPERATOR_MOD;
			return result;
		}
		case VALA_TOKEN_TYPE_PLUS:
		{
			result = VALA_BINARY_OPERATOR_PLUS;
			return result;
		}
		case VALA_TOKEN_TYPE_MINUS:
		{
			result = VALA_BINARY_OPERATOR_MINUS;
			return result;
		}
		case VALA_TOKEN_TYPE_OP_LT:
		{
			result = VALA_BINARY_OPERATOR_LESS_THAN;
			return result;
		}
		case VALA_TOKEN_TYPE_OP_GT:
		{
			result = VALA_BINARY_OPERATOR_GREATER_THAN;
			return result;
		}
		case VALA_TOKEN_TYPE_OP_LE:
		{
			result = VALA_BINARY_OPERATOR_LESS_THAN_OR_EQUAL;
			return result;
		}
		case VALA_TOKEN_TYPE_OP_GE:
		{
			result = VALA_BINARY_OPERATOR_GREATER_THAN_OR_EQUAL;
			return result;
		}
		case VALA_TOKEN_TYPE_OP_EQ:
		{
			result = VALA_BINARY_OPERATOR_EQUALITY;
			return result;
		}
		case VALA_TOKEN_TYPE_OP_NE:
		{
			result = VALA_BINARY_OPERATOR_INEQUALITY;
			return result;
		}
		default:
		{
			result = VALA_BINARY_OPERATOR_NONE;
			return result;
		}
	}
}

static ValaExpression*
vala_parser_parse_multiplicative_expression (ValaParser* self,
                                             GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* left = NULL;
	ValaExpression* _tmp1_;
	gboolean found = FALSE;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_unary_expression (self, &_inner_error0_);
	left = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	found = TRUE;
	while (TRUE) {
		ValaBinaryOperator operator = 0;
		ValaBinaryOperator _tmp2_;
		if (!found) {
			break;
		}
		operator = vala_parser_get_binary_operator (self, vala_parser_current (self));
		_tmp2_ = operator;
		switch (_tmp2_) {
			case VALA_BINARY_OPERATOR_MUL:
			case VALA_BINARY_OPERATOR_DIV:
			case VALA_BINARY_OPERATOR_MOD:
			{
				ValaExpression* right = NULL;
				ValaExpression* _tmp3_;
				ValaBinaryOperator _tmp4_;
				ValaExpression* _tmp5_;
				ValaExpression* _tmp6_;
				ValaSourceLocation _tmp7_;
				ValaSourceReference* _tmp8_;
				ValaSourceReference* _tmp9_;
				ValaBinaryExpression* _tmp10_;
				vala_parser_next (self);
				_tmp3_ = vala_parser_parse_unary_expression (self, &_inner_error0_);
				right = _tmp3_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (left);
						return NULL;
					} else {
						_vala_code_node_unref0 (left);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp4_ = operator;
				_tmp5_ = left;
				_tmp6_ = right;
				_tmp7_ = begin;
				_tmp8_ = vala_parser_get_src (self, &_tmp7_);
				_tmp9_ = _tmp8_;
				_tmp10_ = vala_binary_expression_new (_tmp4_, _tmp5_, _tmp6_, _tmp9_);
				_vala_code_node_unref0 (left);
				left = (ValaExpression*) _tmp10_;
				_vala_source_reference_unref0 (_tmp9_);
				_vala_code_node_unref0 (right);
				break;
			}
			default:
			{
				found = FALSE;
				break;
			}
		}
	}
	result = left;
	return result;
}

static ValaExpression*
vala_parser_parse_additive_expression (ValaParser* self,
                                       GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* left = NULL;
	ValaExpression* _tmp1_;
	gboolean found = FALSE;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_multiplicative_expression (self, &_inner_error0_);
	left = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	found = TRUE;
	while (TRUE) {
		ValaBinaryOperator operator = 0;
		ValaBinaryOperator _tmp2_;
		if (!found) {
			break;
		}
		operator = vala_parser_get_binary_operator (self, vala_parser_current (self));
		_tmp2_ = operator;
		switch (_tmp2_) {
			case VALA_BINARY_OPERATOR_PLUS:
			case VALA_BINARY_OPERATOR_MINUS:
			{
				ValaExpression* right = NULL;
				ValaExpression* _tmp3_;
				ValaBinaryOperator _tmp4_;
				ValaExpression* _tmp5_;
				ValaExpression* _tmp6_;
				ValaSourceLocation _tmp7_;
				ValaSourceReference* _tmp8_;
				ValaSourceReference* _tmp9_;
				ValaBinaryExpression* _tmp10_;
				vala_parser_next (self);
				_tmp3_ = vala_parser_parse_multiplicative_expression (self, &_inner_error0_);
				right = _tmp3_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (left);
						return NULL;
					} else {
						_vala_code_node_unref0 (left);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp4_ = operator;
				_tmp5_ = left;
				_tmp6_ = right;
				_tmp7_ = begin;
				_tmp8_ = vala_parser_get_src (self, &_tmp7_);
				_tmp9_ = _tmp8_;
				_tmp10_ = vala_binary_expression_new (_tmp4_, _tmp5_, _tmp6_, _tmp9_);
				_vala_code_node_unref0 (left);
				left = (ValaExpression*) _tmp10_;
				_vala_source_reference_unref0 (_tmp9_);
				_vala_code_node_unref0 (right);
				break;
			}
			default:
			{
				found = FALSE;
				break;
			}
		}
	}
	result = left;
	return result;
}

static ValaExpression*
vala_parser_parse_shift_expression (ValaParser* self,
                                    GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* left = NULL;
	ValaExpression* _tmp1_;
	gboolean found = FALSE;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_additive_expression (self, &_inner_error0_);
	left = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	found = TRUE;
	while (TRUE) {
		if (!found) {
			break;
		}
		switch (vala_parser_current (self)) {
			case VALA_TOKEN_TYPE_OP_SHIFT_LEFT:
			{
				ValaExpression* right = NULL;
				ValaExpression* _tmp2_;
				ValaExpression* _tmp3_;
				ValaExpression* _tmp4_;
				ValaSourceLocation _tmp5_;
				ValaSourceReference* _tmp6_;
				ValaSourceReference* _tmp7_;
				ValaBinaryExpression* _tmp8_;
				vala_parser_next (self);
				_tmp2_ = vala_parser_parse_additive_expression (self, &_inner_error0_);
				right = _tmp2_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (left);
						return NULL;
					} else {
						_vala_code_node_unref0 (left);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp3_ = left;
				_tmp4_ = right;
				_tmp5_ = begin;
				_tmp6_ = vala_parser_get_src (self, &_tmp5_);
				_tmp7_ = _tmp6_;
				_tmp8_ = vala_binary_expression_new (VALA_BINARY_OPERATOR_SHIFT_LEFT, _tmp3_, _tmp4_, _tmp7_);
				_vala_code_node_unref0 (left);
				left = (ValaExpression*) _tmp8_;
				_vala_source_reference_unref0 (_tmp7_);
				_vala_code_node_unref0 (right);
				break;
			}
			case VALA_TOKEN_TYPE_OP_GT:
			{
				gchar* first_gt_pos = NULL;
				ValaParserTokenInfo* _tmp9_;
				gint _tmp9__length1;
				ValaParserTokenInfo _tmp10_;
				ValaSourceLocation _tmp11_;
				gchar* _tmp12_;
				gboolean _tmp13_ = FALSE;
				_tmp9_ = self->priv->tokens;
				_tmp9__length1 = self->priv->tokens_length1;
				_tmp10_ = _tmp9_[self->priv->index];
				_tmp11_ = _tmp10_.begin;
				_tmp12_ = _tmp11_.pos;
				first_gt_pos = _tmp12_;
				vala_parser_next (self);
				if (vala_parser_current (self) == VALA_TOKEN_TYPE_OP_GT) {
					ValaParserTokenInfo* _tmp14_;
					gint _tmp14__length1;
					ValaParserTokenInfo _tmp15_;
					ValaSourceLocation _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					_tmp14_ = self->priv->tokens;
					_tmp14__length1 = self->priv->tokens_length1;
					_tmp15_ = _tmp14_[self->priv->index];
					_tmp16_ = _tmp15_.begin;
					_tmp17_ = _tmp16_.pos;
					_tmp18_ = first_gt_pos;
					_tmp13_ = _tmp17_ == (_tmp18_ + 1);
				} else {
					_tmp13_ = FALSE;
				}
				if (_tmp13_) {
					ValaExpression* right = NULL;
					ValaExpression* _tmp19_;
					ValaExpression* _tmp20_;
					ValaExpression* _tmp21_;
					ValaSourceLocation _tmp22_;
					ValaSourceReference* _tmp23_;
					ValaSourceReference* _tmp24_;
					ValaBinaryExpression* _tmp25_;
					vala_parser_next (self);
					_tmp19_ = vala_parser_parse_additive_expression (self, &_inner_error0_);
					right = _tmp19_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_vala_code_node_unref0 (left);
							return NULL;
						} else {
							_vala_code_node_unref0 (left);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return NULL;
						}
					}
					_tmp20_ = left;
					_tmp21_ = right;
					_tmp22_ = begin;
					_tmp23_ = vala_parser_get_src (self, &_tmp22_);
					_tmp24_ = _tmp23_;
					_tmp25_ = vala_binary_expression_new (VALA_BINARY_OPERATOR_SHIFT_RIGHT, _tmp20_, _tmp21_, _tmp24_);
					_vala_code_node_unref0 (left);
					left = (ValaExpression*) _tmp25_;
					_vala_source_reference_unref0 (_tmp24_);
					_vala_code_node_unref0 (right);
				} else {
					vala_parser_prev (self);
					found = FALSE;
				}
				break;
			}
			default:
			{
				found = FALSE;
				break;
			}
		}
	}
	result = left;
	return result;
}

static ValaExpression*
vala_parser_parse_relational_expression (ValaParser* self,
                                         GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* left = NULL;
	ValaExpression* _tmp1_;
	gboolean first = FALSE;
	gboolean found = FALSE;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_shift_expression (self, &_inner_error0_);
	left = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	first = TRUE;
	found = TRUE;
	while (TRUE) {
		ValaBinaryOperator operator = 0;
		ValaBinaryOperator _tmp2_;
		if (!found) {
			break;
		}
		operator = vala_parser_get_binary_operator (self, vala_parser_current (self));
		_tmp2_ = operator;
		switch (_tmp2_) {
			case VALA_BINARY_OPERATOR_LESS_THAN:
			case VALA_BINARY_OPERATOR_LESS_THAN_OR_EQUAL:
			case VALA_BINARY_OPERATOR_GREATER_THAN_OR_EQUAL:
			{
				ValaExpression* right = NULL;
				ValaExpression* _tmp3_;
				vala_parser_next (self);
				_tmp3_ = vala_parser_parse_shift_expression (self, &_inner_error0_);
				right = _tmp3_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (left);
						return NULL;
					} else {
						_vala_code_node_unref0 (left);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				if (first) {
					ValaBinaryOperator _tmp4_;
					ValaExpression* _tmp5_;
					ValaExpression* _tmp6_;
					ValaSourceLocation _tmp7_;
					ValaSourceReference* _tmp8_;
					ValaSourceReference* _tmp9_;
					ValaBinaryExpression* _tmp10_;
					_tmp4_ = operator;
					_tmp5_ = left;
					_tmp6_ = right;
					_tmp7_ = begin;
					_tmp8_ = vala_parser_get_src (self, &_tmp7_);
					_tmp9_ = _tmp8_;
					_tmp10_ = vala_binary_expression_new (_tmp4_, _tmp5_, _tmp6_, _tmp9_);
					_vala_code_node_unref0 (left);
					left = (ValaExpression*) _tmp10_;
					_vala_source_reference_unref0 (_tmp9_);
				} else {
					ValaBinaryOperator _tmp11_;
					ValaExpression* _tmp12_;
					ValaExpression* _tmp13_;
					ValaSourceLocation _tmp14_;
					ValaSourceReference* _tmp15_;
					ValaSourceReference* _tmp16_;
					ValaBinaryExpression* _tmp17_;
					_tmp11_ = operator;
					_tmp12_ = left;
					_tmp13_ = right;
					_tmp14_ = begin;
					_tmp15_ = vala_parser_get_src (self, &_tmp14_);
					_tmp16_ = _tmp15_;
					_tmp17_ = vala_binary_expression_new_chained (_tmp11_, _tmp12_, _tmp13_, _tmp16_);
					_vala_code_node_unref0 (left);
					left = (ValaExpression*) _tmp17_;
					_vala_source_reference_unref0 (_tmp16_);
				}
				first = FALSE;
				_vala_code_node_unref0 (right);
				break;
			}
			case VALA_BINARY_OPERATOR_GREATER_THAN:
			{
				gboolean _tmp18_ = FALSE;
				vala_parser_next (self);
				if (vala_parser_current (self) != VALA_TOKEN_TYPE_OP_GT) {
					_tmp18_ = vala_parser_current (self) != VALA_TOKEN_TYPE_OP_GE;
				} else {
					_tmp18_ = FALSE;
				}
				if (_tmp18_) {
					ValaExpression* right = NULL;
					ValaExpression* _tmp19_;
					_tmp19_ = vala_parser_parse_shift_expression (self, &_inner_error0_);
					right = _tmp19_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_vala_code_node_unref0 (left);
							return NULL;
						} else {
							_vala_code_node_unref0 (left);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return NULL;
						}
					}
					if (first) {
						ValaBinaryOperator _tmp20_;
						ValaExpression* _tmp21_;
						ValaExpression* _tmp22_;
						ValaSourceLocation _tmp23_;
						ValaSourceReference* _tmp24_;
						ValaSourceReference* _tmp25_;
						ValaBinaryExpression* _tmp26_;
						_tmp20_ = operator;
						_tmp21_ = left;
						_tmp22_ = right;
						_tmp23_ = begin;
						_tmp24_ = vala_parser_get_src (self, &_tmp23_);
						_tmp25_ = _tmp24_;
						_tmp26_ = vala_binary_expression_new (_tmp20_, _tmp21_, _tmp22_, _tmp25_);
						_vala_code_node_unref0 (left);
						left = (ValaExpression*) _tmp26_;
						_vala_source_reference_unref0 (_tmp25_);
					} else {
						ValaBinaryOperator _tmp27_;
						ValaExpression* _tmp28_;
						ValaExpression* _tmp29_;
						ValaSourceLocation _tmp30_;
						ValaSourceReference* _tmp31_;
						ValaSourceReference* _tmp32_;
						ValaBinaryExpression* _tmp33_;
						_tmp27_ = operator;
						_tmp28_ = left;
						_tmp29_ = right;
						_tmp30_ = begin;
						_tmp31_ = vala_parser_get_src (self, &_tmp30_);
						_tmp32_ = _tmp31_;
						_tmp33_ = vala_binary_expression_new_chained (_tmp27_, _tmp28_, _tmp29_, _tmp32_);
						_vala_code_node_unref0 (left);
						left = (ValaExpression*) _tmp33_;
						_vala_source_reference_unref0 (_tmp32_);
					}
					first = FALSE;
					_vala_code_node_unref0 (right);
				} else {
					vala_parser_prev (self);
					found = FALSE;
				}
				break;
			}
			default:
			{
				switch (vala_parser_current (self)) {
					case VALA_TOKEN_TYPE_IS:
					{
						ValaDataType* type = NULL;
						ValaDataType* _tmp34_;
						ValaExpression* _tmp35_;
						ValaDataType* _tmp36_;
						ValaSourceLocation _tmp37_;
						ValaSourceReference* _tmp38_;
						ValaSourceReference* _tmp39_;
						ValaTypeCheck* _tmp40_;
						vala_parser_next (self);
						_tmp34_ = vala_parser_parse_type (self, TRUE, FALSE, FALSE, &_inner_error0_);
						type = _tmp34_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							if (_inner_error0_->domain == VALA_PARSE_ERROR) {
								g_propagate_error (error, _inner_error0_);
								_vala_code_node_unref0 (left);
								return NULL;
							} else {
								_vala_code_node_unref0 (left);
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return NULL;
							}
						}
						_tmp35_ = left;
						_tmp36_ = type;
						_tmp37_ = begin;
						_tmp38_ = vala_parser_get_src (self, &_tmp37_);
						_tmp39_ = _tmp38_;
						_tmp40_ = vala_typecheck_new (_tmp35_, _tmp36_, _tmp39_);
						_vala_code_node_unref0 (left);
						left = (ValaExpression*) _tmp40_;
						_vala_source_reference_unref0 (_tmp39_);
						_vala_code_node_unref0 (type);
						break;
					}
					case VALA_TOKEN_TYPE_AS:
					{
						ValaDataType* type = NULL;
						ValaDataType* _tmp41_;
						ValaExpression* _tmp42_;
						ValaDataType* _tmp43_;
						ValaSourceLocation _tmp44_;
						ValaSourceReference* _tmp45_;
						ValaSourceReference* _tmp46_;
						ValaCastExpression* _tmp47_;
						vala_parser_next (self);
						_tmp41_ = vala_parser_parse_type (self, TRUE, FALSE, FALSE, &_inner_error0_);
						type = _tmp41_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							if (_inner_error0_->domain == VALA_PARSE_ERROR) {
								g_propagate_error (error, _inner_error0_);
								_vala_code_node_unref0 (left);
								return NULL;
							} else {
								_vala_code_node_unref0 (left);
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return NULL;
							}
						}
						_tmp42_ = left;
						_tmp43_ = type;
						_tmp44_ = begin;
						_tmp45_ = vala_parser_get_src (self, &_tmp44_);
						_tmp46_ = _tmp45_;
						_tmp47_ = vala_cast_expression_new_silent (_tmp42_, _tmp43_, _tmp46_);
						_vala_code_node_unref0 (left);
						left = (ValaExpression*) _tmp47_;
						_vala_source_reference_unref0 (_tmp46_);
						_vala_code_node_unref0 (type);
						break;
					}
					default:
					{
						found = FALSE;
						break;
					}
				}
				break;
			}
		}
	}
	result = left;
	return result;
}

static ValaExpression*
vala_parser_parse_equality_expression (ValaParser* self,
                                       GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* left = NULL;
	ValaExpression* _tmp1_;
	gboolean found = FALSE;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_relational_expression (self, &_inner_error0_);
	left = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	found = TRUE;
	while (TRUE) {
		ValaBinaryOperator operator = 0;
		ValaBinaryOperator _tmp2_;
		if (!found) {
			break;
		}
		operator = vala_parser_get_binary_operator (self, vala_parser_current (self));
		_tmp2_ = operator;
		switch (_tmp2_) {
			case VALA_BINARY_OPERATOR_EQUALITY:
			case VALA_BINARY_OPERATOR_INEQUALITY:
			{
				ValaExpression* right = NULL;
				ValaExpression* _tmp3_;
				ValaBinaryOperator _tmp4_;
				ValaExpression* _tmp5_;
				ValaExpression* _tmp6_;
				ValaSourceLocation _tmp7_;
				ValaSourceReference* _tmp8_;
				ValaSourceReference* _tmp9_;
				ValaBinaryExpression* _tmp10_;
				vala_parser_next (self);
				_tmp3_ = vala_parser_parse_relational_expression (self, &_inner_error0_);
				right = _tmp3_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (left);
						return NULL;
					} else {
						_vala_code_node_unref0 (left);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp4_ = operator;
				_tmp5_ = left;
				_tmp6_ = right;
				_tmp7_ = begin;
				_tmp8_ = vala_parser_get_src (self, &_tmp7_);
				_tmp9_ = _tmp8_;
				_tmp10_ = vala_binary_expression_new (_tmp4_, _tmp5_, _tmp6_, _tmp9_);
				_vala_code_node_unref0 (left);
				left = (ValaExpression*) _tmp10_;
				_vala_source_reference_unref0 (_tmp9_);
				_vala_code_node_unref0 (right);
				break;
			}
			default:
			{
				found = FALSE;
				break;
			}
		}
	}
	result = left;
	return result;
}

static ValaExpression*
vala_parser_parse_and_expression (ValaParser* self,
                                  GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* left = NULL;
	ValaExpression* _tmp1_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_equality_expression (self, &_inner_error0_);
	left = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	while (TRUE) {
		ValaExpression* right = NULL;
		ValaExpression* _tmp2_;
		ValaExpression* _tmp3_;
		ValaExpression* _tmp4_;
		ValaSourceLocation _tmp5_;
		ValaSourceReference* _tmp6_;
		ValaSourceReference* _tmp7_;
		ValaBinaryExpression* _tmp8_;
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_BITWISE_AND)) {
			break;
		}
		_tmp2_ = vala_parser_parse_equality_expression (self, &_inner_error0_);
		right = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (left);
				return NULL;
			} else {
				_vala_code_node_unref0 (left);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp3_ = left;
		_tmp4_ = right;
		_tmp5_ = begin;
		_tmp6_ = vala_parser_get_src (self, &_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = vala_binary_expression_new (VALA_BINARY_OPERATOR_BITWISE_AND, _tmp3_, _tmp4_, _tmp7_);
		_vala_code_node_unref0 (left);
		left = (ValaExpression*) _tmp8_;
		_vala_source_reference_unref0 (_tmp7_);
		_vala_code_node_unref0 (right);
	}
	result = left;
	return result;
}

static ValaExpression*
vala_parser_parse_exclusive_or_expression (ValaParser* self,
                                           GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* left = NULL;
	ValaExpression* _tmp1_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_and_expression (self, &_inner_error0_);
	left = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	while (TRUE) {
		ValaExpression* right = NULL;
		ValaExpression* _tmp2_;
		ValaExpression* _tmp3_;
		ValaExpression* _tmp4_;
		ValaSourceLocation _tmp5_;
		ValaSourceReference* _tmp6_;
		ValaSourceReference* _tmp7_;
		ValaBinaryExpression* _tmp8_;
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_CARRET)) {
			break;
		}
		_tmp2_ = vala_parser_parse_and_expression (self, &_inner_error0_);
		right = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (left);
				return NULL;
			} else {
				_vala_code_node_unref0 (left);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp3_ = left;
		_tmp4_ = right;
		_tmp5_ = begin;
		_tmp6_ = vala_parser_get_src (self, &_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = vala_binary_expression_new (VALA_BINARY_OPERATOR_BITWISE_XOR, _tmp3_, _tmp4_, _tmp7_);
		_vala_code_node_unref0 (left);
		left = (ValaExpression*) _tmp8_;
		_vala_source_reference_unref0 (_tmp7_);
		_vala_code_node_unref0 (right);
	}
	result = left;
	return result;
}

static ValaExpression*
vala_parser_parse_inclusive_or_expression (ValaParser* self,
                                           GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* left = NULL;
	ValaExpression* _tmp1_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_exclusive_or_expression (self, &_inner_error0_);
	left = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	while (TRUE) {
		ValaExpression* right = NULL;
		ValaExpression* _tmp2_;
		ValaExpression* _tmp3_;
		ValaExpression* _tmp4_;
		ValaSourceLocation _tmp5_;
		ValaSourceReference* _tmp6_;
		ValaSourceReference* _tmp7_;
		ValaBinaryExpression* _tmp8_;
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_BITWISE_OR)) {
			break;
		}
		_tmp2_ = vala_parser_parse_exclusive_or_expression (self, &_inner_error0_);
		right = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (left);
				return NULL;
			} else {
				_vala_code_node_unref0 (left);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp3_ = left;
		_tmp4_ = right;
		_tmp5_ = begin;
		_tmp6_ = vala_parser_get_src (self, &_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = vala_binary_expression_new (VALA_BINARY_OPERATOR_BITWISE_OR, _tmp3_, _tmp4_, _tmp7_);
		_vala_code_node_unref0 (left);
		left = (ValaExpression*) _tmp8_;
		_vala_source_reference_unref0 (_tmp7_);
		_vala_code_node_unref0 (right);
	}
	result = left;
	return result;
}

static ValaExpression*
vala_parser_parse_in_expression (ValaParser* self,
                                 GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* left = NULL;
	ValaExpression* _tmp1_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_inclusive_or_expression (self, &_inner_error0_);
	left = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	while (TRUE) {
		ValaExpression* right = NULL;
		ValaExpression* _tmp2_;
		ValaExpression* _tmp3_;
		ValaExpression* _tmp4_;
		ValaSourceLocation _tmp5_;
		ValaSourceReference* _tmp6_;
		ValaSourceReference* _tmp7_;
		ValaBinaryExpression* _tmp8_;
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_IN)) {
			break;
		}
		_tmp2_ = vala_parser_parse_inclusive_or_expression (self, &_inner_error0_);
		right = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (left);
				return NULL;
			} else {
				_vala_code_node_unref0 (left);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp3_ = left;
		_tmp4_ = right;
		_tmp5_ = begin;
		_tmp6_ = vala_parser_get_src (self, &_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = vala_binary_expression_new (VALA_BINARY_OPERATOR_IN, _tmp3_, _tmp4_, _tmp7_);
		_vala_code_node_unref0 (left);
		left = (ValaExpression*) _tmp8_;
		_vala_source_reference_unref0 (_tmp7_);
		_vala_code_node_unref0 (right);
	}
	result = left;
	return result;
}

static ValaExpression*
vala_parser_parse_conditional_and_expression (ValaParser* self,
                                              GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* left = NULL;
	ValaExpression* _tmp1_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_in_expression (self, &_inner_error0_);
	left = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	while (TRUE) {
		ValaExpression* right = NULL;
		ValaExpression* _tmp2_;
		ValaExpression* _tmp3_;
		ValaExpression* _tmp4_;
		ValaSourceLocation _tmp5_;
		ValaSourceReference* _tmp6_;
		ValaSourceReference* _tmp7_;
		ValaBinaryExpression* _tmp8_;
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_OP_AND)) {
			break;
		}
		_tmp2_ = vala_parser_parse_in_expression (self, &_inner_error0_);
		right = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (left);
				return NULL;
			} else {
				_vala_code_node_unref0 (left);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp3_ = left;
		_tmp4_ = right;
		_tmp5_ = begin;
		_tmp6_ = vala_parser_get_src (self, &_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = vala_binary_expression_new (VALA_BINARY_OPERATOR_AND, _tmp3_, _tmp4_, _tmp7_);
		_vala_code_node_unref0 (left);
		left = (ValaExpression*) _tmp8_;
		_vala_source_reference_unref0 (_tmp7_);
		_vala_code_node_unref0 (right);
	}
	result = left;
	return result;
}

static ValaExpression*
vala_parser_parse_conditional_or_expression (ValaParser* self,
                                             GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* left = NULL;
	ValaExpression* _tmp1_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_conditional_and_expression (self, &_inner_error0_);
	left = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	while (TRUE) {
		ValaExpression* right = NULL;
		ValaExpression* _tmp2_;
		ValaExpression* _tmp3_;
		ValaExpression* _tmp4_;
		ValaSourceLocation _tmp5_;
		ValaSourceReference* _tmp6_;
		ValaSourceReference* _tmp7_;
		ValaBinaryExpression* _tmp8_;
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_OP_OR)) {
			break;
		}
		_tmp2_ = vala_parser_parse_conditional_and_expression (self, &_inner_error0_);
		right = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (left);
				return NULL;
			} else {
				_vala_code_node_unref0 (left);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp3_ = left;
		_tmp4_ = right;
		_tmp5_ = begin;
		_tmp6_ = vala_parser_get_src (self, &_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = vala_binary_expression_new (VALA_BINARY_OPERATOR_OR, _tmp3_, _tmp4_, _tmp7_);
		_vala_code_node_unref0 (left);
		left = (ValaExpression*) _tmp8_;
		_vala_source_reference_unref0 (_tmp7_);
		_vala_code_node_unref0 (right);
	}
	result = left;
	return result;
}

static ValaExpression*
vala_parser_parse_coalescing_expression (ValaParser* self,
                                         GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* left = NULL;
	ValaExpression* _tmp1_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_conditional_or_expression (self, &_inner_error0_);
	left = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_OP_COALESCING)) {
		ValaExpression* right = NULL;
		ValaExpression* _tmp2_;
		ValaExpression* _tmp3_;
		ValaExpression* _tmp4_;
		ValaSourceLocation _tmp5_;
		ValaSourceReference* _tmp6_;
		ValaSourceReference* _tmp7_;
		ValaBinaryExpression* _tmp8_;
		ValaExpression* _tmp9_;
		_tmp2_ = vala_parser_parse_coalescing_expression (self, &_inner_error0_);
		right = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (left);
				return NULL;
			} else {
				_vala_code_node_unref0 (left);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp3_ = left;
		_tmp4_ = right;
		_tmp5_ = begin;
		_tmp6_ = vala_parser_get_src (self, &_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = vala_binary_expression_new (VALA_BINARY_OPERATOR_COALESCE, _tmp3_, _tmp4_, _tmp7_);
		_tmp9_ = (ValaExpression*) _tmp8_;
		_vala_source_reference_unref0 (_tmp7_);
		result = _tmp9_;
		_vala_code_node_unref0 (right);
		_vala_code_node_unref0 (left);
		return result;
	} else {
		result = left;
		return result;
	}
	_vala_code_node_unref0 (left);
}

static ValaExpression*
vala_parser_parse_conditional_expression (ValaParser* self,
                                          GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* condition = NULL;
	ValaExpression* _tmp1_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_coalescing_expression (self, &_inner_error0_);
	condition = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_INTERR)) {
		ValaExpression* true_expr = NULL;
		ValaExpression* _tmp2_;
		ValaExpression* false_expr = NULL;
		ValaExpression* _tmp3_;
		ValaExpression* _tmp4_;
		ValaExpression* _tmp5_;
		ValaExpression* _tmp6_;
		ValaSourceLocation _tmp7_;
		ValaSourceReference* _tmp8_;
		ValaSourceReference* _tmp9_;
		ValaConditionalExpression* _tmp10_;
		ValaExpression* _tmp11_;
		_tmp2_ = vala_parser_parse_expression (self, &_inner_error0_);
		true_expr = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (condition);
				return NULL;
			} else {
				_vala_code_node_unref0 (condition);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_COLON, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (true_expr);
				_vala_code_node_unref0 (condition);
				return NULL;
			} else {
				_vala_code_node_unref0 (true_expr);
				_vala_code_node_unref0 (condition);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp3_ = vala_parser_parse_expression (self, &_inner_error0_);
		false_expr = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (true_expr);
				_vala_code_node_unref0 (condition);
				return NULL;
			} else {
				_vala_code_node_unref0 (true_expr);
				_vala_code_node_unref0 (condition);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp4_ = condition;
		_tmp5_ = true_expr;
		_tmp6_ = false_expr;
		_tmp7_ = begin;
		_tmp8_ = vala_parser_get_src (self, &_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = vala_conditional_expression_new (_tmp4_, _tmp5_, _tmp6_, _tmp9_);
		_tmp11_ = (ValaExpression*) _tmp10_;
		_vala_source_reference_unref0 (_tmp9_);
		result = _tmp11_;
		_vala_code_node_unref0 (false_expr);
		_vala_code_node_unref0 (true_expr);
		_vala_code_node_unref0 (condition);
		return result;
	} else {
		result = condition;
		return result;
	}
	_vala_code_node_unref0 (condition);
}

static ValaParameter*
vala_parser_parse_lambda_parameter (ValaParser* self,
                                    GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaParameterDirection direction = 0;
	gchar* id = NULL;
	gchar* _tmp1_;
	ValaParameter* param = NULL;
	ValaSourceLocation _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaSourceReference* _tmp4_;
	ValaParameter* _tmp5_;
	ValaParameter* _tmp6_;
	ValaParameter* _tmp7_;
	ValaParameterDirection _tmp8_;
	GError* _inner_error0_ = NULL;
	ValaParameter* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	direction = VALA_PARAMETER_DIRECTION_IN;
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_OUT)) {
		direction = VALA_PARAMETER_DIRECTION_OUT;
	} else {
		if (vala_parser_accept (self, VALA_TOKEN_TYPE_REF)) {
			direction = VALA_PARAMETER_DIRECTION_REF;
		}
	}
	_tmp1_ = vala_parser_parse_identifier (self, &_inner_error0_);
	id = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = begin;
	_tmp3_ = vala_parser_get_src (self, &_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = vala_parameter_new (id, NULL, _tmp4_);
	_tmp6_ = _tmp5_;
	_vala_source_reference_unref0 (_tmp4_);
	param = _tmp6_;
	_tmp7_ = param;
	_tmp8_ = direction;
	vala_parameter_set_direction (_tmp7_, _tmp8_);
	result = param;
	_g_free0 (id);
	return result;
}

static ValaExpression*
vala_parser_parse_lambda_expression (ValaParser* self,
                                     GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaList* params = NULL;
	GEqualFunc _tmp1_;
	ValaArrayList* _tmp2_;
	ValaLambdaExpression* lambda = NULL;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = g_direct_equal;
	_tmp2_ = vala_array_list_new (VALA_TYPE_PARAMETER, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp1_);
	params = (ValaList*) _tmp2_;
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_OPEN_PARENS)) {
		if (vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_PARENS) {
			{
				gboolean _tmp3_ = FALSE;
				_tmp3_ = TRUE;
				while (TRUE) {
					ValaParameter* _tmp4_ = NULL;
					ValaParameter* _tmp5_;
					ValaList* _tmp6_;
					if (!_tmp3_) {
						if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
							break;
						}
					}
					_tmp3_ = FALSE;
					_tmp5_ = vala_parser_parse_lambda_parameter (self, &_inner_error0_);
					_tmp4_ = _tmp5_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_vala_iterable_unref0 (params);
							return NULL;
						} else {
							_vala_iterable_unref0 (params);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return NULL;
						}
					}
					_tmp6_ = params;
					vala_collection_add ((ValaCollection*) _tmp6_, _tmp4_);
					_vala_code_node_unref0 (_tmp4_);
				}
			}
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_iterable_unref0 (params);
				return NULL;
			} else {
				_vala_iterable_unref0 (params);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	} else {
		ValaParameter* _tmp7_ = NULL;
		ValaParameter* _tmp8_;
		ValaList* _tmp9_;
		_tmp8_ = vala_parser_parse_lambda_parameter (self, &_inner_error0_);
		_tmp7_ = _tmp8_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_iterable_unref0 (params);
				return NULL;
			} else {
				_vala_iterable_unref0 (params);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp9_ = params;
		vala_collection_add ((ValaCollection*) _tmp9_, _tmp7_);
		_vala_code_node_unref0 (_tmp7_);
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_LAMBDA, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_iterable_unref0 (params);
			return NULL;
		} else {
			_vala_iterable_unref0 (params);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	if (vala_parser_current (self) == VALA_TOKEN_TYPE_OPEN_BRACE) {
		ValaBlock* block = NULL;
		ValaBlock* _tmp10_;
		ValaBlock* _tmp11_;
		ValaSourceLocation _tmp12_;
		ValaSourceReference* _tmp13_;
		ValaSourceReference* _tmp14_;
		ValaLambdaExpression* _tmp15_;
		_tmp10_ = vala_parser_parse_block (self, &_inner_error0_);
		block = _tmp10_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (lambda);
				_vala_iterable_unref0 (params);
				return NULL;
			} else {
				_vala_code_node_unref0 (lambda);
				_vala_iterable_unref0 (params);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp11_ = block;
		_tmp12_ = begin;
		_tmp13_ = vala_parser_get_src (self, &_tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = vala_lambda_expression_new_with_statement_body (_tmp11_, _tmp14_);
		_vala_code_node_unref0 (lambda);
		lambda = _tmp15_;
		_vala_source_reference_unref0 (_tmp14_);
		_vala_code_node_unref0 (block);
	} else {
		ValaExpression* expr = NULL;
		ValaExpression* _tmp16_;
		ValaExpression* _tmp17_;
		ValaSourceLocation _tmp18_;
		ValaSourceReference* _tmp19_;
		ValaSourceReference* _tmp20_;
		ValaLambdaExpression* _tmp21_;
		_tmp16_ = vala_parser_parse_expression (self, &_inner_error0_);
		expr = _tmp16_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (lambda);
				_vala_iterable_unref0 (params);
				return NULL;
			} else {
				_vala_code_node_unref0 (lambda);
				_vala_iterable_unref0 (params);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp17_ = expr;
		_tmp18_ = begin;
		_tmp19_ = vala_parser_get_src (self, &_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = vala_lambda_expression_new (_tmp17_, _tmp20_);
		_vala_code_node_unref0 (lambda);
		lambda = _tmp21_;
		_vala_source_reference_unref0 (_tmp20_);
		_vala_code_node_unref0 (expr);
	}
	{
		ValaList* _param_list = NULL;
		ValaList* _tmp22_;
		ValaList* _tmp23_;
		gint _param_size = 0;
		ValaList* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		gint _param_index = 0;
		_tmp22_ = params;
		_tmp23_ = _vala_iterable_ref0 (_tmp22_);
		_param_list = _tmp23_;
		_tmp24_ = _param_list;
		_tmp25_ = vala_collection_get_size ((ValaCollection*) _tmp24_);
		_tmp26_ = _tmp25_;
		_param_size = _tmp26_;
		_param_index = -1;
		while (TRUE) {
			gint _tmp27_;
			gint _tmp28_;
			ValaParameter* param = NULL;
			ValaList* _tmp29_;
			gpointer _tmp30_;
			ValaLambdaExpression* _tmp31_;
			ValaParameter* _tmp32_;
			_param_index = _param_index + 1;
			_tmp27_ = _param_index;
			_tmp28_ = _param_size;
			if (!(_tmp27_ < _tmp28_)) {
				break;
			}
			_tmp29_ = _param_list;
			_tmp30_ = vala_list_get (_tmp29_, _param_index);
			param = (ValaParameter*) _tmp30_;
			_tmp31_ = lambda;
			_tmp32_ = param;
			vala_lambda_expression_add_parameter (_tmp31_, _tmp32_);
			_vala_code_node_unref0 (param);
		}
		_vala_iterable_unref0 (_param_list);
	}
	result = (ValaExpression*) lambda;
	_vala_iterable_unref0 (params);
	return result;
}

static ValaAssignmentOperator
vala_parser_get_assignment_operator (ValaParser* self,
                                     ValaTokenType token_type)
{
	ValaAssignmentOperator result = 0;
	g_return_val_if_fail (self != NULL, 0);
	switch (token_type) {
		case VALA_TOKEN_TYPE_ASSIGN:
		{
			result = VALA_ASSIGNMENT_OPERATOR_SIMPLE;
			return result;
		}
		case VALA_TOKEN_TYPE_ASSIGN_ADD:
		{
			result = VALA_ASSIGNMENT_OPERATOR_ADD;
			return result;
		}
		case VALA_TOKEN_TYPE_ASSIGN_SUB:
		{
			result = VALA_ASSIGNMENT_OPERATOR_SUB;
			return result;
		}
		case VALA_TOKEN_TYPE_ASSIGN_BITWISE_OR:
		{
			result = VALA_ASSIGNMENT_OPERATOR_BITWISE_OR;
			return result;
		}
		case VALA_TOKEN_TYPE_ASSIGN_BITWISE_AND:
		{
			result = VALA_ASSIGNMENT_OPERATOR_BITWISE_AND;
			return result;
		}
		case VALA_TOKEN_TYPE_ASSIGN_BITWISE_XOR:
		{
			result = VALA_ASSIGNMENT_OPERATOR_BITWISE_XOR;
			return result;
		}
		case VALA_TOKEN_TYPE_ASSIGN_DIV:
		{
			result = VALA_ASSIGNMENT_OPERATOR_DIV;
			return result;
		}
		case VALA_TOKEN_TYPE_ASSIGN_MUL:
		{
			result = VALA_ASSIGNMENT_OPERATOR_MUL;
			return result;
		}
		case VALA_TOKEN_TYPE_ASSIGN_PERCENT:
		{
			result = VALA_ASSIGNMENT_OPERATOR_PERCENT;
			return result;
		}
		case VALA_TOKEN_TYPE_ASSIGN_SHIFT_LEFT:
		{
			result = VALA_ASSIGNMENT_OPERATOR_SHIFT_LEFT;
			return result;
		}
		default:
		{
			result = VALA_ASSIGNMENT_OPERATOR_NONE;
			return result;
		}
	}
}

static ValaExpression*
vala_parser_parse_expression (ValaParser* self,
                              GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp3_ = {0};
	ValaExpression* expr = NULL;
	ValaExpression* _tmp4_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (vala_parser_is_lambda_expression (self)) {
		ValaExpression* _tmp0_ = NULL;
		ValaExpression* _tmp1_;
		ValaExpression* _tmp2_;
		_tmp1_ = vala_parser_parse_lambda_expression (self, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		result = _tmp2_;
		_vala_code_node_unref0 (_tmp0_);
		return result;
	}
	vala_parser_get_location (self, &_tmp3_);
	begin = _tmp3_;
	_tmp4_ = vala_parser_parse_conditional_expression (self, &_inner_error0_);
	expr = _tmp4_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	while (TRUE) {
		ValaAssignmentOperator operator = 0;
		ValaAssignmentOperator _tmp5_;
		operator = vala_parser_get_assignment_operator (self, vala_parser_current (self));
		_tmp5_ = operator;
		if (_tmp5_ != VALA_ASSIGNMENT_OPERATOR_NONE) {
			ValaExpression* rhs = NULL;
			ValaExpression* _tmp6_;
			ValaExpression* _tmp7_;
			ValaExpression* _tmp8_;
			ValaAssignmentOperator _tmp9_;
			ValaSourceLocation _tmp10_;
			ValaSourceReference* _tmp11_;
			ValaSourceReference* _tmp12_;
			ValaAssignment* _tmp13_;
			vala_parser_next (self);
			_tmp6_ = vala_parser_parse_expression (self, &_inner_error0_);
			rhs = _tmp6_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (expr);
					return NULL;
				} else {
					_vala_code_node_unref0 (expr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp7_ = expr;
			_tmp8_ = rhs;
			_tmp9_ = operator;
			_tmp10_ = begin;
			_tmp11_ = vala_parser_get_src (self, &_tmp10_);
			_tmp12_ = _tmp11_;
			_tmp13_ = vala_assignment_new (_tmp7_, _tmp8_, _tmp9_, _tmp12_);
			_vala_code_node_unref0 (expr);
			expr = (ValaExpression*) _tmp13_;
			_vala_source_reference_unref0 (_tmp12_);
			_vala_code_node_unref0 (rhs);
		} else {
			if (vala_parser_current (self) == VALA_TOKEN_TYPE_OP_GT) {
				gchar* first_gt_pos = NULL;
				ValaParserTokenInfo* _tmp14_;
				gint _tmp14__length1;
				ValaParserTokenInfo _tmp15_;
				ValaSourceLocation _tmp16_;
				gchar* _tmp17_;
				gboolean _tmp18_ = FALSE;
				_tmp14_ = self->priv->tokens;
				_tmp14__length1 = self->priv->tokens_length1;
				_tmp15_ = _tmp14_[self->priv->index];
				_tmp16_ = _tmp15_.begin;
				_tmp17_ = _tmp16_.pos;
				first_gt_pos = _tmp17_;
				vala_parser_next (self);
				if (vala_parser_current (self) == VALA_TOKEN_TYPE_OP_GE) {
					ValaParserTokenInfo* _tmp19_;
					gint _tmp19__length1;
					ValaParserTokenInfo _tmp20_;
					ValaSourceLocation _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					_tmp19_ = self->priv->tokens;
					_tmp19__length1 = self->priv->tokens_length1;
					_tmp20_ = _tmp19_[self->priv->index];
					_tmp21_ = _tmp20_.begin;
					_tmp22_ = _tmp21_.pos;
					_tmp23_ = first_gt_pos;
					_tmp18_ = _tmp22_ == (_tmp23_ + 1);
				} else {
					_tmp18_ = FALSE;
				}
				if (_tmp18_) {
					ValaExpression* rhs = NULL;
					ValaExpression* _tmp24_;
					ValaExpression* _tmp25_;
					ValaExpression* _tmp26_;
					ValaSourceLocation _tmp27_;
					ValaSourceReference* _tmp28_;
					ValaSourceReference* _tmp29_;
					ValaAssignment* _tmp30_;
					vala_parser_next (self);
					_tmp24_ = vala_parser_parse_expression (self, &_inner_error0_);
					rhs = _tmp24_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_vala_code_node_unref0 (expr);
							return NULL;
						} else {
							_vala_code_node_unref0 (expr);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return NULL;
						}
					}
					_tmp25_ = expr;
					_tmp26_ = rhs;
					_tmp27_ = begin;
					_tmp28_ = vala_parser_get_src (self, &_tmp27_);
					_tmp29_ = _tmp28_;
					_tmp30_ = vala_assignment_new (_tmp25_, _tmp26_, VALA_ASSIGNMENT_OPERATOR_SHIFT_RIGHT, _tmp29_);
					_vala_code_node_unref0 (expr);
					expr = (ValaExpression*) _tmp30_;
					_vala_source_reference_unref0 (_tmp29_);
					_vala_code_node_unref0 (rhs);
				} else {
					vala_parser_prev (self);
					break;
				}
			} else {
				break;
			}
		}
	}
	result = expr;
	return result;
}

static void
vala_parser_parse_statements (ValaParser* self,
                              ValaBlock* block,
                              GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (block != NULL);
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		if (vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_BRACE) {
			_tmp2_ = vala_parser_current (self) != VALA_TOKEN_TYPE_CASE;
		} else {
			_tmp2_ = FALSE;
		}
		if (_tmp2_) {
			_tmp1_ = vala_parser_current (self) != VALA_TOKEN_TYPE_DEFAULT;
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			_tmp0_ = vala_parser_current (self) != VALA_TOKEN_TYPE_EOF;
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		{
			ValaStatement* stmt = NULL;
			gboolean is_decl = FALSE;
			ValaScanner* _tmp3_;
			ValaComment* _tmp4_;
			stmt = NULL;
			is_decl = FALSE;
			_tmp3_ = self->priv->scanner;
			_tmp4_ = vala_scanner_pop_comment (_tmp3_);
			_vala_comment_unref0 (self->priv->comment);
			self->priv->comment = _tmp4_;
			switch (vala_parser_current (self)) {
				case VALA_TOKEN_TYPE_OPEN_BRACE:
				{
					ValaBlock* _tmp5_ = NULL;
					ValaBlock* _tmp6_;
					ValaBlock* _tmp7_;
					_tmp6_ = vala_parser_parse_block (self, &_inner_error0_);
					_tmp5_ = _tmp6_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp7_ = _tmp5_;
					_tmp5_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = (ValaStatement*) _tmp7_;
					_vala_code_node_unref0 (_tmp5_);
					break;
				}
				case VALA_TOKEN_TYPE_SEMICOLON:
				{
					ValaStatement* _tmp8_ = NULL;
					ValaStatement* _tmp9_;
					ValaStatement* _tmp10_;
					_tmp9_ = vala_parser_parse_empty_statement (self, &_inner_error0_);
					_tmp8_ = _tmp9_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp10_ = _tmp8_;
					_tmp8_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp10_;
					_vala_code_node_unref0 (_tmp8_);
					break;
				}
				case VALA_TOKEN_TYPE_IF:
				{
					ValaStatement* _tmp11_ = NULL;
					ValaStatement* _tmp12_;
					ValaStatement* _tmp13_;
					_tmp12_ = vala_parser_parse_if_statement (self, &_inner_error0_);
					_tmp11_ = _tmp12_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp13_ = _tmp11_;
					_tmp11_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp13_;
					_vala_code_node_unref0 (_tmp11_);
					break;
				}
				case VALA_TOKEN_TYPE_SWITCH:
				{
					ValaStatement* _tmp14_ = NULL;
					ValaStatement* _tmp15_;
					ValaStatement* _tmp16_;
					_tmp15_ = vala_parser_parse_switch_statement (self, &_inner_error0_);
					_tmp14_ = _tmp15_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp16_ = _tmp14_;
					_tmp14_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp16_;
					_vala_code_node_unref0 (_tmp14_);
					break;
				}
				case VALA_TOKEN_TYPE_WHILE:
				{
					ValaStatement* _tmp17_ = NULL;
					ValaStatement* _tmp18_;
					ValaStatement* _tmp19_;
					_tmp18_ = vala_parser_parse_while_statement (self, &_inner_error0_);
					_tmp17_ = _tmp18_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp19_ = _tmp17_;
					_tmp17_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp19_;
					_vala_code_node_unref0 (_tmp17_);
					break;
				}
				case VALA_TOKEN_TYPE_DO:
				{
					ValaStatement* _tmp20_ = NULL;
					ValaStatement* _tmp21_;
					ValaStatement* _tmp22_;
					_tmp21_ = vala_parser_parse_do_statement (self, &_inner_error0_);
					_tmp20_ = _tmp21_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp22_ = _tmp20_;
					_tmp20_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp22_;
					_vala_code_node_unref0 (_tmp20_);
					break;
				}
				case VALA_TOKEN_TYPE_FOR:
				{
					ValaStatement* _tmp23_ = NULL;
					ValaStatement* _tmp24_;
					ValaStatement* _tmp25_;
					_tmp24_ = vala_parser_parse_for_statement (self, &_inner_error0_);
					_tmp23_ = _tmp24_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp25_ = _tmp23_;
					_tmp23_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp25_;
					_vala_code_node_unref0 (_tmp23_);
					break;
				}
				case VALA_TOKEN_TYPE_FOREACH:
				{
					ValaStatement* _tmp26_ = NULL;
					ValaStatement* _tmp27_;
					ValaStatement* _tmp28_;
					_tmp27_ = vala_parser_parse_foreach_statement (self, &_inner_error0_);
					_tmp26_ = _tmp27_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp28_ = _tmp26_;
					_tmp26_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp28_;
					_vala_code_node_unref0 (_tmp26_);
					break;
				}
				case VALA_TOKEN_TYPE_BREAK:
				{
					ValaStatement* _tmp29_ = NULL;
					ValaStatement* _tmp30_;
					ValaStatement* _tmp31_;
					_tmp30_ = vala_parser_parse_break_statement (self, &_inner_error0_);
					_tmp29_ = _tmp30_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp31_ = _tmp29_;
					_tmp29_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp31_;
					_vala_code_node_unref0 (_tmp29_);
					break;
				}
				case VALA_TOKEN_TYPE_CONTINUE:
				{
					ValaStatement* _tmp32_ = NULL;
					ValaStatement* _tmp33_;
					ValaStatement* _tmp34_;
					_tmp33_ = vala_parser_parse_continue_statement (self, &_inner_error0_);
					_tmp32_ = _tmp33_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp34_ = _tmp32_;
					_tmp32_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp34_;
					_vala_code_node_unref0 (_tmp32_);
					break;
				}
				case VALA_TOKEN_TYPE_RETURN:
				{
					ValaStatement* _tmp35_ = NULL;
					ValaStatement* _tmp36_;
					ValaStatement* _tmp37_;
					_tmp36_ = vala_parser_parse_return_statement (self, &_inner_error0_);
					_tmp35_ = _tmp36_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp37_ = _tmp35_;
					_tmp35_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp37_;
					_vala_code_node_unref0 (_tmp35_);
					break;
				}
				case VALA_TOKEN_TYPE_YIELD:
				{
					ValaStatement* _tmp38_ = NULL;
					ValaStatement* _tmp39_;
					ValaStatement* _tmp40_;
					_tmp39_ = vala_parser_parse_yield_statement (self, &_inner_error0_);
					_tmp38_ = _tmp39_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp40_ = _tmp38_;
					_tmp38_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp40_;
					_vala_code_node_unref0 (_tmp38_);
					break;
				}
				case VALA_TOKEN_TYPE_THROW:
				{
					ValaStatement* _tmp41_ = NULL;
					ValaStatement* _tmp42_;
					ValaStatement* _tmp43_;
					_tmp42_ = vala_parser_parse_throw_statement (self, &_inner_error0_);
					_tmp41_ = _tmp42_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp43_ = _tmp41_;
					_tmp41_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp43_;
					_vala_code_node_unref0 (_tmp41_);
					break;
				}
				case VALA_TOKEN_TYPE_TRY:
				{
					ValaStatement* _tmp44_ = NULL;
					ValaStatement* _tmp45_;
					ValaStatement* _tmp46_;
					_tmp45_ = vala_parser_parse_try_statement (self, &_inner_error0_);
					_tmp44_ = _tmp45_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp46_ = _tmp44_;
					_tmp44_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp46_;
					_vala_code_node_unref0 (_tmp44_);
					break;
				}
				case VALA_TOKEN_TYPE_LOCK:
				{
					ValaStatement* _tmp47_ = NULL;
					ValaStatement* _tmp48_;
					ValaStatement* _tmp49_;
					_tmp48_ = vala_parser_parse_lock_statement (self, &_inner_error0_);
					_tmp47_ = _tmp48_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp49_ = _tmp47_;
					_tmp47_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp49_;
					_vala_code_node_unref0 (_tmp47_);
					break;
				}
				case VALA_TOKEN_TYPE_UNLOCK:
				{
					ValaStatement* _tmp50_ = NULL;
					ValaStatement* _tmp51_;
					ValaStatement* _tmp52_;
					_tmp51_ = vala_parser_parse_unlock_statement (self, &_inner_error0_);
					_tmp50_ = _tmp51_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp52_ = _tmp50_;
					_tmp50_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp52_;
					_vala_code_node_unref0 (_tmp50_);
					break;
				}
				case VALA_TOKEN_TYPE_DELETE:
				{
					ValaStatement* _tmp53_ = NULL;
					ValaStatement* _tmp54_;
					ValaStatement* _tmp55_;
					_tmp54_ = vala_parser_parse_delete_statement (self, &_inner_error0_);
					_tmp53_ = _tmp54_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp55_ = _tmp53_;
					_tmp53_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp55_;
					_vala_code_node_unref0 (_tmp53_);
					break;
				}
				case VALA_TOKEN_TYPE_VAR:
				{
					is_decl = TRUE;
					vala_parser_parse_local_variable_declarations (self, block, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					break;
				}
				case VALA_TOKEN_TYPE_CONST:
				{
					is_decl = TRUE;
					vala_parser_parse_local_constant_declarations (self, block, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					break;
				}
				case VALA_TOKEN_TYPE_OP_INC:
				case VALA_TOKEN_TYPE_OP_DEC:
				case VALA_TOKEN_TYPE_BASE:
				case VALA_TOKEN_TYPE_THIS:
				case VALA_TOKEN_TYPE_STAR:
				case VALA_TOKEN_TYPE_NEW:
				{
					ValaStatement* _tmp56_ = NULL;
					ValaStatement* _tmp57_;
					ValaStatement* _tmp58_;
					_tmp57_ = vala_parser_parse_expression_statement (self, &_inner_error0_);
					_tmp56_ = _tmp57_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					_tmp58_ = _tmp56_;
					_tmp56_ = NULL;
					_vala_code_node_unref0 (stmt);
					stmt = _tmp58_;
					_vala_code_node_unref0 (_tmp56_);
					break;
				}
				default:
				{
					gboolean is_expr = FALSE;
					is_expr = vala_parser_is_expression (self, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_vala_code_node_unref0 (stmt);
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							goto __catch0_vala_parse_error;
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
					if (is_expr) {
						ValaStatement* _tmp59_ = NULL;
						ValaStatement* _tmp60_;
						ValaStatement* _tmp61_;
						_tmp60_ = vala_parser_parse_expression_statement (self, &_inner_error0_);
						_tmp59_ = _tmp60_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							_vala_code_node_unref0 (stmt);
							if (_inner_error0_->domain == VALA_PARSE_ERROR) {
								goto __catch0_vala_parse_error;
							}
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
						_tmp61_ = _tmp59_;
						_tmp59_ = NULL;
						_vala_code_node_unref0 (stmt);
						stmt = _tmp61_;
						_vala_code_node_unref0 (_tmp59_);
					} else {
						is_decl = TRUE;
						vala_parser_parse_local_variable_declarations (self, block, &_inner_error0_);
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							_vala_code_node_unref0 (stmt);
							if (_inner_error0_->domain == VALA_PARSE_ERROR) {
								goto __catch0_vala_parse_error;
							}
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
					}
					break;
				}
			}
			if (!is_decl) {
				ValaStatement* _tmp62_;
				_tmp62_ = stmt;
				vala_block_add_statement (block, _tmp62_);
			}
			_vala_code_node_unref0 (stmt);
		}
		goto __finally0;
		__catch0_vala_parse_error:
		{
			GError* e = NULL;
			GError* _tmp63_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp63_ = e;
			vala_parser_report_parse_error (self, _tmp63_);
			if (vala_parser_recover (self) != VALA_PARSER_RECOVERY_STATE_STATEMENT_BEGIN) {
				_g_error_free0 (e);
				break;
			}
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
}

static gboolean
vala_parser_is_expression (ValaParser* self,
                           GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (vala_parser_current (self) == VALA_TOKEN_TYPE_OPEN_PARENS) {
		result = !vala_parser_is_inner_array_type (self);
		return result;
	}
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	{
		vala_parser_skip_type (self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp1_ = FALSE;
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				goto __catch0_vala_parse_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp1_;
		}
	}
	goto __finally0;
	__catch0_vala_parse_error:
	{
		GError* e = NULL;
		ValaTokenType token = 0;
		gboolean _tmp2_ = FALSE;
		ValaTokenType _tmp3_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		token = vala_parser_previous (self);
		_tmp3_ = token;
		if (_tmp3_ == VALA_TOKEN_TYPE_DOT) {
			_tmp2_ = TRUE;
		} else {
			ValaTokenType _tmp4_;
			_tmp4_ = token;
			_tmp2_ = _tmp4_ == VALA_TOKEN_TYPE_DOUBLE_COLON;
		}
		if (_tmp2_) {
			ValaSourceLocation _tmp5_;
			_tmp5_ = begin;
			vala_parser_rollback (self, &_tmp5_);
			result = TRUE;
			_g_error_free0 (e);
			return result;
		} else {
			GError* _tmp6_;
			GError* _tmp7_;
			_tmp6_ = e;
			_tmp7_ = _g_error_copy0 (_tmp6_);
			_inner_error0_ = _tmp7_;
			_g_error_free0 (e);
			goto __finally0;
		}
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			gboolean _tmp8_ = FALSE;
			g_propagate_error (error, _inner_error0_);
			return _tmp8_;
		} else {
			gboolean _tmp9_ = FALSE;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp9_;
		}
	}
	switch (vala_parser_current (self)) {
		case VALA_TOKEN_TYPE_OPEN_PARENS:
		case VALA_TOKEN_TYPE_OP_INC:
		case VALA_TOKEN_TYPE_OP_DEC:
		case VALA_TOKEN_TYPE_ASSIGN:
		case VALA_TOKEN_TYPE_ASSIGN_ADD:
		case VALA_TOKEN_TYPE_ASSIGN_BITWISE_AND:
		case VALA_TOKEN_TYPE_ASSIGN_BITWISE_OR:
		case VALA_TOKEN_TYPE_ASSIGN_BITWISE_XOR:
		case VALA_TOKEN_TYPE_ASSIGN_DIV:
		case VALA_TOKEN_TYPE_ASSIGN_MUL:
		case VALA_TOKEN_TYPE_ASSIGN_PERCENT:
		case VALA_TOKEN_TYPE_ASSIGN_SHIFT_LEFT:
		case VALA_TOKEN_TYPE_ASSIGN_SUB:
		case VALA_TOKEN_TYPE_OP_GT:
		case VALA_TOKEN_TYPE_DOT:
		case VALA_TOKEN_TYPE_OP_PTR:
		case VALA_TOKEN_TYPE_INTEGER_LITERAL:
		case VALA_TOKEN_TYPE_REAL_LITERAL:
		{
			ValaSourceLocation _tmp10_;
			_tmp10_ = begin;
			vala_parser_rollback (self, &_tmp10_);
			result = TRUE;
			return result;
		}
		default:
		{
			ValaSourceLocation _tmp11_;
			_tmp11_ = begin;
			vala_parser_rollback (self, &_tmp11_);
			result = FALSE;
			return result;
		}
	}
}

static gboolean
vala_parser_is_lambda_expression (ValaParser* self)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSourceLocation _tmp9_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	switch (vala_parser_current (self)) {
		case VALA_TOKEN_TYPE_OUT:
		case VALA_TOKEN_TYPE_REF:
		{
			gboolean _tmp1_ = FALSE;
			vala_parser_next (self);
			if (vala_parser_accept (self, VALA_TOKEN_TYPE_IDENTIFIER)) {
				_tmp1_ = vala_parser_accept (self, VALA_TOKEN_TYPE_LAMBDA);
			} else {
				_tmp1_ = FALSE;
			}
			if (_tmp1_) {
				ValaSourceLocation _tmp2_;
				_tmp2_ = begin;
				vala_parser_rollback (self, &_tmp2_);
				result = TRUE;
				return result;
			}
			break;
		}
		case VALA_TOKEN_TYPE_IDENTIFIER:
		{
			vala_parser_next (self);
			if (vala_parser_accept (self, VALA_TOKEN_TYPE_LAMBDA)) {
				ValaSourceLocation _tmp3_;
				_tmp3_ = begin;
				vala_parser_rollback (self, &_tmp3_);
				result = TRUE;
				return result;
			}
			break;
		}
		case VALA_TOKEN_TYPE_OPEN_PARENS:
		{
			gboolean _tmp7_ = FALSE;
			vala_parser_next (self);
			if (vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_PARENS) {
				{
					gboolean _tmp4_ = FALSE;
					_tmp4_ = TRUE;
					while (TRUE) {
						gboolean _tmp5_ = FALSE;
						if (!_tmp4_) {
							if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
								break;
							}
						}
						_tmp4_ = FALSE;
						if (vala_parser_current (self) == VALA_TOKEN_TYPE_OUT) {
							_tmp5_ = TRUE;
						} else {
							_tmp5_ = vala_parser_current (self) == VALA_TOKEN_TYPE_REF;
						}
						if (_tmp5_) {
							vala_parser_next (self);
						}
						if (!vala_parser_accept (self, VALA_TOKEN_TYPE_IDENTIFIER)) {
							ValaSourceLocation _tmp6_;
							_tmp6_ = begin;
							vala_parser_rollback (self, &_tmp6_);
							result = FALSE;
							return result;
						}
					}
				}
			}
			if (vala_parser_accept (self, VALA_TOKEN_TYPE_CLOSE_PARENS)) {
				_tmp7_ = vala_parser_accept (self, VALA_TOKEN_TYPE_LAMBDA);
			} else {
				_tmp7_ = FALSE;
			}
			if (_tmp7_) {
				ValaSourceLocation _tmp8_;
				_tmp8_ = begin;
				vala_parser_rollback (self, &_tmp8_);
				result = TRUE;
				return result;
			}
			break;
		}
		default:
		{
			break;
		}
	}
	_tmp9_ = begin;
	vala_parser_rollback (self, &_tmp9_);
	result = FALSE;
	return result;
}

static ValaBlock*
vala_parser_parse_embedded_statement (ValaParser* self,
                                      const gchar* statement_name,
                                      gboolean accept_empty_body,
                                      GError** error)
{
	ValaScanner* _tmp1_;
	ValaComment* _tmp2_;
	ValaBlock* block = NULL;
	ValaSourceLocation _tmp3_ = {0};
	ValaSourceReference* _tmp4_;
	ValaSourceReference* _tmp5_;
	ValaBlock* _tmp6_;
	ValaBlock* _tmp7_;
	ValaBlock* _tmp17_;
	ValaSourceReference* _tmp18_;
	ValaSourceReference* _tmp19_;
	ValaSourceReference* _tmp20_;
	ValaSourceReference* _tmp21_;
	ValaSourceLocation _tmp22_ = {0};
	ValaSourceLocation _tmp23_;
	GError* _inner_error0_ = NULL;
	ValaBlock* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (statement_name != NULL, NULL);
	if (vala_parser_current (self) == VALA_TOKEN_TYPE_OPEN_BRACE) {
		ValaBlock* block = NULL;
		ValaBlock* _tmp0_;
		_tmp0_ = vala_parser_parse_block (self, &_inner_error0_);
		block = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		result = block;
		return result;
	}
	_tmp1_ = self->priv->scanner;
	_tmp2_ = vala_scanner_pop_comment (_tmp1_);
	_vala_comment_unref0 (self->priv->comment);
	self->priv->comment = _tmp2_;
	vala_parser_get_location (self, &_tmp3_);
	_tmp4_ = vala_parser_get_src (self, &_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = vala_block_new (_tmp5_);
	_tmp7_ = _tmp6_;
	_vala_source_reference_unref0 (_tmp5_);
	block = _tmp7_;
	{
		ValaStatement* stmt = NULL;
		ValaStatement* _tmp8_;
		ValaBlock* _tmp9_;
		ValaStatement* _tmp10_;
		_tmp8_ = vala_parser_parse_embedded_statement_without_block (self, statement_name, accept_empty_body, &_inner_error0_);
		stmt = _tmp8_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				goto __catch0_vala_parse_error;
			}
			_vala_code_node_unref0 (block);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp9_ = block;
		_tmp10_ = stmt;
		vala_block_add_statement (_tmp9_, _tmp10_);
		_vala_code_node_unref0 (stmt);
	}
	goto __finally0;
	__catch0_vala_parse_error:
	{
		GError* e = NULL;
		ValaCodeContext* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp11_ = self->priv->context;
		_tmp12_ = vala_code_context_get_keep_going (_tmp11_);
		_tmp13_ = _tmp12_;
		if (_tmp13_) {
			GError* _tmp14_;
			_tmp14_ = e;
			vala_parser_report_parse_error (self, _tmp14_);
		} else {
			GError* _tmp15_;
			GError* _tmp16_;
			_tmp15_ = e;
			_tmp16_ = _g_error_copy0 (_tmp15_);
			_inner_error0_ = _tmp16_;
			_g_error_free0 (e);
			goto __finally0;
		}
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (block);
			return NULL;
		} else {
			_vala_code_node_unref0 (block);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp17_ = block;
	_tmp18_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = vala_parser_get_last_src (self);
	_tmp21_ = _tmp20_;
	vala_source_reference_get_end (_tmp21_, &_tmp22_);
	_tmp23_ = _tmp22_;
	vala_source_reference_set_end (_tmp19_, &_tmp23_);
	_vala_source_reference_unref0 (_tmp21_);
	result = block;
	return result;
}

static ValaStatement*
vala_parser_parse_embedded_statement_without_block (ValaParser* self,
                                                    const gchar* statement_name,
                                                    gboolean accept_empty_body,
                                                    GError** error)
{
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (statement_name != NULL, NULL);
	switch (vala_parser_current (self)) {
		case VALA_TOKEN_TYPE_SEMICOLON:
		{
			ValaStatement* _tmp4_ = NULL;
			ValaStatement* _tmp5_;
			ValaStatement* _tmp6_;
			if (!accept_empty_body) {
				ValaSourceReference* _tmp0_;
				ValaSourceReference* _tmp1_;
				gchar* _tmp2_;
				gchar* _tmp3_;
				_tmp0_ = vala_parser_get_current_src (self);
				_tmp1_ = _tmp0_;
				_tmp2_ = g_strdup_printf ("%s-statement without body", statement_name);
				_tmp3_ = _tmp2_;
				vala_report_warning (_tmp1_, _tmp3_);
				_g_free0 (_tmp3_);
				_vala_source_reference_unref0 (_tmp1_);
			}
			_tmp5_ = vala_parser_parse_empty_statement (self, &_inner_error0_);
			_tmp4_ = _tmp5_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp6_ = _tmp4_;
			_tmp4_ = NULL;
			result = _tmp6_;
			_vala_code_node_unref0 (_tmp4_);
			return result;
		}
		case VALA_TOKEN_TYPE_IF:
		{
			ValaStatement* _tmp7_ = NULL;
			ValaStatement* _tmp8_;
			ValaStatement* _tmp9_;
			_tmp8_ = vala_parser_parse_if_statement (self, &_inner_error0_);
			_tmp7_ = _tmp8_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp9_ = _tmp7_;
			_tmp7_ = NULL;
			result = _tmp9_;
			_vala_code_node_unref0 (_tmp7_);
			return result;
		}
		case VALA_TOKEN_TYPE_SWITCH:
		{
			ValaStatement* _tmp10_ = NULL;
			ValaStatement* _tmp11_;
			ValaStatement* _tmp12_;
			_tmp11_ = vala_parser_parse_switch_statement (self, &_inner_error0_);
			_tmp10_ = _tmp11_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp12_ = _tmp10_;
			_tmp10_ = NULL;
			result = _tmp12_;
			_vala_code_node_unref0 (_tmp10_);
			return result;
		}
		case VALA_TOKEN_TYPE_WHILE:
		{
			ValaStatement* _tmp13_ = NULL;
			ValaStatement* _tmp14_;
			ValaStatement* _tmp15_;
			_tmp14_ = vala_parser_parse_while_statement (self, &_inner_error0_);
			_tmp13_ = _tmp14_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp15_ = _tmp13_;
			_tmp13_ = NULL;
			result = _tmp15_;
			_vala_code_node_unref0 (_tmp13_);
			return result;
		}
		case VALA_TOKEN_TYPE_DO:
		{
			ValaStatement* _tmp16_ = NULL;
			ValaStatement* _tmp17_;
			ValaStatement* _tmp18_;
			_tmp17_ = vala_parser_parse_do_statement (self, &_inner_error0_);
			_tmp16_ = _tmp17_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp18_ = _tmp16_;
			_tmp16_ = NULL;
			result = _tmp18_;
			_vala_code_node_unref0 (_tmp16_);
			return result;
		}
		case VALA_TOKEN_TYPE_FOR:
		{
			ValaStatement* _tmp19_ = NULL;
			ValaStatement* _tmp20_;
			ValaStatement* _tmp21_;
			_tmp20_ = vala_parser_parse_for_statement (self, &_inner_error0_);
			_tmp19_ = _tmp20_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp21_ = _tmp19_;
			_tmp19_ = NULL;
			result = _tmp21_;
			_vala_code_node_unref0 (_tmp19_);
			return result;
		}
		case VALA_TOKEN_TYPE_FOREACH:
		{
			ValaStatement* _tmp22_ = NULL;
			ValaStatement* _tmp23_;
			ValaStatement* _tmp24_;
			_tmp23_ = vala_parser_parse_foreach_statement (self, &_inner_error0_);
			_tmp22_ = _tmp23_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp24_ = _tmp22_;
			_tmp22_ = NULL;
			result = _tmp24_;
			_vala_code_node_unref0 (_tmp22_);
			return result;
		}
		case VALA_TOKEN_TYPE_BREAK:
		{
			ValaStatement* _tmp25_ = NULL;
			ValaStatement* _tmp26_;
			ValaStatement* _tmp27_;
			_tmp26_ = vala_parser_parse_break_statement (self, &_inner_error0_);
			_tmp25_ = _tmp26_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp27_ = _tmp25_;
			_tmp25_ = NULL;
			result = _tmp27_;
			_vala_code_node_unref0 (_tmp25_);
			return result;
		}
		case VALA_TOKEN_TYPE_CONTINUE:
		{
			ValaStatement* _tmp28_ = NULL;
			ValaStatement* _tmp29_;
			ValaStatement* _tmp30_;
			_tmp29_ = vala_parser_parse_continue_statement (self, &_inner_error0_);
			_tmp28_ = _tmp29_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp30_ = _tmp28_;
			_tmp28_ = NULL;
			result = _tmp30_;
			_vala_code_node_unref0 (_tmp28_);
			return result;
		}
		case VALA_TOKEN_TYPE_RETURN:
		{
			ValaStatement* _tmp31_ = NULL;
			ValaStatement* _tmp32_;
			ValaStatement* _tmp33_;
			_tmp32_ = vala_parser_parse_return_statement (self, &_inner_error0_);
			_tmp31_ = _tmp32_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp33_ = _tmp31_;
			_tmp31_ = NULL;
			result = _tmp33_;
			_vala_code_node_unref0 (_tmp31_);
			return result;
		}
		case VALA_TOKEN_TYPE_YIELD:
		{
			ValaStatement* _tmp34_ = NULL;
			ValaStatement* _tmp35_;
			ValaStatement* _tmp36_;
			_tmp35_ = vala_parser_parse_yield_statement (self, &_inner_error0_);
			_tmp34_ = _tmp35_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp36_ = _tmp34_;
			_tmp34_ = NULL;
			result = _tmp36_;
			_vala_code_node_unref0 (_tmp34_);
			return result;
		}
		case VALA_TOKEN_TYPE_THROW:
		{
			ValaStatement* _tmp37_ = NULL;
			ValaStatement* _tmp38_;
			ValaStatement* _tmp39_;
			_tmp38_ = vala_parser_parse_throw_statement (self, &_inner_error0_);
			_tmp37_ = _tmp38_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp39_ = _tmp37_;
			_tmp37_ = NULL;
			result = _tmp39_;
			_vala_code_node_unref0 (_tmp37_);
			return result;
		}
		case VALA_TOKEN_TYPE_TRY:
		{
			ValaStatement* _tmp40_ = NULL;
			ValaStatement* _tmp41_;
			ValaStatement* _tmp42_;
			_tmp41_ = vala_parser_parse_try_statement (self, &_inner_error0_);
			_tmp40_ = _tmp41_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp42_ = _tmp40_;
			_tmp40_ = NULL;
			result = _tmp42_;
			_vala_code_node_unref0 (_tmp40_);
			return result;
		}
		case VALA_TOKEN_TYPE_LOCK:
		{
			ValaStatement* _tmp43_ = NULL;
			ValaStatement* _tmp44_;
			ValaStatement* _tmp45_;
			_tmp44_ = vala_parser_parse_lock_statement (self, &_inner_error0_);
			_tmp43_ = _tmp44_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp45_ = _tmp43_;
			_tmp43_ = NULL;
			result = _tmp45_;
			_vala_code_node_unref0 (_tmp43_);
			return result;
		}
		case VALA_TOKEN_TYPE_UNLOCK:
		{
			ValaStatement* _tmp46_ = NULL;
			ValaStatement* _tmp47_;
			ValaStatement* _tmp48_;
			_tmp47_ = vala_parser_parse_unlock_statement (self, &_inner_error0_);
			_tmp46_ = _tmp47_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp48_ = _tmp46_;
			_tmp46_ = NULL;
			result = _tmp48_;
			_vala_code_node_unref0 (_tmp46_);
			return result;
		}
		case VALA_TOKEN_TYPE_DELETE:
		{
			ValaStatement* _tmp49_ = NULL;
			ValaStatement* _tmp50_;
			ValaStatement* _tmp51_;
			_tmp50_ = vala_parser_parse_delete_statement (self, &_inner_error0_);
			_tmp49_ = _tmp50_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp51_ = _tmp49_;
			_tmp49_ = NULL;
			result = _tmp51_;
			_vala_code_node_unref0 (_tmp49_);
			return result;
		}
		case VALA_TOKEN_TYPE_VAR:
		case VALA_TOKEN_TYPE_CONST:
		{
			GError* _tmp52_;
			_tmp52_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "embedded statement cannot be declaration ");
			_inner_error0_ = _tmp52_;
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		case VALA_TOKEN_TYPE_OP_INC:
		case VALA_TOKEN_TYPE_OP_DEC:
		case VALA_TOKEN_TYPE_BASE:
		case VALA_TOKEN_TYPE_THIS:
		case VALA_TOKEN_TYPE_OPEN_PARENS:
		case VALA_TOKEN_TYPE_STAR:
		case VALA_TOKEN_TYPE_NEW:
		{
			ValaStatement* _tmp53_ = NULL;
			ValaStatement* _tmp54_;
			ValaStatement* _tmp55_;
			_tmp54_ = vala_parser_parse_expression_statement (self, &_inner_error0_);
			_tmp53_ = _tmp54_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp55_ = _tmp53_;
			_tmp53_ = NULL;
			result = _tmp55_;
			_vala_code_node_unref0 (_tmp53_);
			return result;
		}
		default:
		{
			gboolean _tmp56_ = FALSE;
			_tmp56_ = vala_parser_is_expression (self, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			if (_tmp56_) {
				ValaStatement* _tmp57_ = NULL;
				ValaStatement* _tmp58_;
				ValaStatement* _tmp59_;
				_tmp58_ = vala_parser_parse_expression_statement (self, &_inner_error0_);
				_tmp57_ = _tmp58_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						return NULL;
					} else {
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp59_ = _tmp57_;
				_tmp57_ = NULL;
				result = _tmp59_;
				_vala_code_node_unref0 (_tmp57_);
				return result;
			} else {
				GError* _tmp60_;
				_tmp60_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "embedded statement cannot be declaration");
				_inner_error0_ = _tmp60_;
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
		}
	}
}

static ValaBlock*
vala_parser_parse_block (ValaParser* self,
                         GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaBlock* block = NULL;
	ValaSourceLocation _tmp1_;
	ValaSourceReference* _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaBlock* _tmp4_;
	ValaBlock* _tmp5_;
	ValaBlock* _tmp6_;
	ValaBlock* _tmp12_;
	ValaSourceReference* _tmp13_;
	ValaSourceReference* _tmp14_;
	ValaSourceReference* _tmp15_;
	ValaSourceReference* _tmp16_;
	ValaSourceLocation _tmp17_ = {0};
	ValaSourceLocation _tmp18_;
	GError* _inner_error0_ = NULL;
	ValaBlock* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_BRACE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = begin;
	_tmp2_ = vala_parser_get_src (self, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = vala_block_new (_tmp3_);
	_tmp5_ = _tmp4_;
	_vala_source_reference_unref0 (_tmp3_);
	block = _tmp5_;
	_tmp6_ = block;
	vala_parser_parse_statements (self, _tmp6_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (block);
			return NULL;
		} else {
			_vala_code_node_unref0 (block);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	if (!vala_parser_accept (self, VALA_TOKEN_TYPE_CLOSE_BRACE)) {
		ValaCodeContext* _tmp7_;
		ValaReport* _tmp8_;
		ValaReport* _tmp9_;
		_tmp7_ = self->priv->context;
		_tmp8_ = vala_code_context_get_report (_tmp7_);
		_tmp9_ = _tmp8_;
		if (vala_report_get_errors (_tmp9_) == 0) {
			ValaSourceReference* _tmp10_;
			ValaSourceReference* _tmp11_;
			_tmp10_ = vala_parser_get_current_src (self);
			_tmp11_ = _tmp10_;
			vala_report_error (_tmp11_, "expected `}'");
			_vala_source_reference_unref0 (_tmp11_);
		}
	}
	_tmp12_ = block;
	_tmp13_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = vala_parser_get_last_src (self);
	_tmp16_ = _tmp15_;
	vala_source_reference_get_end (_tmp16_, &_tmp17_);
	_tmp18_ = _tmp17_;
	vala_source_reference_set_end (_tmp14_, &_tmp18_);
	_vala_source_reference_unref0 (_tmp16_);
	result = block;
	return result;
}

static ValaStatement*
vala_parser_parse_empty_statement (ValaParser* self,
                                   GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSourceLocation _tmp1_;
	ValaSourceReference* _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaEmptyStatement* _tmp4_;
	ValaStatement* _tmp5_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = begin;
	_tmp2_ = vala_parser_get_src (self, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = vala_empty_statement_new (_tmp3_);
	_tmp5_ = (ValaStatement*) _tmp4_;
	_vala_source_reference_unref0 (_tmp3_);
	result = _tmp5_;
	return result;
}

static void
_vala_array_add12 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
vala_parser_parse_local_variable_declarations (ValaParser* self,
                                               ValaBlock* block,
                                               GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaDataType* variable_type = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean is_first = FALSE;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (block != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_UNOWNED)) {
		_tmp1_ = vala_parser_accept (self, VALA_TOKEN_TYPE_VAR);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		ValaVarType* _tmp2_;
		_tmp2_ = vala_var_type_new (FALSE);
		_vala_code_node_unref0 (variable_type);
		variable_type = (ValaDataType*) _tmp2_;
	} else {
		ValaSourceLocation _tmp3_;
		_tmp3_ = begin;
		vala_parser_rollback (self, &_tmp3_);
		if (vala_parser_accept (self, VALA_TOKEN_TYPE_VAR)) {
			ValaVarType* _tmp4_;
			_tmp4_ = vala_var_type_new (TRUE);
			_vala_code_node_unref0 (variable_type);
			variable_type = (ValaDataType*) _tmp4_;
		} else {
			ValaDataType* _tmp5_ = NULL;
			ValaDataType* _tmp6_;
			ValaDataType* _tmp7_;
			_tmp6_ = vala_parser_parse_type (self, TRUE, TRUE, FALSE, &_inner_error0_);
			_tmp5_ = _tmp6_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (variable_type);
					return;
				} else {
					_vala_code_node_unref0 (variable_type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_tmp7_ = _tmp5_;
			_tmp5_ = NULL;
			_vala_code_node_unref0 (variable_type);
			variable_type = _tmp7_;
			_vala_code_node_unref0 (_tmp5_);
		}
	}
	is_first = TRUE;
	{
		gboolean _tmp8_ = FALSE;
		_tmp8_ = TRUE;
		while (TRUE) {
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
			ValaDataType* _tmp11_;
			ValaDataType* type_copy = NULL;
			ValaDataType* _tmp70_;
			ValaLocalVariable* local = NULL;
			ValaDataType* _tmp73_;
			ValaLocalVariable* _tmp74_;
			ValaLocalVariable* _tmp75_;
			ValaSourceLocation _tmp76_;
			ValaSourceReference* _tmp77_;
			ValaSourceReference* _tmp78_;
			ValaDeclarationStatement* _tmp79_;
			ValaDeclarationStatement* _tmp80_;
			if (!_tmp8_) {
				if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
					break;
				}
			}
			_tmp8_ = FALSE;
			_tmp11_ = variable_type;
			if (VALA_IS_VAR_TYPE (_tmp11_)) {
				ValaDataType* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
				_tmp12_ = variable_type;
				_tmp13_ = vala_data_type_get_value_owned (_tmp12_);
				_tmp14_ = _tmp13_;
				_tmp10_ = _tmp14_;
			} else {
				_tmp10_ = FALSE;
			}
			if (_tmp10_) {
				_tmp9_ = vala_parser_accept (self, VALA_TOKEN_TYPE_OPEN_PARENS);
			} else {
				_tmp9_ = FALSE;
			}
			if (_tmp9_) {
				ValaSourceLocation _tmp15_ = {0};
				gchar** identifiers = NULL;
				gchar** _tmp16_;
				gint identifiers_length1;
				gint _identifiers_size_;
				ValaExpression* tuple = NULL;
				ValaExpression* _tmp21_;
				ValaLocalVariable* tuple_local = NULL;
				gchar* _tmp22_;
				gchar* _tmp23_;
				ValaExpression* _tmp24_;
				ValaSourceLocation _tmp25_;
				ValaSourceReference* _tmp26_;
				ValaSourceReference* _tmp27_;
				ValaLocalVariable* _tmp28_;
				ValaLocalVariable* _tmp29_;
				ValaLocalVariable* _tmp30_;
				ValaLocalVariable* _tmp31_;
				ValaSourceReference* _tmp32_;
				ValaSourceReference* _tmp33_;
				ValaDeclarationStatement* _tmp34_;
				ValaDeclarationStatement* _tmp35_;
				vala_parser_get_location (self, &_tmp15_);
				begin = _tmp15_;
				_tmp16_ = g_new0 (gchar*, 0 + 1);
				identifiers = _tmp16_;
				identifiers_length1 = 0;
				_identifiers_size_ = identifiers_length1;
				{
					gboolean _tmp17_ = FALSE;
					_tmp17_ = TRUE;
					while (TRUE) {
						gchar* _tmp18_ = NULL;
						gchar* _tmp19_;
						gchar* _tmp20_;
						if (!_tmp17_) {
							if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
								break;
							}
						}
						_tmp17_ = FALSE;
						_tmp19_ = vala_parser_parse_identifier (self, &_inner_error0_);
						_tmp18_ = _tmp19_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							if (_inner_error0_->domain == VALA_PARSE_ERROR) {
								g_propagate_error (error, _inner_error0_);
								identifiers = (_vala_array_free (identifiers, identifiers_length1, (GDestroyNotify) g_free), NULL);
								_vala_code_node_unref0 (variable_type);
								return;
							} else {
								identifiers = (_vala_array_free (identifiers, identifiers_length1, (GDestroyNotify) g_free), NULL);
								_vala_code_node_unref0 (variable_type);
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return;
							}
						}
						_tmp20_ = _tmp18_;
						_tmp18_ = NULL;
						_vala_array_add12 (&identifiers, &identifiers_length1, &_identifiers_size_, _tmp20_);
						_g_free0 (_tmp18_);
					}
				}
				vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						identifiers = (_vala_array_free (identifiers, identifiers_length1, (GDestroyNotify) g_free), NULL);
						_vala_code_node_unref0 (variable_type);
						return;
					} else {
						identifiers = (_vala_array_free (identifiers, identifiers_length1, (GDestroyNotify) g_free), NULL);
						_vala_code_node_unref0 (variable_type);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				vala_parser_expect (self, VALA_TOKEN_TYPE_ASSIGN, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						identifiers = (_vala_array_free (identifiers, identifiers_length1, (GDestroyNotify) g_free), NULL);
						_vala_code_node_unref0 (variable_type);
						return;
					} else {
						identifiers = (_vala_array_free (identifiers, identifiers_length1, (GDestroyNotify) g_free), NULL);
						_vala_code_node_unref0 (variable_type);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_tmp21_ = vala_parser_parse_expression (self, &_inner_error0_);
				tuple = _tmp21_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						identifiers = (_vala_array_free (identifiers, identifiers_length1, (GDestroyNotify) g_free), NULL);
						_vala_code_node_unref0 (variable_type);
						return;
					} else {
						identifiers = (_vala_array_free (identifiers, identifiers_length1, (GDestroyNotify) g_free), NULL);
						_vala_code_node_unref0 (variable_type);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_tmp22_ = vala_code_node_get_temp_name ();
				_tmp23_ = _tmp22_;
				_tmp24_ = tuple;
				_tmp25_ = begin;
				_tmp26_ = vala_parser_get_src (self, &_tmp25_);
				_tmp27_ = _tmp26_;
				_tmp28_ = vala_local_variable_new (NULL, _tmp23_, _tmp24_, _tmp27_);
				_tmp29_ = _tmp28_;
				_vala_source_reference_unref0 (_tmp27_);
				_g_free0 (_tmp23_);
				tuple_local = _tmp29_;
				_tmp30_ = tuple_local;
				_tmp31_ = tuple_local;
				_tmp32_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp31_);
				_tmp33_ = _tmp32_;
				_tmp34_ = vala_declaration_statement_new ((ValaSymbol*) _tmp30_, _tmp33_);
				_tmp35_ = _tmp34_;
				vala_block_add_statement (block, (ValaStatement*) _tmp35_);
				_vala_code_node_unref0 (_tmp35_);
				{
					gint i = 0;
					i = 0;
					{
						gboolean _tmp36_ = FALSE;
						_tmp36_ = TRUE;
						while (TRUE) {
							gchar** _tmp38_;
							gint _tmp38__length1;
							ValaMemberAccess* temp_access = NULL;
							ValaLocalVariable* _tmp39_;
							const gchar* _tmp40_;
							const gchar* _tmp41_;
							ValaLocalVariable* _tmp42_;
							ValaSourceReference* _tmp43_;
							ValaSourceReference* _tmp44_;
							ValaMemberAccess* _tmp45_;
							ValaElementAccess* ea = NULL;
							ValaMemberAccess* _tmp46_;
							ValaLocalVariable* _tmp47_;
							ValaSourceReference* _tmp48_;
							ValaSourceReference* _tmp49_;
							ValaElementAccess* _tmp50_;
							ValaElementAccess* _tmp51_;
							gchar* _tmp52_;
							gchar* _tmp53_;
							ValaIntegerLiteral* _tmp54_;
							ValaIntegerLiteral* _tmp55_;
							ValaLocalVariable* local = NULL;
							gchar** _tmp56_;
							gint _tmp56__length1;
							const gchar* _tmp57_;
							ValaElementAccess* _tmp58_;
							ValaLocalVariable* _tmp59_;
							ValaSourceReference* _tmp60_;
							ValaSourceReference* _tmp61_;
							ValaLocalVariable* _tmp62_;
							ValaLocalVariable* _tmp63_;
							ValaLocalVariable* _tmp64_;
							ValaSourceReference* _tmp65_;
							ValaSourceReference* _tmp66_;
							ValaDeclarationStatement* _tmp67_;
							ValaDeclarationStatement* _tmp68_;
							if (!_tmp36_) {
								gint _tmp37_;
								_tmp37_ = i;
								i = _tmp37_ + 1;
							}
							_tmp36_ = FALSE;
							_tmp38_ = identifiers;
							_tmp38__length1 = identifiers_length1;
							if (!(i < _tmp38__length1)) {
								break;
							}
							_tmp39_ = tuple_local;
							_tmp40_ = vala_symbol_get_name ((ValaSymbol*) _tmp39_);
							_tmp41_ = _tmp40_;
							_tmp42_ = tuple_local;
							_tmp43_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp42_);
							_tmp44_ = _tmp43_;
							_tmp45_ = vala_member_access_new_simple (_tmp41_, _tmp44_);
							temp_access = _tmp45_;
							_tmp46_ = temp_access;
							_tmp47_ = tuple_local;
							_tmp48_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp47_);
							_tmp49_ = _tmp48_;
							_tmp50_ = vala_element_access_new ((ValaExpression*) _tmp46_, _tmp49_);
							ea = _tmp50_;
							_tmp51_ = ea;
							_tmp52_ = g_strdup_printf ("%i", i);
							_tmp53_ = _tmp52_;
							_tmp54_ = vala_integer_literal_new (_tmp53_, NULL);
							_tmp55_ = _tmp54_;
							vala_element_access_append_index (_tmp51_, (ValaExpression*) _tmp55_);
							_vala_code_node_unref0 (_tmp55_);
							_g_free0 (_tmp53_);
							_tmp56_ = identifiers;
							_tmp56__length1 = identifiers_length1;
							_tmp57_ = _tmp56_[i];
							_tmp58_ = ea;
							_tmp59_ = tuple_local;
							_tmp60_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp59_);
							_tmp61_ = _tmp60_;
							_tmp62_ = vala_local_variable_new (NULL, _tmp57_, (ValaExpression*) _tmp58_, _tmp61_);
							local = _tmp62_;
							_tmp63_ = local;
							_tmp64_ = local;
							_tmp65_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp64_);
							_tmp66_ = _tmp65_;
							_tmp67_ = vala_declaration_statement_new ((ValaSymbol*) _tmp63_, _tmp66_);
							_tmp68_ = _tmp67_;
							vala_block_add_statement (block, (ValaStatement*) _tmp68_);
							_vala_code_node_unref0 (_tmp68_);
							_vala_code_node_unref0 (local);
							_vala_code_node_unref0 (ea);
							_vala_code_node_unref0 (temp_access);
						}
					}
				}
				_vala_code_node_unref0 (tuple_local);
				_vala_code_node_unref0 (tuple);
				identifiers = (_vala_array_free (identifiers, identifiers_length1, (GDestroyNotify) g_free), NULL);
				continue;
			}
			if (!is_first) {
				ValaSourceLocation _tmp69_ = {0};
				vala_parser_get_location (self, &_tmp69_);
				begin = _tmp69_;
			} else {
				is_first = FALSE;
			}
			type_copy = NULL;
			_tmp70_ = variable_type;
			if (_tmp70_ != NULL) {
				ValaDataType* _tmp71_;
				ValaDataType* _tmp72_;
				_tmp71_ = variable_type;
				_tmp72_ = vala_data_type_copy (_tmp71_);
				_vala_code_node_unref0 (type_copy);
				type_copy = _tmp72_;
			}
			_tmp73_ = type_copy;
			_tmp74_ = vala_parser_parse_local_variable (self, _tmp73_, &_inner_error0_);
			local = _tmp74_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (type_copy);
					_vala_code_node_unref0 (variable_type);
					return;
				} else {
					_vala_code_node_unref0 (type_copy);
					_vala_code_node_unref0 (variable_type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_tmp75_ = local;
			_tmp76_ = begin;
			_tmp77_ = vala_parser_get_src (self, &_tmp76_);
			_tmp78_ = _tmp77_;
			_tmp79_ = vala_declaration_statement_new ((ValaSymbol*) _tmp75_, _tmp78_);
			_tmp80_ = _tmp79_;
			vala_block_add_statement (block, (ValaStatement*) _tmp80_);
			_vala_code_node_unref0 (_tmp80_);
			_vala_source_reference_unref0 (_tmp78_);
			_vala_code_node_unref0 (local);
			_vala_code_node_unref0 (type_copy);
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (variable_type);
			return;
		} else {
			_vala_code_node_unref0 (variable_type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_vala_code_node_unref0 (variable_type);
}

static ValaLocalVariable*
vala_parser_parse_local_variable (ValaParser* self,
                                  ValaDataType* variable_type,
                                  GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	gchar* id = NULL;
	gchar* _tmp1_;
	ValaDataType* type = NULL;
	ValaDataType* _tmp2_;
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp3_;
	ValaSourceReference* _tmp4_;
	ValaExpression* initializer = NULL;
	ValaDataType* _tmp8_;
	const gchar* _tmp9_;
	ValaExpression* _tmp10_;
	ValaSourceReference* _tmp11_;
	ValaLocalVariable* _tmp12_;
	GError* _inner_error0_ = NULL;
	ValaLocalVariable* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_identifier (self, &_inner_error0_);
	id = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = vala_parser_parse_inline_array_type (self, variable_type, &_inner_error0_);
	type = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (id);
			return NULL;
		} else {
			_g_free0 (id);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp3_ = begin;
	_tmp4_ = vala_parser_get_src (self, &_tmp3_);
	src = _tmp4_;
	initializer = NULL;
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_ASSIGN)) {
		ValaExpression* _tmp5_ = NULL;
		ValaExpression* _tmp6_;
		ValaExpression* _tmp7_;
		_tmp6_ = vala_parser_parse_expression (self, &_inner_error0_);
		_tmp5_ = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (initializer);
				_vala_source_reference_unref0 (src);
				_vala_code_node_unref0 (type);
				_g_free0 (id);
				return NULL;
			} else {
				_vala_code_node_unref0 (initializer);
				_vala_source_reference_unref0 (src);
				_vala_code_node_unref0 (type);
				_g_free0 (id);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp7_ = _tmp5_;
		_tmp5_ = NULL;
		_vala_code_node_unref0 (initializer);
		initializer = _tmp7_;
		_vala_code_node_unref0 (_tmp5_);
	}
	_tmp8_ = type;
	_tmp9_ = id;
	_tmp10_ = initializer;
	_tmp11_ = src;
	_tmp12_ = vala_local_variable_new (_tmp8_, _tmp9_, _tmp10_, _tmp11_);
	result = _tmp12_;
	_vala_code_node_unref0 (initializer);
	_vala_source_reference_unref0 (src);
	_vala_code_node_unref0 (type);
	_g_free0 (id);
	return result;
}

static void
vala_parser_parse_local_constant_declarations (ValaParser* self,
                                               ValaBlock* block,
                                               GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaDataType* constant_type = NULL;
	ValaDataType* _tmp1_;
	ValaArrayType* array_type = NULL;
	ValaDataType* _tmp2_;
	ValaArrayType* _tmp3_;
	gboolean is_first = FALSE;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (block != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_CONST, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp1_ = vala_parser_parse_type (self, FALSE, FALSE, FALSE, &_inner_error0_);
	constant_type = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp2_ = constant_type;
	array_type = VALA_IS_ARRAY_TYPE (_tmp2_) ? ((ValaArrayType*) _tmp2_) : NULL;
	_tmp3_ = array_type;
	if (_tmp3_ != NULL) {
		ValaArrayType* _tmp4_;
		ValaDataType* _tmp5_;
		ValaDataType* _tmp6_;
		_tmp4_ = array_type;
		_tmp5_ = vala_array_type_get_element_type (_tmp4_);
		_tmp6_ = _tmp5_;
		vala_data_type_set_value_owned (_tmp6_, FALSE);
	}
	is_first = TRUE;
	{
		gboolean _tmp7_ = FALSE;
		_tmp7_ = TRUE;
		while (TRUE) {
			ValaDataType* type_copy = NULL;
			ValaDataType* _tmp9_;
			ValaDataType* _tmp10_;
			ValaConstant* local = NULL;
			ValaDataType* _tmp11_;
			ValaConstant* _tmp12_;
			ValaConstant* _tmp13_;
			ValaSourceLocation _tmp14_;
			ValaSourceReference* _tmp15_;
			ValaSourceReference* _tmp16_;
			ValaDeclarationStatement* _tmp17_;
			ValaDeclarationStatement* _tmp18_;
			ValaConstant* _tmp19_;
			ValaConstant* _tmp20_;
			if (!_tmp7_) {
				if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
					break;
				}
			}
			_tmp7_ = FALSE;
			if (!is_first) {
				ValaSourceLocation _tmp8_ = {0};
				vala_parser_get_location (self, &_tmp8_);
				begin = _tmp8_;
			} else {
				is_first = FALSE;
			}
			_tmp9_ = constant_type;
			_tmp10_ = vala_data_type_copy (_tmp9_);
			type_copy = _tmp10_;
			_tmp11_ = type_copy;
			_tmp12_ = vala_parser_parse_local_constant (self, _tmp11_, &_inner_error0_);
			local = _tmp12_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (type_copy);
					_vala_code_node_unref0 (constant_type);
					return;
				} else {
					_vala_code_node_unref0 (type_copy);
					_vala_code_node_unref0 (constant_type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_tmp13_ = local;
			_tmp14_ = begin;
			_tmp15_ = vala_parser_get_src (self, &_tmp14_);
			_tmp16_ = _tmp15_;
			_tmp17_ = vala_declaration_statement_new ((ValaSymbol*) _tmp13_, _tmp16_);
			_tmp18_ = _tmp17_;
			vala_block_add_statement (block, (ValaStatement*) _tmp18_);
			_vala_code_node_unref0 (_tmp18_);
			_vala_source_reference_unref0 (_tmp16_);
			_tmp19_ = local;
			vala_block_add_local_constant (block, _tmp19_);
			_tmp20_ = local;
			vala_symbol_set_active ((ValaSymbol*) _tmp20_, FALSE);
			_vala_code_node_unref0 (local);
			_vala_code_node_unref0 (type_copy);
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (constant_type);
			return;
		} else {
			_vala_code_node_unref0 (constant_type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_vala_code_node_unref0 (constant_type);
}

static ValaConstant*
vala_parser_parse_local_constant (ValaParser* self,
                                  ValaDataType* constant_type,
                                  GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	gchar* id = NULL;
	gchar* _tmp1_;
	ValaDataType* type = NULL;
	ValaDataType* _tmp2_;
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp3_;
	ValaSourceReference* _tmp4_;
	ValaExpression* initializer = NULL;
	ValaExpression* _tmp5_;
	ValaDataType* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	const gchar* _tmp10_;
	ValaDataType* _tmp11_;
	ValaExpression* _tmp12_;
	ValaSourceReference* _tmp13_;
	ValaConstant* _tmp14_;
	GError* _inner_error0_ = NULL;
	ValaConstant* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (constant_type != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_identifier (self, &_inner_error0_);
	id = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = vala_parser_parse_inline_array_type (self, constant_type, &_inner_error0_);
	type = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (id);
			return NULL;
		} else {
			_g_free0 (id);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp3_ = begin;
	_tmp4_ = vala_parser_get_src (self, &_tmp3_);
	src = _tmp4_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_ASSIGN, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (type);
			_g_free0 (id);
			return NULL;
		} else {
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (type);
			_g_free0 (id);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp5_ = vala_parser_parse_expression (self, &_inner_error0_);
	initializer = _tmp5_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (type);
			_g_free0 (id);
			return NULL;
		} else {
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (type);
			_g_free0 (id);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp6_ = type;
	_tmp7_ = vala_data_type_get_value_owned (_tmp6_);
	_tmp8_ = _tmp7_;
	if (_tmp8_) {
		ValaSourceReference* _tmp9_;
		_tmp9_ = src;
		vala_report_error (_tmp9_, "`owned' is not allowed on constants");
	}
	_tmp10_ = id;
	_tmp11_ = type;
	_tmp12_ = initializer;
	_tmp13_ = src;
	_tmp14_ = vala_constant_new (_tmp10_, _tmp11_, _tmp12_, _tmp13_, NULL);
	result = _tmp14_;
	_vala_code_node_unref0 (initializer);
	_vala_source_reference_unref0 (src);
	_vala_code_node_unref0 (type);
	_g_free0 (id);
	return result;
}

static ValaStatement*
vala_parser_parse_expression_statement (ValaParser* self,
                                        GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* expr = NULL;
	ValaExpression* _tmp1_;
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaExpression* _tmp4_;
	ValaSourceReference* _tmp5_;
	ValaExpressionStatement* _tmp6_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_parser_parse_statement_expression (self, &_inner_error0_);
	expr = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = begin;
	_tmp3_ = vala_parser_get_src (self, &_tmp2_);
	src = _tmp3_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (expr);
			return NULL;
		} else {
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (expr);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp4_ = expr;
	_tmp5_ = src;
	_tmp6_ = vala_expression_statement_new (_tmp4_, _tmp5_);
	result = (ValaStatement*) _tmp6_;
	_vala_source_reference_unref0 (src);
	_vala_code_node_unref0 (expr);
	return result;
}

static ValaExpression*
vala_parser_parse_statement_expression (ValaParser* self,
                                        GError** error)
{
	ValaExpression* expr = NULL;
	ValaExpression* _tmp0_;
	GError* _inner_error0_ = NULL;
	ValaExpression* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = vala_parser_parse_expression (self, &_inner_error0_);
	expr = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = expr;
	return result;
}

static ValaStatement*
vala_parser_parse_if_statement (ValaParser* self,
                                GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* condition = NULL;
	ValaExpression* _tmp1_;
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaBlock* true_stmt = NULL;
	ValaBlock* _tmp4_;
	ValaBlock* false_stmt = NULL;
	ValaExpression* _tmp8_;
	ValaBlock* _tmp9_;
	ValaBlock* _tmp10_;
	ValaSourceReference* _tmp11_;
	ValaIfStatement* _tmp12_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_IF, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = vala_parser_parse_expression (self, &_inner_error0_);
	condition = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (condition);
			return NULL;
		} else {
			_vala_code_node_unref0 (condition);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = begin;
	_tmp3_ = vala_parser_get_src (self, &_tmp2_);
	src = _tmp3_;
	_tmp4_ = vala_parser_parse_embedded_statement (self, "if", FALSE, &_inner_error0_);
	true_stmt = _tmp4_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (condition);
			return NULL;
		} else {
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (condition);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	false_stmt = NULL;
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_ELSE)) {
		ValaBlock* _tmp5_ = NULL;
		ValaBlock* _tmp6_;
		ValaBlock* _tmp7_;
		_tmp6_ = vala_parser_parse_embedded_statement (self, "else", FALSE, &_inner_error0_);
		_tmp5_ = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (false_stmt);
				_vala_code_node_unref0 (true_stmt);
				_vala_source_reference_unref0 (src);
				_vala_code_node_unref0 (condition);
				return NULL;
			} else {
				_vala_code_node_unref0 (false_stmt);
				_vala_code_node_unref0 (true_stmt);
				_vala_source_reference_unref0 (src);
				_vala_code_node_unref0 (condition);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp7_ = _tmp5_;
		_tmp5_ = NULL;
		_vala_code_node_unref0 (false_stmt);
		false_stmt = _tmp7_;
		_vala_code_node_unref0 (_tmp5_);
	}
	_tmp8_ = condition;
	_tmp9_ = true_stmt;
	_tmp10_ = false_stmt;
	_tmp11_ = src;
	_tmp12_ = vala_if_statement_new (_tmp8_, _tmp9_, _tmp10_, _tmp11_);
	result = (ValaStatement*) _tmp12_;
	_vala_code_node_unref0 (false_stmt);
	_vala_code_node_unref0 (true_stmt);
	_vala_source_reference_unref0 (src);
	_vala_code_node_unref0 (condition);
	return result;
}

static ValaStatement*
vala_parser_parse_switch_statement (ValaParser* self,
                                    GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* condition = NULL;
	ValaExpression* _tmp1_;
	ValaSwitchStatement* stmt = NULL;
	ValaExpression* _tmp2_;
	ValaSourceLocation _tmp3_;
	ValaSourceReference* _tmp4_;
	ValaSourceReference* _tmp5_;
	ValaSwitchStatement* _tmp6_;
	ValaSwitchStatement* _tmp7_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_SWITCH, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = vala_parser_parse_expression (self, &_inner_error0_);
	condition = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (condition);
			return NULL;
		} else {
			_vala_code_node_unref0 (condition);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = condition;
	_tmp3_ = begin;
	_tmp4_ = vala_parser_get_src (self, &_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = vala_switch_statement_new (_tmp2_, _tmp5_);
	_tmp7_ = _tmp6_;
	_vala_source_reference_unref0 (_tmp5_);
	stmt = _tmp7_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_BRACE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (stmt);
			_vala_code_node_unref0 (condition);
			return NULL;
		} else {
			_vala_code_node_unref0 (stmt);
			_vala_code_node_unref0 (condition);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	while (TRUE) {
		ValaSourceLocation _tmp8_ = {0};
		ValaSwitchSection* section = NULL;
		ValaSourceLocation _tmp9_;
		ValaSourceReference* _tmp10_;
		ValaSourceReference* _tmp11_;
		ValaSwitchSection* _tmp12_;
		ValaSwitchSection* _tmp13_;
		ValaSwitchSection* _tmp38_;
		ValaSwitchStatement* _tmp39_;
		ValaSwitchSection* _tmp40_;
		if (!(vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_BRACE)) {
			break;
		}
		vala_parser_get_location (self, &_tmp8_);
		begin = _tmp8_;
		_tmp9_ = begin;
		_tmp10_ = vala_parser_get_src (self, &_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = vala_switch_section_new (_tmp11_);
		_tmp13_ = _tmp12_;
		_vala_source_reference_unref0 (_tmp11_);
		section = _tmp13_;
		{
			gboolean _tmp14_ = FALSE;
			_tmp14_ = TRUE;
			while (TRUE) {
				if (!_tmp14_) {
					gboolean _tmp15_ = FALSE;
					if (vala_parser_current (self) == VALA_TOKEN_TYPE_CASE) {
						_tmp15_ = TRUE;
					} else {
						_tmp15_ = vala_parser_current (self) == VALA_TOKEN_TYPE_DEFAULT;
					}
					if (!_tmp15_) {
						break;
					}
				}
				_tmp14_ = FALSE;
				if (vala_parser_accept (self, VALA_TOKEN_TYPE_CASE)) {
					ValaExpression* _tmp16_ = NULL;
					ValaExpression* _tmp17_;
					ValaSwitchSection* _tmp18_;
					ValaSourceLocation _tmp19_;
					ValaSourceReference* _tmp20_;
					ValaSourceReference* _tmp21_;
					ValaSwitchLabel* _tmp22_;
					ValaSwitchLabel* _tmp23_;
					_tmp17_ = vala_parser_parse_expression (self, &_inner_error0_);
					_tmp16_ = _tmp17_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_vala_code_node_unref0 (section);
							_vala_code_node_unref0 (stmt);
							_vala_code_node_unref0 (condition);
							return NULL;
						} else {
							_vala_code_node_unref0 (section);
							_vala_code_node_unref0 (stmt);
							_vala_code_node_unref0 (condition);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return NULL;
						}
					}
					_tmp18_ = section;
					_tmp19_ = begin;
					_tmp20_ = vala_parser_get_src (self, &_tmp19_);
					_tmp21_ = _tmp20_;
					_tmp22_ = vala_switch_label_new (_tmp16_, _tmp21_);
					_tmp23_ = _tmp22_;
					vala_switch_section_add_label (_tmp18_, _tmp23_);
					_vala_code_node_unref0 (_tmp23_);
					_vala_source_reference_unref0 (_tmp21_);
					while (TRUE) {
						ValaExpression* _tmp24_ = NULL;
						ValaExpression* _tmp25_;
						ValaSwitchSection* _tmp26_;
						ValaSourceLocation _tmp27_;
						ValaSourceReference* _tmp28_;
						ValaSourceReference* _tmp29_;
						ValaSwitchLabel* _tmp30_;
						ValaSwitchLabel* _tmp31_;
						if (!(vala_parser_current (self) == VALA_TOKEN_TYPE_COMMA)) {
							break;
						}
						vala_parser_expect (self, VALA_TOKEN_TYPE_COMMA, &_inner_error0_);
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							if (_inner_error0_->domain == VALA_PARSE_ERROR) {
								g_propagate_error (error, _inner_error0_);
								_vala_code_node_unref0 (_tmp16_);
								_vala_code_node_unref0 (section);
								_vala_code_node_unref0 (stmt);
								_vala_code_node_unref0 (condition);
								return NULL;
							} else {
								_vala_code_node_unref0 (_tmp16_);
								_vala_code_node_unref0 (section);
								_vala_code_node_unref0 (stmt);
								_vala_code_node_unref0 (condition);
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return NULL;
							}
						}
						_tmp25_ = vala_parser_parse_expression (self, &_inner_error0_);
						_tmp24_ = _tmp25_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							if (_inner_error0_->domain == VALA_PARSE_ERROR) {
								g_propagate_error (error, _inner_error0_);
								_vala_code_node_unref0 (_tmp16_);
								_vala_code_node_unref0 (section);
								_vala_code_node_unref0 (stmt);
								_vala_code_node_unref0 (condition);
								return NULL;
							} else {
								_vala_code_node_unref0 (_tmp16_);
								_vala_code_node_unref0 (section);
								_vala_code_node_unref0 (stmt);
								_vala_code_node_unref0 (condition);
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return NULL;
							}
						}
						_tmp26_ = section;
						_tmp27_ = begin;
						_tmp28_ = vala_parser_get_src (self, &_tmp27_);
						_tmp29_ = _tmp28_;
						_tmp30_ = vala_switch_label_new (_tmp24_, _tmp29_);
						_tmp31_ = _tmp30_;
						vala_switch_section_add_label (_tmp26_, _tmp31_);
						_vala_code_node_unref0 (_tmp31_);
						_vala_source_reference_unref0 (_tmp29_);
						_vala_code_node_unref0 (_tmp24_);
					}
					_vala_code_node_unref0 (_tmp16_);
				} else {
					ValaSwitchSection* _tmp32_;
					ValaSourceLocation _tmp33_;
					ValaSourceReference* _tmp34_;
					ValaSourceReference* _tmp35_;
					ValaSwitchLabel* _tmp36_;
					ValaSwitchLabel* _tmp37_;
					vala_parser_expect (self, VALA_TOKEN_TYPE_DEFAULT, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_vala_code_node_unref0 (section);
							_vala_code_node_unref0 (stmt);
							_vala_code_node_unref0 (condition);
							return NULL;
						} else {
							_vala_code_node_unref0 (section);
							_vala_code_node_unref0 (stmt);
							_vala_code_node_unref0 (condition);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return NULL;
						}
					}
					_tmp32_ = section;
					_tmp33_ = begin;
					_tmp34_ = vala_parser_get_src (self, &_tmp33_);
					_tmp35_ = _tmp34_;
					_tmp36_ = vala_switch_label_new_with_default (_tmp35_);
					_tmp37_ = _tmp36_;
					vala_switch_section_add_label (_tmp32_, _tmp37_);
					_vala_code_node_unref0 (_tmp37_);
					_vala_source_reference_unref0 (_tmp35_);
				}
				vala_parser_expect (self, VALA_TOKEN_TYPE_COLON, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (section);
						_vala_code_node_unref0 (stmt);
						_vala_code_node_unref0 (condition);
						return NULL;
					} else {
						_vala_code_node_unref0 (section);
						_vala_code_node_unref0 (stmt);
						_vala_code_node_unref0 (condition);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
			}
		}
		_tmp38_ = section;
		vala_parser_parse_statements (self, (ValaBlock*) _tmp38_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (section);
				_vala_code_node_unref0 (stmt);
				_vala_code_node_unref0 (condition);
				return NULL;
			} else {
				_vala_code_node_unref0 (section);
				_vala_code_node_unref0 (stmt);
				_vala_code_node_unref0 (condition);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp39_ = stmt;
		_tmp40_ = section;
		vala_switch_statement_add_section (_tmp39_, _tmp40_);
		_vala_code_node_unref0 (section);
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_BRACE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (stmt);
			_vala_code_node_unref0 (condition);
			return NULL;
		} else {
			_vala_code_node_unref0 (stmt);
			_vala_code_node_unref0 (condition);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = (ValaStatement*) stmt;
	_vala_code_node_unref0 (condition);
	return result;
}

static ValaStatement*
vala_parser_parse_while_statement (ValaParser* self,
                                   GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* condition = NULL;
	ValaExpression* _tmp1_;
	ValaBlock* body = NULL;
	ValaBlock* _tmp2_;
	ValaExpression* _tmp3_;
	ValaBlock* _tmp4_;
	ValaSourceLocation _tmp5_;
	ValaSourceReference* _tmp6_;
	ValaSourceReference* _tmp7_;
	ValaWhileStatement* _tmp8_;
	ValaStatement* _tmp9_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_WHILE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = vala_parser_parse_expression (self, &_inner_error0_);
	condition = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (condition);
			return NULL;
		} else {
			_vala_code_node_unref0 (condition);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = vala_parser_parse_embedded_statement (self, "while", TRUE, &_inner_error0_);
	body = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (condition);
			return NULL;
		} else {
			_vala_code_node_unref0 (condition);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp3_ = condition;
	_tmp4_ = body;
	_tmp5_ = begin;
	_tmp6_ = vala_parser_get_src (self, &_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = vala_while_statement_new (_tmp3_, _tmp4_, _tmp7_);
	_tmp9_ = (ValaStatement*) _tmp8_;
	_vala_source_reference_unref0 (_tmp7_);
	result = _tmp9_;
	_vala_code_node_unref0 (body);
	_vala_code_node_unref0 (condition);
	return result;
}

static ValaStatement*
vala_parser_parse_do_statement (ValaParser* self,
                                GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaBlock* body = NULL;
	ValaBlock* _tmp1_;
	ValaExpression* condition = NULL;
	ValaExpression* _tmp2_;
	ValaBlock* _tmp3_;
	ValaExpression* _tmp4_;
	ValaSourceLocation _tmp5_;
	ValaSourceReference* _tmp6_;
	ValaSourceReference* _tmp7_;
	ValaDoStatement* _tmp8_;
	ValaStatement* _tmp9_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_DO, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = vala_parser_parse_embedded_statement (self, "do", TRUE, &_inner_error0_);
	body = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_WHILE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (body);
			return NULL;
		} else {
			_vala_code_node_unref0 (body);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (body);
			return NULL;
		} else {
			_vala_code_node_unref0 (body);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = vala_parser_parse_expression (self, &_inner_error0_);
	condition = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (body);
			return NULL;
		} else {
			_vala_code_node_unref0 (body);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (condition);
			_vala_code_node_unref0 (body);
			return NULL;
		} else {
			_vala_code_node_unref0 (condition);
			_vala_code_node_unref0 (body);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (condition);
			_vala_code_node_unref0 (body);
			return NULL;
		} else {
			_vala_code_node_unref0 (condition);
			_vala_code_node_unref0 (body);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp3_ = body;
	_tmp4_ = condition;
	_tmp5_ = begin;
	_tmp6_ = vala_parser_get_src (self, &_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = vala_do_statement_new (_tmp3_, _tmp4_, _tmp7_);
	_tmp9_ = (ValaStatement*) _tmp8_;
	_vala_source_reference_unref0 (_tmp7_);
	result = _tmp9_;
	_vala_code_node_unref0 (condition);
	_vala_code_node_unref0 (body);
	return result;
}

static ValaStatement*
vala_parser_parse_for_statement (ValaParser* self,
                                 GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaBlock* block = NULL;
	ValaArrayList* initializer_list = NULL;
	GEqualFunc _tmp1_;
	ValaArrayList* _tmp2_;
	ValaExpression* condition = NULL;
	ValaArrayList* iterator_list = NULL;
	GEqualFunc _tmp24_;
	ValaArrayList* _tmp25_;
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp30_;
	ValaSourceReference* _tmp31_;
	ValaBlock* body = NULL;
	ValaBlock* _tmp32_;
	ValaForStatement* stmt = NULL;
	ValaExpression* _tmp33_;
	ValaBlock* _tmp34_;
	ValaSourceReference* _tmp35_;
	ValaForStatement* _tmp36_;
	ValaBlock* _tmp59_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	block = NULL;
	vala_parser_expect (self, VALA_TOKEN_TYPE_FOR, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (block);
			return NULL;
		} else {
			_vala_code_node_unref0 (block);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (block);
			return NULL;
		} else {
			_vala_code_node_unref0 (block);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = g_direct_equal;
	_tmp2_ = vala_array_list_new (VALA_TYPE_EXPRESSION, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp1_);
	initializer_list = _tmp2_;
	if (!vala_parser_accept (self, VALA_TOKEN_TYPE_SEMICOLON)) {
		gboolean is_expr = FALSE;
		switch (vala_parser_current (self)) {
			case VALA_TOKEN_TYPE_VAR:
			{
				is_expr = FALSE;
				break;
			}
			case VALA_TOKEN_TYPE_OP_INC:
			case VALA_TOKEN_TYPE_OP_DEC:
			{
				is_expr = TRUE;
				break;
			}
			default:
			{
				gboolean _tmp3_ = FALSE;
				_tmp3_ = vala_parser_is_expression (self, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_iterable_unref0 (initializer_list);
						_vala_code_node_unref0 (block);
						return NULL;
					} else {
						_vala_iterable_unref0 (initializer_list);
						_vala_code_node_unref0 (block);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				is_expr = _tmp3_;
				break;
			}
		}
		if (is_expr) {
			{
				gboolean _tmp4_ = FALSE;
				_tmp4_ = TRUE;
				while (TRUE) {
					ValaExpression* _tmp5_ = NULL;
					ValaExpression* _tmp6_;
					ValaArrayList* _tmp7_;
					if (!_tmp4_) {
						if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
							break;
						}
					}
					_tmp4_ = FALSE;
					_tmp6_ = vala_parser_parse_statement_expression (self, &_inner_error0_);
					_tmp5_ = _tmp6_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_vala_iterable_unref0 (initializer_list);
							_vala_code_node_unref0 (block);
							return NULL;
						} else {
							_vala_iterable_unref0 (initializer_list);
							_vala_code_node_unref0 (block);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return NULL;
						}
					}
					_tmp7_ = initializer_list;
					vala_collection_add ((ValaCollection*) _tmp7_, _tmp5_);
					_vala_code_node_unref0 (_tmp5_);
				}
			}
			vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_iterable_unref0 (initializer_list);
					_vala_code_node_unref0 (block);
					return NULL;
				} else {
					_vala_iterable_unref0 (initializer_list);
					_vala_code_node_unref0 (block);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
		} else {
			ValaSourceLocation decl_begin = {0};
			ValaSourceLocation _tmp8_ = {0};
			ValaSourceLocation _tmp9_;
			ValaSourceReference* _tmp10_;
			ValaSourceReference* _tmp11_;
			ValaBlock* _tmp12_;
			ValaBlock* _tmp13_;
			ValaBlock* _tmp14_;
			ValaSourceReference* _tmp15_;
			ValaSourceReference* _tmp16_;
			ValaSourceReference* _tmp17_;
			ValaSourceReference* _tmp18_;
			ValaSourceLocation _tmp19_ = {0};
			ValaSourceLocation _tmp20_;
			vala_parser_get_location (self, &_tmp8_);
			decl_begin = _tmp8_;
			_tmp9_ = decl_begin;
			_tmp10_ = vala_parser_get_src (self, &_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp12_ = vala_block_new (_tmp11_);
			_vala_code_node_unref0 (block);
			block = _tmp12_;
			_vala_source_reference_unref0 (_tmp11_);
			_tmp13_ = block;
			vala_parser_parse_local_variable_declarations (self, _tmp13_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_iterable_unref0 (initializer_list);
					_vala_code_node_unref0 (block);
					return NULL;
				} else {
					_vala_iterable_unref0 (initializer_list);
					_vala_code_node_unref0 (block);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp14_ = block;
			_tmp15_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp14_);
			_tmp16_ = _tmp15_;
			_tmp17_ = vala_parser_get_last_src (self);
			_tmp18_ = _tmp17_;
			vala_source_reference_get_end (_tmp18_, &_tmp19_);
			_tmp20_ = _tmp19_;
			vala_source_reference_set_end (_tmp16_, &_tmp20_);
			_vala_source_reference_unref0 (_tmp18_);
		}
	}
	condition = NULL;
	if (vala_parser_current (self) != VALA_TOKEN_TYPE_SEMICOLON) {
		ValaExpression* _tmp21_ = NULL;
		ValaExpression* _tmp22_;
		ValaExpression* _tmp23_;
		_tmp22_ = vala_parser_parse_expression (self, &_inner_error0_);
		_tmp21_ = _tmp22_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (condition);
				_vala_iterable_unref0 (initializer_list);
				_vala_code_node_unref0 (block);
				return NULL;
			} else {
				_vala_code_node_unref0 (condition);
				_vala_iterable_unref0 (initializer_list);
				_vala_code_node_unref0 (block);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp23_ = _tmp21_;
		_tmp21_ = NULL;
		_vala_code_node_unref0 (condition);
		condition = _tmp23_;
		_vala_code_node_unref0 (_tmp21_);
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (condition);
			_vala_iterable_unref0 (initializer_list);
			_vala_code_node_unref0 (block);
			return NULL;
		} else {
			_vala_code_node_unref0 (condition);
			_vala_iterable_unref0 (initializer_list);
			_vala_code_node_unref0 (block);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp24_ = g_direct_equal;
	_tmp25_ = vala_array_list_new (VALA_TYPE_EXPRESSION, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp24_);
	iterator_list = _tmp25_;
	if (vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_PARENS) {
		{
			gboolean _tmp26_ = FALSE;
			_tmp26_ = TRUE;
			while (TRUE) {
				ValaExpression* _tmp27_ = NULL;
				ValaExpression* _tmp28_;
				ValaArrayList* _tmp29_;
				if (!_tmp26_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp26_ = FALSE;
				_tmp28_ = vala_parser_parse_statement_expression (self, &_inner_error0_);
				_tmp27_ = _tmp28_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_iterable_unref0 (iterator_list);
						_vala_code_node_unref0 (condition);
						_vala_iterable_unref0 (initializer_list);
						_vala_code_node_unref0 (block);
						return NULL;
					} else {
						_vala_iterable_unref0 (iterator_list);
						_vala_code_node_unref0 (condition);
						_vala_iterable_unref0 (initializer_list);
						_vala_code_node_unref0 (block);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp29_ = iterator_list;
				vala_collection_add ((ValaCollection*) _tmp29_, _tmp27_);
				_vala_code_node_unref0 (_tmp27_);
			}
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_iterable_unref0 (iterator_list);
			_vala_code_node_unref0 (condition);
			_vala_iterable_unref0 (initializer_list);
			_vala_code_node_unref0 (block);
			return NULL;
		} else {
			_vala_iterable_unref0 (iterator_list);
			_vala_code_node_unref0 (condition);
			_vala_iterable_unref0 (initializer_list);
			_vala_code_node_unref0 (block);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp30_ = begin;
	_tmp31_ = vala_parser_get_src (self, &_tmp30_);
	src = _tmp31_;
	_tmp32_ = vala_parser_parse_embedded_statement (self, "for", TRUE, &_inner_error0_);
	body = _tmp32_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_source_reference_unref0 (src);
			_vala_iterable_unref0 (iterator_list);
			_vala_code_node_unref0 (condition);
			_vala_iterable_unref0 (initializer_list);
			_vala_code_node_unref0 (block);
			return NULL;
		} else {
			_vala_source_reference_unref0 (src);
			_vala_iterable_unref0 (iterator_list);
			_vala_code_node_unref0 (condition);
			_vala_iterable_unref0 (initializer_list);
			_vala_code_node_unref0 (block);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp33_ = condition;
	_tmp34_ = body;
	_tmp35_ = src;
	_tmp36_ = vala_for_statement_new (_tmp33_, _tmp34_, _tmp35_);
	stmt = _tmp36_;
	{
		ValaArrayList* _init_list = NULL;
		ValaArrayList* _tmp37_;
		ValaArrayList* _tmp38_;
		gint _init_size = 0;
		ValaArrayList* _tmp39_;
		gint _tmp40_;
		gint _tmp41_;
		gint _init_index = 0;
		_tmp37_ = initializer_list;
		_tmp38_ = _vala_iterable_ref0 (_tmp37_);
		_init_list = _tmp38_;
		_tmp39_ = _init_list;
		_tmp40_ = vala_collection_get_size ((ValaCollection*) _tmp39_);
		_tmp41_ = _tmp40_;
		_init_size = _tmp41_;
		_init_index = -1;
		while (TRUE) {
			gint _tmp42_;
			gint _tmp43_;
			ValaExpression* init = NULL;
			ValaArrayList* _tmp44_;
			gpointer _tmp45_;
			ValaForStatement* _tmp46_;
			ValaExpression* _tmp47_;
			_init_index = _init_index + 1;
			_tmp42_ = _init_index;
			_tmp43_ = _init_size;
			if (!(_tmp42_ < _tmp43_)) {
				break;
			}
			_tmp44_ = _init_list;
			_tmp45_ = vala_list_get ((ValaList*) _tmp44_, _init_index);
			init = (ValaExpression*) _tmp45_;
			_tmp46_ = stmt;
			_tmp47_ = init;
			vala_for_statement_add_initializer (_tmp46_, _tmp47_);
			_vala_code_node_unref0 (init);
		}
		_vala_iterable_unref0 (_init_list);
	}
	{
		ValaArrayList* _iter_list = NULL;
		ValaArrayList* _tmp48_;
		ValaArrayList* _tmp49_;
		gint _iter_size = 0;
		ValaArrayList* _tmp50_;
		gint _tmp51_;
		gint _tmp52_;
		gint _iter_index = 0;
		_tmp48_ = iterator_list;
		_tmp49_ = _vala_iterable_ref0 (_tmp48_);
		_iter_list = _tmp49_;
		_tmp50_ = _iter_list;
		_tmp51_ = vala_collection_get_size ((ValaCollection*) _tmp50_);
		_tmp52_ = _tmp51_;
		_iter_size = _tmp52_;
		_iter_index = -1;
		while (TRUE) {
			gint _tmp53_;
			gint _tmp54_;
			ValaExpression* iter = NULL;
			ValaArrayList* _tmp55_;
			gpointer _tmp56_;
			ValaForStatement* _tmp57_;
			ValaExpression* _tmp58_;
			_iter_index = _iter_index + 1;
			_tmp53_ = _iter_index;
			_tmp54_ = _iter_size;
			if (!(_tmp53_ < _tmp54_)) {
				break;
			}
			_tmp55_ = _iter_list;
			_tmp56_ = vala_list_get ((ValaList*) _tmp55_, _iter_index);
			iter = (ValaExpression*) _tmp56_;
			_tmp57_ = stmt;
			_tmp58_ = iter;
			vala_for_statement_add_iterator (_tmp57_, _tmp58_);
			_vala_code_node_unref0 (iter);
		}
		_vala_iterable_unref0 (_iter_list);
	}
	_tmp59_ = block;
	if (_tmp59_ != NULL) {
		ValaBlock* _tmp60_;
		ValaForStatement* _tmp61_;
		_tmp60_ = block;
		_tmp61_ = stmt;
		vala_block_add_statement (_tmp60_, (ValaStatement*) _tmp61_);
		result = (ValaStatement*) block;
		_vala_code_node_unref0 (stmt);
		_vala_code_node_unref0 (body);
		_vala_source_reference_unref0 (src);
		_vala_iterable_unref0 (iterator_list);
		_vala_code_node_unref0 (condition);
		_vala_iterable_unref0 (initializer_list);
		return result;
	} else {
		result = (ValaStatement*) stmt;
		_vala_code_node_unref0 (body);
		_vala_source_reference_unref0 (src);
		_vala_iterable_unref0 (iterator_list);
		_vala_code_node_unref0 (condition);
		_vala_iterable_unref0 (initializer_list);
		_vala_code_node_unref0 (block);
		return result;
	}
	_vala_code_node_unref0 (stmt);
	_vala_code_node_unref0 (body);
	_vala_source_reference_unref0 (src);
	_vala_iterable_unref0 (iterator_list);
	_vala_code_node_unref0 (condition);
	_vala_iterable_unref0 (initializer_list);
	_vala_code_node_unref0 (block);
}

static ValaStatement*
vala_parser_parse_foreach_statement (ValaParser* self,
                                     GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSourceLocation var_or_type = {0};
	ValaSourceLocation _tmp1_ = {0};
	ValaDataType* type = NULL;
	gboolean _tmp2_ = FALSE;
	gchar* id = NULL;
	gchar* _tmp13_;
	ValaExpression* collection = NULL;
	ValaExpression* _tmp14_;
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp15_;
	ValaSourceReference* _tmp16_;
	ValaBlock* body = NULL;
	ValaBlock* _tmp17_;
	ValaDataType* _tmp18_;
	const gchar* _tmp19_;
	ValaExpression* _tmp20_;
	ValaBlock* _tmp21_;
	ValaSourceReference* _tmp22_;
	ValaForeachStatement* _tmp23_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_FOREACH, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_get_location (self, &_tmp1_);
	var_or_type = _tmp1_;
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_UNOWNED)) {
		_tmp2_ = vala_parser_accept (self, VALA_TOKEN_TYPE_VAR);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		ValaVarType* _tmp3_;
		_tmp3_ = vala_var_type_new (FALSE);
		_vala_code_node_unref0 (type);
		type = (ValaDataType*) _tmp3_;
	} else {
		ValaSourceLocation _tmp4_;
		_tmp4_ = var_or_type;
		vala_parser_rollback (self, &_tmp4_);
		if (vala_parser_accept (self, VALA_TOKEN_TYPE_VAR)) {
			ValaVarType* _tmp5_;
			_tmp5_ = vala_var_type_new (TRUE);
			_vala_code_node_unref0 (type);
			type = (ValaDataType*) _tmp5_;
		} else {
			ValaDataType* _tmp6_ = NULL;
			ValaDataType* _tmp7_;
			ValaDataType* _tmp8_;
			_tmp7_ = vala_parser_parse_type (self, TRUE, TRUE, FALSE, &_inner_error0_);
			_tmp6_ = _tmp7_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (type);
					return NULL;
				} else {
					_vala_code_node_unref0 (type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp8_ = _tmp6_;
			_tmp6_ = NULL;
			_vala_code_node_unref0 (type);
			type = _tmp8_;
			if (vala_parser_accept (self, VALA_TOKEN_TYPE_IN)) {
				ValaDataType* _tmp9_;
				ValaSourceReference* _tmp10_;
				ValaSourceReference* _tmp11_;
				GError* _tmp12_;
				_tmp9_ = type;
				_tmp10_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp9_);
				_tmp11_ = _tmp10_;
				vala_report_error (_tmp11_, "syntax error, expected `unowned var', `var' or type");
				_tmp12_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "expected `unowned var', `var' or type");
				_inner_error0_ = _tmp12_;
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (_tmp6_);
					_vala_code_node_unref0 (type);
					return NULL;
				} else {
					_vala_code_node_unref0 (_tmp6_);
					_vala_code_node_unref0 (type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_vala_code_node_unref0 (_tmp6_);
		}
	}
	_tmp13_ = vala_parser_parse_identifier (self, &_inner_error0_);
	id = _tmp13_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (type);
			return NULL;
		} else {
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_IN, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			return NULL;
		} else {
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp14_ = vala_parser_parse_expression (self, &_inner_error0_);
	collection = _tmp14_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			return NULL;
		} else {
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (collection);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			return NULL;
		} else {
			_vala_code_node_unref0 (collection);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp15_ = begin;
	_tmp16_ = vala_parser_get_src (self, &_tmp15_);
	src = _tmp16_;
	_tmp17_ = vala_parser_parse_embedded_statement (self, "foreach", TRUE, &_inner_error0_);
	body = _tmp17_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (collection);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			return NULL;
		} else {
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (collection);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp18_ = type;
	_tmp19_ = id;
	_tmp20_ = collection;
	_tmp21_ = body;
	_tmp22_ = src;
	_tmp23_ = vala_foreach_statement_new (_tmp18_, _tmp19_, _tmp20_, _tmp21_, _tmp22_);
	result = (ValaStatement*) _tmp23_;
	_vala_code_node_unref0 (body);
	_vala_source_reference_unref0 (src);
	_vala_code_node_unref0 (collection);
	_g_free0 (id);
	_vala_code_node_unref0 (type);
	return result;
}

static ValaStatement*
vala_parser_parse_break_statement (ValaParser* self,
                                   GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp1_;
	ValaSourceReference* _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaBreakStatement* _tmp4_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_BREAK, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = begin;
	_tmp2_ = vala_parser_get_src (self, &_tmp1_);
	src = _tmp2_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_source_reference_unref0 (src);
			return NULL;
		} else {
			_vala_source_reference_unref0 (src);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp3_ = src;
	_tmp4_ = vala_break_statement_new (_tmp3_);
	result = (ValaStatement*) _tmp4_;
	_vala_source_reference_unref0 (src);
	return result;
}

static ValaStatement*
vala_parser_parse_continue_statement (ValaParser* self,
                                      GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp1_;
	ValaSourceReference* _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaContinueStatement* _tmp4_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_CONTINUE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = begin;
	_tmp2_ = vala_parser_get_src (self, &_tmp1_);
	src = _tmp2_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_source_reference_unref0 (src);
			return NULL;
		} else {
			_vala_source_reference_unref0 (src);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp3_ = src;
	_tmp4_ = vala_continue_statement_new (_tmp3_);
	result = (ValaStatement*) _tmp4_;
	_vala_source_reference_unref0 (src);
	return result;
}

static ValaStatement*
vala_parser_parse_return_statement (ValaParser* self,
                                    GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* expr = NULL;
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp4_;
	ValaSourceReference* _tmp5_;
	ValaExpression* _tmp6_;
	ValaSourceReference* _tmp7_;
	ValaReturnStatement* _tmp8_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_RETURN, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	expr = NULL;
	if (vala_parser_current (self) != VALA_TOKEN_TYPE_SEMICOLON) {
		ValaExpression* _tmp1_ = NULL;
		ValaExpression* _tmp2_;
		ValaExpression* _tmp3_;
		_tmp2_ = vala_parser_parse_expression (self, &_inner_error0_);
		_tmp1_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (expr);
				return NULL;
			} else {
				_vala_code_node_unref0 (expr);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp3_ = _tmp1_;
		_tmp1_ = NULL;
		_vala_code_node_unref0 (expr);
		expr = _tmp3_;
		_vala_code_node_unref0 (_tmp1_);
	}
	_tmp4_ = begin;
	_tmp5_ = vala_parser_get_src (self, &_tmp4_);
	src = _tmp5_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (expr);
			return NULL;
		} else {
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (expr);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp6_ = expr;
	_tmp7_ = src;
	_tmp8_ = vala_return_statement_new (_tmp6_, _tmp7_);
	result = (ValaStatement*) _tmp8_;
	_vala_source_reference_unref0 (src);
	_vala_code_node_unref0 (expr);
	return result;
}

static ValaStatement*
vala_parser_parse_yield_statement (ValaParser* self,
                                   GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaTokenType token = 0;
	ValaTokenType _tmp1_;
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp7_;
	ValaSourceReference* _tmp8_;
	ValaSourceReference* _tmp9_;
	ValaYieldStatement* _tmp10_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_YIELD, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	token = vala_parser_current (self);
	_tmp1_ = token;
	if (_tmp1_ != VALA_TOKEN_TYPE_SEMICOLON) {
		ValaTokenType _tmp2_;
		ValaStatement* _tmp4_ = NULL;
		ValaStatement* _tmp5_;
		ValaStatement* _tmp6_;
		vala_parser_prev (self);
		_tmp2_ = token;
		if (_tmp2_ == VALA_TOKEN_TYPE_RETURN) {
			GError* _tmp3_;
			_tmp3_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "expected `return yield'");
			_inner_error0_ = _tmp3_;
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp5_ = vala_parser_parse_expression_statement (self, &_inner_error0_);
		_tmp4_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp6_ = _tmp4_;
		_tmp4_ = NULL;
		result = _tmp6_;
		_vala_code_node_unref0 (_tmp4_);
		return result;
	}
	_tmp7_ = begin;
	_tmp8_ = vala_parser_get_src (self, &_tmp7_);
	src = _tmp8_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_source_reference_unref0 (src);
			return NULL;
		} else {
			_vala_source_reference_unref0 (src);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp9_ = src;
	_tmp10_ = vala_yield_statement_new (_tmp9_);
	result = (ValaStatement*) _tmp10_;
	_vala_source_reference_unref0 (src);
	return result;
}

static ValaStatement*
vala_parser_parse_throw_statement (ValaParser* self,
                                   GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* expr = NULL;
	ValaExpression* _tmp1_;
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaExpression* _tmp4_;
	ValaSourceReference* _tmp5_;
	ValaThrowStatement* _tmp6_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_THROW, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = vala_parser_parse_expression (self, &_inner_error0_);
	expr = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = begin;
	_tmp3_ = vala_parser_get_src (self, &_tmp2_);
	src = _tmp3_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (expr);
			return NULL;
		} else {
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (expr);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp4_ = expr;
	_tmp5_ = src;
	_tmp6_ = vala_throw_statement_new (_tmp4_, _tmp5_);
	result = (ValaStatement*) _tmp6_;
	_vala_source_reference_unref0 (src);
	_vala_code_node_unref0 (expr);
	return result;
}

static ValaStatement*
vala_parser_parse_try_statement (ValaParser* self,
                                 GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaBlock* try_block = NULL;
	ValaBlock* _tmp1_;
	ValaBlock* finally_clause = NULL;
	ValaArrayList* catch_clauses = NULL;
	GEqualFunc _tmp2_;
	ValaArrayList* _tmp3_;
	ValaTryStatement* stmt = NULL;
	ValaBlock* _tmp11_;
	ValaBlock* _tmp12_;
	ValaSourceLocation _tmp13_;
	ValaSourceReference* _tmp14_;
	ValaSourceReference* _tmp15_;
	ValaTryStatement* _tmp16_;
	ValaTryStatement* _tmp17_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_TRY, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = vala_parser_parse_block (self, &_inner_error0_);
	try_block = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	finally_clause = NULL;
	_tmp2_ = g_direct_equal;
	_tmp3_ = vala_array_list_new (VALA_TYPE_CATCH_CLAUSE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp2_);
	catch_clauses = _tmp3_;
	if (vala_parser_current (self) == VALA_TOKEN_TYPE_CATCH) {
		ValaArrayList* _tmp4_;
		_tmp4_ = catch_clauses;
		vala_parser_parse_catch_clauses (self, (ValaList*) _tmp4_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_iterable_unref0 (catch_clauses);
				_vala_code_node_unref0 (finally_clause);
				_vala_code_node_unref0 (try_block);
				return NULL;
			} else {
				_vala_iterable_unref0 (catch_clauses);
				_vala_code_node_unref0 (finally_clause);
				_vala_code_node_unref0 (try_block);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		if (vala_parser_current (self) == VALA_TOKEN_TYPE_FINALLY) {
			ValaBlock* _tmp5_ = NULL;
			ValaBlock* _tmp6_;
			ValaBlock* _tmp7_;
			_tmp6_ = vala_parser_parse_finally_clause (self, &_inner_error0_);
			_tmp5_ = _tmp6_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_iterable_unref0 (catch_clauses);
					_vala_code_node_unref0 (finally_clause);
					_vala_code_node_unref0 (try_block);
					return NULL;
				} else {
					_vala_iterable_unref0 (catch_clauses);
					_vala_code_node_unref0 (finally_clause);
					_vala_code_node_unref0 (try_block);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp7_ = _tmp5_;
			_tmp5_ = NULL;
			_vala_code_node_unref0 (finally_clause);
			finally_clause = _tmp7_;
			_vala_code_node_unref0 (_tmp5_);
		}
	} else {
		ValaBlock* _tmp8_ = NULL;
		ValaBlock* _tmp9_;
		ValaBlock* _tmp10_;
		_tmp9_ = vala_parser_parse_finally_clause (self, &_inner_error0_);
		_tmp8_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_iterable_unref0 (catch_clauses);
				_vala_code_node_unref0 (finally_clause);
				_vala_code_node_unref0 (try_block);
				return NULL;
			} else {
				_vala_iterable_unref0 (catch_clauses);
				_vala_code_node_unref0 (finally_clause);
				_vala_code_node_unref0 (try_block);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp10_ = _tmp8_;
		_tmp8_ = NULL;
		_vala_code_node_unref0 (finally_clause);
		finally_clause = _tmp10_;
		_vala_code_node_unref0 (_tmp8_);
	}
	_tmp11_ = try_block;
	_tmp12_ = finally_clause;
	_tmp13_ = begin;
	_tmp14_ = vala_parser_get_src (self, &_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = vala_try_statement_new (_tmp11_, _tmp12_, _tmp15_);
	_tmp17_ = _tmp16_;
	_vala_source_reference_unref0 (_tmp15_);
	stmt = _tmp17_;
	{
		ValaArrayList* _clause_list = NULL;
		ValaArrayList* _tmp18_;
		ValaArrayList* _tmp19_;
		gint _clause_size = 0;
		ValaArrayList* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		gint _clause_index = 0;
		_tmp18_ = catch_clauses;
		_tmp19_ = _vala_iterable_ref0 (_tmp18_);
		_clause_list = _tmp19_;
		_tmp20_ = _clause_list;
		_tmp21_ = vala_collection_get_size ((ValaCollection*) _tmp20_);
		_tmp22_ = _tmp21_;
		_clause_size = _tmp22_;
		_clause_index = -1;
		while (TRUE) {
			gint _tmp23_;
			gint _tmp24_;
			ValaCatchClause* clause = NULL;
			ValaArrayList* _tmp25_;
			gpointer _tmp26_;
			ValaTryStatement* _tmp27_;
			ValaCatchClause* _tmp28_;
			_clause_index = _clause_index + 1;
			_tmp23_ = _clause_index;
			_tmp24_ = _clause_size;
			if (!(_tmp23_ < _tmp24_)) {
				break;
			}
			_tmp25_ = _clause_list;
			_tmp26_ = vala_list_get ((ValaList*) _tmp25_, _clause_index);
			clause = (ValaCatchClause*) _tmp26_;
			_tmp27_ = stmt;
			_tmp28_ = clause;
			vala_try_statement_add_catch_clause (_tmp27_, _tmp28_);
			_vala_code_node_unref0 (clause);
		}
		_vala_iterable_unref0 (_clause_list);
	}
	result = (ValaStatement*) stmt;
	_vala_iterable_unref0 (catch_clauses);
	_vala_code_node_unref0 (finally_clause);
	_vala_code_node_unref0 (try_block);
	return result;
}

static void
vala_parser_parse_catch_clauses (ValaParser* self,
                                 ValaList* catch_clauses,
                                 GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (catch_clauses != NULL);
	while (TRUE) {
		ValaSourceLocation begin = {0};
		ValaSourceLocation _tmp0_ = {0};
		ValaDataType* type = NULL;
		gchar* id = NULL;
		ValaSourceReference* src = NULL;
		ValaSourceLocation _tmp7_;
		ValaSourceReference* _tmp8_;
		ValaBlock* block = NULL;
		ValaBlock* _tmp9_;
		ValaDataType* _tmp10_;
		const gchar* _tmp11_;
		ValaBlock* _tmp12_;
		ValaSourceReference* _tmp13_;
		ValaCatchClause* _tmp14_;
		ValaCatchClause* _tmp15_;
		if (!(vala_parser_current (self) == VALA_TOKEN_TYPE_CATCH)) {
			break;
		}
		vala_parser_get_location (self, &_tmp0_);
		begin = _tmp0_;
		vala_parser_expect (self, VALA_TOKEN_TYPE_CATCH, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		type = NULL;
		id = NULL;
		if (vala_parser_accept (self, VALA_TOKEN_TYPE_OPEN_PARENS)) {
			ValaDataType* _tmp1_ = NULL;
			ValaDataType* _tmp2_;
			ValaDataType* _tmp3_;
			gchar* _tmp4_ = NULL;
			gchar* _tmp5_;
			gchar* _tmp6_;
			_tmp2_ = vala_parser_parse_type (self, TRUE, TRUE, FALSE, &_inner_error0_);
			_tmp1_ = _tmp2_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_g_free0 (id);
					_vala_code_node_unref0 (type);
					return;
				} else {
					_g_free0 (id);
					_vala_code_node_unref0 (type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_tmp3_ = _tmp1_;
			_tmp1_ = NULL;
			_vala_code_node_unref0 (type);
			type = _tmp3_;
			_tmp5_ = vala_parser_parse_identifier (self, &_inner_error0_);
			_tmp4_ = _tmp5_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (_tmp1_);
					_g_free0 (id);
					_vala_code_node_unref0 (type);
					return;
				} else {
					_vala_code_node_unref0 (_tmp1_);
					_g_free0 (id);
					_vala_code_node_unref0 (type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_tmp6_ = _tmp4_;
			_tmp4_ = NULL;
			_g_free0 (id);
			id = _tmp6_;
			vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_g_free0 (_tmp4_);
					_vala_code_node_unref0 (_tmp1_);
					_g_free0 (id);
					_vala_code_node_unref0 (type);
					return;
				} else {
					_g_free0 (_tmp4_);
					_vala_code_node_unref0 (_tmp1_);
					_g_free0 (id);
					_vala_code_node_unref0 (type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_g_free0 (_tmp4_);
			_vala_code_node_unref0 (_tmp1_);
		}
		_tmp7_ = begin;
		_tmp8_ = vala_parser_get_src (self, &_tmp7_);
		src = _tmp8_;
		_tmp9_ = vala_parser_parse_block (self, &_inner_error0_);
		block = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_source_reference_unref0 (src);
				_g_free0 (id);
				_vala_code_node_unref0 (type);
				return;
			} else {
				_vala_source_reference_unref0 (src);
				_g_free0 (id);
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp10_ = type;
		_tmp11_ = id;
		_tmp12_ = block;
		_tmp13_ = src;
		_tmp14_ = vala_catch_clause_new (_tmp10_, _tmp11_, _tmp12_, _tmp13_);
		_tmp15_ = _tmp14_;
		vala_collection_add ((ValaCollection*) catch_clauses, _tmp15_);
		_vala_code_node_unref0 (_tmp15_);
		_vala_code_node_unref0 (block);
		_vala_source_reference_unref0 (src);
		_g_free0 (id);
		_vala_code_node_unref0 (type);
	}
}

static ValaBlock*
vala_parser_parse_finally_clause (ValaParser* self,
                                  GError** error)
{
	ValaBlock* block = NULL;
	ValaBlock* _tmp0_;
	GError* _inner_error0_ = NULL;
	ValaBlock* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_expect (self, VALA_TOKEN_TYPE_FINALLY, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp0_ = vala_parser_parse_block (self, &_inner_error0_);
	block = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	result = block;
	return result;
}

static ValaStatement*
vala_parser_parse_lock_statement (ValaParser* self,
                                  GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* expr = NULL;
	ValaExpression* _tmp1_;
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaBlock* stmt = NULL;
	ValaExpression* _tmp7_;
	ValaBlock* _tmp8_;
	ValaSourceReference* _tmp9_;
	ValaLockStatement* _tmp10_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_LOCK, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = vala_parser_parse_expression (self, &_inner_error0_);
	expr = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (expr);
			return NULL;
		} else {
			_vala_code_node_unref0 (expr);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = begin;
	_tmp3_ = vala_parser_get_src (self, &_tmp2_);
	src = _tmp3_;
	stmt = NULL;
	if (vala_parser_current (self) != VALA_TOKEN_TYPE_SEMICOLON) {
		ValaBlock* _tmp4_ = NULL;
		ValaBlock* _tmp5_;
		ValaBlock* _tmp6_;
		_tmp5_ = vala_parser_parse_embedded_statement (self, "lock", FALSE, &_inner_error0_);
		_tmp4_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (stmt);
				_vala_source_reference_unref0 (src);
				_vala_code_node_unref0 (expr);
				return NULL;
			} else {
				_vala_code_node_unref0 (stmt);
				_vala_source_reference_unref0 (src);
				_vala_code_node_unref0 (expr);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp6_ = _tmp4_;
		_tmp4_ = NULL;
		_vala_code_node_unref0 (stmt);
		stmt = _tmp6_;
		_vala_code_node_unref0 (_tmp4_);
	}
	_tmp7_ = expr;
	_tmp8_ = stmt;
	_tmp9_ = src;
	_tmp10_ = vala_lock_statement_new (_tmp7_, _tmp8_, _tmp9_);
	result = (ValaStatement*) _tmp10_;
	_vala_code_node_unref0 (stmt);
	_vala_source_reference_unref0 (src);
	_vala_code_node_unref0 (expr);
	return result;
}

static ValaStatement*
vala_parser_parse_unlock_statement (ValaParser* self,
                                    GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* expr = NULL;
	ValaExpression* _tmp1_;
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaExpression* _tmp4_;
	ValaSourceReference* _tmp5_;
	ValaUnlockStatement* _tmp6_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_UNLOCK, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = vala_parser_parse_expression (self, &_inner_error0_);
	expr = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (expr);
			return NULL;
		} else {
			_vala_code_node_unref0 (expr);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = begin;
	_tmp3_ = vala_parser_get_src (self, &_tmp2_);
	src = _tmp3_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (expr);
			return NULL;
		} else {
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (expr);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp4_ = expr;
	_tmp5_ = src;
	_tmp6_ = vala_unlock_statement_new (_tmp4_, _tmp5_);
	result = (ValaStatement*) _tmp6_;
	_vala_source_reference_unref0 (src);
	_vala_code_node_unref0 (expr);
	return result;
}

static ValaStatement*
vala_parser_parse_delete_statement (ValaParser* self,
                                    GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaExpression* expr = NULL;
	ValaExpression* _tmp1_;
	ValaSourceReference* src = NULL;
	ValaSourceLocation _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaExpression* _tmp4_;
	ValaSourceReference* _tmp5_;
	ValaDeleteStatement* _tmp6_;
	GError* _inner_error0_ = NULL;
	ValaStatement* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_DELETE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = vala_parser_parse_expression (self, &_inner_error0_);
	expr = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp2_ = begin;
	_tmp3_ = vala_parser_get_src (self, &_tmp2_);
	src = _tmp3_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (expr);
			return NULL;
		} else {
			_vala_source_reference_unref0 (src);
			_vala_code_node_unref0 (expr);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp4_ = expr;
	_tmp5_ = src;
	_tmp6_ = vala_delete_statement_new (_tmp4_, _tmp5_);
	result = (ValaStatement*) _tmp6_;
	_vala_source_reference_unref0 (src);
	_vala_code_node_unref0 (expr);
	return result;
}

static gchar*
vala_parser_parse_attribute_value (ValaParser* self,
                                   GError** error)
{
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	switch (vala_parser_current (self)) {
		case VALA_TOKEN_TYPE_NULL:
		case VALA_TOKEN_TYPE_TRUE:
		case VALA_TOKEN_TYPE_FALSE:
		case VALA_TOKEN_TYPE_INTEGER_LITERAL:
		case VALA_TOKEN_TYPE_REAL_LITERAL:
		case VALA_TOKEN_TYPE_STRING_LITERAL:
		{
			gchar* _tmp0_;
			vala_parser_next (self);
			_tmp0_ = vala_parser_get_last_string (self);
			result = _tmp0_;
			return result;
		}
		case VALA_TOKEN_TYPE_MINUS:
		{
			vala_parser_next (self);
			switch (vala_parser_current (self)) {
				case VALA_TOKEN_TYPE_INTEGER_LITERAL:
				case VALA_TOKEN_TYPE_REAL_LITERAL:
				{
					gchar* _tmp1_;
					gchar* _tmp2_;
					gchar* _tmp3_;
					gchar* _tmp4_;
					vala_parser_next (self);
					_tmp1_ = vala_parser_get_last_string (self);
					_tmp2_ = _tmp1_;
					_tmp3_ = g_strconcat ("-", _tmp2_, NULL);
					_tmp4_ = _tmp3_;
					_g_free0 (_tmp2_);
					result = _tmp4_;
					return result;
				}
				default:
				{
					GError* _tmp5_;
					_tmp5_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "expected number");
					_inner_error0_ = _tmp5_;
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						return NULL;
					} else {
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
			}
		}
		default:
		{
			GError* _tmp6_;
			_tmp6_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "expected literal");
			_inner_error0_ = _tmp6_;
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
}

static ValaList*
vala_parser_parse_attributes (ValaParser* self,
                              GError** error)
{
	ValaArrayList* attrs = NULL;
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	GError* _inner_error0_ = NULL;
	ValaList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (vala_parser_current (self) != VALA_TOKEN_TYPE_OPEN_BRACKET) {
		result = NULL;
		return result;
	}
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (VALA_TYPE_ATTRIBUTE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp0_);
	attrs = _tmp1_;
	while (TRUE) {
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_OPEN_BRACKET)) {
			break;
		}
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				ValaSourceLocation begin = {0};
				ValaSourceLocation _tmp3_ = {0};
				gchar* id = NULL;
				gchar* _tmp4_;
				ValaAttribute* attr = NULL;
				const gchar* _tmp5_;
				ValaSourceLocation _tmp6_;
				ValaSourceReference* _tmp7_;
				ValaSourceReference* _tmp8_;
				ValaAttribute* _tmp9_;
				ValaAttribute* _tmp10_;
				ValaArrayList* _tmp19_;
				ValaAttribute* _tmp20_;
				if (!_tmp2_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp2_ = FALSE;
				vala_parser_get_location (self, &_tmp3_);
				begin = _tmp3_;
				_tmp4_ = vala_parser_parse_identifier (self, &_inner_error0_);
				id = _tmp4_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_iterable_unref0 (attrs);
						return NULL;
					} else {
						_vala_iterable_unref0 (attrs);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp5_ = id;
				_tmp6_ = begin;
				_tmp7_ = vala_parser_get_src (self, &_tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = vala_attribute_new (_tmp5_, _tmp8_);
				_tmp10_ = _tmp9_;
				_vala_source_reference_unref0 (_tmp8_);
				attr = _tmp10_;
				if (vala_parser_accept (self, VALA_TOKEN_TYPE_OPEN_PARENS)) {
					if (vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_PARENS) {
						{
							gboolean _tmp11_ = FALSE;
							_tmp11_ = TRUE;
							while (TRUE) {
								gchar* _tmp12_ = NULL;
								gchar* _tmp13_;
								gchar* _tmp14_;
								gchar* _tmp15_ = NULL;
								gchar* _tmp16_;
								ValaAttribute* _tmp17_;
								const gchar* _tmp18_;
								if (!_tmp11_) {
									if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
										break;
									}
								}
								_tmp11_ = FALSE;
								_tmp13_ = vala_parser_parse_identifier (self, &_inner_error0_);
								_tmp12_ = _tmp13_;
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
									if (_inner_error0_->domain == VALA_PARSE_ERROR) {
										g_propagate_error (error, _inner_error0_);
										_vala_code_node_unref0 (attr);
										_g_free0 (id);
										_vala_iterable_unref0 (attrs);
										return NULL;
									} else {
										_vala_code_node_unref0 (attr);
										_g_free0 (id);
										_vala_iterable_unref0 (attrs);
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
										g_clear_error (&_inner_error0_);
										return NULL;
									}
								}
								_tmp14_ = _tmp12_;
								_tmp12_ = NULL;
								_g_free0 (id);
								id = _tmp14_;
								vala_parser_expect (self, VALA_TOKEN_TYPE_ASSIGN, &_inner_error0_);
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
									if (_inner_error0_->domain == VALA_PARSE_ERROR) {
										g_propagate_error (error, _inner_error0_);
										_g_free0 (_tmp12_);
										_vala_code_node_unref0 (attr);
										_g_free0 (id);
										_vala_iterable_unref0 (attrs);
										return NULL;
									} else {
										_g_free0 (_tmp12_);
										_vala_code_node_unref0 (attr);
										_g_free0 (id);
										_vala_iterable_unref0 (attrs);
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
										g_clear_error (&_inner_error0_);
										return NULL;
									}
								}
								_tmp16_ = vala_parser_parse_attribute_value (self, &_inner_error0_);
								_tmp15_ = _tmp16_;
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
									if (_inner_error0_->domain == VALA_PARSE_ERROR) {
										g_propagate_error (error, _inner_error0_);
										_g_free0 (_tmp12_);
										_vala_code_node_unref0 (attr);
										_g_free0 (id);
										_vala_iterable_unref0 (attrs);
										return NULL;
									} else {
										_g_free0 (_tmp12_);
										_vala_code_node_unref0 (attr);
										_g_free0 (id);
										_vala_iterable_unref0 (attrs);
										g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
										g_clear_error (&_inner_error0_);
										return NULL;
									}
								}
								_tmp17_ = attr;
								_tmp18_ = id;
								vala_attribute_add_argument (_tmp17_, _tmp18_, _tmp15_);
								_g_free0 (_tmp15_);
								_g_free0 (_tmp12_);
							}
						}
					}
					vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_vala_code_node_unref0 (attr);
							_g_free0 (id);
							_vala_iterable_unref0 (attrs);
							return NULL;
						} else {
							_vala_code_node_unref0 (attr);
							_g_free0 (id);
							_vala_iterable_unref0 (attrs);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return NULL;
						}
					}
				}
				_tmp19_ = attrs;
				_tmp20_ = attr;
				vala_collection_add ((ValaCollection*) _tmp19_, _tmp20_);
				_vala_code_node_unref0 (attr);
				_g_free0 (id);
			}
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_BRACKET, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_iterable_unref0 (attrs);
				return NULL;
			} else {
				_vala_iterable_unref0 (attrs);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
	result = (ValaList*) attrs;
	return result;
}

static void
vala_parser_set_attributes (ValaParser* self,
                            ValaCodeNode* node,
                            ValaList* attributes)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (node != NULL);
	if (attributes != NULL) {
		{
			ValaList* _attr_list = NULL;
			ValaList* _tmp0_;
			gint _attr_size = 0;
			ValaList* _tmp1_;
			gint _tmp2_;
			gint _tmp3_;
			gint _attr_index = 0;
			_tmp0_ = _vala_iterable_ref0 (G_TYPE_CHECK_INSTANCE_CAST (attributes, VALA_TYPE_LIST, ValaList));
			_attr_list = _tmp0_;
			_tmp1_ = _attr_list;
			_tmp2_ = vala_collection_get_size ((ValaCollection*) _tmp1_);
			_tmp3_ = _tmp2_;
			_attr_size = _tmp3_;
			_attr_index = -1;
			while (TRUE) {
				gint _tmp4_;
				gint _tmp5_;
				ValaAttribute* attr = NULL;
				ValaList* _tmp6_;
				gpointer _tmp7_;
				ValaAttribute* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				ValaAttribute* _tmp11_;
				ValaAttribute* _tmp20_;
				ValaAttribute* _tmp21_;
				_attr_index = _attr_index + 1;
				_tmp4_ = _attr_index;
				_tmp5_ = _attr_size;
				if (!(_tmp4_ < _tmp5_)) {
					break;
				}
				_tmp6_ = _attr_list;
				_tmp7_ = vala_list_get (_tmp6_, _attr_index);
				attr = (ValaAttribute*) _tmp7_;
				_tmp8_ = attr;
				_tmp9_ = vala_attribute_get_name (_tmp8_);
				_tmp10_ = _tmp9_;
				_tmp11_ = vala_code_node_get_attribute (node, _tmp10_);
				if (_tmp11_ != NULL) {
					ValaAttribute* _tmp12_;
					ValaSourceReference* _tmp13_;
					ValaSourceReference* _tmp14_;
					ValaAttribute* _tmp15_;
					const gchar* _tmp16_;
					const gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					_tmp12_ = attr;
					_tmp13_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp15_ = attr;
					_tmp16_ = vala_attribute_get_name (_tmp15_);
					_tmp17_ = _tmp16_;
					_tmp18_ = g_strdup_printf ("duplicate attribute `%s'", _tmp17_);
					_tmp19_ = _tmp18_;
					vala_report_error (_tmp14_, _tmp19_);
					_g_free0 (_tmp19_);
				}
				_tmp20_ = attr;
				_tmp21_ = _vala_code_node_ref0 (_tmp20_);
				node->attributes = g_list_append (node->attributes, _tmp21_);
				_vala_code_node_unref0 (attr);
			}
			_vala_iterable_unref0 (_attr_list);
		}
	}
}

static void
vala_parser_parse_main_block (ValaParser* self,
                              ValaSymbol* parent,
                              GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaMethod* method = NULL;
	ValaVoidType* _tmp1_;
	ValaVoidType* _tmp2_;
	ValaSourceLocation _tmp3_;
	ValaSourceReference* _tmp4_;
	ValaSourceReference* _tmp5_;
	ValaMethod* _tmp6_;
	ValaMethod* _tmp7_;
	ValaSourceLocation _tmp8_;
	ValaSourceReference* _tmp9_;
	ValaSourceReference* _tmp10_;
	ValaBlock* _tmp11_;
	ValaBlock* _tmp12_;
	ValaBlock* _tmp13_;
	ValaBlock* _tmp14_;
	ValaBlock* _tmp17_;
	ValaBlock* _tmp18_;
	ValaSourceReference* _tmp19_;
	ValaSourceReference* _tmp20_;
	ValaSourceReference* _tmp21_;
	ValaSourceReference* _tmp22_;
	ValaSourceLocation _tmp23_ = {0};
	ValaSourceLocation _tmp24_;
	ValaCodeContext* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	_tmp1_ = vala_void_type_new (NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = begin;
	_tmp4_ = vala_parser_get_src (self, &_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = vala_method_new ("main", (ValaDataType*) _tmp2_, _tmp5_, NULL);
	_tmp7_ = _tmp6_;
	_vala_source_reference_unref0 (_tmp5_);
	_vala_code_node_unref0 (_tmp2_);
	method = _tmp7_;
	vala_symbol_set_access ((ValaSymbol*) method, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
	vala_method_set_binding (method, VALA_MEMBER_BINDING_STATIC);
	_tmp8_ = begin;
	_tmp9_ = vala_parser_get_src (self, &_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = vala_block_new (_tmp10_);
	_tmp12_ = _tmp11_;
	vala_subroutine_set_body ((ValaSubroutine*) method, _tmp12_);
	_vala_code_node_unref0 (_tmp12_);
	_vala_source_reference_unref0 (_tmp10_);
	_tmp13_ = vala_subroutine_get_body ((ValaSubroutine*) method);
	_tmp14_ = _tmp13_;
	vala_parser_parse_statements (self, _tmp14_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (method);
			return;
		} else {
			_vala_code_node_unref0 (method);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	if (vala_parser_current (self) != VALA_TOKEN_TYPE_EOF) {
		ValaSourceReference* _tmp15_;
		ValaSourceReference* _tmp16_;
		_tmp15_ = vala_parser_get_current_src (self);
		_tmp16_ = _tmp15_;
		vala_report_error (_tmp16_, "expected end of file");
		_vala_source_reference_unref0 (_tmp16_);
	}
	_tmp17_ = vala_subroutine_get_body ((ValaSubroutine*) method);
	_tmp18_ = _tmp17_;
	_tmp19_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp18_);
	_tmp20_ = _tmp19_;
	_tmp21_ = vala_parser_get_current_src (self);
	_tmp22_ = _tmp21_;
	vala_source_reference_get_end (_tmp22_, &_tmp23_);
	_tmp24_ = _tmp23_;
	vala_source_reference_set_end (_tmp20_, &_tmp24_);
	_vala_source_reference_unref0 (_tmp22_);
	_tmp25_ = self->priv->context;
	_tmp26_ = vala_code_context_get_experimental (_tmp25_);
	_tmp27_ = _tmp26_;
	if (!_tmp27_) {
		ValaSourceReference* _tmp28_;
		ValaSourceReference* _tmp29_;
		_tmp28_ = vala_code_node_get_source_reference ((ValaCodeNode*) method);
		_tmp29_ = _tmp28_;
		vala_report_warning (_tmp29_, "main blocks are experimental");
	}
	vala_symbol_add_method (parent, method);
	_vala_code_node_unref0 (method);
}

static void
vala_parser_parse_declaration (ValaParser* self,
                               ValaSymbol* parent,
                               gboolean root,
                               GError** error)
{
	ValaScanner* _tmp0_;
	ValaComment* _tmp1_;
	ValaList* attrs = NULL;
	ValaList* _tmp2_;
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp3_ = {0};
	ValaTokenType last_keyword = 0;
	ValaSourceLocation _tmp42_;
	GError* _tmp43_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	_tmp0_ = self->priv->scanner;
	_tmp1_ = vala_scanner_pop_comment (_tmp0_);
	_vala_comment_unref0 (self->priv->comment);
	self->priv->comment = _tmp1_;
	_tmp2_ = vala_parser_parse_attributes (self, &_inner_error0_);
	attrs = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	vala_parser_get_location (self, &_tmp3_);
	begin = _tmp3_;
	last_keyword = vala_parser_current (self);
	while (TRUE) {
		if (!vala_parser_is_declaration_keyword (self, vala_parser_current (self))) {
			break;
		}
		last_keyword = vala_parser_current (self);
		vala_parser_next (self);
	}
	switch (vala_parser_current (self)) {
		case VALA_TOKEN_TYPE_CONSTRUCT:
		{
			ValaCodeContext* _tmp4_;
			ValaProfile _tmp5_;
			ValaProfile _tmp6_;
			_tmp4_ = self->priv->context;
			_tmp5_ = vala_code_context_get_profile (_tmp4_);
			_tmp6_ = _tmp5_;
			if (_tmp6_ == VALA_PROFILE_GOBJECT) {
				ValaSourceLocation _tmp7_;
				ValaList* _tmp9_;
				_tmp7_ = begin;
				vala_parser_rollback (self, &_tmp7_);
				if (!VALA_IS_TYPESYMBOL (parent)) {
					GError* _tmp8_;
					_tmp8_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "unexpected `construct' declaration");
					_inner_error0_ = _tmp8_;
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_iterable_unref0 (attrs);
						return;
					} else {
						_vala_iterable_unref0 (attrs);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_tmp9_ = attrs;
				vala_parser_parse_constructor_declaration (self, parent, _tmp9_, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_iterable_unref0 (attrs);
						return;
					} else {
						_vala_iterable_unref0 (attrs);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_vala_iterable_unref0 (attrs);
				return;
			}
			break;
		}
		case VALA_TOKEN_TYPE_TILDE:
		{
			ValaSourceLocation _tmp10_;
			ValaList* _tmp12_;
			_tmp10_ = begin;
			vala_parser_rollback (self, &_tmp10_);
			if (!VALA_IS_TYPESYMBOL (parent)) {
				GError* _tmp11_;
				_tmp11_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "unexpected `destructor' declaration");
				_inner_error0_ = _tmp11_;
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_iterable_unref0 (attrs);
					return;
				} else {
					_vala_iterable_unref0 (attrs);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_tmp12_ = attrs;
			vala_parser_parse_destructor_declaration (self, parent, _tmp12_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_iterable_unref0 (attrs);
					return;
				} else {
					_vala_iterable_unref0 (attrs);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_vala_iterable_unref0 (attrs);
			return;
		}
		case VALA_TOKEN_TYPE_OPEN_BRACE:
		case VALA_TOKEN_TYPE_SEMICOLON:
		case VALA_TOKEN_TYPE_IF:
		case VALA_TOKEN_TYPE_SWITCH:
		case VALA_TOKEN_TYPE_WHILE:
		case VALA_TOKEN_TYPE_DO:
		case VALA_TOKEN_TYPE_FOR:
		case VALA_TOKEN_TYPE_FOREACH:
		case VALA_TOKEN_TYPE_BREAK:
		case VALA_TOKEN_TYPE_CONTINUE:
		case VALA_TOKEN_TYPE_RETURN:
		case VALA_TOKEN_TYPE_YIELD:
		case VALA_TOKEN_TYPE_THROW:
		case VALA_TOKEN_TYPE_TRY:
		case VALA_TOKEN_TYPE_LOCK:
		case VALA_TOKEN_TYPE_UNLOCK:
		case VALA_TOKEN_TYPE_DELETE:
		case VALA_TOKEN_TYPE_VAR:
		case VALA_TOKEN_TYPE_OP_INC:
		case VALA_TOKEN_TYPE_OP_DEC:
		case VALA_TOKEN_TYPE_BASE:
		case VALA_TOKEN_TYPE_THIS:
		case VALA_TOKEN_TYPE_STAR:
		case VALA_TOKEN_TYPE_NEW:
		{
			ValaList* _tmp13_;
			ValaSourceLocation _tmp16_;
			_tmp13_ = attrs;
			if (_tmp13_ != NULL) {
				GError* _tmp14_;
				_tmp14_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "expected statement");
				_inner_error0_ = _tmp14_;
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_iterable_unref0 (attrs);
					return;
				} else {
					_vala_iterable_unref0 (attrs);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			if (!root) {
				GError* _tmp15_;
				_tmp15_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "statements outside blocks allowed only in root namespace");
				_inner_error0_ = _tmp15_;
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_iterable_unref0 (attrs);
					return;
				} else {
					_vala_iterable_unref0 (attrs);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_tmp16_ = begin;
			vala_parser_rollback (self, &_tmp16_);
			vala_parser_parse_main_block (self, parent, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_iterable_unref0 (attrs);
					return;
				} else {
					_vala_iterable_unref0 (attrs);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_vala_iterable_unref0 (attrs);
			return;
		}
		default:
		{
			if (root) {
				gboolean is_expr = FALSE;
				is_expr = vala_parser_is_expression (self, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_iterable_unref0 (attrs);
						return;
					} else {
						_vala_iterable_unref0 (attrs);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				if (is_expr) {
					ValaSourceLocation _tmp17_;
					_tmp17_ = begin;
					vala_parser_rollback (self, &_tmp17_);
					vala_parser_parse_main_block (self, parent, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_vala_iterable_unref0 (attrs);
							return;
						} else {
							_vala_iterable_unref0 (attrs);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
					}
					_vala_iterable_unref0 (attrs);
					return;
				}
			}
			vala_parser_skip_type (self, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_iterable_unref0 (attrs);
					return;
				} else {
					_vala_iterable_unref0 (attrs);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			switch (vala_parser_current (self)) {
				case VALA_TOKEN_TYPE_OPEN_BRACE:
				case VALA_TOKEN_TYPE_SEMICOLON:
				case VALA_TOKEN_TYPE_COLON:
				{
					ValaSourceLocation _tmp18_;
					ValaTokenType _tmp19_;
					_tmp18_ = begin;
					vala_parser_rollback (self, &_tmp18_);
					_tmp19_ = last_keyword;
					switch (_tmp19_) {
						case VALA_TOKEN_TYPE_CLASS:
						{
							ValaList* _tmp20_;
							_tmp20_ = attrs;
							vala_parser_parse_class_declaration (self, parent, _tmp20_, &_inner_error0_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								if (_inner_error0_->domain == VALA_PARSE_ERROR) {
									g_propagate_error (error, _inner_error0_);
									_vala_iterable_unref0 (attrs);
									return;
								} else {
									_vala_iterable_unref0 (attrs);
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
									g_clear_error (&_inner_error0_);
									return;
								}
							}
							_vala_iterable_unref0 (attrs);
							return;
						}
						case VALA_TOKEN_TYPE_ENUM:
						{
							ValaList* _tmp21_;
							_tmp21_ = attrs;
							vala_parser_parse_enum_declaration (self, parent, _tmp21_, &_inner_error0_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								if (_inner_error0_->domain == VALA_PARSE_ERROR) {
									g_propagate_error (error, _inner_error0_);
									_vala_iterable_unref0 (attrs);
									return;
								} else {
									_vala_iterable_unref0 (attrs);
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
									g_clear_error (&_inner_error0_);
									return;
								}
							}
							_vala_iterable_unref0 (attrs);
							return;
						}
						case VALA_TOKEN_TYPE_ERRORDOMAIN:
						{
							ValaList* _tmp22_;
							_tmp22_ = attrs;
							vala_parser_parse_errordomain_declaration (self, parent, _tmp22_, &_inner_error0_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								if (_inner_error0_->domain == VALA_PARSE_ERROR) {
									g_propagate_error (error, _inner_error0_);
									_vala_iterable_unref0 (attrs);
									return;
								} else {
									_vala_iterable_unref0 (attrs);
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
									g_clear_error (&_inner_error0_);
									return;
								}
							}
							_vala_iterable_unref0 (attrs);
							return;
						}
						case VALA_TOKEN_TYPE_INTERFACE:
						{
							ValaList* _tmp23_;
							_tmp23_ = attrs;
							vala_parser_parse_interface_declaration (self, parent, _tmp23_, &_inner_error0_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								if (_inner_error0_->domain == VALA_PARSE_ERROR) {
									g_propagate_error (error, _inner_error0_);
									_vala_iterable_unref0 (attrs);
									return;
								} else {
									_vala_iterable_unref0 (attrs);
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
									g_clear_error (&_inner_error0_);
									return;
								}
							}
							_vala_iterable_unref0 (attrs);
							return;
						}
						case VALA_TOKEN_TYPE_NAMESPACE:
						{
							ValaList* _tmp24_;
							_tmp24_ = attrs;
							vala_parser_parse_namespace_declaration (self, parent, _tmp24_, &_inner_error0_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								if (_inner_error0_->domain == VALA_PARSE_ERROR) {
									g_propagate_error (error, _inner_error0_);
									_vala_iterable_unref0 (attrs);
									return;
								} else {
									_vala_iterable_unref0 (attrs);
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
									g_clear_error (&_inner_error0_);
									return;
								}
							}
							_vala_iterable_unref0 (attrs);
							return;
						}
						case VALA_TOKEN_TYPE_STRUCT:
						{
							ValaList* _tmp25_;
							_tmp25_ = attrs;
							vala_parser_parse_struct_declaration (self, parent, _tmp25_, &_inner_error0_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								if (_inner_error0_->domain == VALA_PARSE_ERROR) {
									g_propagate_error (error, _inner_error0_);
									_vala_iterable_unref0 (attrs);
									return;
								} else {
									_vala_iterable_unref0 (attrs);
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
									g_clear_error (&_inner_error0_);
									return;
								}
							}
							_vala_iterable_unref0 (attrs);
							return;
						}
						default:
						{
							break;
						}
					}
					break;
				}
				case VALA_TOKEN_TYPE_OPEN_PARENS:
				{
					ValaSourceLocation _tmp26_;
					ValaList* _tmp28_;
					_tmp26_ = begin;
					vala_parser_rollback (self, &_tmp26_);
					if (!VALA_IS_TYPESYMBOL (parent)) {
						GError* _tmp27_;
						_tmp27_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "unexpected `constructor' declaration");
						_inner_error0_ = _tmp27_;
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_vala_iterable_unref0 (attrs);
							return;
						} else {
							_vala_iterable_unref0 (attrs);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
					}
					_tmp28_ = attrs;
					vala_parser_parse_creation_method_declaration (self, parent, _tmp28_, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_vala_iterable_unref0 (attrs);
							return;
						} else {
							_vala_iterable_unref0 (attrs);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
					}
					_vala_iterable_unref0 (attrs);
					return;
				}
				default:
				{
					vala_parser_skip_type (self, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_vala_iterable_unref0 (attrs);
							return;
						} else {
							_vala_iterable_unref0 (attrs);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
					}
					switch (vala_parser_current (self)) {
						case VALA_TOKEN_TYPE_OPEN_PARENS:
						{
							ValaSourceLocation _tmp29_;
							ValaTokenType _tmp30_;
							_tmp29_ = begin;
							vala_parser_rollback (self, &_tmp29_);
							_tmp30_ = last_keyword;
							switch (_tmp30_) {
								case VALA_TOKEN_TYPE_DELEGATE:
								{
									ValaList* _tmp31_;
									_tmp31_ = attrs;
									vala_parser_parse_delegate_declaration (self, parent, _tmp31_, &_inner_error0_);
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
										if (_inner_error0_->domain == VALA_PARSE_ERROR) {
											g_propagate_error (error, _inner_error0_);
											_vala_iterable_unref0 (attrs);
											return;
										} else {
											_vala_iterable_unref0 (attrs);
											g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
											g_clear_error (&_inner_error0_);
											return;
										}
									}
									_vala_iterable_unref0 (attrs);
									return;
								}
								case VALA_TOKEN_TYPE_SIGNAL:
								{
									ValaList* _tmp33_;
									if (!VALA_IS_OBJECT_TYPE_SYMBOL (parent)) {
										GError* _tmp32_;
										_tmp32_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "unexpected `signal' declaration");
										_inner_error0_ = _tmp32_;
										if (_inner_error0_->domain == VALA_PARSE_ERROR) {
											g_propagate_error (error, _inner_error0_);
											_vala_iterable_unref0 (attrs);
											return;
										} else {
											_vala_iterable_unref0 (attrs);
											g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
											g_clear_error (&_inner_error0_);
											return;
										}
									}
									_tmp33_ = attrs;
									vala_parser_parse_signal_declaration (self, parent, _tmp33_, &_inner_error0_);
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
										if (_inner_error0_->domain == VALA_PARSE_ERROR) {
											g_propagate_error (error, _inner_error0_);
											_vala_iterable_unref0 (attrs);
											return;
										} else {
											_vala_iterable_unref0 (attrs);
											g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
											g_clear_error (&_inner_error0_);
											return;
										}
									}
									_vala_iterable_unref0 (attrs);
									return;
								}
								default:
								{
									ValaList* _tmp34_;
									_tmp34_ = attrs;
									vala_parser_parse_method_declaration (self, parent, _tmp34_, &_inner_error0_);
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
										if (_inner_error0_->domain == VALA_PARSE_ERROR) {
											g_propagate_error (error, _inner_error0_);
											_vala_iterable_unref0 (attrs);
											return;
										} else {
											_vala_iterable_unref0 (attrs);
											g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
											g_clear_error (&_inner_error0_);
											return;
										}
									}
									_vala_iterable_unref0 (attrs);
									return;
								}
							}
						}
						case VALA_TOKEN_TYPE_ASSIGN:
						case VALA_TOKEN_TYPE_SEMICOLON:
						{
							ValaSourceLocation _tmp35_;
							ValaTokenType _tmp36_;
							_tmp35_ = begin;
							vala_parser_rollback (self, &_tmp35_);
							_tmp36_ = last_keyword;
							switch (_tmp36_) {
								case VALA_TOKEN_TYPE_CONST:
								{
									ValaList* _tmp37_;
									_tmp37_ = attrs;
									vala_parser_parse_constant_declaration (self, parent, _tmp37_, &_inner_error0_);
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
										if (_inner_error0_->domain == VALA_PARSE_ERROR) {
											g_propagate_error (error, _inner_error0_);
											_vala_iterable_unref0 (attrs);
											return;
										} else {
											_vala_iterable_unref0 (attrs);
											g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
											g_clear_error (&_inner_error0_);
											return;
										}
									}
									_vala_iterable_unref0 (attrs);
									return;
								}
								default:
								{
									ValaList* _tmp38_;
									_tmp38_ = attrs;
									vala_parser_parse_field_declaration (self, parent, _tmp38_, &_inner_error0_);
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
										if (_inner_error0_->domain == VALA_PARSE_ERROR) {
											g_propagate_error (error, _inner_error0_);
											_vala_iterable_unref0 (attrs);
											return;
										} else {
											_vala_iterable_unref0 (attrs);
											g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
											g_clear_error (&_inner_error0_);
											return;
										}
									}
									_vala_iterable_unref0 (attrs);
									return;
								}
							}
						}
						case VALA_TOKEN_TYPE_OPEN_BRACE:
						case VALA_TOKEN_TYPE_THROWS:
						{
							ValaSourceLocation _tmp39_;
							ValaList* _tmp41_;
							_tmp39_ = begin;
							vala_parser_rollback (self, &_tmp39_);
							if (!VALA_IS_TYPESYMBOL (parent)) {
								GError* _tmp40_;
								_tmp40_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "unexpected `property' declaration");
								_inner_error0_ = _tmp40_;
								if (_inner_error0_->domain == VALA_PARSE_ERROR) {
									g_propagate_error (error, _inner_error0_);
									_vala_iterable_unref0 (attrs);
									return;
								} else {
									_vala_iterable_unref0 (attrs);
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
									g_clear_error (&_inner_error0_);
									return;
								}
							}
							_tmp41_ = attrs;
							vala_parser_parse_property_declaration (self, parent, _tmp41_, &_inner_error0_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								if (_inner_error0_->domain == VALA_PARSE_ERROR) {
									g_propagate_error (error, _inner_error0_);
									_vala_iterable_unref0 (attrs);
									return;
								} else {
									_vala_iterable_unref0 (attrs);
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
									g_clear_error (&_inner_error0_);
									return;
								}
							}
							_vala_iterable_unref0 (attrs);
							return;
						}
						default:
						{
							break;
						}
					}
					break;
				}
			}
			break;
		}
	}
	_tmp42_ = begin;
	vala_parser_rollback (self, &_tmp42_);
	_tmp43_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "expected declaration");
	_inner_error0_ = _tmp43_;
	if (_inner_error0_->domain == VALA_PARSE_ERROR) {
		g_propagate_error (error, _inner_error0_);
		_vala_iterable_unref0 (attrs);
		return;
	} else {
		_vala_iterable_unref0 (attrs);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_vala_iterable_unref0 (attrs);
}

static void
vala_parser_parse_declarations (ValaParser* self,
                                ValaSymbol* parent,
                                gboolean root,
                                GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	if (!root) {
		vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_BRACE, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		if (vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_BRACE) {
			_tmp0_ = vala_parser_current (self) != VALA_TOKEN_TYPE_EOF;
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		{
			ValaCodeContext* _tmp1_;
			ValaNamespace* _tmp2_;
			ValaNamespace* _tmp3_;
			_tmp1_ = self->priv->context;
			_tmp2_ = vala_code_context_get_root (_tmp1_);
			_tmp3_ = _tmp2_;
			vala_parser_parse_declaration (self, parent, parent == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, VALA_TYPE_SYMBOL, ValaSymbol), &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					goto __catch0_vala_parse_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		goto __finally0;
		__catch0_vala_parse_error:
		{
			GError* e = NULL;
			GError* _tmp4_;
			gint r = 0;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp4_ = e;
			vala_parser_report_parse_error (self, _tmp4_);
			while (TRUE) {
				r = (gint) vala_parser_recover (self);
				if (r == ((gint) VALA_PARSER_RECOVERY_STATE_STATEMENT_BEGIN)) {
					vala_parser_next (self);
				} else {
					break;
				}
			}
			if (r == ((gint) VALA_PARSER_RECOVERY_STATE_EOF)) {
				_g_error_free0 (e);
				return;
			}
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	if (!root) {
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_CLOSE_BRACE)) {
			ValaCodeContext* _tmp5_;
			ValaReport* _tmp6_;
			ValaReport* _tmp7_;
			_tmp5_ = self->priv->context;
			_tmp6_ = vala_code_context_get_report (_tmp5_);
			_tmp7_ = _tmp6_;
			if (vala_report_get_errors (_tmp7_) == 0) {
				ValaSourceReference* _tmp8_;
				ValaSourceReference* _tmp9_;
				_tmp8_ = vala_parser_get_current_src (self);
				_tmp9_ = _tmp8_;
				vala_report_error (_tmp9_, "expected `}'");
				_vala_source_reference_unref0 (_tmp9_);
			}
		}
	}
}

static ValaParserRecoveryState
vala_parser_recover (ValaParser* self)
{
	ValaParserRecoveryState result = 0;
	g_return_val_if_fail (self != NULL, 0);
	while (TRUE) {
		if (!(vala_parser_current (self) != VALA_TOKEN_TYPE_EOF)) {
			break;
		}
		switch (vala_parser_current (self)) {
			case VALA_TOKEN_TYPE_ABSTRACT:
			case VALA_TOKEN_TYPE_CLASS:
			case VALA_TOKEN_TYPE_CONST:
			case VALA_TOKEN_TYPE_CONSTRUCT:
			case VALA_TOKEN_TYPE_DELEGATE:
			case VALA_TOKEN_TYPE_ENUM:
			case VALA_TOKEN_TYPE_ERRORDOMAIN:
			case VALA_TOKEN_TYPE_EXTERN:
			case VALA_TOKEN_TYPE_INLINE:
			case VALA_TOKEN_TYPE_INTERFACE:
			case VALA_TOKEN_TYPE_INTERNAL:
			case VALA_TOKEN_TYPE_NAMESPACE:
			case VALA_TOKEN_TYPE_NEW:
			case VALA_TOKEN_TYPE_OVERRIDE:
			case VALA_TOKEN_TYPE_PRIVATE:
			case VALA_TOKEN_TYPE_PROTECTED:
			case VALA_TOKEN_TYPE_PUBLIC:
			case VALA_TOKEN_TYPE_SEALED:
			case VALA_TOKEN_TYPE_SIGNAL:
			case VALA_TOKEN_TYPE_STATIC:
			case VALA_TOKEN_TYPE_STRUCT:
			case VALA_TOKEN_TYPE_VIRTUAL:
			case VALA_TOKEN_TYPE_VOLATILE:
			{
				result = VALA_PARSER_RECOVERY_STATE_DECLARATION_BEGIN;
				return result;
			}
			case VALA_TOKEN_TYPE_BREAK:
			case VALA_TOKEN_TYPE_CONTINUE:
			case VALA_TOKEN_TYPE_DELETE:
			case VALA_TOKEN_TYPE_DO:
			case VALA_TOKEN_TYPE_FOR:
			case VALA_TOKEN_TYPE_FOREACH:
			case VALA_TOKEN_TYPE_IF:
			case VALA_TOKEN_TYPE_LOCK:
			case VALA_TOKEN_TYPE_RETURN:
			case VALA_TOKEN_TYPE_SWITCH:
			case VALA_TOKEN_TYPE_THROW:
			case VALA_TOKEN_TYPE_TRY:
			case VALA_TOKEN_TYPE_UNLOCK:
			case VALA_TOKEN_TYPE_VAR:
			case VALA_TOKEN_TYPE_WHILE:
			case VALA_TOKEN_TYPE_YIELD:
			{
				result = VALA_PARSER_RECOVERY_STATE_STATEMENT_BEGIN;
				return result;
			}
			default:
			{
				vala_parser_next (self);
				break;
			}
		}
	}
	result = VALA_PARSER_RECOVERY_STATE_EOF;
	return result;
}

static void
vala_parser_parse_namespace_declaration (ValaParser* self,
                                         ValaSymbol* parent,
                                         ValaList* attrs,
                                         GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaUnresolvedSymbol* sym = NULL;
	ValaUnresolvedSymbol* _tmp1_;
	ValaNamespace* ns = NULL;
	ValaUnresolvedSymbol* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	ValaSourceLocation _tmp5_;
	ValaSourceReference* _tmp6_;
	ValaSourceReference* _tmp7_;
	ValaNamespace* _tmp8_;
	ValaNamespace* _tmp9_;
	ValaComment* _tmp10_;
	ValaNamespace* _tmp13_;
	ValaList* old_using_directives = NULL;
	ValaScanner* _tmp14_;
	ValaSourceFile* _tmp15_;
	ValaSourceFile* _tmp16_;
	ValaList* _tmp17_;
	ValaList* _tmp18_;
	ValaList* _tmp19_;
	ValaNamespace* _tmp20_;
	ValaNamespace* _tmp21_;
	ValaScanner* _tmp22_;
	ValaSourceFile* _tmp23_;
	ValaSourceFile* _tmp24_;
	ValaList* _tmp25_;
	ValaSymbol* _result_ = NULL;
	ValaNamespace* _tmp31_;
	ValaSymbol* _tmp32_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_NAMESPACE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp1_ = vala_parser_parse_symbol_name (self, &_inner_error0_);
	sym = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp2_ = sym;
	_tmp3_ = vala_symbol_get_name ((ValaSymbol*) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = begin;
	_tmp6_ = vala_parser_get_src (self, &_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = vala_namespace_new (_tmp4_, _tmp7_);
	_tmp9_ = _tmp8_;
	_vala_source_reference_unref0 (_tmp7_);
	ns = _tmp9_;
	_tmp10_ = self->priv->comment;
	if (_tmp10_ != NULL) {
		ValaNamespace* _tmp11_;
		ValaComment* _tmp12_;
		_tmp11_ = ns;
		_tmp12_ = self->priv->comment;
		vala_namespace_add_comment (_tmp11_, _tmp12_);
		_vala_comment_unref0 (self->priv->comment);
		self->priv->comment = NULL;
	}
	_tmp13_ = ns;
	vala_parser_set_attributes (self, (ValaCodeNode*) _tmp13_, attrs);
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_BRACE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (ns);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_code_node_unref0 (ns);
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp14_ = self->priv->scanner;
	_tmp15_ = vala_scanner_get_source_file (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = vala_source_file_get_current_using_directives (_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = _vala_iterable_ref0 (_tmp18_);
	old_using_directives = _tmp19_;
	_tmp20_ = ns;
	vala_parser_parse_using_directives (self, _tmp20_, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_iterable_unref0 (old_using_directives);
			_vala_code_node_unref0 (ns);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_iterable_unref0 (old_using_directives);
			_vala_code_node_unref0 (ns);
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp21_ = ns;
	vala_parser_parse_declarations (self, (ValaSymbol*) _tmp21_, TRUE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_iterable_unref0 (old_using_directives);
			_vala_code_node_unref0 (ns);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_iterable_unref0 (old_using_directives);
			_vala_code_node_unref0 (ns);
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp22_ = self->priv->scanner;
	_tmp23_ = vala_scanner_get_source_file (_tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = old_using_directives;
	vala_source_file_set_current_using_directives (_tmp24_, _tmp25_);
	if (!vala_parser_accept (self, VALA_TOKEN_TYPE_CLOSE_BRACE)) {
		ValaCodeContext* _tmp26_;
		ValaReport* _tmp27_;
		ValaReport* _tmp28_;
		_tmp26_ = self->priv->context;
		_tmp27_ = vala_code_context_get_report (_tmp26_);
		_tmp28_ = _tmp27_;
		if (vala_report_get_errors (_tmp28_) == 0) {
			ValaSourceReference* _tmp29_;
			ValaSourceReference* _tmp30_;
			_tmp29_ = vala_parser_get_current_src (self);
			_tmp30_ = _tmp29_;
			vala_report_error (_tmp30_, "expected `}'");
			_vala_source_reference_unref0 (_tmp30_);
		}
	}
	_tmp31_ = ns;
	_tmp32_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp31_);
	_result_ = _tmp32_;
	while (TRUE) {
		ValaUnresolvedSymbol* _tmp33_;
		ValaUnresolvedSymbol* _tmp34_;
		ValaUnresolvedSymbol* _tmp35_;
		ValaUnresolvedSymbol* _tmp36_;
		ValaUnresolvedSymbol* _tmp37_;
		ValaSymbol* _tmp38_ = NULL;
		ValaUnresolvedSymbol* _tmp39_;
		ValaSymbol* next = NULL;
		ValaSymbol* _tmp48_;
		ValaSymbol* _tmp49_;
		ValaSymbol* _tmp50_;
		ValaSymbol* _tmp51_;
		ValaSymbol* _tmp52_;
		_tmp33_ = sym;
		if (!(_tmp33_ != NULL)) {
			break;
		}
		_tmp34_ = sym;
		_tmp35_ = vala_unresolved_symbol_get_inner (_tmp34_);
		_tmp36_ = _tmp35_;
		_tmp37_ = _vala_code_node_ref0 (_tmp36_);
		_vala_code_node_unref0 (sym);
		sym = _tmp37_;
		_tmp39_ = sym;
		if (_tmp39_ != NULL) {
			ValaUnresolvedSymbol* _tmp40_;
			const gchar* _tmp41_;
			const gchar* _tmp42_;
			ValaNamespace* _tmp43_;
			ValaSourceReference* _tmp44_;
			ValaSourceReference* _tmp45_;
			ValaNamespace* _tmp46_;
			_tmp40_ = sym;
			_tmp41_ = vala_symbol_get_name ((ValaSymbol*) _tmp40_);
			_tmp42_ = _tmp41_;
			_tmp43_ = ns;
			_tmp44_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp43_);
			_tmp45_ = _tmp44_;
			_tmp46_ = vala_namespace_new (_tmp42_, _tmp45_);
			_vala_code_node_unref0 (_tmp38_);
			_tmp38_ = (ValaSymbol*) _tmp46_;
		} else {
			ValaSymbol* _tmp47_;
			_tmp47_ = _vala_code_node_ref0 (parent);
			_vala_code_node_unref0 (_tmp38_);
			_tmp38_ = _tmp47_;
		}
		_tmp48_ = _vala_code_node_ref0 (_tmp38_);
		next = _tmp48_;
		_tmp49_ = next;
		_tmp50_ = _result_;
		vala_symbol_add_namespace (_tmp49_, G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, VALA_TYPE_NAMESPACE, ValaNamespace));
		_tmp51_ = next;
		_tmp52_ = _vala_code_node_ref0 (_tmp51_);
		_vala_code_node_unref0 (_result_);
		_result_ = _tmp52_;
		_vala_code_node_unref0 (next);
		_vala_code_node_unref0 (_tmp38_);
	}
	_vala_code_node_unref0 (_result_);
	_vala_iterable_unref0 (old_using_directives);
	_vala_code_node_unref0 (ns);
	_vala_code_node_unref0 (sym);
}

static void
vala_parser_parse_using_directives (ValaParser* self,
                                    ValaNamespace* ns,
                                    GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ns != NULL);
	while (TRUE) {
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_USING)) {
			break;
		}
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				ValaSourceLocation begin = {0};
				ValaSourceLocation _tmp1_ = {0};
				ValaUnresolvedSymbol* sym = NULL;
				ValaUnresolvedSymbol* _tmp2_;
				ValaUsingDirective* ns_ref = NULL;
				ValaUnresolvedSymbol* _tmp3_;
				ValaSourceLocation _tmp4_;
				ValaSourceReference* _tmp5_;
				ValaSourceReference* _tmp6_;
				ValaUsingDirective* _tmp7_;
				ValaUsingDirective* _tmp8_;
				ValaScanner* _tmp9_;
				ValaSourceFile* _tmp10_;
				ValaSourceFile* _tmp11_;
				ValaUsingDirective* _tmp12_;
				ValaUsingDirective* _tmp13_;
				if (!_tmp0_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp0_ = FALSE;
				vala_parser_get_location (self, &_tmp1_);
				begin = _tmp1_;
				_tmp2_ = vala_parser_parse_symbol_name (self, &_inner_error0_);
				sym = _tmp2_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						return;
					} else {
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_tmp3_ = sym;
				_tmp4_ = begin;
				_tmp5_ = vala_parser_get_src (self, &_tmp4_);
				_tmp6_ = _tmp5_;
				_tmp7_ = vala_using_directive_new ((ValaSymbol*) _tmp3_, _tmp6_);
				_tmp8_ = _tmp7_;
				_vala_source_reference_unref0 (_tmp6_);
				ns_ref = _tmp8_;
				_tmp9_ = self->priv->scanner;
				_tmp10_ = vala_scanner_get_source_file (_tmp9_);
				_tmp11_ = _tmp10_;
				_tmp12_ = ns_ref;
				vala_source_file_add_using_directive (_tmp11_, _tmp12_);
				_tmp13_ = ns_ref;
				vala_namespace_add_using_directive (ns, _tmp13_);
				_vala_code_node_unref0 (ns_ref);
				_vala_code_node_unref0 (sym);
			}
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
}

static void
vala_parser_parse_class_declaration (ValaParser* self,
                                     ValaSymbol* parent,
                                     ValaList* attrs,
                                     GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSymbolAccessibility access = 0;
	ValaParserModifierFlags flags = 0U;
	ValaUnresolvedSymbol* sym = NULL;
	ValaUnresolvedSymbol* _tmp1_;
	ValaList* type_param_list = NULL;
	ValaList* _tmp2_;
	ValaArrayList* base_types = NULL;
	GEqualFunc _tmp3_;
	ValaArrayList* _tmp4_;
	ValaClass* cl = NULL;
	ValaUnresolvedSymbol* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	ValaSourceLocation _tmp12_;
	ValaSourceReference* _tmp13_;
	ValaSourceReference* _tmp14_;
	ValaComment* _tmp15_;
	ValaClass* _tmp16_;
	ValaClass* _tmp17_;
	ValaClass* _tmp18_;
	ValaSymbolAccessibility _tmp19_;
	ValaParserModifierFlags _tmp20_;
	ValaParserModifierFlags _tmp22_;
	ValaParserModifierFlags _tmp24_;
	ValaClass* _tmp26_;
	ValaClass* _tmp49_;
	gboolean _tmp50_ = FALSE;
	ValaScanner* _tmp51_;
	ValaSourceFile* _tmp52_;
	ValaSourceFile* _tmp53_;
	ValaSourceFileType _tmp54_;
	ValaSourceFileType _tmp55_;
	ValaSymbol* _result_ = NULL;
	ValaClass* _tmp79_;
	ValaSymbol* _tmp80_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	access = vala_parser_parse_access_modifier (self, VALA_SYMBOL_ACCESSIBILITY_PRIVATE);
	flags = vala_parser_parse_type_declaration_modifiers (self);
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLASS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp1_ = vala_parser_parse_symbol_name (self, &_inner_error0_);
	sym = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp2_ = vala_parser_parse_type_parameter_list (self, &_inner_error0_);
	type_param_list = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp3_ = g_direct_equal;
	_tmp4_ = vala_array_list_new (VALA_TYPE_DATA_TYPE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp3_);
	base_types = _tmp4_;
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_COLON)) {
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				ValaDataType* _tmp6_ = NULL;
				ValaDataType* _tmp7_;
				ValaArrayList* _tmp8_;
				if (!_tmp5_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp5_ = FALSE;
				_tmp7_ = vala_parser_parse_type (self, TRUE, FALSE, FALSE, &_inner_error0_);
				_tmp6_ = _tmp7_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_iterable_unref0 (base_types);
						_vala_iterable_unref0 (type_param_list);
						_vala_code_node_unref0 (sym);
						return;
					} else {
						_vala_iterable_unref0 (base_types);
						_vala_iterable_unref0 (type_param_list);
						_vala_code_node_unref0 (sym);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_tmp8_ = base_types;
				vala_collection_add ((ValaCollection*) _tmp8_, _tmp6_);
				_vala_code_node_unref0 (_tmp6_);
			}
		}
	}
	_tmp9_ = sym;
	_tmp10_ = vala_symbol_get_name ((ValaSymbol*) _tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = begin;
	_tmp13_ = vala_parser_get_src (self, &_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = self->priv->comment;
	_tmp16_ = vala_class_new (_tmp11_, _tmp14_, _tmp15_);
	_tmp17_ = _tmp16_;
	_vala_source_reference_unref0 (_tmp14_);
	cl = _tmp17_;
	_tmp18_ = cl;
	_tmp19_ = access;
	vala_symbol_set_access ((ValaSymbol*) _tmp18_, _tmp19_);
	_tmp20_ = flags;
	if ((_tmp20_ & VALA_PARSER_MODIFIER_FLAGS_ABSTRACT) == VALA_PARSER_MODIFIER_FLAGS_ABSTRACT) {
		ValaClass* _tmp21_;
		_tmp21_ = cl;
		vala_class_set_is_abstract (_tmp21_, TRUE);
	}
	_tmp22_ = flags;
	if ((_tmp22_ & VALA_PARSER_MODIFIER_FLAGS_SEALED) == VALA_PARSER_MODIFIER_FLAGS_SEALED) {
		ValaClass* _tmp23_;
		_tmp23_ = cl;
		vala_class_set_is_sealed (_tmp23_, TRUE);
	}
	_tmp24_ = flags;
	if ((_tmp24_ & VALA_PARSER_MODIFIER_FLAGS_EXTERN) == VALA_PARSER_MODIFIER_FLAGS_EXTERN) {
		ValaClass* _tmp25_;
		_tmp25_ = cl;
		vala_symbol_set_is_extern ((ValaSymbol*) _tmp25_, TRUE);
	}
	_tmp26_ = cl;
	vala_parser_set_attributes (self, (ValaCodeNode*) _tmp26_, attrs);
	{
		ValaList* _type_param_list = NULL;
		ValaList* _tmp27_;
		ValaList* _tmp28_;
		gint _type_param_size = 0;
		ValaList* _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
		gint _type_param_index = 0;
		_tmp27_ = type_param_list;
		_tmp28_ = _vala_iterable_ref0 (_tmp27_);
		_type_param_list = _tmp28_;
		_tmp29_ = _type_param_list;
		_tmp30_ = vala_collection_get_size ((ValaCollection*) _tmp29_);
		_tmp31_ = _tmp30_;
		_type_param_size = _tmp31_;
		_type_param_index = -1;
		while (TRUE) {
			gint _tmp32_;
			gint _tmp33_;
			ValaTypeParameter* type_param = NULL;
			ValaList* _tmp34_;
			gpointer _tmp35_;
			ValaClass* _tmp36_;
			ValaTypeParameter* _tmp37_;
			_type_param_index = _type_param_index + 1;
			_tmp32_ = _type_param_index;
			_tmp33_ = _type_param_size;
			if (!(_tmp32_ < _tmp33_)) {
				break;
			}
			_tmp34_ = _type_param_list;
			_tmp35_ = vala_list_get (_tmp34_, _type_param_index);
			type_param = (ValaTypeParameter*) _tmp35_;
			_tmp36_ = cl;
			_tmp37_ = type_param;
			vala_object_type_symbol_add_type_parameter ((ValaObjectTypeSymbol*) _tmp36_, _tmp37_);
			_vala_code_node_unref0 (type_param);
		}
		_vala_iterable_unref0 (_type_param_list);
	}
	{
		ValaArrayList* _base_type_list = NULL;
		ValaArrayList* _tmp38_;
		ValaArrayList* _tmp39_;
		gint _base_type_size = 0;
		ValaArrayList* _tmp40_;
		gint _tmp41_;
		gint _tmp42_;
		gint _base_type_index = 0;
		_tmp38_ = base_types;
		_tmp39_ = _vala_iterable_ref0 (_tmp38_);
		_base_type_list = _tmp39_;
		_tmp40_ = _base_type_list;
		_tmp41_ = vala_collection_get_size ((ValaCollection*) _tmp40_);
		_tmp42_ = _tmp41_;
		_base_type_size = _tmp42_;
		_base_type_index = -1;
		while (TRUE) {
			gint _tmp43_;
			gint _tmp44_;
			ValaDataType* base_type = NULL;
			ValaArrayList* _tmp45_;
			gpointer _tmp46_;
			ValaClass* _tmp47_;
			ValaDataType* _tmp48_;
			_base_type_index = _base_type_index + 1;
			_tmp43_ = _base_type_index;
			_tmp44_ = _base_type_size;
			if (!(_tmp43_ < _tmp44_)) {
				break;
			}
			_tmp45_ = _base_type_list;
			_tmp46_ = vala_list_get ((ValaList*) _tmp45_, _base_type_index);
			base_type = (ValaDataType*) _tmp46_;
			_tmp47_ = cl;
			_tmp48_ = base_type;
			vala_class_add_base_type (_tmp47_, _tmp48_);
			_vala_code_node_unref0 (base_type);
		}
		_vala_iterable_unref0 (_base_type_list);
	}
	_tmp49_ = cl;
	vala_parser_parse_declarations (self, (ValaSymbol*) _tmp49_, FALSE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (cl);
			_vala_iterable_unref0 (base_types);
			_vala_iterable_unref0 (type_param_list);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_code_node_unref0 (cl);
			_vala_iterable_unref0 (base_types);
			_vala_iterable_unref0 (type_param_list);
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp51_ = self->priv->scanner;
	_tmp52_ = vala_scanner_get_source_file (_tmp51_);
	_tmp53_ = _tmp52_;
	_tmp54_ = vala_source_file_get_file_type (_tmp53_);
	_tmp55_ = _tmp54_;
	if (_tmp55_ == VALA_SOURCE_FILE_TYPE_SOURCE) {
		ValaClass* _tmp56_;
		ValaCreationMethod* _tmp57_;
		ValaCreationMethod* _tmp58_;
		_tmp56_ = cl;
		_tmp57_ = vala_class_get_default_construction_method (_tmp56_);
		_tmp58_ = _tmp57_;
		_tmp50_ = _tmp58_ == NULL;
	} else {
		_tmp50_ = FALSE;
	}
	if (_tmp50_) {
		ValaCreationMethod* m = NULL;
		ValaClass* _tmp59_;
		const gchar* _tmp60_;
		const gchar* _tmp61_;
		ValaClass* _tmp62_;
		ValaSourceReference* _tmp63_;
		ValaSourceReference* _tmp64_;
		ValaCreationMethod* _tmp65_;
		ValaSymbolAccessibility _tmp66_ = 0;
		ValaClass* _tmp67_;
		gboolean _tmp68_;
		gboolean _tmp69_;
		ValaCreationMethod* _tmp70_;
		ValaCreationMethod* _tmp71_;
		ValaClass* _tmp72_;
		ValaSourceReference* _tmp73_;
		ValaSourceReference* _tmp74_;
		ValaBlock* _tmp75_;
		ValaBlock* _tmp76_;
		ValaClass* _tmp77_;
		ValaCreationMethod* _tmp78_;
		_tmp59_ = cl;
		_tmp60_ = vala_symbol_get_name ((ValaSymbol*) _tmp59_);
		_tmp61_ = _tmp60_;
		_tmp62_ = cl;
		_tmp63_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp62_);
		_tmp64_ = _tmp63_;
		_tmp65_ = vala_creation_method_new (_tmp61_, NULL, _tmp64_, NULL);
		m = _tmp65_;
		_tmp67_ = cl;
		_tmp68_ = vala_class_get_is_abstract (_tmp67_);
		_tmp69_ = _tmp68_;
		if (_tmp69_) {
			_tmp66_ = VALA_SYMBOL_ACCESSIBILITY_PROTECTED;
		} else {
			_tmp66_ = VALA_SYMBOL_ACCESSIBILITY_PUBLIC;
		}
		_tmp70_ = m;
		vala_symbol_set_access ((ValaSymbol*) _tmp70_, _tmp66_);
		_tmp71_ = m;
		_tmp72_ = cl;
		_tmp73_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp72_);
		_tmp74_ = _tmp73_;
		_tmp75_ = vala_block_new (_tmp74_);
		_tmp76_ = _tmp75_;
		vala_subroutine_set_body ((ValaSubroutine*) _tmp71_, _tmp76_);
		_vala_code_node_unref0 (_tmp76_);
		_tmp77_ = cl;
		_tmp78_ = m;
		vala_symbol_add_method ((ValaSymbol*) _tmp77_, (ValaMethod*) _tmp78_);
		_vala_code_node_unref0 (m);
	}
	_tmp79_ = cl;
	_tmp80_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp79_);
	_result_ = _tmp80_;
	while (TRUE) {
		ValaUnresolvedSymbol* _tmp81_;
		ValaUnresolvedSymbol* _tmp82_;
		ValaUnresolvedSymbol* _tmp83_;
		ValaUnresolvedSymbol* _tmp84_;
		ValaUnresolvedSymbol* _tmp85_;
		ValaSymbol* _tmp86_ = NULL;
		ValaUnresolvedSymbol* _tmp87_;
		ValaSymbol* next = NULL;
		ValaSymbol* _tmp96_;
		ValaSymbol* _tmp97_;
		ValaSymbol* _tmp102_;
		ValaSymbol* _tmp103_;
		_tmp81_ = sym;
		if (!(_tmp81_ != NULL)) {
			break;
		}
		_tmp82_ = sym;
		_tmp83_ = vala_unresolved_symbol_get_inner (_tmp82_);
		_tmp84_ = _tmp83_;
		_tmp85_ = _vala_code_node_ref0 (_tmp84_);
		_vala_code_node_unref0 (sym);
		sym = _tmp85_;
		_tmp87_ = sym;
		if (_tmp87_ != NULL) {
			ValaUnresolvedSymbol* _tmp88_;
			const gchar* _tmp89_;
			const gchar* _tmp90_;
			ValaClass* _tmp91_;
			ValaSourceReference* _tmp92_;
			ValaSourceReference* _tmp93_;
			ValaNamespace* _tmp94_;
			_tmp88_ = sym;
			_tmp89_ = vala_symbol_get_name ((ValaSymbol*) _tmp88_);
			_tmp90_ = _tmp89_;
			_tmp91_ = cl;
			_tmp92_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp91_);
			_tmp93_ = _tmp92_;
			_tmp94_ = vala_namespace_new (_tmp90_, _tmp93_);
			_vala_code_node_unref0 (_tmp86_);
			_tmp86_ = (ValaSymbol*) _tmp94_;
		} else {
			ValaSymbol* _tmp95_;
			_tmp95_ = _vala_code_node_ref0 (parent);
			_vala_code_node_unref0 (_tmp86_);
			_tmp86_ = _tmp95_;
		}
		_tmp96_ = _vala_code_node_ref0 (_tmp86_);
		next = _tmp96_;
		_tmp97_ = _result_;
		if (VALA_IS_NAMESPACE (_tmp97_)) {
			ValaSymbol* _tmp98_;
			ValaSymbol* _tmp99_;
			_tmp98_ = next;
			_tmp99_ = _result_;
			vala_symbol_add_namespace (_tmp98_, G_TYPE_CHECK_INSTANCE_CAST (_tmp99_, VALA_TYPE_NAMESPACE, ValaNamespace));
		} else {
			ValaSymbol* _tmp100_;
			ValaSymbol* _tmp101_;
			_tmp100_ = next;
			_tmp101_ = _result_;
			vala_symbol_add_class (_tmp100_, G_TYPE_CHECK_INSTANCE_CAST (_tmp101_, VALA_TYPE_CLASS, ValaClass));
		}
		_tmp102_ = next;
		_tmp103_ = _vala_code_node_ref0 (_tmp102_);
		_vala_code_node_unref0 (_result_);
		_result_ = _tmp103_;
		_vala_code_node_unref0 (next);
		_vala_code_node_unref0 (_tmp86_);
	}
	_vala_code_node_unref0 (_result_);
	_vala_code_node_unref0 (cl);
	_vala_iterable_unref0 (base_types);
	_vala_iterable_unref0 (type_param_list);
	_vala_code_node_unref0 (sym);
}

static void
vala_parser_parse_constant_declaration (ValaParser* self,
                                        ValaSymbol* parent,
                                        ValaList* attrs,
                                        GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSymbolAccessibility access = 0;
	ValaParserModifierFlags flags = 0U;
	ValaDataType* type = NULL;
	ValaDataType* _tmp1_;
	gchar* id = NULL;
	gchar* _tmp2_;
	ValaDataType* _tmp3_ = NULL;
	ValaDataType* _tmp4_;
	ValaDataType* _tmp5_;
	ValaDataType* _tmp6_;
	ValaArrayType* array_type = NULL;
	ValaDataType* _tmp7_;
	ValaArrayType* _tmp8_;
	ValaConstant* c = NULL;
	const gchar* _tmp12_;
	ValaDataType* _tmp13_;
	ValaSourceLocation _tmp14_;
	ValaSourceReference* _tmp15_;
	ValaSourceReference* _tmp16_;
	ValaComment* _tmp17_;
	ValaConstant* _tmp18_;
	ValaConstant* _tmp19_;
	ValaConstant* _tmp20_;
	ValaSymbolAccessibility _tmp21_;
	ValaParserModifierFlags _tmp22_;
	ValaParserModifierFlags _tmp24_;
	ValaConstant* _tmp26_;
	ValaParserModifierFlags _tmp27_;
	ValaDataType* _tmp31_;
	gboolean _tmp32_;
	gboolean _tmp33_;
	ValaConstant* _tmp40_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	access = vala_parser_parse_access_modifier (self, VALA_SYMBOL_ACCESSIBILITY_PRIVATE);
	flags = vala_parser_parse_member_declaration_modifiers (self);
	vala_parser_expect (self, VALA_TOKEN_TYPE_CONST, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp1_ = vala_parser_parse_type (self, FALSE, FALSE, FALSE, &_inner_error0_);
	type = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp2_ = vala_parser_parse_identifier (self, &_inner_error0_);
	id = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp4_ = type;
	_tmp5_ = vala_parser_parse_inline_array_type (self, _tmp4_, &_inner_error0_);
	_tmp3_ = _tmp5_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp6_ = _tmp3_;
	_tmp3_ = NULL;
	_vala_code_node_unref0 (type);
	type = _tmp6_;
	_tmp7_ = type;
	array_type = VALA_IS_ARRAY_TYPE (_tmp7_) ? ((ValaArrayType*) _tmp7_) : NULL;
	_tmp8_ = array_type;
	if (_tmp8_ != NULL) {
		ValaArrayType* _tmp9_;
		ValaDataType* _tmp10_;
		ValaDataType* _tmp11_;
		_tmp9_ = array_type;
		_tmp10_ = vala_array_type_get_element_type (_tmp9_);
		_tmp11_ = _tmp10_;
		vala_data_type_set_value_owned (_tmp11_, FALSE);
	}
	_tmp12_ = id;
	_tmp13_ = type;
	_tmp14_ = begin;
	_tmp15_ = vala_parser_get_src (self, &_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = self->priv->comment;
	_tmp18_ = vala_constant_new (_tmp12_, _tmp13_, NULL, _tmp16_, _tmp17_);
	_tmp19_ = _tmp18_;
	_vala_source_reference_unref0 (_tmp16_);
	c = _tmp19_;
	_tmp20_ = c;
	_tmp21_ = access;
	vala_symbol_set_access ((ValaSymbol*) _tmp20_, _tmp21_);
	_tmp22_ = flags;
	if ((_tmp22_ & VALA_PARSER_MODIFIER_FLAGS_EXTERN) == VALA_PARSER_MODIFIER_FLAGS_EXTERN) {
		ValaConstant* _tmp23_;
		_tmp23_ = c;
		vala_symbol_set_is_extern ((ValaSymbol*) _tmp23_, TRUE);
	}
	_tmp24_ = flags;
	if ((_tmp24_ & VALA_PARSER_MODIFIER_FLAGS_NEW) == VALA_PARSER_MODIFIER_FLAGS_NEW) {
		ValaConstant* _tmp25_;
		_tmp25_ = c;
		vala_symbol_set_hides ((ValaSymbol*) _tmp25_, TRUE);
	}
	_tmp26_ = c;
	vala_parser_set_attributes (self, (ValaCodeNode*) _tmp26_, attrs);
	_tmp27_ = flags;
	if ((_tmp27_ & VALA_PARSER_MODIFIER_FLAGS_STATIC) == VALA_PARSER_MODIFIER_FLAGS_STATIC) {
		ValaConstant* _tmp28_;
		ValaSourceReference* _tmp29_;
		ValaSourceReference* _tmp30_;
		_tmp28_ = c;
		_tmp29_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp28_);
		_tmp30_ = _tmp29_;
		vala_report_warning (_tmp30_, "the modifier `static' is not applicable to constants");
	}
	_tmp31_ = type;
	_tmp32_ = vala_data_type_get_value_owned (_tmp31_);
	_tmp33_ = _tmp32_;
	if (_tmp33_) {
		ValaConstant* _tmp34_;
		ValaSourceReference* _tmp35_;
		ValaSourceReference* _tmp36_;
		_tmp34_ = c;
		_tmp35_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp34_);
		_tmp36_ = _tmp35_;
		vala_report_error (_tmp36_, "`owned' is not allowed on constants");
	}
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_ASSIGN)) {
		ValaExpression* _tmp37_ = NULL;
		ValaExpression* _tmp38_;
		ValaConstant* _tmp39_;
		_tmp38_ = vala_parser_parse_expression (self, &_inner_error0_);
		_tmp37_ = _tmp38_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (c);
				_vala_code_node_unref0 (_tmp3_);
				_g_free0 (id);
				_vala_code_node_unref0 (type);
				return;
			} else {
				_vala_code_node_unref0 (c);
				_vala_code_node_unref0 (_tmp3_);
				_g_free0 (id);
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp39_ = c;
		vala_constant_set_value (_tmp39_, _tmp37_);
		_vala_code_node_unref0 (_tmp37_);
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (c);
			_vala_code_node_unref0 (_tmp3_);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (c);
			_vala_code_node_unref0 (_tmp3_);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp40_ = c;
	vala_symbol_add_constant (parent, _tmp40_);
	_vala_code_node_unref0 (c);
	_vala_code_node_unref0 (_tmp3_);
	_g_free0 (id);
	_vala_code_node_unref0 (type);
}

static void
vala_parser_parse_field_declaration (ValaParser* self,
                                     ValaSymbol* parent,
                                     ValaList* attrs,
                                     GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSymbolAccessibility _tmp1_ = 0;
	ValaSymbolAccessibility access = 0;
	ValaParserModifierFlags flags = 0U;
	ValaDataType* type = NULL;
	ValaDataType* _tmp2_;
	gchar* id = NULL;
	gchar* _tmp3_;
	ValaDataType* _tmp4_ = NULL;
	ValaDataType* _tmp5_;
	ValaDataType* _tmp6_;
	ValaDataType* _tmp7_;
	ValaField* f = NULL;
	const gchar* _tmp8_;
	ValaDataType* _tmp9_;
	ValaSourceLocation _tmp10_;
	ValaSourceReference* _tmp11_;
	ValaSourceReference* _tmp12_;
	ValaComment* _tmp13_;
	ValaField* _tmp14_;
	ValaField* _tmp15_;
	ValaField* _tmp16_;
	ValaSymbolAccessibility _tmp17_;
	ValaField* _tmp18_;
	gboolean _tmp19_ = FALSE;
	ValaParserModifierFlags _tmp20_;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_;
	gboolean _tmp34_;
	gboolean _tmp44_ = FALSE;
	gboolean _tmp45_ = FALSE;
	ValaParserModifierFlags _tmp46_;
	ValaParserModifierFlags _tmp52_;
	ValaParserModifierFlags _tmp54_;
	ValaField* _tmp59_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	if (VALA_IS_STRUCT (parent)) {
		_tmp1_ = VALA_SYMBOL_ACCESSIBILITY_PUBLIC;
	} else {
		_tmp1_ = VALA_SYMBOL_ACCESSIBILITY_PRIVATE;
	}
	access = vala_parser_parse_access_modifier (self, _tmp1_);
	flags = vala_parser_parse_member_declaration_modifiers (self);
	_tmp2_ = vala_parser_parse_type (self, TRUE, TRUE, FALSE, &_inner_error0_);
	type = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp3_ = vala_parser_parse_identifier (self, &_inner_error0_);
	id = _tmp3_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp5_ = type;
	_tmp6_ = vala_parser_parse_inline_array_type (self, _tmp5_, &_inner_error0_);
	_tmp4_ = _tmp6_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp7_ = _tmp4_;
	_tmp4_ = NULL;
	_vala_code_node_unref0 (type);
	type = _tmp7_;
	_tmp8_ = id;
	_tmp9_ = type;
	_tmp10_ = begin;
	_tmp11_ = vala_parser_get_src (self, &_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = self->priv->comment;
	_tmp14_ = vala_field_new (_tmp8_, _tmp9_, NULL, _tmp12_, _tmp13_);
	_tmp15_ = _tmp14_;
	_vala_source_reference_unref0 (_tmp12_);
	f = _tmp15_;
	_tmp16_ = f;
	_tmp17_ = access;
	vala_symbol_set_access ((ValaSymbol*) _tmp16_, _tmp17_);
	_tmp18_ = f;
	vala_parser_set_attributes (self, (ValaCodeNode*) _tmp18_, attrs);
	_tmp20_ = flags;
	if ((_tmp20_ & VALA_PARSER_MODIFIER_FLAGS_STATIC) == VALA_PARSER_MODIFIER_FLAGS_STATIC) {
		ValaParserModifierFlags _tmp21_;
		_tmp21_ = flags;
		_tmp19_ = (_tmp21_ & VALA_PARSER_MODIFIER_FLAGS_CLASS) == VALA_PARSER_MODIFIER_FLAGS_CLASS;
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		ValaField* _tmp22_;
		ValaSourceReference* _tmp23_;
		ValaSourceReference* _tmp24_;
		_tmp22_ = f;
		_tmp23_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp22_);
		_tmp24_ = _tmp23_;
		vala_report_error (_tmp24_, "only one of `static' or `class' may be specified");
	} else {
		ValaParserModifierFlags _tmp25_;
		_tmp25_ = flags;
		if ((_tmp25_ & VALA_PARSER_MODIFIER_FLAGS_STATIC) == VALA_PARSER_MODIFIER_FLAGS_STATIC) {
			ValaField* _tmp26_;
			_tmp26_ = f;
			vala_field_set_binding (_tmp26_, VALA_MEMBER_BINDING_STATIC);
		} else {
			ValaParserModifierFlags _tmp27_;
			_tmp27_ = flags;
			if ((_tmp27_ & VALA_PARSER_MODIFIER_FLAGS_CLASS) == VALA_PARSER_MODIFIER_FLAGS_CLASS) {
				ValaField* _tmp28_;
				_tmp28_ = f;
				vala_field_set_binding (_tmp28_, VALA_MEMBER_BINDING_CLASS);
			} else {
				if (VALA_IS_NAMESPACE (parent)) {
					ValaField* _tmp29_;
					_tmp29_ = f;
					vala_field_set_binding (_tmp29_, VALA_MEMBER_BINDING_STATIC);
				}
			}
		}
	}
	_tmp33_ = vala_symbol_get_external_package (parent);
	_tmp34_ = _tmp33_;
	if (!_tmp34_) {
		_tmp32_ = VALA_IS_STRUCT (parent);
	} else {
		_tmp32_ = FALSE;
	}
	if (_tmp32_) {
		ValaField* _tmp35_;
		ValaSymbolAccessibility _tmp36_;
		ValaSymbolAccessibility _tmp37_;
		_tmp35_ = f;
		_tmp36_ = vala_symbol_get_access ((ValaSymbol*) _tmp35_);
		_tmp37_ = _tmp36_;
		_tmp31_ = _tmp37_ != VALA_SYMBOL_ACCESSIBILITY_PUBLIC;
	} else {
		_tmp31_ = FALSE;
	}
	if (_tmp31_) {
		ValaField* _tmp38_;
		ValaMemberBinding _tmp39_;
		ValaMemberBinding _tmp40_;
		_tmp38_ = f;
		_tmp39_ = vala_field_get_binding (_tmp38_);
		_tmp40_ = _tmp39_;
		_tmp30_ = _tmp40_ == VALA_MEMBER_BINDING_INSTANCE;
	} else {
		_tmp30_ = FALSE;
	}
	if (_tmp30_) {
		ValaField* _tmp41_;
		ValaSourceReference* _tmp42_;
		ValaSourceReference* _tmp43_;
		_tmp41_ = f;
		_tmp42_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp41_);
		_tmp43_ = _tmp42_;
		vala_report_warning (_tmp43_, "accessibility of struct fields can only be `public`");
	}
	_tmp46_ = flags;
	if ((_tmp46_ & VALA_PARSER_MODIFIER_FLAGS_ABSTRACT) == VALA_PARSER_MODIFIER_FLAGS_ABSTRACT) {
		_tmp45_ = TRUE;
	} else {
		ValaParserModifierFlags _tmp47_;
		_tmp47_ = flags;
		_tmp45_ = (_tmp47_ & VALA_PARSER_MODIFIER_FLAGS_VIRTUAL) == VALA_PARSER_MODIFIER_FLAGS_VIRTUAL;
	}
	if (_tmp45_) {
		_tmp44_ = TRUE;
	} else {
		ValaParserModifierFlags _tmp48_;
		_tmp48_ = flags;
		_tmp44_ = (_tmp48_ & VALA_PARSER_MODIFIER_FLAGS_OVERRIDE) == VALA_PARSER_MODIFIER_FLAGS_OVERRIDE;
	}
	if (_tmp44_) {
		ValaField* _tmp49_;
		ValaSourceReference* _tmp50_;
		ValaSourceReference* _tmp51_;
		_tmp49_ = f;
		_tmp50_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp49_);
		_tmp51_ = _tmp50_;
		vala_report_error (_tmp51_, "abstract, virtual, and override modifiers are not applicable to fields");
	}
	_tmp52_ = flags;
	if ((_tmp52_ & VALA_PARSER_MODIFIER_FLAGS_EXTERN) == VALA_PARSER_MODIFIER_FLAGS_EXTERN) {
		ValaField* _tmp53_;
		_tmp53_ = f;
		vala_symbol_set_is_extern ((ValaSymbol*) _tmp53_, TRUE);
	}
	_tmp54_ = flags;
	if ((_tmp54_ & VALA_PARSER_MODIFIER_FLAGS_NEW) == VALA_PARSER_MODIFIER_FLAGS_NEW) {
		ValaField* _tmp55_;
		_tmp55_ = f;
		vala_symbol_set_hides ((ValaSymbol*) _tmp55_, TRUE);
	}
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_ASSIGN)) {
		ValaExpression* _tmp56_ = NULL;
		ValaExpression* _tmp57_;
		ValaField* _tmp58_;
		_tmp57_ = vala_parser_parse_expression (self, &_inner_error0_);
		_tmp56_ = _tmp57_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (f);
				_vala_code_node_unref0 (_tmp4_);
				_g_free0 (id);
				_vala_code_node_unref0 (type);
				return;
			} else {
				_vala_code_node_unref0 (f);
				_vala_code_node_unref0 (_tmp4_);
				_g_free0 (id);
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp58_ = f;
		vala_variable_set_initializer ((ValaVariable*) _tmp58_, _tmp56_);
		_vala_code_node_unref0 (_tmp56_);
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (f);
			_vala_code_node_unref0 (_tmp4_);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (f);
			_vala_code_node_unref0 (_tmp4_);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp59_ = f;
	vala_symbol_add_field (parent, _tmp59_);
	_vala_code_node_unref0 (f);
	_vala_code_node_unref0 (_tmp4_);
	_g_free0 (id);
	_vala_code_node_unref0 (type);
}

static ValaInitializerList*
vala_parser_parse_initializer (ValaParser* self,
                               GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaInitializerList* initializer = NULL;
	ValaSourceLocation _tmp1_;
	ValaSourceReference* _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaInitializerList* _tmp4_;
	ValaInitializerList* _tmp5_;
	ValaInitializerList* _tmp17_;
	ValaSourceLocation _tmp18_;
	ValaSourceReference* _tmp19_;
	ValaSourceReference* _tmp20_;
	GError* _inner_error0_ = NULL;
	ValaInitializerList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_BRACE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = begin;
	_tmp2_ = vala_parser_get_src (self, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = vala_initializer_list_new (_tmp3_);
	_tmp5_ = _tmp4_;
	_vala_source_reference_unref0 (_tmp3_);
	initializer = _tmp5_;
	while (TRUE) {
		if (!(vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_BRACE)) {
			break;
		}
		{
			ValaExpression* _tmp6_ = NULL;
			ValaExpression* _tmp7_;
			ValaInitializerList* _tmp8_;
			_tmp7_ = vala_parser_parse_argument (self, &_inner_error0_);
			_tmp6_ = _tmp7_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					goto __catch0_vala_parse_error;
				}
				_vala_code_node_unref0 (initializer);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
			_tmp8_ = initializer;
			vala_initializer_list_append (_tmp8_, _tmp6_);
			_vala_code_node_unref0 (_tmp6_);
		}
		goto __finally0;
		__catch0_vala_parse_error:
		{
			GError* e = NULL;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			if (vala_parser_current (self) == VALA_TOKEN_TYPE_CLOSE_BRACE) {
				GError* _tmp9_;
				GError* _tmp10_;
				vala_parser_prev (self);
				_tmp9_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "incomplete initializer");
				_tmp10_ = _tmp9_;
				vala_parser_report_parse_error (self, _tmp10_);
				_g_error_free0 (_tmp10_);
			} else {
				ValaCodeContext* _tmp11_;
				gboolean _tmp12_;
				gboolean _tmp13_;
				_tmp11_ = self->priv->context;
				_tmp12_ = vala_code_context_get_keep_going (_tmp11_);
				_tmp13_ = _tmp12_;
				if (_tmp13_) {
					GError* _tmp14_;
					_tmp14_ = e;
					vala_parser_report_parse_error (self, _tmp14_);
				} else {
					GError* _tmp15_;
					GError* _tmp16_;
					_tmp15_ = e;
					_tmp16_ = _g_error_copy0 (_tmp15_);
					_inner_error0_ = _tmp16_;
					_g_error_free0 (e);
					goto __finally0;
				}
			}
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (initializer);
				return NULL;
			} else {
				_vala_code_node_unref0 (initializer);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
			break;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_BRACE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (initializer);
			return NULL;
		} else {
			_vala_code_node_unref0 (initializer);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp17_ = initializer;
	_tmp18_ = begin;
	_tmp19_ = vala_parser_get_src (self, &_tmp18_);
	_tmp20_ = _tmp19_;
	vala_code_node_set_source_reference ((ValaCodeNode*) _tmp17_, _tmp20_);
	_vala_source_reference_unref0 (_tmp20_);
	result = initializer;
	return result;
}

static void
vala_parser_parse_method_declaration (ValaParser* self,
                                      ValaSymbol* parent,
                                      ValaList* attrs,
                                      GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSymbolAccessibility access = 0;
	ValaParserModifierFlags flags = 0U;
	ValaDataType* type = NULL;
	ValaDataType* _tmp1_;
	ValaUnresolvedSymbol* sym = NULL;
	ValaUnresolvedSymbol* _tmp2_;
	ValaList* type_param_list = NULL;
	ValaList* _tmp3_;
	ValaMethod* method = NULL;
	ValaUnresolvedSymbol* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	ValaDataType* _tmp7_;
	ValaSourceLocation _tmp8_;
	ValaSourceReference* _tmp9_;
	ValaSourceReference* _tmp10_;
	ValaComment* _tmp11_;
	ValaMethod* _tmp12_;
	ValaMethod* _tmp13_;
	ValaUnresolvedSymbol* _tmp14_;
	ValaUnresolvedSymbol* _tmp15_;
	ValaUnresolvedSymbol* _tmp16_;
	ValaMethod* _tmp28_;
	ValaSymbolAccessibility _tmp29_;
	ValaMethod* _tmp30_;
	gboolean _tmp42_ = FALSE;
	ValaParserModifierFlags _tmp43_;
	ValaParserModifierFlags _tmp53_;
	ValaParserModifierFlags _tmp55_;
	ValaMethod* _tmp57_;
	ValaMemberBinding _tmp58_;
	ValaMemberBinding _tmp59_;
	ValaParserModifierFlags _tmp98_;
	ValaParserModifierFlags _tmp100_;
	ValaMethod* _tmp120_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	access = vala_parser_parse_access_modifier (self, VALA_SYMBOL_ACCESSIBILITY_PRIVATE);
	flags = vala_parser_parse_member_declaration_modifiers (self);
	_tmp1_ = vala_parser_parse_type (self, TRUE, FALSE, FALSE, &_inner_error0_);
	type = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp2_ = vala_parser_parse_symbol_name (self, &_inner_error0_);
	sym = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp3_ = vala_parser_parse_type_parameter_list (self, &_inner_error0_);
	type_param_list = _tmp3_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (sym);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (sym);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp4_ = sym;
	_tmp5_ = vala_symbol_get_name ((ValaSymbol*) _tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = type;
	_tmp8_ = begin;
	_tmp9_ = vala_parser_get_src (self, &_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = self->priv->comment;
	_tmp12_ = vala_method_new (_tmp6_, _tmp7_, _tmp10_, _tmp11_);
	_tmp13_ = _tmp12_;
	_vala_source_reference_unref0 (_tmp10_);
	method = _tmp13_;
	_tmp14_ = sym;
	_tmp15_ = vala_unresolved_symbol_get_inner (_tmp14_);
	_tmp16_ = _tmp15_;
	if (_tmp16_ != NULL) {
		ValaMethod* _tmp17_;
		ValaUnresolvedSymbol* _tmp18_;
		ValaUnresolvedSymbol* _tmp19_;
		ValaUnresolvedSymbol* _tmp20_;
		ValaUnresolvedSymbol* _tmp21_;
		ValaUnresolvedSymbol* _tmp22_;
		ValaUnresolvedSymbol* _tmp23_;
		ValaSourceReference* _tmp24_;
		ValaSourceReference* _tmp25_;
		ValaUnresolvedType* _tmp26_;
		ValaUnresolvedType* _tmp27_;
		_tmp17_ = method;
		_tmp18_ = sym;
		_tmp19_ = vala_unresolved_symbol_get_inner (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = sym;
		_tmp22_ = vala_unresolved_symbol_get_inner (_tmp21_);
		_tmp23_ = _tmp22_;
		_tmp24_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = vala_unresolved_type_new_from_symbol (_tmp20_, _tmp25_);
		_tmp27_ = _tmp26_;
		vala_method_set_base_interface_type (_tmp17_, (ValaDataType*) _tmp27_);
		_vala_code_node_unref0 (_tmp27_);
	}
	_tmp28_ = method;
	_tmp29_ = access;
	vala_symbol_set_access ((ValaSymbol*) _tmp28_, _tmp29_);
	_tmp30_ = method;
	vala_parser_set_attributes (self, (ValaCodeNode*) _tmp30_, attrs);
	{
		ValaList* _type_param_list = NULL;
		ValaList* _tmp31_;
		ValaList* _tmp32_;
		gint _type_param_size = 0;
		ValaList* _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
		gint _type_param_index = 0;
		_tmp31_ = type_param_list;
		_tmp32_ = _vala_iterable_ref0 (_tmp31_);
		_type_param_list = _tmp32_;
		_tmp33_ = _type_param_list;
		_tmp34_ = vala_collection_get_size ((ValaCollection*) _tmp33_);
		_tmp35_ = _tmp34_;
		_type_param_size = _tmp35_;
		_type_param_index = -1;
		while (TRUE) {
			gint _tmp36_;
			gint _tmp37_;
			ValaTypeParameter* type_param = NULL;
			ValaList* _tmp38_;
			gpointer _tmp39_;
			ValaMethod* _tmp40_;
			ValaTypeParameter* _tmp41_;
			_type_param_index = _type_param_index + 1;
			_tmp36_ = _type_param_index;
			_tmp37_ = _type_param_size;
			if (!(_tmp36_ < _tmp37_)) {
				break;
			}
			_tmp38_ = _type_param_list;
			_tmp39_ = vala_list_get (_tmp38_, _type_param_index);
			type_param = (ValaTypeParameter*) _tmp39_;
			_tmp40_ = method;
			_tmp41_ = type_param;
			vala_method_add_type_parameter (_tmp40_, _tmp41_);
			_vala_code_node_unref0 (type_param);
		}
		_vala_iterable_unref0 (_type_param_list);
	}
	_tmp43_ = flags;
	if ((_tmp43_ & VALA_PARSER_MODIFIER_FLAGS_STATIC) == VALA_PARSER_MODIFIER_FLAGS_STATIC) {
		ValaParserModifierFlags _tmp44_;
		_tmp44_ = flags;
		_tmp42_ = (_tmp44_ & VALA_PARSER_MODIFIER_FLAGS_CLASS) == VALA_PARSER_MODIFIER_FLAGS_CLASS;
	} else {
		_tmp42_ = FALSE;
	}
	if (_tmp42_) {
		ValaMethod* _tmp45_;
		ValaSourceReference* _tmp46_;
		ValaSourceReference* _tmp47_;
		_tmp45_ = method;
		_tmp46_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp45_);
		_tmp47_ = _tmp46_;
		vala_report_error (_tmp47_, "only one of `static' or `class' may be specified");
	} else {
		ValaParserModifierFlags _tmp48_;
		_tmp48_ = flags;
		if ((_tmp48_ & VALA_PARSER_MODIFIER_FLAGS_STATIC) == VALA_PARSER_MODIFIER_FLAGS_STATIC) {
			ValaMethod* _tmp49_;
			_tmp49_ = method;
			vala_method_set_binding (_tmp49_, VALA_MEMBER_BINDING_STATIC);
		} else {
			ValaParserModifierFlags _tmp50_;
			_tmp50_ = flags;
			if ((_tmp50_ & VALA_PARSER_MODIFIER_FLAGS_CLASS) == VALA_PARSER_MODIFIER_FLAGS_CLASS) {
				ValaMethod* _tmp51_;
				_tmp51_ = method;
				vala_method_set_binding (_tmp51_, VALA_MEMBER_BINDING_CLASS);
			} else {
				if (VALA_IS_NAMESPACE (parent)) {
					ValaMethod* _tmp52_;
					_tmp52_ = method;
					vala_method_set_binding (_tmp52_, VALA_MEMBER_BINDING_STATIC);
				}
			}
		}
	}
	_tmp53_ = flags;
	if ((_tmp53_ & VALA_PARSER_MODIFIER_FLAGS_ASYNC) == VALA_PARSER_MODIFIER_FLAGS_ASYNC) {
		ValaMethod* _tmp54_;
		_tmp54_ = method;
		vala_method_set_coroutine (_tmp54_, TRUE);
	}
	_tmp55_ = flags;
	if ((_tmp55_ & VALA_PARSER_MODIFIER_FLAGS_NEW) == VALA_PARSER_MODIFIER_FLAGS_NEW) {
		ValaMethod* _tmp56_;
		_tmp56_ = method;
		vala_symbol_set_hides ((ValaSymbol*) _tmp56_, TRUE);
	}
	_tmp57_ = method;
	_tmp58_ = vala_method_get_binding (_tmp57_);
	_tmp59_ = _tmp58_;
	if (_tmp59_ == VALA_MEMBER_BINDING_INSTANCE) {
		ValaParserModifierFlags _tmp60_;
		ValaParserModifierFlags _tmp62_;
		ValaParserModifierFlags _tmp64_;
		gboolean _tmp66_ = FALSE;
		gboolean _tmp67_ = FALSE;
		gboolean _tmp68_ = FALSE;
		ValaMethod* _tmp69_;
		gboolean _tmp70_;
		gboolean _tmp71_;
		_tmp60_ = flags;
		if ((_tmp60_ & VALA_PARSER_MODIFIER_FLAGS_ABSTRACT) == VALA_PARSER_MODIFIER_FLAGS_ABSTRACT) {
			ValaMethod* _tmp61_;
			_tmp61_ = method;
			vala_method_set_is_abstract (_tmp61_, TRUE);
		}
		_tmp62_ = flags;
		if ((_tmp62_ & VALA_PARSER_MODIFIER_FLAGS_VIRTUAL) == VALA_PARSER_MODIFIER_FLAGS_VIRTUAL) {
			ValaMethod* _tmp63_;
			_tmp63_ = method;
			vala_method_set_is_virtual (_tmp63_, TRUE);
		}
		_tmp64_ = flags;
		if ((_tmp64_ & VALA_PARSER_MODIFIER_FLAGS_OVERRIDE) == VALA_PARSER_MODIFIER_FLAGS_OVERRIDE) {
			ValaMethod* _tmp65_;
			_tmp65_ = method;
			vala_method_set_overrides (_tmp65_, TRUE);
		}
		_tmp69_ = method;
		_tmp70_ = vala_method_get_is_abstract (_tmp69_);
		_tmp71_ = _tmp70_;
		if (_tmp71_) {
			ValaMethod* _tmp72_;
			gboolean _tmp73_;
			gboolean _tmp74_;
			_tmp72_ = method;
			_tmp73_ = vala_method_get_is_virtual (_tmp72_);
			_tmp74_ = _tmp73_;
			_tmp68_ = _tmp74_;
		} else {
			_tmp68_ = FALSE;
		}
		if (_tmp68_) {
			_tmp67_ = TRUE;
		} else {
			gboolean _tmp75_ = FALSE;
			ValaMethod* _tmp76_;
			gboolean _tmp77_;
			gboolean _tmp78_;
			_tmp76_ = method;
			_tmp77_ = vala_method_get_is_abstract (_tmp76_);
			_tmp78_ = _tmp77_;
			if (_tmp78_) {
				ValaMethod* _tmp79_;
				gboolean _tmp80_;
				gboolean _tmp81_;
				_tmp79_ = method;
				_tmp80_ = vala_method_get_overrides (_tmp79_);
				_tmp81_ = _tmp80_;
				_tmp75_ = _tmp81_;
			} else {
				_tmp75_ = FALSE;
			}
			_tmp67_ = _tmp75_;
		}
		if (_tmp67_) {
			_tmp66_ = TRUE;
		} else {
			gboolean _tmp82_ = FALSE;
			ValaMethod* _tmp83_;
			gboolean _tmp84_;
			gboolean _tmp85_;
			_tmp83_ = method;
			_tmp84_ = vala_method_get_is_virtual (_tmp83_);
			_tmp85_ = _tmp84_;
			if (_tmp85_) {
				ValaMethod* _tmp86_;
				gboolean _tmp87_;
				gboolean _tmp88_;
				_tmp86_ = method;
				_tmp87_ = vala_method_get_overrides (_tmp86_);
				_tmp88_ = _tmp87_;
				_tmp82_ = _tmp88_;
			} else {
				_tmp82_ = FALSE;
			}
			_tmp66_ = _tmp82_;
		}
		if (_tmp66_) {
			GError* _tmp89_;
			_tmp89_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "only one of `abstract', `virtual', or `override' may be specified");
			_inner_error0_ = _tmp89_;
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				return;
			} else {
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	} else {
		gboolean _tmp90_ = FALSE;
		gboolean _tmp91_ = FALSE;
		ValaParserModifierFlags _tmp92_;
		_tmp92_ = flags;
		if ((_tmp92_ & VALA_PARSER_MODIFIER_FLAGS_ABSTRACT) == VALA_PARSER_MODIFIER_FLAGS_ABSTRACT) {
			_tmp91_ = TRUE;
		} else {
			ValaParserModifierFlags _tmp93_;
			_tmp93_ = flags;
			_tmp91_ = (_tmp93_ & VALA_PARSER_MODIFIER_FLAGS_VIRTUAL) == VALA_PARSER_MODIFIER_FLAGS_VIRTUAL;
		}
		if (_tmp91_) {
			_tmp90_ = TRUE;
		} else {
			ValaParserModifierFlags _tmp94_;
			_tmp94_ = flags;
			_tmp90_ = (_tmp94_ & VALA_PARSER_MODIFIER_FLAGS_OVERRIDE) == VALA_PARSER_MODIFIER_FLAGS_OVERRIDE;
		}
		if (_tmp90_) {
			const gchar* _tmp95_ = NULL;
			ValaParserModifierFlags _tmp96_;
			GError* _tmp97_;
			_tmp96_ = flags;
			if ((_tmp96_ & VALA_PARSER_MODIFIER_FLAGS_CLASS) == VALA_PARSER_MODIFIER_FLAGS_CLASS) {
				_tmp95_ = "class";
			} else {
				_tmp95_ = "static";
			}
			_tmp97_ = g_error_new (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "the modifiers `abstract', `virtual', and `override' are not valid for " \
"%s methods", _tmp95_);
			_inner_error0_ = _tmp97_;
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				return;
			} else {
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	_tmp98_ = flags;
	if ((_tmp98_ & VALA_PARSER_MODIFIER_FLAGS_INLINE) == VALA_PARSER_MODIFIER_FLAGS_INLINE) {
		ValaMethod* _tmp99_;
		_tmp99_ = method;
		vala_method_set_is_inline (_tmp99_, TRUE);
	}
	_tmp100_ = flags;
	if ((_tmp100_ & VALA_PARSER_MODIFIER_FLAGS_EXTERN) == VALA_PARSER_MODIFIER_FLAGS_EXTERN) {
		ValaMethod* _tmp101_;
		_tmp101_ = method;
		vala_symbol_set_is_extern ((ValaSymbol*) _tmp101_, TRUE);
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (method);
			_vala_iterable_unref0 (type_param_list);
			_vala_code_node_unref0 (sym);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (method);
			_vala_iterable_unref0 (type_param_list);
			_vala_code_node_unref0 (sym);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	if (vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_PARENS) {
		{
			gboolean _tmp102_ = FALSE;
			_tmp102_ = TRUE;
			while (TRUE) {
				ValaParameter* param = NULL;
				ValaParameter* _tmp103_;
				ValaMethod* _tmp104_;
				ValaParameter* _tmp105_;
				if (!_tmp102_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp102_ = FALSE;
				_tmp103_ = vala_parser_parse_parameter (self, &_inner_error0_);
				param = _tmp103_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (method);
						_vala_iterable_unref0 (type_param_list);
						_vala_code_node_unref0 (sym);
						_vala_code_node_unref0 (type);
						return;
					} else {
						_vala_code_node_unref0 (method);
						_vala_iterable_unref0 (type_param_list);
						_vala_code_node_unref0 (sym);
						_vala_code_node_unref0 (type);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_tmp104_ = method;
				_tmp105_ = param;
				vala_callable_add_parameter ((ValaCallable*) _tmp104_, _tmp105_);
				_vala_code_node_unref0 (param);
			}
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (method);
			_vala_iterable_unref0 (type_param_list);
			_vala_code_node_unref0 (sym);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (method);
			_vala_iterable_unref0 (type_param_list);
			_vala_code_node_unref0 (sym);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_THROWS)) {
		{
			gboolean _tmp106_ = FALSE;
			_tmp106_ = TRUE;
			while (TRUE) {
				ValaDataType* _tmp107_ = NULL;
				ValaDataType* _tmp108_;
				ValaMethod* _tmp109_;
				if (!_tmp106_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp106_ = FALSE;
				_tmp108_ = vala_parser_parse_type (self, TRUE, FALSE, FALSE, &_inner_error0_);
				_tmp107_ = _tmp108_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (method);
						_vala_iterable_unref0 (type_param_list);
						_vala_code_node_unref0 (sym);
						_vala_code_node_unref0 (type);
						return;
					} else {
						_vala_code_node_unref0 (method);
						_vala_iterable_unref0 (type_param_list);
						_vala_code_node_unref0 (sym);
						_vala_code_node_unref0 (type);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_tmp109_ = method;
				vala_method_add_error_type (_tmp109_, _tmp107_);
				_vala_code_node_unref0 (_tmp107_);
			}
		}
	}
	while (TRUE) {
		ValaExpression* _tmp110_ = NULL;
		ValaExpression* _tmp111_;
		ValaMethod* _tmp112_;
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_REQUIRES)) {
			break;
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				return;
			} else {
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp111_ = vala_parser_parse_expression (self, &_inner_error0_);
		_tmp110_ = _tmp111_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				return;
			} else {
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp112_ = method;
		vala_method_add_precondition (_tmp112_, _tmp110_);
		vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (_tmp110_);
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				return;
			} else {
				_vala_code_node_unref0 (_tmp110_);
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_vala_code_node_unref0 (_tmp110_);
	}
	while (TRUE) {
		ValaExpression* _tmp113_ = NULL;
		ValaExpression* _tmp114_;
		ValaMethod* _tmp115_;
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_ENSURES)) {
			break;
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				return;
			} else {
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp114_ = vala_parser_parse_expression (self, &_inner_error0_);
		_tmp113_ = _tmp114_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				return;
			} else {
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp115_ = method;
		vala_method_add_postcondition (_tmp115_, _tmp113_);
		vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (_tmp113_);
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				return;
			} else {
				_vala_code_node_unref0 (_tmp113_);
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_vala_code_node_unref0 (_tmp113_);
	}
	if (!vala_parser_accept (self, VALA_TOKEN_TYPE_SEMICOLON)) {
		ValaBlock* _tmp116_ = NULL;
		ValaBlock* _tmp117_;
		ValaMethod* _tmp118_;
		ValaMethod* _tmp119_;
		_tmp117_ = vala_parser_parse_block (self, &_inner_error0_);
		_tmp116_ = _tmp117_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				return;
			} else {
				_vala_code_node_unref0 (method);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp118_ = method;
		vala_subroutine_set_body ((ValaSubroutine*) _tmp118_, _tmp116_);
		_tmp119_ = method;
		vala_symbol_set_external ((ValaSymbol*) _tmp119_, FALSE);
		_vala_code_node_unref0 (_tmp116_);
	}
	_tmp120_ = method;
	vala_symbol_add_method (parent, _tmp120_);
	_vala_code_node_unref0 (method);
	_vala_iterable_unref0 (type_param_list);
	_vala_code_node_unref0 (sym);
	_vala_code_node_unref0 (type);
}

static void
vala_parser_parse_property_declaration (ValaParser* self,
                                        ValaSymbol* parent,
                                        ValaList* attrs,
                                        GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSymbolAccessibility access = 0;
	ValaParserModifierFlags flags = 0U;
	ValaDataType* type = NULL;
	ValaDataType* _tmp1_;
	gchar* id = NULL;
	gchar* _tmp2_;
	ValaProperty* prop = NULL;
	const gchar* _tmp3_;
	ValaDataType* _tmp4_;
	ValaSourceLocation _tmp5_;
	ValaSourceReference* _tmp6_;
	ValaSourceReference* _tmp7_;
	ValaComment* _tmp8_;
	ValaProperty* _tmp9_;
	ValaProperty* _tmp10_;
	ValaProperty* _tmp11_;
	ValaSymbolAccessibility _tmp12_;
	ValaProperty* _tmp13_;
	gboolean _tmp14_ = FALSE;
	ValaParserModifierFlags _tmp15_;
	ValaParserModifierFlags _tmp24_;
	ValaParserModifierFlags _tmp26_;
	ValaParserModifierFlags _tmp28_;
	ValaParserModifierFlags _tmp30_;
	ValaParserModifierFlags _tmp32_;
	ValaParserModifierFlags _tmp36_;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp39_ = FALSE;
	gboolean _tmp40_ = FALSE;
	ValaProperty* _tmp41_;
	gboolean _tmp42_;
	gboolean _tmp43_;
	ValaProperty* _tmp144_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	access = vala_parser_parse_access_modifier (self, VALA_SYMBOL_ACCESSIBILITY_PRIVATE);
	flags = vala_parser_parse_member_declaration_modifiers (self);
	_tmp1_ = vala_parser_parse_type (self, TRUE, TRUE, FALSE, &_inner_error0_);
	type = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp2_ = vala_parser_parse_identifier (self, &_inner_error0_);
	id = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp3_ = id;
	_tmp4_ = type;
	_tmp5_ = begin;
	_tmp6_ = vala_parser_get_src (self, &_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = self->priv->comment;
	_tmp9_ = vala_property_new (_tmp3_, _tmp4_, NULL, NULL, _tmp7_, _tmp8_);
	_tmp10_ = _tmp9_;
	_vala_source_reference_unref0 (_tmp7_);
	prop = _tmp10_;
	_tmp11_ = prop;
	_tmp12_ = access;
	vala_symbol_set_access ((ValaSymbol*) _tmp11_, _tmp12_);
	_tmp13_ = prop;
	vala_parser_set_attributes (self, (ValaCodeNode*) _tmp13_, attrs);
	_tmp15_ = flags;
	if ((_tmp15_ & VALA_PARSER_MODIFIER_FLAGS_STATIC) == VALA_PARSER_MODIFIER_FLAGS_STATIC) {
		ValaParserModifierFlags _tmp16_;
		_tmp16_ = flags;
		_tmp14_ = (_tmp16_ & VALA_PARSER_MODIFIER_FLAGS_CLASS) == VALA_PARSER_MODIFIER_FLAGS_CLASS;
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		ValaProperty* _tmp17_;
		ValaSourceReference* _tmp18_;
		ValaSourceReference* _tmp19_;
		_tmp17_ = prop;
		_tmp18_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp17_);
		_tmp19_ = _tmp18_;
		vala_report_error (_tmp19_, "only one of `static' or `class' may be specified");
	} else {
		ValaParserModifierFlags _tmp20_;
		_tmp20_ = flags;
		if ((_tmp20_ & VALA_PARSER_MODIFIER_FLAGS_STATIC) == VALA_PARSER_MODIFIER_FLAGS_STATIC) {
			ValaProperty* _tmp21_;
			_tmp21_ = prop;
			vala_property_set_binding (_tmp21_, VALA_MEMBER_BINDING_STATIC);
		} else {
			ValaParserModifierFlags _tmp22_;
			_tmp22_ = flags;
			if ((_tmp22_ & VALA_PARSER_MODIFIER_FLAGS_CLASS) == VALA_PARSER_MODIFIER_FLAGS_CLASS) {
				ValaProperty* _tmp23_;
				_tmp23_ = prop;
				vala_property_set_binding (_tmp23_, VALA_MEMBER_BINDING_CLASS);
			}
		}
	}
	_tmp24_ = flags;
	if ((_tmp24_ & VALA_PARSER_MODIFIER_FLAGS_ABSTRACT) == VALA_PARSER_MODIFIER_FLAGS_ABSTRACT) {
		ValaProperty* _tmp25_;
		_tmp25_ = prop;
		vala_property_set_is_abstract (_tmp25_, TRUE);
	}
	_tmp26_ = flags;
	if ((_tmp26_ & VALA_PARSER_MODIFIER_FLAGS_VIRTUAL) == VALA_PARSER_MODIFIER_FLAGS_VIRTUAL) {
		ValaProperty* _tmp27_;
		_tmp27_ = prop;
		vala_property_set_is_virtual (_tmp27_, TRUE);
	}
	_tmp28_ = flags;
	if ((_tmp28_ & VALA_PARSER_MODIFIER_FLAGS_OVERRIDE) == VALA_PARSER_MODIFIER_FLAGS_OVERRIDE) {
		ValaProperty* _tmp29_;
		_tmp29_ = prop;
		vala_property_set_overrides (_tmp29_, TRUE);
	}
	_tmp30_ = flags;
	if ((_tmp30_ & VALA_PARSER_MODIFIER_FLAGS_NEW) == VALA_PARSER_MODIFIER_FLAGS_NEW) {
		ValaProperty* _tmp31_;
		_tmp31_ = prop;
		vala_symbol_set_hides ((ValaSymbol*) _tmp31_, TRUE);
	}
	_tmp32_ = flags;
	if ((_tmp32_ & VALA_PARSER_MODIFIER_FLAGS_ASYNC) == VALA_PARSER_MODIFIER_FLAGS_ASYNC) {
		ValaProperty* _tmp33_;
		ValaSourceReference* _tmp34_;
		ValaSourceReference* _tmp35_;
		_tmp33_ = prop;
		_tmp34_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp33_);
		_tmp35_ = _tmp34_;
		vala_report_error (_tmp35_, "async properties are not supported yet");
	}
	_tmp36_ = flags;
	if ((_tmp36_ & VALA_PARSER_MODIFIER_FLAGS_EXTERN) == VALA_PARSER_MODIFIER_FLAGS_EXTERN) {
		ValaProperty* _tmp37_;
		_tmp37_ = prop;
		vala_symbol_set_is_extern ((ValaSymbol*) _tmp37_, TRUE);
	}
	_tmp41_ = prop;
	_tmp42_ = vala_property_get_is_abstract (_tmp41_);
	_tmp43_ = _tmp42_;
	if (_tmp43_) {
		ValaProperty* _tmp44_;
		gboolean _tmp45_;
		gboolean _tmp46_;
		_tmp44_ = prop;
		_tmp45_ = vala_property_get_is_virtual (_tmp44_);
		_tmp46_ = _tmp45_;
		_tmp40_ = _tmp46_;
	} else {
		_tmp40_ = FALSE;
	}
	if (_tmp40_) {
		_tmp39_ = TRUE;
	} else {
		gboolean _tmp47_ = FALSE;
		ValaProperty* _tmp48_;
		gboolean _tmp49_;
		gboolean _tmp50_;
		_tmp48_ = prop;
		_tmp49_ = vala_property_get_is_abstract (_tmp48_);
		_tmp50_ = _tmp49_;
		if (_tmp50_) {
			ValaProperty* _tmp51_;
			gboolean _tmp52_;
			gboolean _tmp53_;
			_tmp51_ = prop;
			_tmp52_ = vala_property_get_overrides (_tmp51_);
			_tmp53_ = _tmp52_;
			_tmp47_ = _tmp53_;
		} else {
			_tmp47_ = FALSE;
		}
		_tmp39_ = _tmp47_;
	}
	if (_tmp39_) {
		_tmp38_ = TRUE;
	} else {
		gboolean _tmp54_ = FALSE;
		ValaProperty* _tmp55_;
		gboolean _tmp56_;
		gboolean _tmp57_;
		_tmp55_ = prop;
		_tmp56_ = vala_property_get_is_virtual (_tmp55_);
		_tmp57_ = _tmp56_;
		if (_tmp57_) {
			ValaProperty* _tmp58_;
			gboolean _tmp59_;
			gboolean _tmp60_;
			_tmp58_ = prop;
			_tmp59_ = vala_property_get_overrides (_tmp58_);
			_tmp60_ = _tmp59_;
			_tmp54_ = _tmp60_;
		} else {
			_tmp54_ = FALSE;
		}
		_tmp38_ = _tmp54_;
	}
	if (_tmp38_) {
		GError* _tmp61_;
		_tmp61_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "only one of `abstract', `virtual', or `override' may be specified");
		_inner_error0_ = _tmp61_;
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (prop);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (prop);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_THROWS)) {
		ValaProperty* _tmp65_;
		ValaSourceReference* _tmp66_;
		ValaSourceReference* _tmp67_;
		{
			gboolean _tmp62_ = FALSE;
			_tmp62_ = TRUE;
			while (TRUE) {
				ValaDataType* _tmp63_;
				ValaDataType* _tmp64_;
				if (!_tmp62_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp62_ = FALSE;
				_tmp63_ = vala_parser_parse_type (self, TRUE, FALSE, FALSE, &_inner_error0_);
				_tmp64_ = _tmp63_;
				_vala_code_node_unref0 (_tmp64_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (prop);
						_g_free0 (id);
						_vala_code_node_unref0 (type);
						return;
					} else {
						_vala_code_node_unref0 (prop);
						_g_free0 (id);
						_vala_code_node_unref0 (type);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
			}
		}
		_tmp65_ = prop;
		_tmp66_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp65_);
		_tmp67_ = _tmp66_;
		vala_report_error (_tmp67_, "properties throwing errors are not supported yet");
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_BRACE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (prop);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (prop);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	while (TRUE) {
		if (!(vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_BRACE)) {
			break;
		}
		if (vala_parser_accept (self, VALA_TOKEN_TYPE_DEFAULT)) {
			ValaProperty* _tmp68_;
			ValaExpression* _tmp69_;
			ValaExpression* _tmp70_;
			ValaExpression* _tmp72_ = NULL;
			ValaExpression* _tmp73_;
			ValaProperty* _tmp74_;
			_tmp68_ = prop;
			_tmp69_ = vala_property_get_initializer (_tmp68_);
			_tmp70_ = _tmp69_;
			if (_tmp70_ != NULL) {
				GError* _tmp71_;
				_tmp71_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "property default value already defined");
				_inner_error0_ = _tmp71_;
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (prop);
					_g_free0 (id);
					_vala_code_node_unref0 (type);
					return;
				} else {
					_vala_code_node_unref0 (prop);
					_g_free0 (id);
					_vala_code_node_unref0 (type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			vala_parser_expect (self, VALA_TOKEN_TYPE_ASSIGN, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (prop);
					_g_free0 (id);
					_vala_code_node_unref0 (type);
					return;
				} else {
					_vala_code_node_unref0 (prop);
					_g_free0 (id);
					_vala_code_node_unref0 (type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_tmp73_ = vala_parser_parse_expression (self, &_inner_error0_);
			_tmp72_ = _tmp73_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (prop);
					_g_free0 (id);
					_vala_code_node_unref0 (type);
					return;
				} else {
					_vala_code_node_unref0 (prop);
					_g_free0 (id);
					_vala_code_node_unref0 (type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_tmp74_ = prop;
			vala_property_set_initializer (_tmp74_, _tmp72_);
			vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (_tmp72_);
					_vala_code_node_unref0 (prop);
					_g_free0 (id);
					_vala_code_node_unref0 (type);
					return;
				} else {
					_vala_code_node_unref0 (_tmp72_);
					_vala_code_node_unref0 (prop);
					_g_free0 (id);
					_vala_code_node_unref0 (type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_vala_code_node_unref0 (_tmp72_);
		} else {
			ValaScanner* _tmp75_;
			ValaComment* _tmp76_;
			ValaSourceLocation accessor_begin = {0};
			ValaSourceLocation _tmp77_ = {0};
			ValaList* accessor_attrs = NULL;
			ValaList* _tmp78_;
			ValaSymbolAccessibility accessor_access = 0;
			ValaDataType* value_type = NULL;
			ValaDataType* _tmp79_;
			ValaDataType* _tmp80_;
			_tmp75_ = self->priv->scanner;
			_tmp76_ = vala_scanner_pop_comment (_tmp75_);
			_vala_comment_unref0 (self->priv->comment);
			self->priv->comment = _tmp76_;
			vala_parser_get_location (self, &_tmp77_);
			accessor_begin = _tmp77_;
			_tmp78_ = vala_parser_parse_attributes (self, &_inner_error0_);
			accessor_attrs = _tmp78_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (prop);
					_g_free0 (id);
					_vala_code_node_unref0 (type);
					return;
				} else {
					_vala_code_node_unref0 (prop);
					_g_free0 (id);
					_vala_code_node_unref0 (type);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			accessor_access = vala_parser_parse_access_modifier (self, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
			_tmp79_ = type;
			_tmp80_ = vala_data_type_copy (_tmp79_);
			value_type = _tmp80_;
			if (vala_parser_accept (self, VALA_TOKEN_TYPE_OWNED)) {
				ValaDataType* _tmp81_;
				_tmp81_ = value_type;
				vala_data_type_set_value_owned (_tmp81_, TRUE);
			} else {
				ValaDataType* _tmp82_;
				_tmp82_ = value_type;
				vala_data_type_set_value_owned (_tmp82_, FALSE);
				if (vala_parser_accept (self, VALA_TOKEN_TYPE_UNOWNED)) {
					ValaSourceReference* _tmp83_;
					ValaSourceReference* _tmp84_;
					_tmp83_ = vala_parser_get_last_src (self);
					_tmp84_ = _tmp83_;
					vala_report_warning (_tmp84_, "property getters are `unowned' by default");
					_vala_source_reference_unref0 (_tmp84_);
				}
			}
			if (vala_parser_accept (self, VALA_TOKEN_TYPE_GET)) {
				ValaProperty* _tmp85_;
				ValaPropertyAccessor* _tmp86_;
				ValaPropertyAccessor* _tmp87_;
				ValaBlock* block = NULL;
				ValaProperty* _tmp93_;
				ValaDataType* _tmp94_;
				ValaBlock* _tmp95_;
				ValaSourceLocation _tmp96_;
				ValaSourceReference* _tmp97_;
				ValaSourceReference* _tmp98_;
				ValaComment* _tmp99_;
				ValaPropertyAccessor* _tmp100_;
				ValaPropertyAccessor* _tmp101_;
				ValaProperty* _tmp102_;
				ValaPropertyAccessor* _tmp103_;
				ValaPropertyAccessor* _tmp104_;
				ValaList* _tmp105_;
				ValaProperty* _tmp106_;
				ValaPropertyAccessor* _tmp107_;
				ValaPropertyAccessor* _tmp108_;
				ValaSymbolAccessibility _tmp109_;
				_tmp85_ = prop;
				_tmp86_ = vala_property_get_get_accessor (_tmp85_);
				_tmp87_ = _tmp86_;
				if (_tmp87_ != NULL) {
					GError* _tmp88_;
					_tmp88_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "property get accessor already defined");
					_inner_error0_ = _tmp88_;
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (value_type);
						_vala_iterable_unref0 (accessor_attrs);
						_vala_code_node_unref0 (prop);
						_g_free0 (id);
						_vala_code_node_unref0 (type);
						return;
					} else {
						_vala_code_node_unref0 (value_type);
						_vala_iterable_unref0 (accessor_attrs);
						_vala_code_node_unref0 (prop);
						_g_free0 (id);
						_vala_code_node_unref0 (type);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				block = NULL;
				if (!vala_parser_accept (self, VALA_TOKEN_TYPE_SEMICOLON)) {
					ValaBlock* _tmp89_ = NULL;
					ValaBlock* _tmp90_;
					ValaBlock* _tmp91_;
					ValaProperty* _tmp92_;
					_tmp90_ = vala_parser_parse_block (self, &_inner_error0_);
					_tmp89_ = _tmp90_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_vala_code_node_unref0 (block);
							_vala_code_node_unref0 (value_type);
							_vala_iterable_unref0 (accessor_attrs);
							_vala_code_node_unref0 (prop);
							_g_free0 (id);
							_vala_code_node_unref0 (type);
							return;
						} else {
							_vala_code_node_unref0 (block);
							_vala_code_node_unref0 (value_type);
							_vala_iterable_unref0 (accessor_attrs);
							_vala_code_node_unref0 (prop);
							_g_free0 (id);
							_vala_code_node_unref0 (type);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
					}
					_tmp91_ = _tmp89_;
					_tmp89_ = NULL;
					_vala_code_node_unref0 (block);
					block = _tmp91_;
					_tmp92_ = prop;
					vala_symbol_set_external ((ValaSymbol*) _tmp92_, FALSE);
					_vala_code_node_unref0 (_tmp89_);
				}
				_tmp93_ = prop;
				_tmp94_ = value_type;
				_tmp95_ = block;
				_tmp96_ = accessor_begin;
				_tmp97_ = vala_parser_get_src (self, &_tmp96_);
				_tmp98_ = _tmp97_;
				_tmp99_ = self->priv->comment;
				_tmp100_ = vala_property_accessor_new (TRUE, FALSE, FALSE, _tmp94_, _tmp95_, _tmp98_, _tmp99_);
				_tmp101_ = _tmp100_;
				vala_property_set_get_accessor (_tmp93_, _tmp101_);
				_vala_code_node_unref0 (_tmp101_);
				_vala_source_reference_unref0 (_tmp98_);
				_tmp102_ = prop;
				_tmp103_ = vala_property_get_get_accessor (_tmp102_);
				_tmp104_ = _tmp103_;
				_tmp105_ = accessor_attrs;
				vala_parser_set_attributes (self, (ValaCodeNode*) _tmp104_, _tmp105_);
				_tmp106_ = prop;
				_tmp107_ = vala_property_get_get_accessor (_tmp106_);
				_tmp108_ = _tmp107_;
				_tmp109_ = accessor_access;
				vala_symbol_set_access ((ValaSymbol*) _tmp108_, _tmp109_);
				_vala_code_node_unref0 (block);
			} else {
				gboolean writable = FALSE;
				gboolean _construct = FALSE;
				ValaProperty* _tmp119_;
				ValaPropertyAccessor* _tmp120_;
				ValaPropertyAccessor* _tmp121_;
				ValaBlock* block = NULL;
				ValaProperty* _tmp127_;
				ValaDataType* _tmp128_;
				ValaBlock* _tmp129_;
				ValaSourceLocation _tmp130_;
				ValaSourceReference* _tmp131_;
				ValaSourceReference* _tmp132_;
				ValaComment* _tmp133_;
				ValaPropertyAccessor* _tmp134_;
				ValaPropertyAccessor* _tmp135_;
				ValaProperty* _tmp136_;
				ValaPropertyAccessor* _tmp137_;
				ValaPropertyAccessor* _tmp138_;
				ValaList* _tmp139_;
				ValaProperty* _tmp140_;
				ValaPropertyAccessor* _tmp141_;
				ValaPropertyAccessor* _tmp142_;
				ValaSymbolAccessibility _tmp143_;
				if (vala_parser_accept (self, VALA_TOKEN_TYPE_SET)) {
					gboolean _tmp110_ = FALSE;
					ValaCodeContext* _tmp111_;
					ValaProfile _tmp112_;
					ValaProfile _tmp113_;
					writable = TRUE;
					_tmp111_ = self->priv->context;
					_tmp112_ = vala_code_context_get_profile (_tmp111_);
					_tmp113_ = _tmp112_;
					if (_tmp113_ == VALA_PROFILE_GOBJECT) {
						_tmp110_ = vala_parser_accept (self, VALA_TOKEN_TYPE_CONSTRUCT);
					} else {
						_tmp110_ = FALSE;
					}
					_construct = _tmp110_;
				} else {
					gboolean _tmp114_ = FALSE;
					ValaCodeContext* _tmp115_;
					ValaProfile _tmp116_;
					ValaProfile _tmp117_;
					_tmp115_ = self->priv->context;
					_tmp116_ = vala_code_context_get_profile (_tmp115_);
					_tmp117_ = _tmp116_;
					if (_tmp117_ == VALA_PROFILE_GOBJECT) {
						_tmp114_ = vala_parser_accept (self, VALA_TOKEN_TYPE_CONSTRUCT);
					} else {
						_tmp114_ = FALSE;
					}
					if (_tmp114_) {
						_construct = TRUE;
						writable = vala_parser_accept (self, VALA_TOKEN_TYPE_SET);
					} else {
						GError* _tmp118_;
						_tmp118_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "expected get, set, or construct");
						_inner_error0_ = _tmp118_;
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_vala_code_node_unref0 (value_type);
							_vala_iterable_unref0 (accessor_attrs);
							_vala_code_node_unref0 (prop);
							_g_free0 (id);
							_vala_code_node_unref0 (type);
							return;
						} else {
							_vala_code_node_unref0 (value_type);
							_vala_iterable_unref0 (accessor_attrs);
							_vala_code_node_unref0 (prop);
							_g_free0 (id);
							_vala_code_node_unref0 (type);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
					}
				}
				_tmp119_ = prop;
				_tmp120_ = vala_property_get_set_accessor (_tmp119_);
				_tmp121_ = _tmp120_;
				if (_tmp121_ != NULL) {
					GError* _tmp122_;
					_tmp122_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "property set accessor already defined");
					_inner_error0_ = _tmp122_;
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (value_type);
						_vala_iterable_unref0 (accessor_attrs);
						_vala_code_node_unref0 (prop);
						_g_free0 (id);
						_vala_code_node_unref0 (type);
						return;
					} else {
						_vala_code_node_unref0 (value_type);
						_vala_iterable_unref0 (accessor_attrs);
						_vala_code_node_unref0 (prop);
						_g_free0 (id);
						_vala_code_node_unref0 (type);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				block = NULL;
				if (!vala_parser_accept (self, VALA_TOKEN_TYPE_SEMICOLON)) {
					ValaBlock* _tmp123_ = NULL;
					ValaBlock* _tmp124_;
					ValaBlock* _tmp125_;
					ValaProperty* _tmp126_;
					_tmp124_ = vala_parser_parse_block (self, &_inner_error0_);
					_tmp123_ = _tmp124_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						if (_inner_error0_->domain == VALA_PARSE_ERROR) {
							g_propagate_error (error, _inner_error0_);
							_vala_code_node_unref0 (block);
							_vala_code_node_unref0 (value_type);
							_vala_iterable_unref0 (accessor_attrs);
							_vala_code_node_unref0 (prop);
							_g_free0 (id);
							_vala_code_node_unref0 (type);
							return;
						} else {
							_vala_code_node_unref0 (block);
							_vala_code_node_unref0 (value_type);
							_vala_iterable_unref0 (accessor_attrs);
							_vala_code_node_unref0 (prop);
							_g_free0 (id);
							_vala_code_node_unref0 (type);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
					}
					_tmp125_ = _tmp123_;
					_tmp123_ = NULL;
					_vala_code_node_unref0 (block);
					block = _tmp125_;
					_tmp126_ = prop;
					vala_symbol_set_external ((ValaSymbol*) _tmp126_, FALSE);
					_vala_code_node_unref0 (_tmp123_);
				}
				_tmp127_ = prop;
				_tmp128_ = value_type;
				_tmp129_ = block;
				_tmp130_ = accessor_begin;
				_tmp131_ = vala_parser_get_src (self, &_tmp130_);
				_tmp132_ = _tmp131_;
				_tmp133_ = self->priv->comment;
				_tmp134_ = vala_property_accessor_new (FALSE, writable, _construct, _tmp128_, _tmp129_, _tmp132_, _tmp133_);
				_tmp135_ = _tmp134_;
				vala_property_set_set_accessor (_tmp127_, _tmp135_);
				_vala_code_node_unref0 (_tmp135_);
				_vala_source_reference_unref0 (_tmp132_);
				_tmp136_ = prop;
				_tmp137_ = vala_property_get_set_accessor (_tmp136_);
				_tmp138_ = _tmp137_;
				_tmp139_ = accessor_attrs;
				vala_parser_set_attributes (self, (ValaCodeNode*) _tmp138_, _tmp139_);
				_tmp140_ = prop;
				_tmp141_ = vala_property_get_set_accessor (_tmp140_);
				_tmp142_ = _tmp141_;
				_tmp143_ = accessor_access;
				vala_symbol_set_access ((ValaSymbol*) _tmp142_, _tmp143_);
				_vala_code_node_unref0 (block);
			}
			_vala_code_node_unref0 (value_type);
			_vala_iterable_unref0 (accessor_attrs);
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_BRACE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (prop);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (prop);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp144_ = prop;
	vala_symbol_add_property (parent, _tmp144_);
	_vala_code_node_unref0 (prop);
	_g_free0 (id);
	_vala_code_node_unref0 (type);
}

static void
vala_parser_parse_signal_declaration (ValaParser* self,
                                      ValaSymbol* parent,
                                      ValaList* attrs,
                                      GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSymbolAccessibility access = 0;
	ValaParserModifierFlags flags = 0U;
	ValaDataType* type = NULL;
	ValaDataType* _tmp1_;
	gchar* id = NULL;
	gchar* _tmp2_;
	ValaSignal* sig = NULL;
	const gchar* _tmp3_;
	ValaDataType* _tmp4_;
	ValaSourceLocation _tmp5_;
	ValaSourceReference* _tmp6_;
	ValaSourceReference* _tmp7_;
	ValaComment* _tmp8_;
	ValaSignal* _tmp9_;
	ValaSignal* _tmp10_;
	ValaSignal* _tmp11_;
	ValaSymbolAccessibility _tmp12_;
	ValaSignal* _tmp13_;
	ValaParserModifierFlags _tmp14_;
	ValaParserModifierFlags _tmp18_;
	ValaParserModifierFlags _tmp20_;
	ValaSignal* _tmp29_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	access = vala_parser_parse_access_modifier (self, VALA_SYMBOL_ACCESSIBILITY_PRIVATE);
	flags = vala_parser_parse_member_declaration_modifiers (self);
	vala_parser_expect (self, VALA_TOKEN_TYPE_SIGNAL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp1_ = vala_parser_parse_type (self, TRUE, FALSE, FALSE, &_inner_error0_);
	type = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp2_ = vala_parser_parse_identifier (self, &_inner_error0_);
	id = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp3_ = id;
	_tmp4_ = type;
	_tmp5_ = begin;
	_tmp6_ = vala_parser_get_src (self, &_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = self->priv->comment;
	_tmp9_ = vala_signal_new (_tmp3_, _tmp4_, _tmp7_, _tmp8_);
	_tmp10_ = _tmp9_;
	_vala_source_reference_unref0 (_tmp7_);
	sig = _tmp10_;
	_tmp11_ = sig;
	_tmp12_ = access;
	vala_symbol_set_access ((ValaSymbol*) _tmp11_, _tmp12_);
	_tmp13_ = sig;
	vala_parser_set_attributes (self, (ValaCodeNode*) _tmp13_, attrs);
	_tmp14_ = flags;
	if ((_tmp14_ & VALA_PARSER_MODIFIER_FLAGS_STATIC) == VALA_PARSER_MODIFIER_FLAGS_STATIC) {
		GError* _tmp15_;
		_tmp15_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "`static' modifier not allowed on signals");
		_inner_error0_ = _tmp15_;
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (sig);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (sig);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	} else {
		ValaParserModifierFlags _tmp16_;
		_tmp16_ = flags;
		if ((_tmp16_ & VALA_PARSER_MODIFIER_FLAGS_CLASS) == VALA_PARSER_MODIFIER_FLAGS_CLASS) {
			GError* _tmp17_;
			_tmp17_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "`class' modifier not allowed on signals");
			_inner_error0_ = _tmp17_;
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (sig);
				_g_free0 (id);
				_vala_code_node_unref0 (type);
				return;
			} else {
				_vala_code_node_unref0 (sig);
				_g_free0 (id);
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	_tmp18_ = flags;
	if ((_tmp18_ & VALA_PARSER_MODIFIER_FLAGS_VIRTUAL) == VALA_PARSER_MODIFIER_FLAGS_VIRTUAL) {
		ValaSignal* _tmp19_;
		_tmp19_ = sig;
		vala_signal_set_is_virtual (_tmp19_, TRUE);
	}
	_tmp20_ = flags;
	if ((_tmp20_ & VALA_PARSER_MODIFIER_FLAGS_NEW) == VALA_PARSER_MODIFIER_FLAGS_NEW) {
		ValaSignal* _tmp21_;
		_tmp21_ = sig;
		vala_symbol_set_hides ((ValaSymbol*) _tmp21_, TRUE);
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (sig);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (sig);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	if (vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_PARENS) {
		{
			gboolean _tmp22_ = FALSE;
			_tmp22_ = TRUE;
			while (TRUE) {
				ValaParameter* param = NULL;
				ValaParameter* _tmp23_;
				ValaSignal* _tmp24_;
				ValaParameter* _tmp25_;
				if (!_tmp22_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp22_ = FALSE;
				_tmp23_ = vala_parser_parse_parameter (self, &_inner_error0_);
				param = _tmp23_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (sig);
						_g_free0 (id);
						_vala_code_node_unref0 (type);
						return;
					} else {
						_vala_code_node_unref0 (sig);
						_g_free0 (id);
						_vala_code_node_unref0 (type);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_tmp24_ = sig;
				_tmp25_ = param;
				vala_callable_add_parameter ((ValaCallable*) _tmp24_, _tmp25_);
				_vala_code_node_unref0 (param);
			}
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (sig);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (sig);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	if (!vala_parser_accept (self, VALA_TOKEN_TYPE_SEMICOLON)) {
		ValaBlock* _tmp26_ = NULL;
		ValaBlock* _tmp27_;
		ValaSignal* _tmp28_;
		_tmp27_ = vala_parser_parse_block (self, &_inner_error0_);
		_tmp26_ = _tmp27_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (sig);
				_g_free0 (id);
				_vala_code_node_unref0 (type);
				return;
			} else {
				_vala_code_node_unref0 (sig);
				_g_free0 (id);
				_vala_code_node_unref0 (type);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp28_ = sig;
		vala_signal_set_body (_tmp28_, _tmp26_);
		_vala_code_node_unref0 (_tmp26_);
	}
	_tmp29_ = sig;
	vala_symbol_add_signal (parent, _tmp29_);
	_vala_code_node_unref0 (sig);
	_g_free0 (id);
	_vala_code_node_unref0 (type);
}

static void
vala_parser_parse_constructor_declaration (ValaParser* self,
                                           ValaSymbol* parent,
                                           ValaList* attrs,
                                           GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaParserModifierFlags flags = 0U;
	ValaParserModifierFlags _tmp1_;
	ValaConstructor* c = NULL;
	ValaSourceLocation _tmp3_;
	ValaSourceReference* _tmp4_;
	ValaSourceReference* _tmp5_;
	ValaConstructor* _tmp6_;
	ValaConstructor* _tmp7_;
	gboolean _tmp8_ = FALSE;
	ValaParserModifierFlags _tmp9_;
	ValaBlock* _tmp18_ = NULL;
	ValaBlock* _tmp19_;
	ValaConstructor* _tmp20_;
	ValaConstructor* _tmp21_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	flags = vala_parser_parse_member_declaration_modifiers (self);
	vala_parser_expect (self, VALA_TOKEN_TYPE_CONSTRUCT, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp1_ = flags;
	if ((_tmp1_ & VALA_PARSER_MODIFIER_FLAGS_NEW) == VALA_PARSER_MODIFIER_FLAGS_NEW) {
		GError* _tmp2_;
		_tmp2_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "`new' modifier not allowed on constructor");
		_inner_error0_ = _tmp2_;
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp3_ = begin;
	_tmp4_ = vala_parser_get_src (self, &_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = vala_constructor_new (_tmp5_);
	_tmp7_ = _tmp6_;
	_vala_source_reference_unref0 (_tmp5_);
	c = _tmp7_;
	_tmp9_ = flags;
	if ((_tmp9_ & VALA_PARSER_MODIFIER_FLAGS_STATIC) == VALA_PARSER_MODIFIER_FLAGS_STATIC) {
		ValaParserModifierFlags _tmp10_;
		_tmp10_ = flags;
		_tmp8_ = (_tmp10_ & VALA_PARSER_MODIFIER_FLAGS_CLASS) == VALA_PARSER_MODIFIER_FLAGS_CLASS;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		ValaConstructor* _tmp11_;
		ValaSourceReference* _tmp12_;
		ValaSourceReference* _tmp13_;
		_tmp11_ = c;
		_tmp12_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp11_);
		_tmp13_ = _tmp12_;
		vala_report_error (_tmp13_, "only one of `static' or `class' may be specified");
	} else {
		ValaParserModifierFlags _tmp14_;
		_tmp14_ = flags;
		if ((_tmp14_ & VALA_PARSER_MODIFIER_FLAGS_STATIC) == VALA_PARSER_MODIFIER_FLAGS_STATIC) {
			ValaConstructor* _tmp15_;
			_tmp15_ = c;
			vala_constructor_set_binding (_tmp15_, VALA_MEMBER_BINDING_STATIC);
		} else {
			ValaParserModifierFlags _tmp16_;
			_tmp16_ = flags;
			if ((_tmp16_ & VALA_PARSER_MODIFIER_FLAGS_CLASS) == VALA_PARSER_MODIFIER_FLAGS_CLASS) {
				ValaConstructor* _tmp17_;
				_tmp17_ = c;
				vala_constructor_set_binding (_tmp17_, VALA_MEMBER_BINDING_CLASS);
			}
		}
	}
	_tmp19_ = vala_parser_parse_block (self, &_inner_error0_);
	_tmp18_ = _tmp19_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (c);
			return;
		} else {
			_vala_code_node_unref0 (c);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp20_ = c;
	vala_subroutine_set_body ((ValaSubroutine*) _tmp20_, _tmp18_);
	_tmp21_ = c;
	vala_symbol_add_constructor (parent, _tmp21_);
	_vala_code_node_unref0 (_tmp18_);
	_vala_code_node_unref0 (c);
}

static void
vala_parser_parse_destructor_declaration (ValaParser* self,
                                          ValaSymbol* parent,
                                          ValaList* attrs,
                                          GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaParserModifierFlags flags = 0U;
	gchar* identifier = NULL;
	gchar* _tmp1_;
	ValaParserModifierFlags _tmp2_;
	ValaDestructor* d = NULL;
	ValaSourceLocation _tmp4_;
	ValaSourceReference* _tmp5_;
	ValaSourceReference* _tmp6_;
	ValaDestructor* _tmp7_;
	ValaDestructor* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gboolean _tmp15_ = FALSE;
	ValaParserModifierFlags _tmp16_;
	ValaBlock* _tmp25_ = NULL;
	ValaBlock* _tmp26_;
	ValaDestructor* _tmp27_;
	ValaDestructor* _tmp28_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	flags = vala_parser_parse_member_declaration_modifiers (self);
	vala_parser_expect (self, VALA_TOKEN_TYPE_TILDE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp1_ = vala_parser_parse_identifier (self, &_inner_error0_);
	identifier = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (identifier);
			return;
		} else {
			_g_free0 (identifier);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (identifier);
			return;
		} else {
			_g_free0 (identifier);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp2_ = flags;
	if ((_tmp2_ & VALA_PARSER_MODIFIER_FLAGS_NEW) == VALA_PARSER_MODIFIER_FLAGS_NEW) {
		GError* _tmp3_;
		_tmp3_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "`new' modifier not allowed on destructor");
		_inner_error0_ = _tmp3_;
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (identifier);
			return;
		} else {
			_g_free0 (identifier);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp4_ = begin;
	_tmp5_ = vala_parser_get_src (self, &_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = vala_destructor_new (_tmp6_);
	_tmp8_ = _tmp7_;
	_vala_source_reference_unref0 (_tmp6_);
	d = _tmp8_;
	_tmp9_ = identifier;
	_tmp10_ = vala_symbol_get_name (parent);
	_tmp11_ = _tmp10_;
	if (g_strcmp0 (_tmp9_, _tmp11_) != 0) {
		ValaDestructor* _tmp12_;
		ValaSourceReference* _tmp13_;
		ValaSourceReference* _tmp14_;
		_tmp12_ = d;
		_tmp13_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp12_);
		_tmp14_ = _tmp13_;
		vala_report_error (_tmp14_, "destructor and parent symbol name do not match");
	}
	_tmp16_ = flags;
	if ((_tmp16_ & VALA_PARSER_MODIFIER_FLAGS_STATIC) == VALA_PARSER_MODIFIER_FLAGS_STATIC) {
		ValaParserModifierFlags _tmp17_;
		_tmp17_ = flags;
		_tmp15_ = (_tmp17_ & VALA_PARSER_MODIFIER_FLAGS_CLASS) == VALA_PARSER_MODIFIER_FLAGS_CLASS;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		ValaDestructor* _tmp18_;
		ValaSourceReference* _tmp19_;
		ValaSourceReference* _tmp20_;
		_tmp18_ = d;
		_tmp19_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp18_);
		_tmp20_ = _tmp19_;
		vala_report_error (_tmp20_, "only one of `static' or `class' may be specified");
	} else {
		ValaParserModifierFlags _tmp21_;
		_tmp21_ = flags;
		if ((_tmp21_ & VALA_PARSER_MODIFIER_FLAGS_STATIC) == VALA_PARSER_MODIFIER_FLAGS_STATIC) {
			ValaDestructor* _tmp22_;
			_tmp22_ = d;
			vala_destructor_set_binding (_tmp22_, VALA_MEMBER_BINDING_STATIC);
		} else {
			ValaParserModifierFlags _tmp23_;
			_tmp23_ = flags;
			if ((_tmp23_ & VALA_PARSER_MODIFIER_FLAGS_CLASS) == VALA_PARSER_MODIFIER_FLAGS_CLASS) {
				ValaDestructor* _tmp24_;
				_tmp24_ = d;
				vala_destructor_set_binding (_tmp24_, VALA_MEMBER_BINDING_CLASS);
			}
		}
	}
	_tmp26_ = vala_parser_parse_block (self, &_inner_error0_);
	_tmp25_ = _tmp26_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (d);
			_g_free0 (identifier);
			return;
		} else {
			_vala_code_node_unref0 (d);
			_g_free0 (identifier);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp27_ = d;
	vala_subroutine_set_body ((ValaSubroutine*) _tmp27_, _tmp25_);
	_tmp28_ = d;
	vala_symbol_add_destructor (parent, _tmp28_);
	_vala_code_node_unref0 (_tmp25_);
	_vala_code_node_unref0 (d);
	_g_free0 (identifier);
}

static void
vala_parser_parse_struct_declaration (ValaParser* self,
                                      ValaSymbol* parent,
                                      ValaList* attrs,
                                      GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSymbolAccessibility access = 0;
	ValaParserModifierFlags flags = 0U;
	ValaUnresolvedSymbol* sym = NULL;
	ValaUnresolvedSymbol* _tmp1_;
	ValaList* type_param_list = NULL;
	ValaList* _tmp2_;
	ValaDataType* base_type = NULL;
	ValaStruct* st = NULL;
	ValaUnresolvedSymbol* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	ValaSourceLocation _tmp9_;
	ValaSourceReference* _tmp10_;
	ValaSourceReference* _tmp11_;
	ValaComment* _tmp12_;
	ValaStruct* _tmp13_;
	ValaStruct* _tmp14_;
	ValaStruct* _tmp15_;
	ValaSymbolAccessibility _tmp16_;
	ValaParserModifierFlags _tmp17_;
	ValaStruct* _tmp19_;
	ValaDataType* _tmp31_;
	ValaStruct* _tmp34_;
	ValaSymbol* _result_ = NULL;
	ValaStruct* _tmp35_;
	ValaSymbol* _tmp36_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	access = vala_parser_parse_access_modifier (self, VALA_SYMBOL_ACCESSIBILITY_PRIVATE);
	flags = vala_parser_parse_type_declaration_modifiers (self);
	vala_parser_expect (self, VALA_TOKEN_TYPE_STRUCT, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp1_ = vala_parser_parse_symbol_name (self, &_inner_error0_);
	sym = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp2_ = vala_parser_parse_type_parameter_list (self, &_inner_error0_);
	type_param_list = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	base_type = NULL;
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_COLON)) {
		ValaDataType* _tmp3_ = NULL;
		ValaDataType* _tmp4_;
		ValaDataType* _tmp5_;
		_tmp4_ = vala_parser_parse_type (self, TRUE, FALSE, FALSE, &_inner_error0_);
		_tmp3_ = _tmp4_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (base_type);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				return;
			} else {
				_vala_code_node_unref0 (base_type);
				_vala_iterable_unref0 (type_param_list);
				_vala_code_node_unref0 (sym);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp5_ = _tmp3_;
		_tmp3_ = NULL;
		_vala_code_node_unref0 (base_type);
		base_type = _tmp5_;
		_vala_code_node_unref0 (_tmp3_);
	}
	_tmp6_ = sym;
	_tmp7_ = vala_symbol_get_name ((ValaSymbol*) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = begin;
	_tmp10_ = vala_parser_get_src (self, &_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = self->priv->comment;
	_tmp13_ = vala_struct_new (_tmp8_, _tmp11_, _tmp12_);
	_tmp14_ = _tmp13_;
	_vala_source_reference_unref0 (_tmp11_);
	st = _tmp14_;
	_tmp15_ = st;
	_tmp16_ = access;
	vala_symbol_set_access ((ValaSymbol*) _tmp15_, _tmp16_);
	_tmp17_ = flags;
	if ((_tmp17_ & VALA_PARSER_MODIFIER_FLAGS_EXTERN) == VALA_PARSER_MODIFIER_FLAGS_EXTERN) {
		ValaStruct* _tmp18_;
		_tmp18_ = st;
		vala_symbol_set_is_extern ((ValaSymbol*) _tmp18_, TRUE);
	}
	_tmp19_ = st;
	vala_parser_set_attributes (self, (ValaCodeNode*) _tmp19_, attrs);
	{
		ValaList* _type_param_list = NULL;
		ValaList* _tmp20_;
		ValaList* _tmp21_;
		gint _type_param_size = 0;
		ValaList* _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
		gint _type_param_index = 0;
		_tmp20_ = type_param_list;
		_tmp21_ = _vala_iterable_ref0 (_tmp20_);
		_type_param_list = _tmp21_;
		_tmp22_ = _type_param_list;
		_tmp23_ = vala_collection_get_size ((ValaCollection*) _tmp22_);
		_tmp24_ = _tmp23_;
		_type_param_size = _tmp24_;
		_type_param_index = -1;
		while (TRUE) {
			gint _tmp25_;
			gint _tmp26_;
			ValaTypeParameter* type_param = NULL;
			ValaList* _tmp27_;
			gpointer _tmp28_;
			ValaStruct* _tmp29_;
			ValaTypeParameter* _tmp30_;
			_type_param_index = _type_param_index + 1;
			_tmp25_ = _type_param_index;
			_tmp26_ = _type_param_size;
			if (!(_tmp25_ < _tmp26_)) {
				break;
			}
			_tmp27_ = _type_param_list;
			_tmp28_ = vala_list_get (_tmp27_, _type_param_index);
			type_param = (ValaTypeParameter*) _tmp28_;
			_tmp29_ = st;
			_tmp30_ = type_param;
			vala_struct_add_type_parameter (_tmp29_, _tmp30_);
			_vala_code_node_unref0 (type_param);
		}
		_vala_iterable_unref0 (_type_param_list);
	}
	_tmp31_ = base_type;
	if (_tmp31_ != NULL) {
		ValaStruct* _tmp32_;
		ValaDataType* _tmp33_;
		_tmp32_ = st;
		_tmp33_ = base_type;
		vala_struct_set_base_type (_tmp32_, _tmp33_);
	}
	_tmp34_ = st;
	vala_parser_parse_declarations (self, (ValaSymbol*) _tmp34_, FALSE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (st);
			_vala_code_node_unref0 (base_type);
			_vala_iterable_unref0 (type_param_list);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_code_node_unref0 (st);
			_vala_code_node_unref0 (base_type);
			_vala_iterable_unref0 (type_param_list);
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp35_ = st;
	_tmp36_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp35_);
	_result_ = _tmp36_;
	while (TRUE) {
		ValaUnresolvedSymbol* _tmp37_;
		ValaUnresolvedSymbol* _tmp38_;
		ValaUnresolvedSymbol* _tmp39_;
		ValaUnresolvedSymbol* _tmp40_;
		ValaUnresolvedSymbol* _tmp41_;
		ValaSymbol* _tmp42_ = NULL;
		ValaUnresolvedSymbol* _tmp43_;
		ValaSymbol* next = NULL;
		ValaSymbol* _tmp52_;
		ValaSymbol* _tmp53_;
		ValaSymbol* _tmp58_;
		ValaSymbol* _tmp59_;
		_tmp37_ = sym;
		if (!(_tmp37_ != NULL)) {
			break;
		}
		_tmp38_ = sym;
		_tmp39_ = vala_unresolved_symbol_get_inner (_tmp38_);
		_tmp40_ = _tmp39_;
		_tmp41_ = _vala_code_node_ref0 (_tmp40_);
		_vala_code_node_unref0 (sym);
		sym = _tmp41_;
		_tmp43_ = sym;
		if (_tmp43_ != NULL) {
			ValaUnresolvedSymbol* _tmp44_;
			const gchar* _tmp45_;
			const gchar* _tmp46_;
			ValaStruct* _tmp47_;
			ValaSourceReference* _tmp48_;
			ValaSourceReference* _tmp49_;
			ValaNamespace* _tmp50_;
			_tmp44_ = sym;
			_tmp45_ = vala_symbol_get_name ((ValaSymbol*) _tmp44_);
			_tmp46_ = _tmp45_;
			_tmp47_ = st;
			_tmp48_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp47_);
			_tmp49_ = _tmp48_;
			_tmp50_ = vala_namespace_new (_tmp46_, _tmp49_);
			_vala_code_node_unref0 (_tmp42_);
			_tmp42_ = (ValaSymbol*) _tmp50_;
		} else {
			ValaSymbol* _tmp51_;
			_tmp51_ = _vala_code_node_ref0 (parent);
			_vala_code_node_unref0 (_tmp42_);
			_tmp42_ = _tmp51_;
		}
		_tmp52_ = _vala_code_node_ref0 (_tmp42_);
		next = _tmp52_;
		_tmp53_ = _result_;
		if (VALA_IS_NAMESPACE (_tmp53_)) {
			ValaSymbol* _tmp54_;
			ValaSymbol* _tmp55_;
			_tmp54_ = next;
			_tmp55_ = _result_;
			vala_symbol_add_namespace (_tmp54_, G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, VALA_TYPE_NAMESPACE, ValaNamespace));
		} else {
			ValaSymbol* _tmp56_;
			ValaSymbol* _tmp57_;
			_tmp56_ = next;
			_tmp57_ = _result_;
			vala_symbol_add_struct (_tmp56_, G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, VALA_TYPE_STRUCT, ValaStruct));
		}
		_tmp58_ = next;
		_tmp59_ = _vala_code_node_ref0 (_tmp58_);
		_vala_code_node_unref0 (_result_);
		_result_ = _tmp59_;
		_vala_code_node_unref0 (next);
		_vala_code_node_unref0 (_tmp42_);
	}
	_vala_code_node_unref0 (_result_);
	_vala_code_node_unref0 (st);
	_vala_code_node_unref0 (base_type);
	_vala_iterable_unref0 (type_param_list);
	_vala_code_node_unref0 (sym);
}

static void
vala_parser_parse_interface_declaration (ValaParser* self,
                                         ValaSymbol* parent,
                                         ValaList* attrs,
                                         GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSymbolAccessibility access = 0;
	ValaParserModifierFlags flags = 0U;
	ValaUnresolvedSymbol* sym = NULL;
	ValaUnresolvedSymbol* _tmp1_;
	ValaList* type_param_list = NULL;
	ValaList* _tmp2_;
	ValaArrayList* base_types = NULL;
	GEqualFunc _tmp3_;
	ValaArrayList* _tmp4_;
	ValaInterface* iface = NULL;
	ValaUnresolvedSymbol* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	ValaSourceLocation _tmp12_;
	ValaSourceReference* _tmp13_;
	ValaSourceReference* _tmp14_;
	ValaComment* _tmp15_;
	ValaInterface* _tmp16_;
	ValaInterface* _tmp17_;
	ValaInterface* _tmp18_;
	ValaSymbolAccessibility _tmp19_;
	ValaParserModifierFlags _tmp20_;
	ValaInterface* _tmp22_;
	ValaInterface* _tmp45_;
	ValaSymbol* _result_ = NULL;
	ValaInterface* _tmp46_;
	ValaSymbol* _tmp47_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	access = vala_parser_parse_access_modifier (self, VALA_SYMBOL_ACCESSIBILITY_PRIVATE);
	flags = vala_parser_parse_type_declaration_modifiers (self);
	vala_parser_expect (self, VALA_TOKEN_TYPE_INTERFACE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp1_ = vala_parser_parse_symbol_name (self, &_inner_error0_);
	sym = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp2_ = vala_parser_parse_type_parameter_list (self, &_inner_error0_);
	type_param_list = _tmp2_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp3_ = g_direct_equal;
	_tmp4_ = vala_array_list_new (VALA_TYPE_DATA_TYPE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp3_);
	base_types = _tmp4_;
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_COLON)) {
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				ValaDataType* type = NULL;
				ValaDataType* _tmp6_;
				ValaArrayList* _tmp7_;
				ValaDataType* _tmp8_;
				if (!_tmp5_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp5_ = FALSE;
				_tmp6_ = vala_parser_parse_type (self, TRUE, FALSE, FALSE, &_inner_error0_);
				type = _tmp6_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_iterable_unref0 (base_types);
						_vala_iterable_unref0 (type_param_list);
						_vala_code_node_unref0 (sym);
						return;
					} else {
						_vala_iterable_unref0 (base_types);
						_vala_iterable_unref0 (type_param_list);
						_vala_code_node_unref0 (sym);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_tmp7_ = base_types;
				_tmp8_ = type;
				vala_collection_add ((ValaCollection*) _tmp7_, _tmp8_);
				_vala_code_node_unref0 (type);
			}
		}
	}
	_tmp9_ = sym;
	_tmp10_ = vala_symbol_get_name ((ValaSymbol*) _tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = begin;
	_tmp13_ = vala_parser_get_src (self, &_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = self->priv->comment;
	_tmp16_ = vala_interface_new (_tmp11_, _tmp14_, _tmp15_);
	_tmp17_ = _tmp16_;
	_vala_source_reference_unref0 (_tmp14_);
	iface = _tmp17_;
	_tmp18_ = iface;
	_tmp19_ = access;
	vala_symbol_set_access ((ValaSymbol*) _tmp18_, _tmp19_);
	_tmp20_ = flags;
	if ((_tmp20_ & VALA_PARSER_MODIFIER_FLAGS_EXTERN) == VALA_PARSER_MODIFIER_FLAGS_EXTERN) {
		ValaInterface* _tmp21_;
		_tmp21_ = iface;
		vala_symbol_set_is_extern ((ValaSymbol*) _tmp21_, TRUE);
	}
	_tmp22_ = iface;
	vala_parser_set_attributes (self, (ValaCodeNode*) _tmp22_, attrs);
	{
		ValaList* _type_param_list = NULL;
		ValaList* _tmp23_;
		ValaList* _tmp24_;
		gint _type_param_size = 0;
		ValaList* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		gint _type_param_index = 0;
		_tmp23_ = type_param_list;
		_tmp24_ = _vala_iterable_ref0 (_tmp23_);
		_type_param_list = _tmp24_;
		_tmp25_ = _type_param_list;
		_tmp26_ = vala_collection_get_size ((ValaCollection*) _tmp25_);
		_tmp27_ = _tmp26_;
		_type_param_size = _tmp27_;
		_type_param_index = -1;
		while (TRUE) {
			gint _tmp28_;
			gint _tmp29_;
			ValaTypeParameter* type_param = NULL;
			ValaList* _tmp30_;
			gpointer _tmp31_;
			ValaInterface* _tmp32_;
			ValaTypeParameter* _tmp33_;
			_type_param_index = _type_param_index + 1;
			_tmp28_ = _type_param_index;
			_tmp29_ = _type_param_size;
			if (!(_tmp28_ < _tmp29_)) {
				break;
			}
			_tmp30_ = _type_param_list;
			_tmp31_ = vala_list_get (_tmp30_, _type_param_index);
			type_param = (ValaTypeParameter*) _tmp31_;
			_tmp32_ = iface;
			_tmp33_ = type_param;
			vala_object_type_symbol_add_type_parameter ((ValaObjectTypeSymbol*) _tmp32_, _tmp33_);
			_vala_code_node_unref0 (type_param);
		}
		_vala_iterable_unref0 (_type_param_list);
	}
	{
		ValaArrayList* _base_type_list = NULL;
		ValaArrayList* _tmp34_;
		ValaArrayList* _tmp35_;
		gint _base_type_size = 0;
		ValaArrayList* _tmp36_;
		gint _tmp37_;
		gint _tmp38_;
		gint _base_type_index = 0;
		_tmp34_ = base_types;
		_tmp35_ = _vala_iterable_ref0 (_tmp34_);
		_base_type_list = _tmp35_;
		_tmp36_ = _base_type_list;
		_tmp37_ = vala_collection_get_size ((ValaCollection*) _tmp36_);
		_tmp38_ = _tmp37_;
		_base_type_size = _tmp38_;
		_base_type_index = -1;
		while (TRUE) {
			gint _tmp39_;
			gint _tmp40_;
			ValaDataType* base_type = NULL;
			ValaArrayList* _tmp41_;
			gpointer _tmp42_;
			ValaInterface* _tmp43_;
			ValaDataType* _tmp44_;
			_base_type_index = _base_type_index + 1;
			_tmp39_ = _base_type_index;
			_tmp40_ = _base_type_size;
			if (!(_tmp39_ < _tmp40_)) {
				break;
			}
			_tmp41_ = _base_type_list;
			_tmp42_ = vala_list_get ((ValaList*) _tmp41_, _base_type_index);
			base_type = (ValaDataType*) _tmp42_;
			_tmp43_ = iface;
			_tmp44_ = base_type;
			vala_interface_add_prerequisite (_tmp43_, _tmp44_);
			_vala_code_node_unref0 (base_type);
		}
		_vala_iterable_unref0 (_base_type_list);
	}
	_tmp45_ = iface;
	vala_parser_parse_declarations (self, (ValaSymbol*) _tmp45_, FALSE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (iface);
			_vala_iterable_unref0 (base_types);
			_vala_iterable_unref0 (type_param_list);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_code_node_unref0 (iface);
			_vala_iterable_unref0 (base_types);
			_vala_iterable_unref0 (type_param_list);
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp46_ = iface;
	_tmp47_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp46_);
	_result_ = _tmp47_;
	while (TRUE) {
		ValaUnresolvedSymbol* _tmp48_;
		ValaUnresolvedSymbol* _tmp49_;
		ValaUnresolvedSymbol* _tmp50_;
		ValaUnresolvedSymbol* _tmp51_;
		ValaUnresolvedSymbol* _tmp52_;
		ValaSymbol* _tmp53_ = NULL;
		ValaUnresolvedSymbol* _tmp54_;
		ValaSymbol* next = NULL;
		ValaSymbol* _tmp63_;
		ValaSymbol* _tmp64_;
		ValaSymbol* _tmp69_;
		ValaSymbol* _tmp70_;
		_tmp48_ = sym;
		if (!(_tmp48_ != NULL)) {
			break;
		}
		_tmp49_ = sym;
		_tmp50_ = vala_unresolved_symbol_get_inner (_tmp49_);
		_tmp51_ = _tmp50_;
		_tmp52_ = _vala_code_node_ref0 (_tmp51_);
		_vala_code_node_unref0 (sym);
		sym = _tmp52_;
		_tmp54_ = sym;
		if (_tmp54_ != NULL) {
			ValaUnresolvedSymbol* _tmp55_;
			const gchar* _tmp56_;
			const gchar* _tmp57_;
			ValaInterface* _tmp58_;
			ValaSourceReference* _tmp59_;
			ValaSourceReference* _tmp60_;
			ValaNamespace* _tmp61_;
			_tmp55_ = sym;
			_tmp56_ = vala_symbol_get_name ((ValaSymbol*) _tmp55_);
			_tmp57_ = _tmp56_;
			_tmp58_ = iface;
			_tmp59_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp58_);
			_tmp60_ = _tmp59_;
			_tmp61_ = vala_namespace_new (_tmp57_, _tmp60_);
			_vala_code_node_unref0 (_tmp53_);
			_tmp53_ = (ValaSymbol*) _tmp61_;
		} else {
			ValaSymbol* _tmp62_;
			_tmp62_ = _vala_code_node_ref0 (parent);
			_vala_code_node_unref0 (_tmp53_);
			_tmp53_ = _tmp62_;
		}
		_tmp63_ = _vala_code_node_ref0 (_tmp53_);
		next = _tmp63_;
		_tmp64_ = _result_;
		if (VALA_IS_NAMESPACE (_tmp64_)) {
			ValaSymbol* _tmp65_;
			ValaSymbol* _tmp66_;
			_tmp65_ = next;
			_tmp66_ = _result_;
			vala_symbol_add_namespace (_tmp65_, G_TYPE_CHECK_INSTANCE_CAST (_tmp66_, VALA_TYPE_NAMESPACE, ValaNamespace));
		} else {
			ValaSymbol* _tmp67_;
			ValaSymbol* _tmp68_;
			_tmp67_ = next;
			_tmp68_ = _result_;
			vala_symbol_add_interface (_tmp67_, G_TYPE_CHECK_INSTANCE_CAST (_tmp68_, VALA_TYPE_INTERFACE, ValaInterface));
		}
		_tmp69_ = next;
		_tmp70_ = _vala_code_node_ref0 (_tmp69_);
		_vala_code_node_unref0 (_result_);
		_result_ = _tmp70_;
		_vala_code_node_unref0 (next);
		_vala_code_node_unref0 (_tmp53_);
	}
	_vala_code_node_unref0 (_result_);
	_vala_code_node_unref0 (iface);
	_vala_iterable_unref0 (base_types);
	_vala_iterable_unref0 (type_param_list);
	_vala_code_node_unref0 (sym);
}

static void
vala_parser_parse_enum_declaration (ValaParser* self,
                                    ValaSymbol* parent,
                                    ValaList* attrs,
                                    GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSymbolAccessibility access = 0;
	ValaParserModifierFlags flags = 0U;
	ValaUnresolvedSymbol* sym = NULL;
	ValaUnresolvedSymbol* _tmp1_;
	ValaEnum* en = NULL;
	ValaUnresolvedSymbol* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	ValaSourceLocation _tmp5_;
	ValaSourceReference* _tmp6_;
	ValaSourceReference* _tmp7_;
	ValaComment* _tmp8_;
	ValaEnum* _tmp9_;
	ValaEnum* _tmp10_;
	ValaEnum* _tmp11_;
	ValaSymbolAccessibility _tmp12_;
	ValaParserModifierFlags _tmp13_;
	ValaEnum* _tmp15_;
	ValaSourceLocation inner_begin = {0};
	ValaSourceLocation _tmp16_ = {0};
	ValaSymbol* _result_ = NULL;
	ValaEnum* _tmp43_;
	ValaSymbol* _tmp44_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	access = vala_parser_parse_access_modifier (self, VALA_SYMBOL_ACCESSIBILITY_PRIVATE);
	flags = vala_parser_parse_type_declaration_modifiers (self);
	vala_parser_expect (self, VALA_TOKEN_TYPE_ENUM, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp1_ = vala_parser_parse_symbol_name (self, &_inner_error0_);
	sym = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp2_ = sym;
	_tmp3_ = vala_symbol_get_name ((ValaSymbol*) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = begin;
	_tmp6_ = vala_parser_get_src (self, &_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = self->priv->comment;
	_tmp9_ = vala_enum_new (_tmp4_, _tmp7_, _tmp8_);
	_tmp10_ = _tmp9_;
	_vala_source_reference_unref0 (_tmp7_);
	en = _tmp10_;
	_tmp11_ = en;
	_tmp12_ = access;
	vala_symbol_set_access ((ValaSymbol*) _tmp11_, _tmp12_);
	_tmp13_ = flags;
	if ((_tmp13_ & VALA_PARSER_MODIFIER_FLAGS_EXTERN) == VALA_PARSER_MODIFIER_FLAGS_EXTERN) {
		ValaEnum* _tmp14_;
		_tmp14_ = en;
		vala_symbol_set_is_extern ((ValaSymbol*) _tmp14_, TRUE);
	}
	_tmp15_ = en;
	vala_parser_set_attributes (self, (ValaCodeNode*) _tmp15_, attrs);
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_BRACE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (en);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_code_node_unref0 (en);
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	vala_parser_get_location (self, &_tmp16_);
	inner_begin = _tmp16_;
	{
		while (TRUE) {
			ValaEnum* _tmp17_;
			if (!(vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_BRACE)) {
				break;
			}
			_tmp17_ = en;
			vala_parser_parse_declaration (self, (ValaSymbol*) _tmp17_, FALSE, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					goto __catch0_vala_parse_error;
				}
				_vala_code_node_unref0 (en);
				_vala_code_node_unref0 (sym);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	goto __finally0;
	__catch0_vala_parse_error:
	{
		ValaSourceLocation _tmp18_;
		g_clear_error (&_inner_error0_);
		_tmp18_ = inner_begin;
		vala_parser_rollback (self, &_tmp18_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (en);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_code_node_unref0 (en);
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	{
		gboolean _tmp19_ = FALSE;
		_tmp19_ = TRUE;
		while (TRUE) {
			ValaList* value_attrs = NULL;
			ValaList* _tmp20_;
			ValaSourceLocation value_begin = {0};
			ValaSourceLocation _tmp21_ = {0};
			gchar* id = NULL;
			gchar* _tmp22_;
			ValaComment* _tmp23_;
			ValaExpression* value = NULL;
			ValaEnumValue* ev = NULL;
			const gchar* _tmp29_;
			ValaExpression* _tmp30_;
			ValaSourceLocation _tmp31_;
			ValaSourceReference* _tmp32_;
			ValaSourceReference* _tmp33_;
			ValaComment* _tmp34_;
			ValaEnumValue* _tmp35_;
			ValaEnumValue* _tmp36_;
			ValaEnumValue* _tmp37_;
			ValaEnumValue* _tmp38_;
			ValaList* _tmp39_;
			ValaEnum* _tmp40_;
			ValaEnumValue* _tmp41_;
			if (!_tmp19_) {
				if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
					break;
				}
			}
			_tmp19_ = FALSE;
			if (vala_parser_current (self) == VALA_TOKEN_TYPE_CLOSE_BRACE) {
				break;
			}
			_tmp20_ = vala_parser_parse_attributes (self, &_inner_error0_);
			value_attrs = _tmp20_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (en);
					_vala_code_node_unref0 (sym);
					return;
				} else {
					_vala_code_node_unref0 (en);
					_vala_code_node_unref0 (sym);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			vala_parser_get_location (self, &_tmp21_);
			value_begin = _tmp21_;
			_tmp22_ = vala_parser_parse_identifier (self, &_inner_error0_);
			id = _tmp22_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_iterable_unref0 (value_attrs);
					_vala_code_node_unref0 (en);
					_vala_code_node_unref0 (sym);
					return;
				} else {
					_vala_iterable_unref0 (value_attrs);
					_vala_code_node_unref0 (en);
					_vala_code_node_unref0 (sym);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_tmp23_ = self->priv->comment;
			if (_tmp23_ == NULL) {
				ValaScanner* _tmp24_;
				ValaComment* _tmp25_;
				_tmp24_ = self->priv->scanner;
				_tmp25_ = vala_scanner_pop_comment (_tmp24_);
				_vala_comment_unref0 (self->priv->comment);
				self->priv->comment = _tmp25_;
			}
			value = NULL;
			if (vala_parser_accept (self, VALA_TOKEN_TYPE_ASSIGN)) {
				ValaExpression* _tmp26_ = NULL;
				ValaExpression* _tmp27_;
				ValaExpression* _tmp28_;
				_tmp27_ = vala_parser_parse_expression (self, &_inner_error0_);
				_tmp26_ = _tmp27_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (value);
						_g_free0 (id);
						_vala_iterable_unref0 (value_attrs);
						_vala_code_node_unref0 (en);
						_vala_code_node_unref0 (sym);
						return;
					} else {
						_vala_code_node_unref0 (value);
						_g_free0 (id);
						_vala_iterable_unref0 (value_attrs);
						_vala_code_node_unref0 (en);
						_vala_code_node_unref0 (sym);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_tmp28_ = _tmp26_;
				_tmp26_ = NULL;
				_vala_code_node_unref0 (value);
				value = _tmp28_;
				_vala_code_node_unref0 (_tmp26_);
			}
			_tmp29_ = id;
			_tmp30_ = value;
			_tmp31_ = value_begin;
			_tmp32_ = vala_parser_get_src (self, &_tmp31_);
			_tmp33_ = _tmp32_;
			_tmp34_ = self->priv->comment;
			_tmp35_ = vala_enum_value_new (_tmp29_, _tmp30_, _tmp33_, _tmp34_);
			_tmp36_ = _tmp35_;
			_vala_source_reference_unref0 (_tmp33_);
			ev = _tmp36_;
			_tmp37_ = ev;
			vala_symbol_set_access ((ValaSymbol*) _tmp37_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
			_tmp38_ = ev;
			_tmp39_ = value_attrs;
			vala_parser_set_attributes (self, (ValaCodeNode*) _tmp38_, _tmp39_);
			_tmp40_ = en;
			_tmp41_ = ev;
			vala_enum_add_value (_tmp40_, _tmp41_);
			_vala_comment_unref0 (self->priv->comment);
			self->priv->comment = NULL;
			_vala_code_node_unref0 (ev);
			_vala_code_node_unref0 (value);
			_g_free0 (id);
			_vala_iterable_unref0 (value_attrs);
		}
	}
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_SEMICOLON)) {
		while (TRUE) {
			ValaEnum* _tmp42_;
			if (!(vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_BRACE)) {
				break;
			}
			_tmp42_ = en;
			vala_parser_parse_declaration (self, (ValaSymbol*) _tmp42_, FALSE, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (en);
					_vala_code_node_unref0 (sym);
					return;
				} else {
					_vala_code_node_unref0 (en);
					_vala_code_node_unref0 (sym);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_BRACE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (en);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_code_node_unref0 (en);
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp43_ = en;
	_tmp44_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp43_);
	_result_ = _tmp44_;
	while (TRUE) {
		ValaUnresolvedSymbol* _tmp45_;
		ValaUnresolvedSymbol* _tmp46_;
		ValaUnresolvedSymbol* _tmp47_;
		ValaUnresolvedSymbol* _tmp48_;
		ValaUnresolvedSymbol* _tmp49_;
		ValaSymbol* _tmp50_ = NULL;
		ValaUnresolvedSymbol* _tmp51_;
		ValaSymbol* next = NULL;
		ValaSymbol* _tmp60_;
		ValaSymbol* _tmp61_;
		ValaSymbol* _tmp66_;
		ValaSymbol* _tmp67_;
		_tmp45_ = sym;
		if (!(_tmp45_ != NULL)) {
			break;
		}
		_tmp46_ = sym;
		_tmp47_ = vala_unresolved_symbol_get_inner (_tmp46_);
		_tmp48_ = _tmp47_;
		_tmp49_ = _vala_code_node_ref0 (_tmp48_);
		_vala_code_node_unref0 (sym);
		sym = _tmp49_;
		_tmp51_ = sym;
		if (_tmp51_ != NULL) {
			ValaUnresolvedSymbol* _tmp52_;
			const gchar* _tmp53_;
			const gchar* _tmp54_;
			ValaEnum* _tmp55_;
			ValaSourceReference* _tmp56_;
			ValaSourceReference* _tmp57_;
			ValaNamespace* _tmp58_;
			_tmp52_ = sym;
			_tmp53_ = vala_symbol_get_name ((ValaSymbol*) _tmp52_);
			_tmp54_ = _tmp53_;
			_tmp55_ = en;
			_tmp56_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp55_);
			_tmp57_ = _tmp56_;
			_tmp58_ = vala_namespace_new (_tmp54_, _tmp57_);
			_vala_code_node_unref0 (_tmp50_);
			_tmp50_ = (ValaSymbol*) _tmp58_;
		} else {
			ValaSymbol* _tmp59_;
			_tmp59_ = _vala_code_node_ref0 (parent);
			_vala_code_node_unref0 (_tmp50_);
			_tmp50_ = _tmp59_;
		}
		_tmp60_ = _vala_code_node_ref0 (_tmp50_);
		next = _tmp60_;
		_tmp61_ = _result_;
		if (VALA_IS_NAMESPACE (_tmp61_)) {
			ValaSymbol* _tmp62_;
			ValaSymbol* _tmp63_;
			_tmp62_ = next;
			_tmp63_ = _result_;
			vala_symbol_add_namespace (_tmp62_, G_TYPE_CHECK_INSTANCE_CAST (_tmp63_, VALA_TYPE_NAMESPACE, ValaNamespace));
		} else {
			ValaSymbol* _tmp64_;
			ValaSymbol* _tmp65_;
			_tmp64_ = next;
			_tmp65_ = _result_;
			vala_symbol_add_enum (_tmp64_, G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, VALA_TYPE_ENUM, ValaEnum));
		}
		_tmp66_ = next;
		_tmp67_ = _vala_code_node_ref0 (_tmp66_);
		_vala_code_node_unref0 (_result_);
		_result_ = _tmp67_;
		_vala_code_node_unref0 (next);
		_vala_code_node_unref0 (_tmp50_);
	}
	_vala_code_node_unref0 (_result_);
	_vala_code_node_unref0 (en);
	_vala_code_node_unref0 (sym);
}

static void
vala_parser_parse_errordomain_declaration (ValaParser* self,
                                           ValaSymbol* parent,
                                           ValaList* attrs,
                                           GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSymbolAccessibility access = 0;
	ValaParserModifierFlags flags = 0U;
	ValaUnresolvedSymbol* sym = NULL;
	ValaUnresolvedSymbol* _tmp1_;
	ValaErrorDomain* ed = NULL;
	ValaUnresolvedSymbol* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	ValaSourceLocation _tmp5_;
	ValaSourceReference* _tmp6_;
	ValaSourceReference* _tmp7_;
	ValaComment* _tmp8_;
	ValaErrorDomain* _tmp9_;
	ValaErrorDomain* _tmp10_;
	ValaErrorDomain* _tmp11_;
	ValaSymbolAccessibility _tmp12_;
	ValaParserModifierFlags _tmp13_;
	ValaErrorDomain* _tmp15_;
	ValaSourceLocation inner_begin = {0};
	ValaSourceLocation _tmp16_ = {0};
	ValaSymbol* _result_ = NULL;
	ValaErrorDomain* _tmp41_;
	ValaSymbol* _tmp42_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	access = vala_parser_parse_access_modifier (self, VALA_SYMBOL_ACCESSIBILITY_PRIVATE);
	flags = vala_parser_parse_type_declaration_modifiers (self);
	vala_parser_expect (self, VALA_TOKEN_TYPE_ERRORDOMAIN, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp1_ = vala_parser_parse_symbol_name (self, &_inner_error0_);
	sym = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp2_ = sym;
	_tmp3_ = vala_symbol_get_name ((ValaSymbol*) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = begin;
	_tmp6_ = vala_parser_get_src (self, &_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = self->priv->comment;
	_tmp9_ = vala_error_domain_new (_tmp4_, _tmp7_, _tmp8_);
	_tmp10_ = _tmp9_;
	_vala_source_reference_unref0 (_tmp7_);
	ed = _tmp10_;
	_tmp11_ = ed;
	_tmp12_ = access;
	vala_symbol_set_access ((ValaSymbol*) _tmp11_, _tmp12_);
	_tmp13_ = flags;
	if ((_tmp13_ & VALA_PARSER_MODIFIER_FLAGS_EXTERN) == VALA_PARSER_MODIFIER_FLAGS_EXTERN) {
		ValaErrorDomain* _tmp14_;
		_tmp14_ = ed;
		vala_symbol_set_is_extern ((ValaSymbol*) _tmp14_, TRUE);
	}
	_tmp15_ = ed;
	vala_parser_set_attributes (self, (ValaCodeNode*) _tmp15_, attrs);
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_BRACE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (ed);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_code_node_unref0 (ed);
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	vala_parser_get_location (self, &_tmp16_);
	inner_begin = _tmp16_;
	{
		while (TRUE) {
			ValaErrorDomain* _tmp17_;
			if (!(vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_BRACE)) {
				break;
			}
			_tmp17_ = ed;
			vala_parser_parse_declaration (self, (ValaSymbol*) _tmp17_, FALSE, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					goto __catch0_vala_parse_error;
				}
				_vala_code_node_unref0 (ed);
				_vala_code_node_unref0 (sym);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	goto __finally0;
	__catch0_vala_parse_error:
	{
		ValaSourceLocation _tmp18_;
		g_clear_error (&_inner_error0_);
		_tmp18_ = inner_begin;
		vala_parser_rollback (self, &_tmp18_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (ed);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_code_node_unref0 (ed);
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	{
		gboolean _tmp19_ = FALSE;
		_tmp19_ = TRUE;
		while (TRUE) {
			ValaList* code_attrs = NULL;
			ValaList* _tmp20_;
			ValaSourceLocation code_begin = {0};
			ValaSourceLocation _tmp21_ = {0};
			gchar* id = NULL;
			gchar* _tmp22_;
			ValaComment* _tmp23_;
			ValaErrorCode* ec = NULL;
			const gchar* _tmp26_;
			ValaSourceLocation _tmp27_;
			ValaSourceReference* _tmp28_;
			ValaSourceReference* _tmp29_;
			ValaComment* _tmp30_;
			ValaErrorCode* _tmp31_;
			ValaErrorCode* _tmp32_;
			ValaErrorCode* _tmp33_;
			ValaList* _tmp34_;
			ValaErrorDomain* _tmp38_;
			ValaErrorCode* _tmp39_;
			if (!_tmp19_) {
				if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
					break;
				}
			}
			_tmp19_ = FALSE;
			if (vala_parser_current (self) == VALA_TOKEN_TYPE_CLOSE_BRACE) {
				break;
			}
			_tmp20_ = vala_parser_parse_attributes (self, &_inner_error0_);
			code_attrs = _tmp20_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (ed);
					_vala_code_node_unref0 (sym);
					return;
				} else {
					_vala_code_node_unref0 (ed);
					_vala_code_node_unref0 (sym);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			vala_parser_get_location (self, &_tmp21_);
			code_begin = _tmp21_;
			_tmp22_ = vala_parser_parse_identifier (self, &_inner_error0_);
			id = _tmp22_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_iterable_unref0 (code_attrs);
					_vala_code_node_unref0 (ed);
					_vala_code_node_unref0 (sym);
					return;
				} else {
					_vala_iterable_unref0 (code_attrs);
					_vala_code_node_unref0 (ed);
					_vala_code_node_unref0 (sym);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			_tmp23_ = self->priv->comment;
			if (_tmp23_ == NULL) {
				ValaScanner* _tmp24_;
				ValaComment* _tmp25_;
				_tmp24_ = self->priv->scanner;
				_tmp25_ = vala_scanner_pop_comment (_tmp24_);
				_vala_comment_unref0 (self->priv->comment);
				self->priv->comment = _tmp25_;
			}
			_tmp26_ = id;
			_tmp27_ = code_begin;
			_tmp28_ = vala_parser_get_src (self, &_tmp27_);
			_tmp29_ = _tmp28_;
			_tmp30_ = self->priv->comment;
			_tmp31_ = vala_error_code_new (_tmp26_, _tmp29_, _tmp30_);
			_tmp32_ = _tmp31_;
			_vala_source_reference_unref0 (_tmp29_);
			ec = _tmp32_;
			_tmp33_ = ec;
			_tmp34_ = code_attrs;
			vala_parser_set_attributes (self, (ValaCodeNode*) _tmp33_, _tmp34_);
			if (vala_parser_accept (self, VALA_TOKEN_TYPE_ASSIGN)) {
				ValaExpression* _tmp35_ = NULL;
				ValaExpression* _tmp36_;
				ValaErrorCode* _tmp37_;
				_tmp36_ = vala_parser_parse_expression (self, &_inner_error0_);
				_tmp35_ = _tmp36_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (ec);
						_g_free0 (id);
						_vala_iterable_unref0 (code_attrs);
						_vala_code_node_unref0 (ed);
						_vala_code_node_unref0 (sym);
						return;
					} else {
						_vala_code_node_unref0 (ec);
						_g_free0 (id);
						_vala_iterable_unref0 (code_attrs);
						_vala_code_node_unref0 (ed);
						_vala_code_node_unref0 (sym);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_tmp37_ = ec;
				vala_error_code_set_value (_tmp37_, _tmp35_);
				_vala_code_node_unref0 (_tmp35_);
			}
			_tmp38_ = ed;
			_tmp39_ = ec;
			vala_error_domain_add_code (_tmp38_, _tmp39_);
			_vala_comment_unref0 (self->priv->comment);
			self->priv->comment = NULL;
			_vala_code_node_unref0 (ec);
			_g_free0 (id);
			_vala_iterable_unref0 (code_attrs);
		}
	}
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_SEMICOLON)) {
		while (TRUE) {
			ValaErrorDomain* _tmp40_;
			if (!(vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_BRACE)) {
				break;
			}
			_tmp40_ = ed;
			vala_parser_parse_declaration (self, (ValaSymbol*) _tmp40_, FALSE, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (ed);
					_vala_code_node_unref0 (sym);
					return;
				} else {
					_vala_code_node_unref0 (ed);
					_vala_code_node_unref0 (sym);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_BRACE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (ed);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_code_node_unref0 (ed);
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp41_ = ed;
	_tmp42_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp41_);
	_result_ = _tmp42_;
	while (TRUE) {
		ValaUnresolvedSymbol* _tmp43_;
		ValaUnresolvedSymbol* _tmp44_;
		ValaUnresolvedSymbol* _tmp45_;
		ValaUnresolvedSymbol* _tmp46_;
		ValaUnresolvedSymbol* _tmp47_;
		ValaSymbol* _tmp48_ = NULL;
		ValaUnresolvedSymbol* _tmp49_;
		ValaSymbol* next = NULL;
		ValaSymbol* _tmp58_;
		ValaSymbol* _tmp59_;
		ValaSymbol* _tmp64_;
		ValaSymbol* _tmp65_;
		_tmp43_ = sym;
		if (!(_tmp43_ != NULL)) {
			break;
		}
		_tmp44_ = sym;
		_tmp45_ = vala_unresolved_symbol_get_inner (_tmp44_);
		_tmp46_ = _tmp45_;
		_tmp47_ = _vala_code_node_ref0 (_tmp46_);
		_vala_code_node_unref0 (sym);
		sym = _tmp47_;
		_tmp49_ = sym;
		if (_tmp49_ != NULL) {
			ValaUnresolvedSymbol* _tmp50_;
			const gchar* _tmp51_;
			const gchar* _tmp52_;
			ValaErrorDomain* _tmp53_;
			ValaSourceReference* _tmp54_;
			ValaSourceReference* _tmp55_;
			ValaNamespace* _tmp56_;
			_tmp50_ = sym;
			_tmp51_ = vala_symbol_get_name ((ValaSymbol*) _tmp50_);
			_tmp52_ = _tmp51_;
			_tmp53_ = ed;
			_tmp54_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp53_);
			_tmp55_ = _tmp54_;
			_tmp56_ = vala_namespace_new (_tmp52_, _tmp55_);
			_vala_code_node_unref0 (_tmp48_);
			_tmp48_ = (ValaSymbol*) _tmp56_;
		} else {
			ValaSymbol* _tmp57_;
			_tmp57_ = _vala_code_node_ref0 (parent);
			_vala_code_node_unref0 (_tmp48_);
			_tmp48_ = _tmp57_;
		}
		_tmp58_ = _vala_code_node_ref0 (_tmp48_);
		next = _tmp58_;
		_tmp59_ = _result_;
		if (VALA_IS_NAMESPACE (_tmp59_)) {
			ValaSymbol* _tmp60_;
			ValaSymbol* _tmp61_;
			_tmp60_ = next;
			_tmp61_ = _result_;
			vala_symbol_add_namespace (_tmp60_, G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, VALA_TYPE_NAMESPACE, ValaNamespace));
		} else {
			ValaSymbol* _tmp62_;
			ValaSymbol* _tmp63_;
			_tmp62_ = next;
			_tmp63_ = _result_;
			vala_symbol_add_error_domain (_tmp62_, G_TYPE_CHECK_INSTANCE_CAST (_tmp63_, VALA_TYPE_ERROR_DOMAIN, ValaErrorDomain));
		}
		_tmp64_ = next;
		_tmp65_ = _vala_code_node_ref0 (_tmp64_);
		_vala_code_node_unref0 (_result_);
		_result_ = _tmp65_;
		_vala_code_node_unref0 (next);
		_vala_code_node_unref0 (_tmp48_);
	}
	_vala_code_node_unref0 (_result_);
	_vala_code_node_unref0 (ed);
	_vala_code_node_unref0 (sym);
}

static ValaSymbolAccessibility
vala_parser_parse_access_modifier (ValaParser* self,
                                   ValaSymbolAccessibility default_access)
{
	ValaSymbolAccessibility result = 0;
	g_return_val_if_fail (self != NULL, 0);
	switch (vala_parser_current (self)) {
		case VALA_TOKEN_TYPE_PRIVATE:
		{
			vala_parser_next (self);
			result = VALA_SYMBOL_ACCESSIBILITY_PRIVATE;
			return result;
		}
		case VALA_TOKEN_TYPE_PROTECTED:
		{
			vala_parser_next (self);
			result = VALA_SYMBOL_ACCESSIBILITY_PROTECTED;
			return result;
		}
		case VALA_TOKEN_TYPE_INTERNAL:
		{
			vala_parser_next (self);
			result = VALA_SYMBOL_ACCESSIBILITY_INTERNAL;
			return result;
		}
		case VALA_TOKEN_TYPE_PUBLIC:
		{
			vala_parser_next (self);
			result = VALA_SYMBOL_ACCESSIBILITY_PUBLIC;
			return result;
		}
		default:
		{
			result = default_access;
			return result;
		}
	}
}

static ValaParserModifierFlags
vala_parser_parse_type_declaration_modifiers (ValaParser* self)
{
	ValaParserModifierFlags flags = 0U;
	ValaParserModifierFlags result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	flags = 0;
	while (TRUE) {
		switch (vala_parser_current (self)) {
			case VALA_TOKEN_TYPE_ABSTRACT:
			{
				ValaParserModifierFlags _tmp0_;
				vala_parser_next (self);
				_tmp0_ = flags;
				flags = _tmp0_ | VALA_PARSER_MODIFIER_FLAGS_ABSTRACT;
				break;
			}
			case VALA_TOKEN_TYPE_EXTERN:
			{
				ValaParserModifierFlags _tmp1_;
				vala_parser_next (self);
				_tmp1_ = flags;
				flags = _tmp1_ | VALA_PARSER_MODIFIER_FLAGS_EXTERN;
				break;
			}
			case VALA_TOKEN_TYPE_SEALED:
			{
				ValaParserModifierFlags _tmp2_;
				vala_parser_next (self);
				_tmp2_ = flags;
				flags = _tmp2_ | VALA_PARSER_MODIFIER_FLAGS_SEALED;
				break;
			}
			default:
			{
				result = flags;
				return result;
			}
		}
	}
}

static ValaParserModifierFlags
vala_parser_parse_member_declaration_modifiers (ValaParser* self)
{
	ValaParserModifierFlags flags = 0U;
	ValaParserModifierFlags result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	flags = 0;
	while (TRUE) {
		switch (vala_parser_current (self)) {
			case VALA_TOKEN_TYPE_ABSTRACT:
			{
				ValaParserModifierFlags _tmp0_;
				vala_parser_next (self);
				_tmp0_ = flags;
				flags = _tmp0_ | VALA_PARSER_MODIFIER_FLAGS_ABSTRACT;
				break;
			}
			case VALA_TOKEN_TYPE_ASYNC:
			{
				ValaParserModifierFlags _tmp1_;
				vala_parser_next (self);
				_tmp1_ = flags;
				flags = _tmp1_ | VALA_PARSER_MODIFIER_FLAGS_ASYNC;
				break;
			}
			case VALA_TOKEN_TYPE_CLASS:
			{
				ValaParserModifierFlags _tmp2_;
				vala_parser_next (self);
				_tmp2_ = flags;
				flags = _tmp2_ | VALA_PARSER_MODIFIER_FLAGS_CLASS;
				break;
			}
			case VALA_TOKEN_TYPE_EXTERN:
			{
				ValaParserModifierFlags _tmp3_;
				vala_parser_next (self);
				_tmp3_ = flags;
				flags = _tmp3_ | VALA_PARSER_MODIFIER_FLAGS_EXTERN;
				break;
			}
			case VALA_TOKEN_TYPE_INLINE:
			{
				ValaParserModifierFlags _tmp4_;
				vala_parser_next (self);
				_tmp4_ = flags;
				flags = _tmp4_ | VALA_PARSER_MODIFIER_FLAGS_INLINE;
				break;
			}
			case VALA_TOKEN_TYPE_NEW:
			{
				ValaParserModifierFlags _tmp5_;
				vala_parser_next (self);
				_tmp5_ = flags;
				flags = _tmp5_ | VALA_PARSER_MODIFIER_FLAGS_NEW;
				break;
			}
			case VALA_TOKEN_TYPE_OVERRIDE:
			{
				ValaParserModifierFlags _tmp6_;
				vala_parser_next (self);
				_tmp6_ = flags;
				flags = _tmp6_ | VALA_PARSER_MODIFIER_FLAGS_OVERRIDE;
				break;
			}
			case VALA_TOKEN_TYPE_SEALED:
			{
				ValaParserModifierFlags _tmp7_;
				vala_parser_next (self);
				_tmp7_ = flags;
				flags = _tmp7_ | VALA_PARSER_MODIFIER_FLAGS_SEALED;
				break;
			}
			case VALA_TOKEN_TYPE_STATIC:
			{
				ValaParserModifierFlags _tmp8_;
				vala_parser_next (self);
				_tmp8_ = flags;
				flags = _tmp8_ | VALA_PARSER_MODIFIER_FLAGS_STATIC;
				break;
			}
			case VALA_TOKEN_TYPE_VIRTUAL:
			{
				ValaParserModifierFlags _tmp9_;
				vala_parser_next (self);
				_tmp9_ = flags;
				flags = _tmp9_ | VALA_PARSER_MODIFIER_FLAGS_VIRTUAL;
				break;
			}
			default:
			{
				result = flags;
				return result;
			}
		}
	}
}

static ValaParameter*
vala_parser_parse_parameter (ValaParser* self,
                             GError** error)
{
	ValaList* attrs = NULL;
	ValaList* _tmp0_;
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp1_ = {0};
	gboolean params_array = FALSE;
	ValaParameterDirection direction = 0;
	ValaDataType* type = NULL;
	ValaParameterDirection _tmp7_;
	gchar* id = NULL;
	gchar* _tmp18_;
	ValaDataType* _tmp19_ = NULL;
	ValaDataType* _tmp20_;
	ValaDataType* _tmp21_;
	ValaDataType* _tmp22_;
	ValaParameter* param = NULL;
	const gchar* _tmp23_;
	ValaDataType* _tmp24_;
	ValaSourceLocation _tmp25_;
	ValaSourceReference* _tmp26_;
	ValaSourceReference* _tmp27_;
	ValaParameter* _tmp28_;
	ValaParameter* _tmp29_;
	ValaParameter* _tmp30_;
	ValaList* _tmp31_;
	ValaParameter* _tmp32_;
	ValaParameterDirection _tmp33_;
	ValaParameter* _tmp34_;
	GError* _inner_error0_ = NULL;
	ValaParameter* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = vala_parser_parse_attributes (self, &_inner_error0_);
	attrs = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	vala_parser_get_location (self, &_tmp1_);
	begin = _tmp1_;
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_ELLIPSIS)) {
		ValaSourceLocation _tmp2_;
		ValaSourceReference* _tmp3_;
		ValaSourceReference* _tmp4_;
		ValaParameter* _tmp5_;
		ValaParameter* _tmp6_;
		_tmp2_ = begin;
		_tmp3_ = vala_parser_get_src (self, &_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = vala_parameter_new_with_ellipsis (_tmp4_);
		_tmp6_ = _tmp5_;
		_vala_source_reference_unref0 (_tmp4_);
		result = _tmp6_;
		_vala_iterable_unref0 (attrs);
		return result;
	}
	params_array = vala_parser_accept (self, VALA_TOKEN_TYPE_PARAMS);
	direction = VALA_PARAMETER_DIRECTION_IN;
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_OUT)) {
		direction = VALA_PARAMETER_DIRECTION_OUT;
	} else {
		if (vala_parser_accept (self, VALA_TOKEN_TYPE_REF)) {
			direction = VALA_PARAMETER_DIRECTION_REF;
		}
	}
	_tmp7_ = direction;
	if (_tmp7_ == VALA_PARAMETER_DIRECTION_IN) {
		ValaDataType* _tmp8_ = NULL;
		ValaDataType* _tmp9_;
		ValaDataType* _tmp10_;
		_tmp9_ = vala_parser_parse_type (self, FALSE, FALSE, FALSE, &_inner_error0_);
		_tmp8_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (type);
				_vala_iterable_unref0 (attrs);
				return NULL;
			} else {
				_vala_code_node_unref0 (type);
				_vala_iterable_unref0 (attrs);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp10_ = _tmp8_;
		_tmp8_ = NULL;
		_vala_code_node_unref0 (type);
		type = _tmp10_;
		_vala_code_node_unref0 (_tmp8_);
	} else {
		ValaParameterDirection _tmp11_;
		_tmp11_ = direction;
		if (_tmp11_ == VALA_PARAMETER_DIRECTION_REF) {
			ValaDataType* _tmp12_ = NULL;
			ValaDataType* _tmp13_;
			ValaDataType* _tmp14_;
			_tmp13_ = vala_parser_parse_type (self, TRUE, TRUE, FALSE, &_inner_error0_);
			_tmp12_ = _tmp13_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (type);
					_vala_iterable_unref0 (attrs);
					return NULL;
				} else {
					_vala_code_node_unref0 (type);
					_vala_iterable_unref0 (attrs);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp14_ = _tmp12_;
			_tmp12_ = NULL;
			_vala_code_node_unref0 (type);
			type = _tmp14_;
			_vala_code_node_unref0 (_tmp12_);
		} else {
			ValaDataType* _tmp15_ = NULL;
			ValaDataType* _tmp16_;
			ValaDataType* _tmp17_;
			_tmp16_ = vala_parser_parse_type (self, TRUE, FALSE, FALSE, &_inner_error0_);
			_tmp15_ = _tmp16_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (type);
					_vala_iterable_unref0 (attrs);
					return NULL;
				} else {
					_vala_code_node_unref0 (type);
					_vala_iterable_unref0 (attrs);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp17_ = _tmp15_;
			_tmp15_ = NULL;
			_vala_code_node_unref0 (type);
			type = _tmp17_;
			_vala_code_node_unref0 (_tmp15_);
		}
	}
	_tmp18_ = vala_parser_parse_identifier (self, &_inner_error0_);
	id = _tmp18_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (type);
			_vala_iterable_unref0 (attrs);
			return NULL;
		} else {
			_vala_code_node_unref0 (type);
			_vala_iterable_unref0 (attrs);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp20_ = type;
	_tmp21_ = vala_parser_parse_inline_array_type (self, _tmp20_, &_inner_error0_);
	_tmp19_ = _tmp21_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			_vala_iterable_unref0 (attrs);
			return NULL;
		} else {
			_g_free0 (id);
			_vala_code_node_unref0 (type);
			_vala_iterable_unref0 (attrs);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp22_ = _tmp19_;
	_tmp19_ = NULL;
	_vala_code_node_unref0 (type);
	type = _tmp22_;
	_tmp23_ = id;
	_tmp24_ = type;
	_tmp25_ = begin;
	_tmp26_ = vala_parser_get_src (self, &_tmp25_);
	_tmp27_ = _tmp26_;
	_tmp28_ = vala_parameter_new (_tmp23_, _tmp24_, _tmp27_);
	_tmp29_ = _tmp28_;
	_vala_source_reference_unref0 (_tmp27_);
	param = _tmp29_;
	_tmp30_ = param;
	_tmp31_ = attrs;
	vala_parser_set_attributes (self, (ValaCodeNode*) _tmp30_, _tmp31_);
	_tmp32_ = param;
	_tmp33_ = direction;
	vala_parameter_set_direction (_tmp32_, _tmp33_);
	_tmp34_ = param;
	vala_parameter_set_params_array (_tmp34_, params_array);
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_ASSIGN)) {
		ValaExpression* _tmp35_ = NULL;
		ValaExpression* _tmp36_;
		ValaParameter* _tmp37_;
		_tmp36_ = vala_parser_parse_expression (self, &_inner_error0_);
		_tmp35_ = _tmp36_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (param);
				_vala_code_node_unref0 (_tmp19_);
				_g_free0 (id);
				_vala_code_node_unref0 (type);
				_vala_iterable_unref0 (attrs);
				return NULL;
			} else {
				_vala_code_node_unref0 (param);
				_vala_code_node_unref0 (_tmp19_);
				_g_free0 (id);
				_vala_code_node_unref0 (type);
				_vala_iterable_unref0 (attrs);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		_tmp37_ = param;
		vala_variable_set_initializer ((ValaVariable*) _tmp37_, _tmp35_);
		_vala_code_node_unref0 (_tmp35_);
	}
	result = param;
	_vala_code_node_unref0 (_tmp19_);
	_g_free0 (id);
	_vala_code_node_unref0 (type);
	_vala_iterable_unref0 (attrs);
	return result;
}

static void
vala_parser_parse_creation_method_declaration (ValaParser* self,
                                               ValaSymbol* parent,
                                               ValaList* attrs,
                                               GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSymbolAccessibility access = 0;
	ValaParserModifierFlags flags = 0U;
	ValaUnresolvedSymbol* sym = NULL;
	ValaUnresolvedSymbol* _tmp1_;
	ValaParserModifierFlags _tmp2_;
	ValaCreationMethod* method = NULL;
	ValaUnresolvedSymbol* _tmp4_;
	ValaUnresolvedSymbol* _tmp5_;
	ValaUnresolvedSymbol* _tmp6_;
	ValaParserModifierFlags _tmp28_;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	ValaParserModifierFlags _tmp32_;
	ValaParserModifierFlags _tmp38_;
	ValaCreationMethod* _tmp54_;
	ValaSymbolAccessibility _tmp55_;
	ValaCreationMethod* _tmp56_;
	ValaCreationMethod* _tmp61_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	access = vala_parser_parse_access_modifier (self, VALA_SYMBOL_ACCESSIBILITY_PRIVATE);
	flags = vala_parser_parse_member_declaration_modifiers (self);
	_tmp1_ = vala_parser_parse_symbol_name (self, &_inner_error0_);
	sym = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp2_ = flags;
	if ((_tmp2_ & VALA_PARSER_MODIFIER_FLAGS_NEW) == VALA_PARSER_MODIFIER_FLAGS_NEW) {
		GError* _tmp3_;
		_tmp3_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "`new' modifier not allowed on creation method");
		_inner_error0_ = _tmp3_;
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp4_ = sym;
	_tmp5_ = vala_unresolved_symbol_get_inner (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_ == NULL) {
		ValaUnresolvedSymbol* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		ValaSourceLocation _tmp10_;
		ValaSourceReference* _tmp11_;
		ValaSourceReference* _tmp12_;
		ValaComment* _tmp13_;
		ValaCreationMethod* _tmp14_;
		_tmp7_ = sym;
		_tmp8_ = vala_symbol_get_name ((ValaSymbol*) _tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = begin;
		_tmp11_ = vala_parser_get_src (self, &_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = self->priv->comment;
		_tmp14_ = vala_creation_method_new (_tmp9_, NULL, _tmp12_, _tmp13_);
		_vala_code_node_unref0 (method);
		method = _tmp14_;
		_vala_source_reference_unref0 (_tmp12_);
	} else {
		ValaUnresolvedSymbol* _tmp15_;
		ValaUnresolvedSymbol* _tmp16_;
		ValaUnresolvedSymbol* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		ValaUnresolvedSymbol* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		ValaSourceLocation _tmp23_;
		ValaSourceReference* _tmp24_;
		ValaSourceReference* _tmp25_;
		ValaComment* _tmp26_;
		ValaCreationMethod* _tmp27_;
		_tmp15_ = sym;
		_tmp16_ = vala_unresolved_symbol_get_inner (_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp18_ = vala_symbol_get_name ((ValaSymbol*) _tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = sym;
		_tmp21_ = vala_symbol_get_name ((ValaSymbol*) _tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = begin;
		_tmp24_ = vala_parser_get_src (self, &_tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = self->priv->comment;
		_tmp27_ = vala_creation_method_new (_tmp19_, _tmp22_, _tmp25_, _tmp26_);
		_vala_code_node_unref0 (method);
		method = _tmp27_;
		_vala_source_reference_unref0 (_tmp25_);
	}
	_tmp28_ = flags;
	if ((_tmp28_ & VALA_PARSER_MODIFIER_FLAGS_EXTERN) == VALA_PARSER_MODIFIER_FLAGS_EXTERN) {
		ValaCreationMethod* _tmp29_;
		_tmp29_ = method;
		vala_symbol_set_is_extern ((ValaSymbol*) _tmp29_, TRUE);
	}
	_tmp32_ = flags;
	if ((_tmp32_ & VALA_PARSER_MODIFIER_FLAGS_ABSTRACT) == VALA_PARSER_MODIFIER_FLAGS_ABSTRACT) {
		_tmp31_ = TRUE;
	} else {
		ValaParserModifierFlags _tmp33_;
		_tmp33_ = flags;
		_tmp31_ = (_tmp33_ & VALA_PARSER_MODIFIER_FLAGS_VIRTUAL) == VALA_PARSER_MODIFIER_FLAGS_VIRTUAL;
	}
	if (_tmp31_) {
		_tmp30_ = TRUE;
	} else {
		ValaParserModifierFlags _tmp34_;
		_tmp34_ = flags;
		_tmp30_ = (_tmp34_ & VALA_PARSER_MODIFIER_FLAGS_OVERRIDE) == VALA_PARSER_MODIFIER_FLAGS_OVERRIDE;
	}
	if (_tmp30_) {
		ValaCreationMethod* _tmp35_;
		ValaSourceReference* _tmp36_;
		ValaSourceReference* _tmp37_;
		_tmp35_ = method;
		_tmp36_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp35_);
		_tmp37_ = _tmp36_;
		vala_report_error (_tmp37_, "abstract, virtual, and override modifiers are not applicable to creati" \
"on methods");
	}
	_tmp38_ = flags;
	if ((_tmp38_ & VALA_PARSER_MODIFIER_FLAGS_ASYNC) == VALA_PARSER_MODIFIER_FLAGS_ASYNC) {
		ValaCreationMethod* _tmp39_;
		_tmp39_ = method;
		vala_method_set_coroutine ((ValaMethod*) _tmp39_, TRUE);
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (method);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_code_node_unref0 (method);
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	if (vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_PARENS) {
		{
			gboolean _tmp40_ = FALSE;
			_tmp40_ = TRUE;
			while (TRUE) {
				ValaParameter* param = NULL;
				ValaParameter* _tmp41_;
				ValaCreationMethod* _tmp42_;
				ValaParameter* _tmp43_;
				if (!_tmp40_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp40_ = FALSE;
				_tmp41_ = vala_parser_parse_parameter (self, &_inner_error0_);
				param = _tmp41_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (method);
						_vala_code_node_unref0 (sym);
						return;
					} else {
						_vala_code_node_unref0 (method);
						_vala_code_node_unref0 (sym);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_tmp42_ = method;
				_tmp43_ = param;
				vala_callable_add_parameter ((ValaCallable*) _tmp42_, _tmp43_);
				_vala_code_node_unref0 (param);
			}
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (method);
			_vala_code_node_unref0 (sym);
			return;
		} else {
			_vala_code_node_unref0 (method);
			_vala_code_node_unref0 (sym);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_THROWS)) {
		{
			gboolean _tmp44_ = FALSE;
			_tmp44_ = TRUE;
			while (TRUE) {
				ValaDataType* _tmp45_ = NULL;
				ValaDataType* _tmp46_;
				ValaCreationMethod* _tmp47_;
				if (!_tmp44_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp44_ = FALSE;
				_tmp46_ = vala_parser_parse_type (self, TRUE, FALSE, FALSE, &_inner_error0_);
				_tmp45_ = _tmp46_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (method);
						_vala_code_node_unref0 (sym);
						return;
					} else {
						_vala_code_node_unref0 (method);
						_vala_code_node_unref0 (sym);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_tmp47_ = method;
				vala_method_add_error_type ((ValaMethod*) _tmp47_, _tmp45_);
				_vala_code_node_unref0 (_tmp45_);
			}
		}
	}
	while (TRUE) {
		ValaExpression* _tmp48_ = NULL;
		ValaExpression* _tmp49_;
		ValaCreationMethod* _tmp50_;
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_REQUIRES)) {
			break;
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (method);
				_vala_code_node_unref0 (sym);
				return;
			} else {
				_vala_code_node_unref0 (method);
				_vala_code_node_unref0 (sym);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp49_ = vala_parser_parse_expression (self, &_inner_error0_);
		_tmp48_ = _tmp49_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (method);
				_vala_code_node_unref0 (sym);
				return;
			} else {
				_vala_code_node_unref0 (method);
				_vala_code_node_unref0 (sym);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp50_ = method;
		vala_method_add_precondition ((ValaMethod*) _tmp50_, _tmp48_);
		vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (_tmp48_);
				_vala_code_node_unref0 (method);
				_vala_code_node_unref0 (sym);
				return;
			} else {
				_vala_code_node_unref0 (_tmp48_);
				_vala_code_node_unref0 (method);
				_vala_code_node_unref0 (sym);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_vala_code_node_unref0 (_tmp48_);
	}
	while (TRUE) {
		ValaExpression* _tmp51_ = NULL;
		ValaExpression* _tmp52_;
		ValaCreationMethod* _tmp53_;
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_ENSURES)) {
			break;
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (method);
				_vala_code_node_unref0 (sym);
				return;
			} else {
				_vala_code_node_unref0 (method);
				_vala_code_node_unref0 (sym);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp52_ = vala_parser_parse_expression (self, &_inner_error0_);
		_tmp51_ = _tmp52_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (method);
				_vala_code_node_unref0 (sym);
				return;
			} else {
				_vala_code_node_unref0 (method);
				_vala_code_node_unref0 (sym);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp53_ = method;
		vala_method_add_postcondition ((ValaMethod*) _tmp53_, _tmp51_);
		vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (_tmp51_);
				_vala_code_node_unref0 (method);
				_vala_code_node_unref0 (sym);
				return;
			} else {
				_vala_code_node_unref0 (_tmp51_);
				_vala_code_node_unref0 (method);
				_vala_code_node_unref0 (sym);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_vala_code_node_unref0 (_tmp51_);
	}
	_tmp54_ = method;
	_tmp55_ = access;
	vala_symbol_set_access ((ValaSymbol*) _tmp54_, _tmp55_);
	_tmp56_ = method;
	vala_parser_set_attributes (self, (ValaCodeNode*) _tmp56_, attrs);
	if (!vala_parser_accept (self, VALA_TOKEN_TYPE_SEMICOLON)) {
		ValaBlock* _tmp57_ = NULL;
		ValaBlock* _tmp58_;
		ValaCreationMethod* _tmp59_;
		ValaCreationMethod* _tmp60_;
		_tmp58_ = vala_parser_parse_block (self, &_inner_error0_);
		_tmp57_ = _tmp58_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_code_node_unref0 (method);
				_vala_code_node_unref0 (sym);
				return;
			} else {
				_vala_code_node_unref0 (method);
				_vala_code_node_unref0 (sym);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
		_tmp59_ = method;
		vala_subroutine_set_body ((ValaSubroutine*) _tmp59_, _tmp57_);
		_tmp60_ = method;
		vala_symbol_set_external ((ValaSymbol*) _tmp60_, FALSE);
		_vala_code_node_unref0 (_tmp57_);
	}
	_tmp61_ = method;
	vala_symbol_add_method (parent, (ValaMethod*) _tmp61_);
	_vala_code_node_unref0 (method);
	_vala_code_node_unref0 (sym);
}

static void
vala_parser_parse_delegate_declaration (ValaParser* self,
                                        ValaSymbol* parent,
                                        ValaList* attrs,
                                        GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSymbolAccessibility access = 0;
	ValaParserModifierFlags flags = 0U;
	ValaParserModifierFlags _tmp1_;
	ValaDataType* type = NULL;
	ValaDataType* _tmp3_;
	ValaUnresolvedSymbol* sym = NULL;
	ValaUnresolvedSymbol* _tmp4_;
	ValaList* type_param_list = NULL;
	ValaList* _tmp5_;
	ValaDelegate* d = NULL;
	ValaUnresolvedSymbol* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	ValaDataType* _tmp9_;
	ValaSourceLocation _tmp10_;
	ValaSourceReference* _tmp11_;
	ValaSourceReference* _tmp12_;
	ValaComment* _tmp13_;
	ValaDelegate* _tmp14_;
	ValaDelegate* _tmp15_;
	ValaDelegate* _tmp16_;
	ValaSymbolAccessibility _tmp17_;
	ValaDelegate* _tmp18_;
	ValaParserModifierFlags _tmp19_;
	ValaParserModifierFlags _tmp26_;
	ValaDelegate* _tmp28_;
	ValaSymbol* _result_ = NULL;
	ValaDelegate* _tmp54_;
	ValaSymbol* _tmp55_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	access = vala_parser_parse_access_modifier (self, VALA_SYMBOL_ACCESSIBILITY_PRIVATE);
	flags = vala_parser_parse_member_declaration_modifiers (self);
	vala_parser_expect (self, VALA_TOKEN_TYPE_DELEGATE, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp1_ = flags;
	if ((_tmp1_ & VALA_PARSER_MODIFIER_FLAGS_NEW) == VALA_PARSER_MODIFIER_FLAGS_NEW) {
		GError* _tmp2_;
		_tmp2_ = g_error_new_literal (VALA_PARSE_ERROR, VALA_PARSE_ERROR_SYNTAX, "`new' modifier not allowed on delegates");
		_inner_error0_ = _tmp2_;
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp3_ = vala_parser_parse_type (self, TRUE, FALSE, FALSE, &_inner_error0_);
	type = _tmp3_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp4_ = vala_parser_parse_symbol_name (self, &_inner_error0_);
	sym = _tmp4_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp5_ = vala_parser_parse_type_parameter_list (self, &_inner_error0_);
	type_param_list = _tmp5_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (sym);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (sym);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp6_ = sym;
	_tmp7_ = vala_symbol_get_name ((ValaSymbol*) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = type;
	_tmp10_ = begin;
	_tmp11_ = vala_parser_get_src (self, &_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = self->priv->comment;
	_tmp14_ = vala_delegate_new (_tmp8_, _tmp9_, _tmp12_, _tmp13_);
	_tmp15_ = _tmp14_;
	_vala_source_reference_unref0 (_tmp12_);
	d = _tmp15_;
	_tmp16_ = d;
	_tmp17_ = access;
	vala_symbol_set_access ((ValaSymbol*) _tmp16_, _tmp17_);
	_tmp18_ = d;
	vala_parser_set_attributes (self, (ValaCodeNode*) _tmp18_, attrs);
	_tmp19_ = flags;
	if ((_tmp19_ & VALA_PARSER_MODIFIER_FLAGS_STATIC) == VALA_PARSER_MODIFIER_FLAGS_STATIC) {
		ValaCodeContext* _tmp20_;
		gboolean _tmp21_;
		gboolean _tmp22_;
		ValaDelegate* _tmp25_;
		_tmp20_ = self->priv->context;
		_tmp21_ = vala_code_context_get_deprecated (_tmp20_);
		_tmp22_ = _tmp21_;
		if (!_tmp22_) {
			ValaSourceReference* _tmp23_;
			ValaSourceReference* _tmp24_;
			_tmp23_ = vala_parser_get_last_src (self);
			_tmp24_ = _tmp23_;
			vala_report_warning (_tmp24_, "deprecated syntax, use [CCode (has_target = false)]");
			_vala_source_reference_unref0 (_tmp24_);
		}
		_tmp25_ = d;
		vala_delegate_set_has_target (_tmp25_, FALSE);
	}
	_tmp26_ = flags;
	if ((_tmp26_ & VALA_PARSER_MODIFIER_FLAGS_EXTERN) == VALA_PARSER_MODIFIER_FLAGS_EXTERN) {
		ValaDelegate* _tmp27_;
		_tmp27_ = d;
		vala_symbol_set_is_extern ((ValaSymbol*) _tmp27_, TRUE);
	}
	_tmp28_ = d;
	if (!vala_code_node_get_attribute_bool ((ValaCodeNode*) _tmp28_, "CCode", "has_typedef", TRUE)) {
		ValaDelegate* _tmp29_;
		gboolean _tmp30_;
		gboolean _tmp31_;
		ValaDelegate* _tmp34_;
		_tmp29_ = d;
		_tmp30_ = vala_symbol_get_external ((ValaSymbol*) _tmp29_);
		_tmp31_ = _tmp30_;
		if (!_tmp31_) {
			ValaSourceReference* _tmp32_;
			ValaSourceReference* _tmp33_;
			_tmp32_ = vala_parser_get_last_src (self);
			_tmp33_ = _tmp32_;
			vala_report_error (_tmp33_, "Delegates without definition must be external");
			_vala_source_reference_unref0 (_tmp33_);
		}
		_tmp34_ = d;
		vala_symbol_set_anonymous ((ValaSymbol*) _tmp34_, TRUE);
	}
	{
		ValaList* _type_param_list = NULL;
		ValaList* _tmp35_;
		ValaList* _tmp36_;
		gint _type_param_size = 0;
		ValaList* _tmp37_;
		gint _tmp38_;
		gint _tmp39_;
		gint _type_param_index = 0;
		_tmp35_ = type_param_list;
		_tmp36_ = _vala_iterable_ref0 (_tmp35_);
		_type_param_list = _tmp36_;
		_tmp37_ = _type_param_list;
		_tmp38_ = vala_collection_get_size ((ValaCollection*) _tmp37_);
		_tmp39_ = _tmp38_;
		_type_param_size = _tmp39_;
		_type_param_index = -1;
		while (TRUE) {
			gint _tmp40_;
			gint _tmp41_;
			ValaTypeParameter* type_param = NULL;
			ValaList* _tmp42_;
			gpointer _tmp43_;
			ValaDelegate* _tmp44_;
			ValaTypeParameter* _tmp45_;
			_type_param_index = _type_param_index + 1;
			_tmp40_ = _type_param_index;
			_tmp41_ = _type_param_size;
			if (!(_tmp40_ < _tmp41_)) {
				break;
			}
			_tmp42_ = _type_param_list;
			_tmp43_ = vala_list_get (_tmp42_, _type_param_index);
			type_param = (ValaTypeParameter*) _tmp43_;
			_tmp44_ = d;
			_tmp45_ = type_param;
			vala_delegate_add_type_parameter (_tmp44_, _tmp45_);
			_vala_code_node_unref0 (type_param);
		}
		_vala_iterable_unref0 (_type_param_list);
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_OPEN_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (d);
			_vala_iterable_unref0 (type_param_list);
			_vala_code_node_unref0 (sym);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (d);
			_vala_iterable_unref0 (type_param_list);
			_vala_code_node_unref0 (sym);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	if (vala_parser_current (self) != VALA_TOKEN_TYPE_CLOSE_PARENS) {
		{
			gboolean _tmp46_ = FALSE;
			_tmp46_ = TRUE;
			while (TRUE) {
				ValaParameter* param = NULL;
				ValaParameter* _tmp47_;
				ValaDelegate* _tmp48_;
				ValaParameter* _tmp49_;
				if (!_tmp46_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp46_ = FALSE;
				_tmp47_ = vala_parser_parse_parameter (self, &_inner_error0_);
				param = _tmp47_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (d);
						_vala_iterable_unref0 (type_param_list);
						_vala_code_node_unref0 (sym);
						_vala_code_node_unref0 (type);
						return;
					} else {
						_vala_code_node_unref0 (d);
						_vala_iterable_unref0 (type_param_list);
						_vala_code_node_unref0 (sym);
						_vala_code_node_unref0 (type);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_tmp48_ = d;
				_tmp49_ = param;
				vala_callable_add_parameter ((ValaCallable*) _tmp48_, _tmp49_);
				_vala_code_node_unref0 (param);
			}
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_CLOSE_PARENS, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (d);
			_vala_iterable_unref0 (type_param_list);
			_vala_code_node_unref0 (sym);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (d);
			_vala_iterable_unref0 (type_param_list);
			_vala_code_node_unref0 (sym);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_THROWS)) {
		{
			gboolean _tmp50_ = FALSE;
			_tmp50_ = TRUE;
			while (TRUE) {
				ValaDataType* _tmp51_ = NULL;
				ValaDataType* _tmp52_;
				ValaDelegate* _tmp53_;
				if (!_tmp50_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp50_ = FALSE;
				_tmp52_ = vala_parser_parse_type (self, TRUE, FALSE, FALSE, &_inner_error0_);
				_tmp51_ = _tmp52_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_code_node_unref0 (d);
						_vala_iterable_unref0 (type_param_list);
						_vala_code_node_unref0 (sym);
						_vala_code_node_unref0 (type);
						return;
					} else {
						_vala_code_node_unref0 (d);
						_vala_iterable_unref0 (type_param_list);
						_vala_code_node_unref0 (sym);
						_vala_code_node_unref0 (type);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
				_tmp53_ = d;
				vala_delegate_add_error_type (_tmp53_, _tmp51_);
				_vala_code_node_unref0 (_tmp51_);
			}
		}
	}
	vala_parser_expect (self, VALA_TOKEN_TYPE_SEMICOLON, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VALA_PARSE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_vala_code_node_unref0 (d);
			_vala_iterable_unref0 (type_param_list);
			_vala_code_node_unref0 (sym);
			_vala_code_node_unref0 (type);
			return;
		} else {
			_vala_code_node_unref0 (d);
			_vala_iterable_unref0 (type_param_list);
			_vala_code_node_unref0 (sym);
			_vala_code_node_unref0 (type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp54_ = d;
	_tmp55_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp54_);
	_result_ = _tmp55_;
	while (TRUE) {
		ValaUnresolvedSymbol* _tmp56_;
		ValaUnresolvedSymbol* _tmp57_;
		ValaUnresolvedSymbol* _tmp58_;
		ValaUnresolvedSymbol* _tmp59_;
		ValaUnresolvedSymbol* _tmp60_;
		ValaSymbol* _tmp61_ = NULL;
		ValaUnresolvedSymbol* _tmp62_;
		ValaSymbol* next = NULL;
		ValaSymbol* _tmp71_;
		ValaSymbol* _tmp72_;
		ValaSymbol* _tmp77_;
		ValaSymbol* _tmp78_;
		_tmp56_ = sym;
		if (!(_tmp56_ != NULL)) {
			break;
		}
		_tmp57_ = sym;
		_tmp58_ = vala_unresolved_symbol_get_inner (_tmp57_);
		_tmp59_ = _tmp58_;
		_tmp60_ = _vala_code_node_ref0 (_tmp59_);
		_vala_code_node_unref0 (sym);
		sym = _tmp60_;
		_tmp62_ = sym;
		if (_tmp62_ != NULL) {
			ValaUnresolvedSymbol* _tmp63_;
			const gchar* _tmp64_;
			const gchar* _tmp65_;
			ValaDelegate* _tmp66_;
			ValaSourceReference* _tmp67_;
			ValaSourceReference* _tmp68_;
			ValaNamespace* _tmp69_;
			_tmp63_ = sym;
			_tmp64_ = vala_symbol_get_name ((ValaSymbol*) _tmp63_);
			_tmp65_ = _tmp64_;
			_tmp66_ = d;
			_tmp67_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp66_);
			_tmp68_ = _tmp67_;
			_tmp69_ = vala_namespace_new (_tmp65_, _tmp68_);
			_vala_code_node_unref0 (_tmp61_);
			_tmp61_ = (ValaSymbol*) _tmp69_;
		} else {
			ValaSymbol* _tmp70_;
			_tmp70_ = _vala_code_node_ref0 (parent);
			_vala_code_node_unref0 (_tmp61_);
			_tmp61_ = _tmp70_;
		}
		_tmp71_ = _vala_code_node_ref0 (_tmp61_);
		next = _tmp71_;
		_tmp72_ = _result_;
		if (VALA_IS_NAMESPACE (_tmp72_)) {
			ValaSymbol* _tmp73_;
			ValaSymbol* _tmp74_;
			_tmp73_ = next;
			_tmp74_ = _result_;
			vala_symbol_add_namespace (_tmp73_, G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, VALA_TYPE_NAMESPACE, ValaNamespace));
		} else {
			ValaSymbol* _tmp75_;
			ValaSymbol* _tmp76_;
			_tmp75_ = next;
			_tmp76_ = _result_;
			vala_symbol_add_delegate (_tmp75_, G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, VALA_TYPE_DELEGATE, ValaDelegate));
		}
		_tmp77_ = next;
		_tmp78_ = _vala_code_node_ref0 (_tmp77_);
		_vala_code_node_unref0 (_result_);
		_result_ = _tmp78_;
		_vala_code_node_unref0 (next);
		_vala_code_node_unref0 (_tmp61_);
	}
	_vala_code_node_unref0 (_result_);
	_vala_code_node_unref0 (d);
	_vala_iterable_unref0 (type_param_list);
	_vala_code_node_unref0 (sym);
	_vala_code_node_unref0 (type);
}

static ValaList*
vala_parser_parse_type_parameter_list (ValaParser* self,
                                       GError** error)
{
	GError* _inner_error0_ = NULL;
	ValaList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_OP_LT)) {
		ValaArrayList* list = NULL;
		GEqualFunc _tmp0_;
		ValaArrayList* _tmp1_;
		_tmp0_ = g_direct_equal;
		_tmp1_ = vala_array_list_new (VALA_TYPE_TYPEPARAMETER, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp0_);
		list = _tmp1_;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				ValaSourceLocation begin = {0};
				ValaSourceLocation _tmp3_ = {0};
				gchar* id = NULL;
				gchar* _tmp4_;
				ValaArrayList* _tmp5_;
				const gchar* _tmp6_;
				ValaSourceLocation _tmp7_;
				ValaSourceReference* _tmp8_;
				ValaSourceReference* _tmp9_;
				ValaTypeParameter* _tmp10_;
				ValaTypeParameter* _tmp11_;
				if (!_tmp2_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp2_ = FALSE;
				vala_parser_get_location (self, &_tmp3_);
				begin = _tmp3_;
				_tmp4_ = vala_parser_parse_identifier (self, &_inner_error0_);
				id = _tmp4_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_vala_iterable_unref0 (list);
						return NULL;
					} else {
						_vala_iterable_unref0 (list);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp5_ = list;
				_tmp6_ = id;
				_tmp7_ = begin;
				_tmp8_ = vala_parser_get_src (self, &_tmp7_);
				_tmp9_ = _tmp8_;
				_tmp10_ = vala_typeparameter_new (_tmp6_, _tmp9_);
				_tmp11_ = _tmp10_;
				vala_collection_add ((ValaCollection*) _tmp5_, _tmp11_);
				_vala_code_node_unref0 (_tmp11_);
				_vala_source_reference_unref0 (_tmp9_);
				_g_free0 (id);
			}
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_OP_GT, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_vala_iterable_unref0 (list);
				return NULL;
			} else {
				_vala_iterable_unref0 (list);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
		result = (ValaList*) list;
		return result;
	} else {
		ValaList* _tmp12_;
		ValaList* _tmp15_;
		ValaList* _tmp16_;
		_tmp12_ = vala_parser__empty_type_parameter_list;
		if (_tmp12_ == NULL) {
			GEqualFunc _tmp13_;
			ValaArrayList* _tmp14_;
			_tmp13_ = g_direct_equal;
			_tmp14_ = vala_array_list_new (VALA_TYPE_TYPEPARAMETER, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp13_);
			_vala_iterable_unref0 (vala_parser__empty_type_parameter_list);
			vala_parser__empty_type_parameter_list = (ValaList*) _tmp14_;
		}
		_tmp15_ = vala_parser__empty_type_parameter_list;
		_tmp16_ = _vala_iterable_ref0 (_tmp15_);
		result = _tmp16_;
		return result;
	}
}

static void
vala_parser_skip_type_argument_list (ValaParser* self,
                                     GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_OP_LT)) {
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp0_ = FALSE;
				vala_parser_skip_type (self, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						return;
					} else {
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return;
					}
				}
			}
		}
		vala_parser_expect (self, VALA_TOKEN_TYPE_OP_GT, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VALA_PARSE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
}

static ValaList*
vala_parser_parse_type_argument_list (ValaParser* self,
                                      gboolean maybe_expression,
                                      GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
	ValaList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	if (vala_parser_accept (self, VALA_TOKEN_TYPE_OP_LT)) {
		ValaArrayList* list = NULL;
		GEqualFunc _tmp1_;
		ValaArrayList* _tmp2_;
		_tmp1_ = g_direct_equal;
		_tmp2_ = vala_array_list_new (VALA_TYPE_DATA_TYPE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp1_);
		list = _tmp2_;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				if (!_tmp3_) {
					if (!vala_parser_accept (self, VALA_TOKEN_TYPE_COMMA)) {
						break;
					}
				}
				_tmp3_ = FALSE;
				switch (vala_parser_current (self)) {
					case VALA_TOKEN_TYPE_VOID:
					case VALA_TOKEN_TYPE_DYNAMIC:
					case VALA_TOKEN_TYPE_UNOWNED:
					case VALA_TOKEN_TYPE_WEAK:
					case VALA_TOKEN_TYPE_IDENTIFIER:
					{
						ValaDataType* type = NULL;
						ValaDataType* _tmp4_;
						ValaArrayList* _tmp5_;
						ValaDataType* _tmp6_;
						_tmp4_ = vala_parser_parse_type (self, TRUE, TRUE, FALSE, &_inner_error0_);
						type = _tmp4_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							if (_inner_error0_->domain == VALA_PARSE_ERROR) {
								g_propagate_error (error, _inner_error0_);
								_vala_iterable_unref0 (list);
								return NULL;
							} else {
								_vala_iterable_unref0 (list);
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
								g_clear_error (&_inner_error0_);
								return NULL;
							}
						}
						_tmp5_ = list;
						_tmp6_ = type;
						vala_collection_add ((ValaCollection*) _tmp5_, _tmp6_);
						_vala_code_node_unref0 (type);
						break;
					}
					default:
					{
						ValaSourceLocation _tmp7_;
						_tmp7_ = begin;
						vala_parser_rollback (self, &_tmp7_);
						result = NULL;
						_vala_iterable_unref0 (list);
						return result;
					}
				}
			}
		}
		if (!vala_parser_accept (self, VALA_TOKEN_TYPE_OP_GT)) {
			ValaSourceLocation _tmp8_;
			_tmp8_ = begin;
			vala_parser_rollback (self, &_tmp8_);
			result = NULL;
			_vala_iterable_unref0 (list);
			return result;
		}
		if (maybe_expression) {
			switch (vala_parser_current (self)) {
				case VALA_TOKEN_TYPE_OPEN_PARENS:
				case VALA_TOKEN_TYPE_CLOSE_PARENS:
				case VALA_TOKEN_TYPE_CLOSE_BRACKET:
				case VALA_TOKEN_TYPE_OPEN_BRACE:
				case VALA_TOKEN_TYPE_COLON:
				case VALA_TOKEN_TYPE_SEMICOLON:
				case VALA_TOKEN_TYPE_COMMA:
				case VALA_TOKEN_TYPE_DOT:
				case VALA_TOKEN_TYPE_INTERR:
				case VALA_TOKEN_TYPE_OP_EQ:
				case VALA_TOKEN_TYPE_OP_NE:
				{
					break;
				}
				default:
				{
					ValaSourceLocation _tmp9_;
					_tmp9_ = begin;
					vala_parser_rollback (self, &_tmp9_);
					result = NULL;
					_vala_iterable_unref0 (list);
					return result;
				}
			}
		}
		result = (ValaList*) list;
		return result;
	}
	result = NULL;
	return result;
}

static ValaMemberAccess*
vala_parser_parse_member_name (ValaParser* self,
                               ValaExpression* base_expr,
                               GError** error)
{
	ValaSourceLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaMemberAccess* expr = NULL;
	gboolean first = FALSE;
	GError* _inner_error0_ = NULL;
	ValaMemberAccess* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	vala_parser_get_location (self, &_tmp0_);
	begin = _tmp0_;
	expr = NULL;
	first = TRUE;
	{
		gboolean _tmp1_ = FALSE;
		_tmp1_ = TRUE;
		while (TRUE) {
			gchar* id = NULL;
			gchar* _tmp2_;
			gboolean qualified = FALSE;
			gboolean _tmp3_ = FALSE;
			gboolean _tmp4_ = FALSE;
			ValaList* type_arg_list = NULL;
			ValaList* _tmp9_;
			ValaExpression* _tmp10_ = NULL;
			ValaMemberAccess* _tmp11_;
			const gchar* _tmp13_;
			ValaSourceLocation _tmp14_;
			ValaSourceReference* _tmp15_;
			ValaSourceReference* _tmp16_;
			ValaMemberAccess* _tmp17_;
			ValaMemberAccess* _tmp18_;
			ValaList* _tmp19_;
			if (!_tmp1_) {
				if (!vala_parser_accept (self, VALA_TOKEN_TYPE_DOT)) {
					break;
				}
			}
			_tmp1_ = FALSE;
			_tmp2_ = vala_parser_parse_identifier (self, &_inner_error0_);
			id = _tmp2_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_vala_code_node_unref0 (expr);
					return NULL;
				} else {
					_vala_code_node_unref0 (expr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			qualified = FALSE;
			if (first) {
				const gchar* _tmp5_;
				_tmp5_ = id;
				_tmp4_ = g_strcmp0 (_tmp5_, "global") == 0;
			} else {
				_tmp4_ = FALSE;
			}
			if (_tmp4_) {
				_tmp3_ = vala_parser_accept (self, VALA_TOKEN_TYPE_DOUBLE_COLON);
			} else {
				_tmp3_ = FALSE;
			}
			if (_tmp3_) {
				gchar* _tmp6_ = NULL;
				gchar* _tmp7_;
				gchar* _tmp8_;
				_tmp7_ = vala_parser_parse_identifier (self, &_inner_error0_);
				_tmp6_ = _tmp7_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == VALA_PARSE_ERROR) {
						g_propagate_error (error, _inner_error0_);
						_g_free0 (id);
						_vala_code_node_unref0 (expr);
						return NULL;
					} else {
						_g_free0 (id);
						_vala_code_node_unref0 (expr);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return NULL;
					}
				}
				_tmp8_ = _tmp6_;
				_tmp6_ = NULL;
				_g_free0 (id);
				id = _tmp8_;
				qualified = TRUE;
				_g_free0 (_tmp6_);
			}
			_tmp9_ = vala_parser_parse_type_argument_list (self, FALSE, &_inner_error0_);
			type_arg_list = _tmp9_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == VALA_PARSE_ERROR) {
					g_propagate_error (error, _inner_error0_);
					_g_free0 (id);
					_vala_code_node_unref0 (expr);
					return NULL;
				} else {
					_g_free0 (id);
					_vala_code_node_unref0 (expr);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			_tmp11_ = expr;
			if (_tmp11_ != NULL) {
				ValaMemberAccess* _tmp12_;
				_tmp12_ = expr;
				_tmp10_ = (ValaExpression*) _tmp12_;
			} else {
				_tmp10_ = base_expr;
			}
			_tmp13_ = id;
			_tmp14_ = begin;
			_tmp15_ = vala_parser_get_src (self, &_tmp14_);
			_tmp16_ = _tmp15_;
			_tmp17_ = vala_member_access_new (_tmp10_, _tmp13_, _tmp16_);
			_vala_code_node_unref0 (expr);
			expr = _tmp17_;
			_vala_source_reference_unref0 (_tmp16_);
			_tmp18_ = expr;
			vala_member_access_set_qualified (_tmp18_, qualified);
			_tmp19_ = type_arg_list;
			if (_tmp19_ != NULL) {
				{
					ValaList* _type_arg_list = NULL;
					ValaList* _tmp20_;
					ValaList* _tmp21_;
					gint _type_arg_size = 0;
					ValaList* _tmp22_;
					gint _tmp23_;
					gint _tmp24_;
					gint _type_arg_index = 0;
					_tmp20_ = type_arg_list;
					_tmp21_ = _vala_iterable_ref0 (_tmp20_);
					_type_arg_list = _tmp21_;
					_tmp22_ = _type_arg_list;
					_tmp23_ = vala_collection_get_size ((ValaCollection*) _tmp22_);
					_tmp24_ = _tmp23_;
					_type_arg_size = _tmp24_;
					_type_arg_index = -1;
					while (TRUE) {
						gint _tmp25_;
						gint _tmp26_;
						ValaDataType* type_arg = NULL;
						ValaList* _tmp27_;
						gpointer _tmp28_;
						ValaMemberAccess* _tmp29_;
						ValaDataType* _tmp30_;
						_type_arg_index = _type_arg_index + 1;
						_tmp25_ = _type_arg_index;
						_tmp26_ = _type_arg_size;
						if (!(_tmp25_ < _tmp26_)) {
							break;
						}
						_tmp27_ = _type_arg_list;
						_tmp28_ = vala_list_get (_tmp27_, _type_arg_index);
						type_arg = (ValaDataType*) _tmp28_;
						_tmp29_ = expr;
						_tmp30_ = type_arg;
						vala_member_access_add_type_argument (_tmp29_, _tmp30_);
						_vala_code_node_unref0 (type_arg);
					}
					_vala_iterable_unref0 (_type_arg_list);
				}
			}
			first = FALSE;
			_vala_iterable_unref0 (type_arg_list);
			_g_free0 (id);
		}
	}
	result = expr;
	return result;
}

static gboolean
vala_parser_is_declaration_keyword (ValaParser* self,
                                    ValaTokenType type)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	switch (type) {
		case VALA_TOKEN_TYPE_ABSTRACT:
		case VALA_TOKEN_TYPE_ASYNC:
		case VALA_TOKEN_TYPE_CLASS:
		case VALA_TOKEN_TYPE_CONST:
		case VALA_TOKEN_TYPE_DELEGATE:
		case VALA_TOKEN_TYPE_ENUM:
		case VALA_TOKEN_TYPE_ERRORDOMAIN:
		case VALA_TOKEN_TYPE_EXTERN:
		case VALA_TOKEN_TYPE_INLINE:
		case VALA_TOKEN_TYPE_INTERFACE:
		case VALA_TOKEN_TYPE_INTERNAL:
		case VALA_TOKEN_TYPE_NAMESPACE:
		case VALA_TOKEN_TYPE_NEW:
		case VALA_TOKEN_TYPE_OVERRIDE:
		case VALA_TOKEN_TYPE_PRIVATE:
		case VALA_TOKEN_TYPE_PROTECTED:
		case VALA_TOKEN_TYPE_PUBLIC:
		case VALA_TOKEN_TYPE_SEALED:
		case VALA_TOKEN_TYPE_SIGNAL:
		case VALA_TOKEN_TYPE_STATIC:
		case VALA_TOKEN_TYPE_STRUCT:
		case VALA_TOKEN_TYPE_VIRTUAL:
		case VALA_TOKEN_TYPE_VOLATILE:
		{
			result = TRUE;
			return result;
		}
		default:
		{
			result = FALSE;
			return result;
		}
	}
}

static ValaParserTokenInfo*
vala_parser_token_info_dup (const ValaParserTokenInfo* self)
{
	ValaParserTokenInfo* dup;
	dup = g_new0 (ValaParserTokenInfo, 1);
	memcpy (dup, self, sizeof (ValaParserTokenInfo));
	return dup;
}

static void
vala_parser_token_info_free (ValaParserTokenInfo* self)
{
	g_free (self);
}

static GType
vala_parser_token_info_get_type_once (void)
{
	GType vala_parser_token_info_type_id;
	vala_parser_token_info_type_id = g_boxed_type_register_static ("ValaParserTokenInfo", (GBoxedCopyFunc) vala_parser_token_info_dup, (GBoxedFreeFunc) vala_parser_token_info_free);
	return vala_parser_token_info_type_id;
}

static GType
vala_parser_token_info_get_type (void)
{
	static volatile gsize vala_parser_token_info_type_id__volatile = 0;
	if (g_once_init_enter (&vala_parser_token_info_type_id__volatile)) {
		GType vala_parser_token_info_type_id;
		vala_parser_token_info_type_id = vala_parser_token_info_get_type_once ();
		g_once_init_leave (&vala_parser_token_info_type_id__volatile, vala_parser_token_info_type_id);
	}
	return vala_parser_token_info_type_id__volatile;
}

static void
vala_parser_class_init (ValaParserClass * klass,
                        gpointer klass_data)
{
	vala_parser_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeVisitorClass *) klass)->finalize = vala_parser_finalize;
	g_type_class_adjust_private_offset (klass, &ValaParser_private_offset);
	((ValaCodeVisitorClass *) klass)->visit_source_file = (void (*) (ValaCodeVisitor*, ValaSourceFile*)) vala_parser_real_visit_source_file;
}

static void
vala_parser_instance_init (ValaParser * self,
                           gpointer klass)
{
	self->priv = vala_parser_get_instance_private (self);
}

static void
vala_parser_finalize (ValaCodeVisitor * obj)
{
	ValaParser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_PARSER, ValaParser);
	_vala_scanner_unref0 (self->priv->scanner);
	_vala_code_context_unref0 (self->priv->context);
	self->priv->tokens = (g_free (self->priv->tokens), NULL);
	_vala_comment_unref0 (self->priv->comment);
	VALA_CODE_VISITOR_CLASS (vala_parser_parent_class)->finalize (obj);
}

/**
 * Code visitor parsing all Vala source files.
 */
static GType
vala_parser_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaParser), 0, (GInstanceInitFunc) vala_parser_instance_init, NULL };
	GType vala_parser_type_id;
	vala_parser_type_id = g_type_register_static (VALA_TYPE_CODE_VISITOR, "ValaParser", &g_define_type_info, 0);
	ValaParser_private_offset = g_type_add_instance_private (vala_parser_type_id, sizeof (ValaParserPrivate));
	return vala_parser_type_id;
}

GType
vala_parser_get_type (void)
{
	static volatile gsize vala_parser_type_id__volatile = 0;
	if (g_once_init_enter (&vala_parser_type_id__volatile)) {
		GType vala_parser_type_id;
		vala_parser_type_id = vala_parser_get_type_once ();
		g_once_init_leave (&vala_parser_type_id__volatile, vala_parser_type_id);
	}
	return vala_parser_type_id__volatile;
}

GQuark
vala_parse_error_quark (void)
{
	return g_quark_from_static_string ("vala-parse-error-quark");
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

